package sk.xref.java2html;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.filechooser.*;
import javax.swing.plaf.basic.*;
import java.util.*;
import java.io.*;

class Options  extends JDialog {

	Main 				main;
	Java2HtmlOptions 	j2hopt;

	class OKButton extends JButton implements ActionListener {
		OKButton() {
			super("O.K");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			main.java2htmlOptions = j2hopt.options.getText();
			Options.this.setVisible(false);
		}
	}

	class ResetButton extends JButton implements ActionListener {
		ResetButton() {
			super("Reset");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			j2hopt.reset();
		}
	}

	class CancelButton extends JButton implements ActionListener {
		CancelButton() {
			super("Cancel");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			Options.this.setVisible(false);
		}
	}

	class ApplyButton extends JButton implements ActionListener {
		ApplyButton() {
			super("Apply");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			main.java2htmlOptions = j2hopt.options.getText();
		}
	}

	Options(Main main) {
		super(main, "Options");
		this.main = main;
		getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		int y = -1;

		// ---------------------- source
		y++;
		/*
		  tb.add(opt_gen, new GeneralOptions(main.generalOptions));
		  tb.add(opt_jdoc, new JavaDocOptions(main.javadocOptions));
		  tb.add(opt_j2h , new Java2HtmlOptions(main.java2htmlOptions));
		  gbc.gridx = 0; gbc.gridy = y; 
		  gbc.gridwidth = 7; gbc.gridheight = 1;
		  gbc.weightx = 1000; gbc.weighty = 1000; gbc.fill = GridBagConstraints.BOTH;
		  getContentPane().add(tb, gbc);
		*/
		j2hopt = new Java2HtmlOptions(this, main.java2htmlOptions);
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 6; gbc.gridheight = 1;
		gbc.weightx = 1000; gbc.weighty = 1000; gbc.fill = GridBagConstraints.BOTH;
		getContentPane().add(j2hopt, gbc);

		y++;
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new JPanel(), gbc);
		gbc.gridx = 1; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new OKButton(), gbc);
		gbc.gridx = 2; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new ResetButton(), gbc);
		gbc.gridx = 3; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new CancelButton(), gbc);
		gbc.gridx = 4; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new ApplyButton(), gbc);
		gbc.gridx = 5; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new JPanel(), gbc);

		pack();
		setLocation(170,50);
		//& setSize(600,600);
	}

	public static void main(String args[]) {
		Main m = new Main();
		Options oo = new Options(m);
		oo.setVisible(true);
	}
}
