package sk.xref.java2html;

import java.util.*;

class OptionsString {


	public static final int MODE_ONE_OPTIONS = 0;
	public static final int MODE_TWO_OPTIONS = 1;	

	String 		optString;
	int 		posAfterGetOptionAfter;

	OptionsString(String ss) {
		this.optString = ss;
	}

	public String getOptionAfterUntil(String ss, int i, char finc) {
		String res;
		int len = ss.length();
		int s;
		res = null;
		s = i;
		while (i<len && ss.charAt(i)!=finc) i++;
		res = ss.substring(s, i);
		if (finc !=  ' ') i++;
		posAfterGetOptionAfter = i;
		return(res);
	}

	public String getOptionAfter(int ii, String ss) {
		String res = null;
		int i = ii;
		int len = ss.length();
		int s;
		while (i<len && ss.charAt(i) == ' ') i++;
		posAfterGetOptionAfter = i;
		if (i<len) {
			char finc;
			if (ss.charAt(i) == '\"') {
				finc = '\"';
				i++;
			} else {
				finc = ' ';
			}
			res = getOptionAfterUntil(ss, i, finc);
		}
		return(res);
	}

	public String getOptionAfter(int ii) {
		String ss = optString;
		String res = getOptionAfter(ii, ss);
		return(res);
	}

	public String getOptionAfter(int ii, String option, int mode) {
		String ss = optString;
		String res = null;
		if (mode == MODE_ONE_OPTIONS) {	
			int i = ii;
			int len = ss.length();
			while (i<len && ss.charAt(i) == ' ') i++;
			if (i>=len) return(res);
			if (ss.charAt(i) == '\"') {
				res = getOptionAfterUntil(ss, i+option.length()+1, '\"');
			} else {
				res = getOptionAfterUntil(ss, i+option.length(), ' ');
			}
		} else {
			res = getOptionAfter(ii, ss);
			res = getOptionAfter(posAfterGetOptionAfter, ss);
		}
		return(res);
	}

	public int containsOption(String opt, int mode) {
		String ss;
		if (mode == MODE_ONE_OPTIONS) {
			ss = " " + opt;
		} else {
			ss = " " + opt + " ";
		}
		String opts = optString;
		int ii = opts.indexOf(ss);
		if (ii != -1) return(ii+1);
		if (mode == MODE_ONE_OPTIONS) {
			ss = " \"" + opt;
		} else {
			ss = " \"" + opt + "\" ";
		}
		ii = opts.indexOf(ss);
		if (ii != -1) return(ii+1);
		return(-1);
	}

	public int containsOption(String opt) {
		return(containsOption(opt, MODE_TWO_OPTIONS));
	}

	public void addOption(String opt) {
		optString = optString + " " + opt + " ";
		normalizeOptions();
	}

	public void removeOption(String opt) {
		String ss = optString;
		int op = ss.indexOf(" " + opt + " ");
		if (op != -1) {
			ss = ss.substring(0, op) + ss.substring(op+1+opt.length());
			optString = ss;
		}
		normalizeOptions();
	}

	public void normalizeOptions() {
		String ss;
		String res = " ";
		int ii=0;
		while ((ss=getOptionAfter(ii))!=null) {
			if (ss.indexOf(' ')!=-1 || ss.indexOf(';')!=-1) {
				res += "\"" + ss + "\" ";
			} else {
				res += ss + " ";
			}
			ii = posAfterGetOptionAfter;
		}
		optString = res;
	}

	public String[] tokenize() {
		String ss;
		int i,n,ii;
		n = 0; 
		ii = 0;
		while ((ss=getOptionAfter(ii))!=null) {
			n ++;
			ii = posAfterGetOptionAfter;
		}
		String[] res = new String[n];
		i = 0;
		ii = 0;
		while ((ss=getOptionAfter(ii))!=null) {
			res[i++] = ss;
			ii = posAfterGetOptionAfter;
		}
		return(res);
	}

}
