package sk.xref.java2html;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.filechooser.*;
import javax.swing.plaf.basic.*;
import java.util.*;
import java.io.*;


class PathSelectionDialog extends StringSelectionDialog {

	FileBrowser fbrowser;

	Vector		paths = new Vector();
	JList 		path = new JList(paths);

	public void setVisible(boolean b) {
		int i,j,len;
		if (b == true) {
			paths = new Vector();
			if (! resultString.equals("")) {
				i=0;
				while ((j=resultString.indexOf(';', i))!=-1) {
					paths.add(resultString.substring(i, j));
					i = j+1;
				}
				paths.add(resultString.substring(i));
			}
			path.setListData(paths);
		} 
		super.setVisible(b);
		getFocusOwner();
	}

	class AddButton extends JButton implements ActionListener {
		AddButton() {
			super("Add");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			String[] pp = fbrowser.tree.selection(false);
			if (pp!=null) {
				for(int i=0; i<pp.length; i++) {
					if (! paths.contains(pp[i])) {
						paths.add(pp[i]);
					}
				}
				path.setListData(paths);
			}
		}
	}

	class DelButton extends JButton implements ActionListener {
		DelButton () {
			super("Del");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			Object pp[] = path.getSelectedValues();
			if (pp!=null) {
				for(int i=0; i<pp.length; i++) {
					paths.remove(pp[i]);
				}
				path.setListData(paths);
			}
		}
	}

	class OKButton extends JButton implements ActionListener {
		OKButton () {
			super("O.K.");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			int i;
			int len = paths.size();
			resultString = "";
			for(i=0; i<len; i++) {
				resultString += paths.elementAt(i);
				if (i+1<len) resultString += Main.cpsep;
			}	
			PathSelectionDialog.this.setVisible(false);
		}
	}

	class CancelButton extends JButton implements ActionListener {
		CancelButton () {
			super("Cancel");
			addActionListener(this);
		}
		public void actionPerformed( ActionEvent e) {
			PathSelectionDialog.this.setVisible(false);
		}
	}

	class Stc extends Container {

		Stc() {
			int height;
			setLayout(new GridBagLayout());
			GridBagConstraints gbc = new GridBagConstraints();
			int y = -1;

			y++;
			gbc.gridx = 1; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.NONE;
			add(new JPanel(), gbc);
			gbc.gridx = 2; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.NONE;
			add(new JLabel("Path:"), gbc);

			y++;
			gbc.gridx = 1; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 10; gbc.fill = GridBagConstraints.BOTH;
			add(new JPanel(), gbc);
			y++;
			gbc.gridx = 1; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
			add(new AddButton(), gbc);

			y++;
			gbc.gridx = 1; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
			add(new DelButton(), gbc);

			y++;
			gbc.gridx = 1; gbc.gridy = y; 
			gbc.gridwidth = 1; gbc.gridheight = 1;
			gbc.weightx = 1; gbc.weighty = 10; gbc.fill = GridBagConstraints.BOTH;
			add(new JPanel(), gbc);

			height = 4;
			gbc.gridx = 2; gbc.gridy = y-height+1; 
			gbc.gridwidth = 1; gbc.gridheight = height;
			gbc.weightx = 100; gbc.weighty = 5000; gbc.fill = GridBagConstraints.BOTH;
			add(new JScrollPane(path), gbc);
		}
	}

	PathSelectionDialog(Dialog father, String path) {
		super(father, "Path selection");
		getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		int y = -1;
		
		// ---------------------- source
		y++;
		fbrowser = new FileBrowser(Main.defaultRootDir);
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 4; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 100; gbc.fill = GridBagConstraints.BOTH;
		getContentPane().add(new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, fbrowser, new Stc()), gbc);

		y++;
		gbc.gridx = 0; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new JPanel(), gbc);
		gbc.gridx = 1; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new OKButton(), gbc);
		gbc.gridx = 2; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new CancelButton(), gbc);
   		gbc.gridx = 3; gbc.gridy = y; 
		gbc.gridwidth = 1; gbc.gridheight = 1;
		gbc.weightx = 1; gbc.weighty = 1; gbc.fill = GridBagConstraints.HORIZONTAL;
		getContentPane().add(new JPanel(), gbc);

		setLocation(150,100);
		pack();
		setModal(true);
		
	}

}
