
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
#if XREF_HUGE
#define PutLexFilePos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexFilePos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#ifdef XREF_HUGE
#define PutLexNumPos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexNumPos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#if XREF_HUGE
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#ifdef XREF_HUGE
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#if XREF_HUGE
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
#ifdef XREF_HUGE
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
