
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
typedef unsigned char bitArray;
static bitArray tmpChRelevant[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChProcessed[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChMarkProcessed[(((MAX_FILES)+(8 -1))/8)];
static int s_symbolListOutputCurrentLine =0;
static void clearTmpChRelevant() {
        memset(tmpChRelevant, 0, sizeof(tmpChRelevant));
}
static void clearTmpChProcessed() {
        memset(tmpChProcessed, 0, sizeof(tmpChProcessed));
}
static void clearTmpChMarkProcessed() {
        memset(tmpChMarkProcessed, 0, sizeof(tmpChMarkProcessed));
}
int classHierarchyClassNameLess(int c1, int c2) {
        char *n2, *nn;
        S_fileItem *fi1, *fi2;
        int ccc;
        char ttt[MAX_FILE_NAME_SIZE];
        fi1 = s_fileTab.tab[c1];
        fi2 = s_fileTab.tab[c2];
        { if (!(fi1 && fi2)) internalCheckFail("fi1 && fi2", "classh.c", 45);};
        if (fi2->b.isInterface && ! fi1->b.isInterface) return(1);
        if (fi1->b.isInterface && ! fi2->b.isInterface) return(0);
        nn = fi1->name;
        nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),NO_OUTERS_CUT);
        strcpy(ttt,nn);
        nn = fi2->name;
    nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),NO_OUTERS_CUT);
        ccc = strcmp(ttt,nn);
        if (ccc!=0) return(ccc<0);
        ccc = strcmp(fi1->name, fi2->name);
        return(ccc<0);
}
int classHierarchySupClassNameLess(S_chReference *c1, S_chReference *c2) {
        return(classHierarchyClassNameLess(c1->clas, c2->clas));
}
static int markTransitiveRelevantSubsRec(int cind, int pass) {
        S_fileItem *fi, *tt;
        S_chReference *s;
        int res;
        fi = s_fileTab.tab[cind];
        if (((tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)) return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
        {tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
        res = 0;
        for(s=fi->infs; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 74);};
                if (markTransitiveRelevantSubsRec(s->clas, pass)) {
                        {tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
                }
        }
        return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
}
static void markTransitiveRelevantSubs(int cind, int pass) {
        S_fileItem *fi;
        fi = s_fileTab.tab[cind];
        if (((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)==0) return;
        markTransitiveRelevantSubsRec(cind, pass);
}
void classHierarchyGenInit() {
        clearTmpChRelevant();
        clearTmpChProcessed();
}
static void genClassHierarchyVerticalBars( FILE *ff, S_intlist *nextbars,
                                                                                   int secondpass) {
        S_intlist *nn;
        if (nextbars==NULL) return;
        { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
        for(nn = nextbars; nn!=NULL; nn=nn->next) {
                if (nn->next==NULL) {
                        if (secondpass) fprintf(ff,"  +- ");
                        else fprintf(ff,"  |  ");
                }
                else if (nn->i) fprintf(ff,"  | ");
                else fprintf(ff,"    ");
        }
        { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
}
static S_olSymbolsMenu *htmlItemInOriginalList(S_olSymbolsMenu *orr, int fInd) {
        S_olSymbolsMenu *rr;
        { register S_olSymbolsMenu *tmp; tmp = orr; while (tmp!=NULL && tmp->s.vApplClass!=(fInd) ) tmp = tmp->next; rr = tmp; };
        return(rr);
}
static void htmlCHEmptyIndent( FILE *ff ) {
  fprintf(ff,"    ");
}
static void htmlPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname, *pref1, *pref2, *suf1, *suf2;
        S_fileItem *fi;
        int cnt;
        fi = s_fileTab.tab[fInd];
        htmlCHEmptyIndent( ff);
        genClassHierarchyVerticalBars( ff, nextbars, 0);
        fprintf(ff,"\n");
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          NO_OUTERS_CUT);
        pref1 = pref2 = suf1 = suf2 = "";
        if (fi->b.isInterface) {
                pref2 = "<em>"; suf2 = "</em>";
        }
        if (itt!=NULL && ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 154);};
                genClassHierarchyItemLinks( ff, itt, virtFlag);
                genClassHierarchyVerticalBars( ff, nextbars, 1);
                if (itt->s.vApplClass == itt->s.vFunClass) {
                        pref1 = "<B>"; suf1 = "</B>";
                }
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
                cnt = itt->defRefn+itt->refn;
                if (cnt > 0) {
                        fprintf(ff,"\t\t(%d)", cnt);
                }
        } else {
            htmlCHEmptyIndent( ff);
            genClassHierarchyVerticalBars( ff, nextbars, 1);
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
        }
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==1) {
                fprintf(ff, " ---> up");
        }
        fprintf(ff,"\n");
}
static void olcxPrintMenuItemPrefix(FILE *ff, S_olSymbolsMenu *itt,
                                                                   int selectable) {
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "classh.c", 179);};
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff,"");
        } else if (! selectable) {
                fprintf(ff,"- ");
        } else if (itt!=NULL && itt->selected) {
                fprintf(ff,"+ ");
        } else {
                fprintf(ff,"  ");
        }
        if (itt!=NULL && itt->vlevel==1) fprintf(ff,">>");
        else fprintf(ff,"  ");
        fprintf(ff," ");
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff, "");
        } else if (itt==NULL || (itt->defRefn==0 && itt->refn==0) || !selectable) {
                fprintf(ff, "  -/-  ");
        } else if (itt->defRefn==0) {
                fprintf(ff, "  -/%-3d", itt->refn);
        } else if (itt->refn==0) {
                fprintf(ff, "%3d/-  ", itt->defRefn);
        } else {
                fprintf(ff, "%3d/%-3d", itt->defRefn, itt->refn);
        }
        fprintf(ff,"    ");
}
static void olcxMenuGenNonVirtualGlobSymList( FILE *ff, S_olSymbolsMenu *ss) {
        int ii;
        ss->outOnLine = s_symbolListOutputCurrentLine;
        s_symbolListOutputCurrentLine ++ ;
        olcxPrintMenuItemPrefix(ff, ss, 1);
        printSymbolLinkName( ff, ss);
        if (ss->s.b.symType!=TypeDefault) {
                fprintf(ff,"\t(%s)", typesName[ss->s.b.symType]);
        }
        fprintf(ff,"\n");
}
static void olcxMenuPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname;
        S_fileItem *fi;
        int yetProcesed;
        yetProcesed = ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0);
        olcxPrintMenuItemPrefix(ff, itt, ! yetProcesed);
        genClassHierarchyVerticalBars( ff, nextbars, 1);
        fi = s_fileTab.tab[fInd];
        if (itt!=NULL) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 232);};
                if (itt->s.vApplClass == itt->s.vFunClass) fprintf(ff,"*");
                itt->visible = 1;
        }
        if (fi->b.isInterface) fprintf(ff,"~");
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          NO_OUTERS_CUT);
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) fprintf(ff,"(%s) -> up", cname);
        else fprintf(ff,"%s", cname);
        fprintf(ff,"\n");
}
static void htmlDescendTheClassHierarchy( FILE *ff,
                                                                                        int fInd,
                                                                                        S_olSymbolsMenu *rrr,
                                                                                        int level,
                                                                                        S_intlist *nextbars,
                                                                                        int virtFlag,
                                                                                        int pass
        ) {
        S_intlist snextbar,*nn;
        S_fileItem *tt, *fi;
        S_chReference *s,*ol,*snext;
        S_olSymbolsMenu *itt;
        char *cname,*pref1,*pref2,*suf1,*suf2;
        int i;
        fi = s_fileTab.tab[fInd];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 261);};
        if (((tmpChRelevant[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) return;
        itt = htmlItemInOriginalList(rrr, fInd);
        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                htmlPrintClassHierarchyLine( ff, fInd, nextbars, virtFlag, itt);
        } else {
                olcxMenuPrintClassHierarchyLine( ff, fInd, nextbars, virtFlag, itt);
        }
        s_symbolListOutputCurrentLine ++;
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==1) return;
        {tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] |= (1<<((fInd) & ((8 -1))));};
        if (itt!=NULL) itt->outOnLine = s_symbolListOutputCurrentLine-1;
        { S_chReference *_macrores; _macrores = (fi->infs); { S_chReference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (classHierarchySupClassNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (fi->infs) = _macrores;};
        s=fi->infs;
        while (s!=NULL) {
                { if (!(s_fileTab.tab[s->clas])) internalCheckFail("s_fileTab.tab[s->clas]", "classh.c", 282);};
                snext = s->next;
                while (snext!=NULL && ((tmpChRelevant[(((snext->clas) & ~(((8 -1))))>> 3)] & (1<<((snext->clas) & ((8 -1)))))!=0)==0) {
                        snext = snext->next;
                }
                { (&snextbar)->i = (snext!=NULL); (&snextbar)->next = nextbars;}
                htmlDescendTheClassHierarchy(ff, s->clas, rrr, level+1,
                                                                         &snextbar, virtFlag, pass);
                s = snext;
        }
}
static int htmlGenThisClassHierarchy(int fInd,
                                                                          FILE *ff,
                                                                          S_olSymbolsMenu *rrr,
                                                                          int virtFlag,
                                                                         int pass) {
        S_fileItem *top,*tt,*fi;
        S_chReference *s;
        fi = s_fileTab.tab[fInd];
        if (fi==NULL) return(0);
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) return(0);
        if (((tmpChRelevant[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) return(0);
        for(s=fi->sups; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 308);};
                if (((tmpChRelevant[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0) && ((tmpChProcessed[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0)==0) return(0);
        }
        if (pass==FIRST_PASS && fi->b.isInterface) return(0);
        htmlDescendTheClassHierarchy(ff, fInd, rrr, 0, NULL, virtFlag, pass);
        return(1);
}
void htmlGenClassHierarchies( FILE *ff, S_olSymbolsMenu *rrr,
                                                                                int virtFlag, int pass ) {
        S_olSymbolsMenu *ss;
        int i,rr;
        S_fileItem *fi;
        clearTmpChRelevant();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                { if (!(s_fileTab.tab[ss->s.vApplClass])) internalCheckFail("s_fileTab.tab[ss->s.vApplClass]", "classh.c", 327);};
                if (ss->visible) {
                        {tmpChRelevant[(((ss->s.vApplClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vApplClass) & ((8 -1))));};
                        {tmpChRelevant[(((ss->s.vFunClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vFunClass) & ((8 -1))));};
                }
        }
        clearTmpChMarkProcessed();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                markTransitiveRelevantSubs(ss->s.vFunClass, pass);
                markTransitiveRelevantSubs(ss->s.vApplClass, pass);
        }
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                htmlGenThisClassHierarchy(ss->s.vFunClass,ff,rrr,virtFlag,pass);
                htmlGenThisClassHierarchy(ss->s.vApplClass,ff,rrr,virtFlag,pass);
        }
}
static int isInterface(int fnum) {
        S_fileItem *fi;
        fi = s_fileTab.tab[fnum];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 349);};
        return(fi->b.isInterface);
}
static int htmlRefItemsClassNameLess(S_olSymbolsMenu *ss1,
                                                                         S_olSymbolsMenu *ss2) {
        return(classHierarchyClassNameLess(ss1->s.vApplClass,ss2->s.vApplClass));
}
int chLineOrderLess(S_olSymbolsMenu *r1, S_olSymbolsMenu *r2) {
        return(r1->outOnLine < r2->outOnLine);
}
void olcxMenuGenGlobRefsForVirtMethod(FILE *ff, S_olSymbolsMenu *rrr) {
        char ln[MAX_HTML_REF_LEN];
        int virtFlag;
        linkNamePrettyPrint(ln,rrr->s.name,MAX_HTML_REF_LEN,SHORT_NAME);
        if (strcmp(rrr->s.name, " [classTree]")==0) {
        } else {
                fprintf(ff, "\n== %s\n", ln);
                s_symbolListOutputCurrentLine += 2 ;
        }
        classHierarchyGenInit();
        htmlGenClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, FIRST_PASS);
        htmlGenClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, SECOND_PASS);
        fprintf(ff, "\n");
        s_symbolListOutputCurrentLine ++ ;
}
static void htmlMarkVisibleAllClassesHavingDefinition( S_olSymbolsMenu *rrr ) {
        S_olSymbolsMenu *rr;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                if (rr->s.vApplClass==rr->s.vFunClass) rr->visible = 1;
        }
}
static int isVirtualMenuItem(S_symbolRefItem *p) {
        return (p->b.storage == StorageField
                        || p->b.storage == StorageMethod
                        || p->b.storage == StorageConstructor);
}
static void genVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 409);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 411);};
        if (isVirtualMenuItem(p)) {
                if (s_opt.taskRegime==RegimeHtmlGenerate) {
                        htmlMarkVisibleAllClassesHavingDefinition( rrr);
                        htmlGenGlobRefsForVirtMethod( ff, fn, rrr);
                } else {
                        olcxMenuGenGlobRefsForVirtMethod( ff, rrr);
                }
        }
}
static void genNonVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 435);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 437);};
        if (! isVirtualMenuItem(p)) {
                for(ss=rrr; ss!=NULL; ss=ss->next) {
                        p = &ss->s;
                        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                                htmlGenNonVirtualGlobSymList( ff, fn, p);
                        } else {
                                olcxMenuGenNonVirtualGlobSymList( ff, ss);
                        }
                }
        }
}
static void genGlobVirtNonVirtRefList(S_olSymbolsMenu *rrr, FILE *ff,
                                                                          char *fn, int virtFlag ) {
        S_olSymbolsMenu *rr, *ss, *nextl;
        rr = rrr;
        while (rr!=NULL) {
                for(ss= rr;
                        ss!=NULL&&ss->next!=NULL && itIsSameCxSymbol(&ss->next->s,&rr->s);
                        ss = ss->next
                        ) ;
                { if (!(ss!=NULL)) internalCheckFail("ss!=NULL", "classh.c", 460);};
                nextl = ss->next;
                ss->next = NULL;
                if (virtFlag == GEN_VIRTUALS) {
                        genVirtualsGlobRefLists(rr,ff,fn);
                } else {
                        genNonVirtualsGlobRefLists(rr,ff,fn);
                }
                { if ((rr)==NULL) rr = nextl; else { register S_olSymbolsMenu *tempnsl; tempnsl = rr; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = nextl; } };
                rr = nextl;
        }
}
void htmlGenGlobRefLists(S_olSymbolsMenu *rrr, FILE *ff, char *fn) {
        S_olSymbolsMenu *rr,*ss,*nextl;
        int i,n;
        static int counter;
        S_symbolRefItem *p;
        for(rr=rrr; rr!=NULL; rr=rr->next) rr->outOnLine = 0;
        s_symbolListOutputCurrentLine = 1;
        genGlobVirtNonVirtRefList( rrr, ff, fn, GEN_NON_VIRTUALS);
        genGlobVirtNonVirtRefList( rrr, ff, fn, GEN_VIRTUALS);
}
