
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
char s_base[MAX_FILE_NAME_SIZE];
z_stream s_defaultZStream = {NULL,};
S_counters s_count;
unsigned s_recFindCl = 1;
S_currentlyParsedCl s_cp;
S_currentlyParsedCl s_cpInit = {0,};
S_currentlyParsedStatics s_cps;
S_currentlyParsedStatics s_cpsInit = {0,};
S_caching s_cache;
S_topBlock *s_topBlock;
int ppmMemoryi=0;
int mbMemoryi=0;
time_t s_expTime;
char s_olSymbolType[COMPLETION_STRING_SIZE];
S_position s_paramPosition;
S_idIdent s_yyIdentBuf[YYBUFFERED_ID_INDEX];
int s_yyIdentBufi = 0;
S_typeModifiers *s_structRecordCompletionType;
S_typeModifiers *s_upLevelFunctionCompletionType;
S_exprTokenType s_forCompletionType;
S_typeModifiers *s_javaCompletionLastPrimary;
YYSTYPE *uniyylval = &cyylval;
struct yyGlobalState *s_yygstate;
char *s_input_file_name="";
S_completions s_completions;
S_fileDesc cFile = {0};
S_symTab *s_symTab;
S_javaFqtTab s_javaFqtTab;
S_idTab s_fileTab;
S_refTab s_cxrefTab;
S_fileDesc inStack[INSTACK_SIZE];
int inStacki=0;
S_lexInput macStack[MACSTACK_SIZE];
int macStacki=0;
S_lexInput cInput;
char tmpMemory[SIZE_TMP_MEM];
char memory[SIZE_workMemory];
char ppmMemory[SIZE_ppmMemory];
char mbMemory[SIZE_mbMemory];
char ftMemory[SIZE_ftMemory];
int ftMemoryi = 0;
unsigned long next;
char nextus[32];
char tmpWorkMemory[SIZE_tmpWorkMemory];
int tmpWorkMemoryi = 0;
S_memory cxMemory = {cxMemoryOverflowHandler, CX_MEMORY_CHUNK_SIZE,0,0,NULL};
int s_ifEvaluation = 0;
S_position s_olcxByPassPos;
S_position s_cxRefPos;
int s_cxRefFlag=0;
time_t s_fileProcessStartTime;
int s_language;
int s_currCppPass;
int s_maximalCppPass;
S_userOlcx *s_olcxCurrentUser;
unsigned s_menuFilterOoBits[MAX_MENU_FILTER_LEVEL] = {
        (00000 | 00000),
        (00000 | 02000),
        (00100 | 02000),
};
int s_refListFilters[MAX_REF_LIST_FILTER_LEVEL] = {
        UsageMaxOLUsages,
        UsageUsed,
        UsageAddrUsed,
        UsageLvalUsed,
};
char *s_cppVarArgsName = "__VA_ARGS__";
char s_defaultClassPath[] = ".";
S_stringList *s_javaClassPaths;
char *s_javaSourcePaths;
S_idIdent s_javaAnonymousClassName = {"{Anonymous}", NULL, -1,0,0};
S_idIdent s_javaConstructorName = {"<init>", NULL, -1,0,0};
static S_idIdentList s_javaDefaultPackageNameBody[] = {
        {"", NULL, -1,0,0, "", TypePackage, NULL},
};
S_idIdentList *s_javaDefaultPackageName = s_javaDefaultPackageNameBody;
static S_idIdentList s_javaLangNameBody[] = {
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangNameBody[1]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangName = s_javaLangNameBody;
static S_idIdentList s_javaLangStringNameBody[] = {
        {"String", NULL, -1,0,0, "String", TypeStruct, &s_javaLangStringNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangStringNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangStringName = s_javaLangStringNameBody;
static S_idIdentList s_javaLangCloneableNameBody[] = {
        {"Cloneable", NULL, -1,0,0, "Cloneable", TypeStruct, &s_javaLangCloneableNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangCloneableNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangCloneableName = s_javaLangCloneableNameBody;
static S_idIdentList s_javaIoSerializableNameBody[] = {
        {"Serializable", NULL, -1,0,0, "Serializable", TypeStruct, &s_javaIoSerializableNameBody[1]},
        {"io", NULL, -1,0,0, "io", TypePackage, &s_javaIoSerializableNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaIoSerializableName = s_javaIoSerializableNameBody;
static S_idIdentList s_javaLangClassNameBody[] = {
        {"Class", NULL, -1,0,0, "Class", TypeStruct, &s_javaLangClassNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangClassNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangClassName = s_javaLangClassNameBody;
static S_idIdentList s_javaLangObjectNameBody[] = {
        {"Object", NULL, -1,0,0, "Object", TypeStruct, &s_javaLangObjectNameBody[1]},
        {"lang", NULL, -1,0,0, "lang", TypePackage, &s_javaLangObjectNameBody[2]},
        {"java", NULL, -1,0,0, "java", TypePackage, NULL},
};
S_idIdentList *s_javaLangObjectName = s_javaLangObjectNameBody;
char *s_javaLangObjectLinkName="java/lang/Object";
int s_olstringFound = 0;
int s_olstringServed = 0;
int s_olstringUsage = 0;
char *s_olstringInMbody = NULL;
int s_olMacro2PassFile;
char *yytext;
struct options s_opt;
S_javaStat *s_javaStat;
S_javaStat s_initJavaStat;
char *s_javaThisPackageName="";
FILE *cxOut;
FILE *fIn;
FILE *ccOut=NULL;
int s_cxResizingBlocked = 0;
int s_input_file_number = -1;
int s_olStringSecondProcessing=0;
int s_olOriginalFileNumber = -1;
int s_olOriginalComFileNumber = -1;
int s_noneFileIndex = -1;
time_t s_expiration;
S_typeModifiers s_defaultIntModifier;
S_symbol s_defaultIntDefinition;
S_typeModifiers s_defaultPackedTypeModifier;
S_typeModifiers s_defaultVoidModifier;
S_symbol s_defaultVoidDefinition;
S_typeModifiers s_errorModifier;
S_symbol s_errorSymbol;
S_position s_noPos = {-1, 0, 0};
S_reference s_noRef = {UsageNone, {-1, 0, 0}, NULL};
S_symbol s_javaArrayObjectSymbol;
S_symbol *s_javaStringSymbol;
S_symbol *s_javaCloneableSymbol;
S_symbol *s_javaIoSerializableSymbol;
S_symbol *s_javaObjectSymbol;
S_typeModifiers s_javaStringModifier;
S_typeModifiers s_javaClassModifier;
S_typeModifiers s_javaObjectModifier;
S_zipFileTabItem s_zipArchivTab[MAX_JAVA_ZIP_ARCHIVES];
char s_cwd[MAX_FILE_NAME_SIZE];
jmp_buf cxmemOverflow;
jmp_buf s_memoryResize;
S_options s_initOpt = {
        "",
        NULL,
#ifdef __WIN32__
        "c",
        "java;JAV",
        "C;cpp;CC;cc",
#else
        "c",
        "java",
        "C:cpp:CC:cc",
#endif
        1,
        ":",
        0,
        TSS_FULL_SEARCH,
        "Auto",
        "",
        0,
        0,
        0,
        0,
        "nouser",
        0,
        0,
        NULL,
        TPC_NONE,
        1,
        0,
        0,
        NULL,
        NULL,
        NULL,
        DEFAULT_CXREF_FILE,
        NULL,
        NULL,
        0,
        ((int) (((unsigned) -2)>>1)),
        0,
        "",
        0,
        1,
        0,
        NULL,
        80,
        "java.applet:java.awt:java.beans:java.io:java.lang:java.math:java.net:java.rmi:java.security:java.sql:java.text:java.util:javax.accessibility:javax.swing:org.omg.CORBA:org.omg.CosNaming",
        0,
        "http://java.sun.com/j2se/1.3/docs/api",
        "",
        0,
        NULL,
        0,
        "/tmp",
        0,
        0,
        0,
        1,
        0,
        "",
        DEFAULT_VALUE,
        NULL,
        1,
        0,
        0,
        "navy",
        "",
        0,
        (00100 | 02000 | 00002),
        0,
        0,
        1,
        1,
        0,
        NULL,
        0,
        0,
        0,
        "0:3",
        NULL,
        "",
        79,
        "1/1/2000/1365:x:dadde11113b13b11",
        "",
        "*_",
        EXTR_FUNCTION,
        0,
        "__newFunction__",
        MAX_COMPLETIONS,
        0,
        0,
        "",
        1,
        "",
        8,
        "",
        0,
        0,
        0,
        0,
        -1,
        -1,
        RegimeXref,
        "nouser",
        0,
        1,
        0,
        0,
        0,
        "",
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        NULL,
        0,
        0,
};
char *s_editCommunicationString = "C@$./@mVeDitznAC";
uchar typeShortChange[MAX_TYPE];
uchar typeLongChange[MAX_TYPE];
uchar typeSignedChange[MAX_TYPE];
uchar typeUnsignedChange[MAX_TYPE];
char s_javaBaseTypeCharCodes[MAX_TYPE];
int s_javaCharCodeBaseTypes[127];
char s_javaTypePCTIConvert[MAX_TYPE];
char s_javaPrimitiveWideningConversions[MAX_PCTIndex-1][MAX_PCTIndex-1] = {
    1, 1, 0, 1, 1, 1, 1,
    0, 1, 0, 1, 1, 1, 1,
    0, 0, 1, 1, 1, 1, 1,
    0, 0, 0, 1, 1, 1, 1,
    0, 0, 0, 0, 1, 1, 1,
    0, 0, 0, 0, 0, 1, 1,
    0, 0, 0, 0, 0, 0, 1,
};
char *s_tokenName[446];
S_typeModifiers * s_preCrTypesTab[MAX_TYPE];
S_typeModifiers * s_preCrPtr1TypesTab[MAX_TYPE];
S_typeModifiers * s_preCrPtr2TypesTab[MAX_TYPE];
S_typeModificationsInit s_typeModificationsInit[] = {
  {TypeDefault, TypeShortInt, TypeLongInt, TypeSignedInt, TypeUnsignedInt},
  {TypeChar, -1, -1, TypeSignedChar, TypeUnsignedChar},
  {TypeInt, TypeShortInt, TypeLongInt, TypeSignedInt, TypeUnsignedInt},
  {TypeUnsignedInt, TypeShortUnsignedInt, TypeLongUnsignedInt, -1, -1},
  {TypeSignedInt, TypeShortSignedInt, TypeLongSignedInt, -1, -1},
  {TypeShortInt, -1, -1, TypeShortSignedInt, TypeShortUnsignedInt},
  {TypeLongInt, -1, -1, TypeLongSignedInt, TypeLongUnsignedInt},
  {TmodLong, -1, -1, TmodLongSigned, TmodLongUnsigned},
  {TmodShort, -1, -1, TmodShortSigned, TmodShortUnsigned},
  {TmodSigned, TmodShortSigned, TmodLongSigned, -1, -1},
  {TmodUnsigned, TmodShortUnsigned, TmodLongUnsigned, -1, -1},
  {-1,-1,-1,-1,-1}
};
S_tokenNameIni s_tokenNameIniTab[] = {
        {"asm", 364 ,16},
        {"auto", 315 ,2 | 8 | 16},
        {"enum", 321 ,2 | 8 | 16},
        {"extern", 314 ,2 | 8 | 16},
        {"register", 316 ,2 | 8 | 16},
        {"signed", 317 ,2 | 8 | 16},
        {"sizeof", 322 ,2 | 8 | 16},
        {"struct", 319 ,2 | 8 | 16},
        {"typedef", 313 ,2 | 8 | 16},
        {"union", 320 ,2 | 8 | 16},
        {"unsigned", 318 ,2 | 8 | 16},
        {"abstract", 324 ,4},
        {"boolean", 325 ,4},
        {"byte", 326 ,4},
        {"catch", 327 ,4 | 16},
        {"class", 328 ,4 | 16},
        {"extends", 329 ,4},
        {"final", 330 ,4},
        {"finally", 331 ,4},
        {"implements", 332 ,4},
        {"import", 333 ,4},
        {"instanceof", 334 ,4},
        {"interface", 335 ,4},
        {"native", 336 ,4},
        {"new", 337 ,4 | 16},
        {"package", 338 ,4},
        {"private", 339 ,4 | 16},
        {"protected", 340 ,4 | 16},
        {"public", 341 ,4 | 16},
        {"super", 342 ,4},
        {"synchronized",343 ,4},
        {"strictfp", 352 ,4},
        {"this", 344 ,4 | 16},
        {"throw", 345 ,4 | 16},
        {"throws", 346 ,4},
        {"transient", 347 ,4},
        {"try", 348 ,4 | 16},
        {"true", 349 ,4 | 16},
        {"false", 350 ,4 | 16},
        {"null", 351 ,4},
        {"bool", 362 ,16},
        {"const_cast", 372 ,16},
        {"delete", 358 ,16},
        {"dynamic_cast", 369 ,16},
        {"explicit", 360 ,16},
        {"friend", 354 ,16},
        {"inline", 367 ,16},
        {"mutable", 359 ,16},
        {"namespace", 356 ,16},
        {"operator", 355 ,16},
        {"reinterpret_cast", 371,16},
        {"static_cast", 370 ,16},
        {"template", 357 ,16},
        {"typeid", 373 ,16},
        {"typename", 368 ,16},
        {"using", 363 ,16},
        {"virtual", 366 ,16},
        {"wchar_t", 361 ,16},
        {"break", 292 ,2 | 8 | 16 | 4},
        {"case", 293 ,2 | 8 | 16 | 4},
        {"char", 294 ,2 | 8 | 16 | 4},
        {"const", 295 ,2 | 8 | 16 | 4},
        {"continue", 296 ,2 | 8 | 16 | 4},
        {"default", 297 ,2 | 8 | 16 | 4},
        {"do", 298 ,2 | 8 | 16 | 4},
        {"double", 299 ,2 | 8 | 16 | 4},
        {"else", 300 ,2 | 8 | 16 | 4},
        {"float", 301 ,2 | 8 | 16 | 4},
        {"for", 302 ,2 | 8 | 16 | 4},
        {"goto", 303 ,2 | 8 | 16 | 4},
        {"if", 304 ,2 | 8 | 16 | 4},
        {"int", 305 ,2 | 8 | 16 | 4},
        {"long", 306 ,2 | 8 | 16 | 4},
        {"return", 307 ,2 | 8 | 16 | 4},
        {"short", 308 ,2 | 8 | 16 | 4},
        {"static", 291 ,2 | 8 | 16 | 4},
        {"switch", 309 ,2 | 8 | 16 | 4},
        {"void", 310 ,2 | 8 | 16 | 4},
        {"volatile", 311 ,2 | 8 | 16 | 4},
        {"while", 312 ,2 | 8 | 16 | 4},
        {">>>=", 285 ,4},
        {">>>", 284 ,4},
        {"...", 283 ,2},
        {">>=", 278 ,2},
        {"<<=", 277 ,2},
        {"+=", 275 ,2},
        {"-=", 276 ,2},
        {"*=", 272 ,2},
        {"/=", 273 ,2},
        {"%=", 274 ,2},
        {"&=", 279 ,2},
        {"^=", 280 ,2},
        {"|=", 281 ,2},
        {">>", 265 ,2},
        {"<<", 264 ,2},
        {"++", 262 ,2},
        {"--", 263 ,2},
        {"->", 282 ,2},
        {"->*", 290 ,16},
        {".*", 289 ,16},
        {"::", 288 ,16},
        {"&&", 270 ,2},
        {"||", 271 ,2},
        {"<=", 266 ,2},
        {">=", 267 ,2},
        {"==", 268 ,2},
        {"!=", 269 ,2},
        {";", ';' ,2},
        {"{", '{' ,2},
        {"}", '}' ,2},
        {",", ',' ,2},
        {":", ':' ,2},
        {"=", '=' ,2},
        {"(", '(' ,2},
        {")", ')' ,2},
        {"[", '[' ,2},
        {"]", ']' ,2},
        {".", '.' ,2},
        {"&", '&' ,2},
        {"!", '!' ,2},
        {"~", '~' ,2},
        {"-", '-' ,2},
        {"+", '+' ,2},
        {"*", '*' ,2},
        {"/", '/' ,2},
        {"%", '%' ,2},
        {"<", '<' ,2},
        {">", '>' ,2},
        {"^", '^' ,2},
        {"|", '|' ,2},
        {"?", '?' ,2},
        {"()", 434 ,16},
        {"[]", 435 ,16},
        {"'CONSTANT'", 438 ,2},
        {"'CONSTANT'", 439 ,2},
        {"'CONSTANT'", 425 ,2},
        {"'CONSTANT'", 426 ,2},
        {"'STRING_LITERAL'", 440 ,2},
        {"'IDENTIFIER'", 437 ,2},
        {"'LINE_TOK'", 441 ,2},
        {"'BLOCK_MARKER'", 429 ,2},
        {"#INCLUDE", 410 ,2},
        {"#DEFINE0", 421 ,2},
        {"#DEFINE", 411 ,2},
        {"#IFDEF", 412 ,2},
        {"#IFNDEF", 413 ,2},
        {"#IF", 414 ,2},
        {"#ELSE", 415 ,2},
        {"#ENDIF", 416 ,2},
        {"#PRAGMA", 419 ,2},
        {"#LINE", 420 ,2},
        {"##", 423 ,2},
        {NULL, 0 ,2}
};
S_tokenNameIni s_tokenNameIniTab2[] = {
        {"__const", 295 ,2 | 8 | 16},
        {"__const__", 295 ,2 | 8 | 16},
        {"__signed", 317 ,2 | 8 | 16},
        {"__signed__", 317 ,2 | 8 | 16},
        {"__inline", 323 ,2 | 8 | 16},
        {"__inline__", 323 ,2 | 8 | 16},
        {"__volatile", 311 ,2 | 8 | 16},
        {"__volatile__", 311 ,2 | 8 | 16},
        {"__asm", 364 ,2 | 16},
        {"__asm__", 364 ,2 | 16},
        {"__label__", 376 ,2 | 16},
        {"__near", 323 ,2 | 8 | 16},
        {"__far", 323 ,2 | 8 | 16},
        {"__pascal", 323 ,2 | 8 | 16},
        {"_near", 323 ,2 | 8 | 16},
        {"_far", 323 ,2 | 8 | 16},
        {"_pascal", 323 ,2 | 8 | 16},
        {"_const", 323 ,2 | 8 | 16},
        {"__near", 323 ,2 | 8 | 16},
        {"__far", 323 ,2 | 8 | 16},
        {"__pascal", 323 ,2 | 8 | 16},
        {"__cdecl", 323 ,2 | 8 | 16},
        {"__fastcall", 323 ,2 | 8 | 16},
        {"__stdcall", 323 ,2 | 8 | 16},
        {"__int8", 305 ,2 | 8 | 16},
        {"__int16", 305 ,2 | 8 | 16},
        {"__int32", 305 ,2 | 8 | 16},
        {"__int64", 305 ,2 | 8 | 16},
        {NULL, 0 ,2}
};
S_tokenNameIni s_tokenNameIniTab3[] = {
        {"assert", 353 ,4},
        {NULL, 0 ,2}
};
S_typeCharCodeIni s_baseTypeCharCodesIniTab[] = {
        {TypeByte, 'B'},
        {TypeChar, 'C'},
        {TypeDouble, 'D'},
        {TypeFloat, 'F'},
        {TypeInt, 'I'},
        {TypeLong, 'J'},
        {TypeShort, 'S'},
        {TypeBoolean, 'Z'},
        {TypeVoid, 'V'},
        {TypeError, 'E'},
        {TypeNull, 'N'},
        {-1, ' '},
};
S_javaTypePCTIConvertIni s_javaTypePCTIConvertIniTab[] = {
        {TypeByte, PCTIndexByte},
        {TypeShort, PCTIndexShort},
        {TypeChar, PCTIndexChar},
        {TypeInt, PCTIndexInt},
        {TypeLong, PCTIndexLong},
        {TypeFloat, PCTIndexFloat},
        {TypeDouble, PCTIndexDouble},
        {-1,-1},
};
char *s_extractStorageName[MAX_STORAGE];
S_intStringTab s_extractStoragesNamesInitTab[] = {
        {StorageExtern, "extern "},
        {StorageStatic, "static "},
        {StorageRegister, "register "},
        {StorageTypedef, "typedef "},
        {-1, NULL}
};
S_intStringTab s_typesNamesInitTab[] = {
        {TypeDefault , "Default"},
        {TypeChar , "char"},
        {TypeUnsignedChar , "unsigned char"},
        {TypeSignedChar , "signed char"},
        {TypeInt , "int"},
        {TypeUnsignedInt , "unsigned int"},
        {TypeSignedInt , "signed int"},
        {TypeShortInt , "short int"},
        {TypeShortUnsignedInt , "short unsigned int"},
        {TypeShortSignedInt , "short signed int"},
        {TypeLongInt , "long int"},
        {TypeLongUnsignedInt , "long unsigned int"},
        {TypeLongSignedInt , "long signed int"},
        {TypeFloat , "float"},
        {TypeDouble , "double"},
        {TypeStruct, "struct"},
        {TypeUnion, "union"},
        {TypeEnum , "enum"},
        {TypeVoid , "void"},
        {TypePointer, "Pointer"},
        {TypeArray, "Array"},
        {TypeFunction, "Function"},
        {TypeAnonymeField, "AnonymeField"},
        {TypeError, "Error"},
        {TypeCppIfElse, "#if-else-fi"},
        {TypeCppInclude, "#include"},
        {TypeCppCollate, "##"},
        {TmodLong, "long"},
        {TmodShort, "short"},
        {TmodSigned, "signed"},
        {TmodUnsigned, "unsigned"},
        {TmodShortSigned, "short signed"},
        {TmodShortUnsigned, "short unsigned"},
        {TmodLongSigned, "long signed"},
        {TmodLongUnsigned, "long unsigned"},
        {TypeElipsis, "elipsis"},
        {TypeByte, "byte"},
        {TypeShort, "short"},
        {TypeLong, "long"},
        {TypeBoolean, "boolean"},
        {TypeNull, "null"},
        {TypeOverloadedFunction, "OverloadedFunction"},
        {TypeWchar_t, "wchar_t"},
        {TypeLabel, "label"},
        {TypeKeyword, "keyword"},
        {TypeToken, "token"},
        {TypeMacro, "macro"},
        {TypeMacroArg, "macro argument"},
        {TypeUndefMacro, "Undefined Macro"},
        {TypePackage, "package"},
        {TypeYaccSymbol, "yacc symbol"},
        {TypeCppCollate, "Cpp##sym"},
        {TypeSpecialComplet, "(Completion Wizard)"},
        {TypeInheritedFullMethod, "(Override Wizard)"},
        {TypeNonImportedClass, "fully qualified name"},
        {-1,NULL}
};
int s_preCrTypesIniTab[] = {
        TypeDefault,
        TypeChar ,
        TypeUnsignedChar ,
        TypeSignedChar ,
        TypeInt ,
        TypeUnsignedInt ,
        TypeSignedInt ,
        TypeShortInt ,
        TypeShortUnsignedInt ,
        TypeShortSignedInt ,
        TypeLongInt ,
        TypeLongUnsignedInt ,
        TypeLongSignedInt ,
        TypeFloat ,
        TypeDouble ,
        TypeVoid ,
        TypeError ,
        TypeAnonymeField ,
        TmodLong,
        TmodShort,
        TmodSigned,
        TmodUnsigned,
        TmodShortSigned,
        TmodShortUnsigned,
        TmodLongSigned,
        TmodLongUnsigned,
        TypeByte,
        TypeShort,
        TypeLong,
        TypeBoolean,
        TypeNull,
        TypeWchar_t,
        -1,
};
