
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
S_jslStat *s_jsl;
static void jslFillTypeSymbolItem( S_symbol *sd, S_symbolList *ss ,
                                                           char *name) {
        { (&sd->b)->record = 0; (&sd->b)->accessFlags = 0; (&sd->b)->javaSourceLoaded = 0; (&sd->b)->javaFileLoaded = 0; (&sd->b)->symType = TypeStruct; (&sd->b)->storage = StorageNone; (&sd->b)->npointers = 0;};
        { (sd)->name = name; (sd)->linkName = name; (sd)->pos = s_noPos; (sd)->b = sd->b; (sd)->u.type = NULL; (sd)->next = NULL;};
        { (ss)->d = sd; (ss)->next = NULL;};
}
S_symbol *jslTypeSpecifier2(S_typeModifiers *t) {
        S_symbol *r;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 33);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } r = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&r->b)->record = 0; (&r->b)->accessFlags = 0; (&r->b)->javaSourceLoaded = 0; (&r->b)->javaFileLoaded = 0; (&r->b)->symType = TypeDefault; (&r->b)->storage = StorageDefault; (&r->b)->npointers = 0;};
        { (r)->name = NULL; (r)->linkName = NULL; (r)->pos = s_noPos; (r)->b = r->b; (r)->u.type = t; (r)->next = NULL;};
        r->u.type = t;
        return(r);
}
S_typeModifiers *jslCrSimpleTypeMofifier(unsigned t) {
        S_typeModifiers *p;
        { if (!(t>=0 && t<MAX_TYPE)) internalCheckFail("t>=0 && t<MAX_TYPE", "jslsemact.c", 42);};
        if (s_preCrTypesTab[t] == NULL) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 44);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } p = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
                { (p)->m = t; { (&((&(p)->u)->f))->args = NULL; (&((&(p)->u)->f))->thisFunList = NULL;}; (p)->typedefin = NULL; (p)->next = NULL;};
        } else {
                p = s_preCrTypesTab[t];
        }
        { if (!(p->m == t)) internalCheckFail("p->m == t", "jslsemact.c", 50);};
        return(p);
}
S_symbol *jslTypeSpecifier1(unsigned t) {
        S_symbol *r;
        r = jslTypeSpecifier2(jslCrSimpleTypeMofifier(t));
        return(r);
}
S_typeModifiers *jslAppendComposedType(S_typeModifiers **d, unsigned t) {
        S_typeModifiers *p;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 62);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } p = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
        { (p)->m = t; { (&((&(p)->u)->f))->args = NULL; (&((&(p)->u)->f))->thisFunList = NULL;}; (p)->typedefin = NULL; (p)->next = NULL;};
        { if (((*d))==NULL) (*d) = p; else { register S_typeModifiers *tempnsl; tempnsl = (*d); while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = p; } };
        return(p);
}
S_typeModifiers *jslPrependComposedType(S_typeModifiers *d, unsigned t) {
        S_typeModifiers *p;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 70);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } p = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
        { (p)->m = t; { (&((&(p)->u)->f))->args = NULL; (&((&(p)->u)->f))->thisFunList = NULL;}; (p)->typedefin = NULL; (p)->next = d;};
        return(p);
}
void jslCompleteDeclarator(S_symbol *t, S_symbol *d) {
        { if (!(t && d)) internalCheckFail("t && d", "jslsemact.c", 76);};
        if (t == &s_errorSymbol || d == &s_errorSymbol
                || t->b.symType==TypeError || d->b.symType==TypeError) return;
        { if ((d->u.type)==NULL) d->u.type = t->u.type; else { register S_typeModifiers *tempnsl; tempnsl = d->u.type; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = t->u.type; } };
        d->b.storage = t->b.storage;
}
void jslRemoveNestedClass(void *ddv) {
        S_symbolList *dd;
        int check;
        dd = (S_symbolList *) ddv;
        { if (s_opt.debug) {fprintf(dumpOut,"removing class %s from jsltab\n",dd->d->name);fflush(dumpOut);}};
        { if (!(s_jsl!=NULL)) internalCheckFail("s_jsl!=NULL", "jslsemact.c", 88);};
        check = jslTypeTabDeleteExact(s_jsl->typeTab, dd);
        { if (!(check)) internalCheckFail("check", "jslsemact.c", 90);};
}
S_symbol *jslTypeSymbolDefinition(char *ttt2, S_idIdentList *packid,
                                                                  int add, int order) {
        char fqtName[MAX_FILE_NAME_SIZE];
        S_idIdentList dd2;
        int ii, res;
        S_symbol sd, *smemb;
        S_symbolList ss, *xss, *memb;
        jslFillTypeSymbolItem( &sd, &ss, ttt2);
        { (&dd2)->idi.name = ttt2; (&dd2)->idi.sd = NULL; (&dd2)->idi.p.file = -1; (&dd2)->idi.p.line = 0; (&dd2)->idi.p.coll = 0; (&dd2)->fname = ttt2; (&dd2)->nameType = TypeStruct; (&dd2)->next = packid;};
        javaCreateComposedName(NULL,&dd2,NULL,fqtName,MAX_FILE_NAME_SIZE);
        smemb = javaFQTypeSymbolDefinition(ttt2, fqtName);
        if (add==TYPE_ADD_YES) {
                {xss = (S_symbolList*) stackMemoryAlloc(sizeof(S_symbolList)); };
                { (xss)->d = smemb; (xss)->next = NULL;};
                jslTypeTabIsMember(s_jsl->typeTab, xss, &ii, &memb);
                if (order == ORDER_PREPEND) {
                        { if (s_opt.debug) {fprintf(dumpOut,"[jsl] prepending class %s to jsltab\n",smemb->name);fflush(dumpOut);}};
                        jslTypeTabSet(s_jsl->typeTab, xss, ii);
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"[jsl] appending class %s to jsltab\n",smemb->name);fflush(dumpOut);}};
                        jslTypeTabSetLast(s_jsl->typeTab, xss, ii);
                }
                addToTrail(jslRemoveNestedClass, xss);
        }
        return(smemb);
}
S_symbol *jslTypeSymbolUsage(char *ttt2, S_idIdentList *packid) {
        char fqtName[MAX_FILE_NAME_SIZE];
        S_idIdentList dd2;
        int ii, res;
        S_symbol sd, *smemb;
        S_symbolList ss, *xss, *memb;
        jslFillTypeSymbolItem( &sd, &ss, ttt2);
        if (packid==NULL && jslTypeTabIsMember(s_jsl->typeTab, &ss, &ii, &memb)) {
                smemb = memb->d;
                return(smemb);
        }
        { (&dd2)->idi.name = ttt2; (&dd2)->idi.sd = NULL; (&dd2)->idi.p.file = -1; (&dd2)->idi.p.line = 0; (&dd2)->idi.p.coll = 0; (&dd2)->fname = ttt2; (&dd2)->nameType = TypeStruct; (&dd2)->next = packid;};
        javaCreateComposedName(NULL,&dd2,NULL,fqtName,MAX_FILE_NAME_SIZE);
        smemb = javaFQTypeSymbolDefinition(ttt2, fqtName);
        return(smemb);
}
S_symbol *jslTypeNameDefinition(S_idIdentList *tname) {
        S_symbol *memb;
        S_symbol *dd;
        S_typeModifiers *td;
        memb = jslTypeSymbolUsage(tname->idi.name, tname->next);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 144);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } td = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
        { (td)->m = TypeStruct; (&(td)->u)->t = memb;; (td)->typedefin = NULL; (td)->next = NULL;};
        td->u.t = memb;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 147);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } dd = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&dd->b)->record = 0; (&dd->b)->accessFlags = 0; (&dd->b)->javaSourceLoaded = 0; (&dd->b)->javaFileLoaded = 0; (&dd->b)->symType = TypeDefault; (&dd->b)->storage = StorageDefault; (&dd->b)->npointers = 0;};
        { (dd)->name = memb->name; (dd)->linkName = memb->linkName; (dd)->pos = tname->idi.p; (dd)->b = dd->b; (dd)->u.type = td; (dd)->next = NULL;};
        dd->u.type = td;
        return(dd);
}
static int jslClassifySingleAmbigNameToTypeOrPack(S_idIdentList *name,
                                                                                        S_symbol **str
        ){
        S_symbol sd;
        S_symbolList ss, *memb, *nextmemb;
        int ii, haveit;
        jslFillTypeSymbolItem( &sd, &ss, name->idi.name);
        if (jslTypeTabIsMember(s_jsl->typeTab, &ss, &ii, &memb)) {
                { if (!(memb)) internalCheckFail("memb", "jslsemact.c", 165);};
                for(; memb!=NULL; memb=nextmemb) {
                        nextmemb = memb;
                        jslTypeTabNextMember(&ss, &nextmemb);
                        haveit = 1;
                        if (nextmemb!=NULL) {
                                javaLoadClassSymbolsFromFile(memb->d);
                                haveit = javaOuterClassAccessible(memb->d);
                        }
                        if (haveit) {
                                *str = memb->d;
                                name->nameType = TypeStruct;
                                name->fname = memb->d->linkName;
                                return(TypeStruct);
                        }
                }
        }
        name->nameType = TypePackage;
        return(TypePackage);
}
int jslClassifyAmbiguousTypeName(S_idIdentList *name, S_symbol **str) {
        int pres;
        S_symbol *pstr;
        { if (!(name)) internalCheckFail("name", "jslsemact.c", 193);};
        *str = &s_errorSymbol;
        if (name->next == NULL) {
                jslClassifySingleAmbigNameToTypeOrPack( name, str);
        } else {
                pres = jslClassifyAmbiguousTypeName(name->next, &pstr);
                switch (pres) {
                case TypePackage:
                        if (javaTypeFileExist(name)) {
                                name->nameType = TypeStruct;
                                *str = jslTypeSymbolUsage(name->idi.name, name->next);
                        } else {
                                name->nameType = TypePackage;
                        }
                        break;
                case TypeStruct:
                        name->nameType = TypeStruct;
                        *str = jslTypeSymbolUsage(name->idi.name, name->next);
                        break;
                default: { if (!(0)) internalCheckFail("0", "jslsemact.c", 214);};
                }
        }
        return(name->nameType);
}
S_symbol *jslPrependDirectEnclosingInstanceArgument(S_symbol *args) {
        warning(ERR_ST,"[jslPrependDirectEnclosingInstanceArgument] not yet implemented");
        return(args);
}
S_symbol *jslMethodHeader(unsigned modif, S_symbol *type,
                                                  S_symbol *decl, int storage) {
        int newFun,vClass;
        completeDeclarator(type,decl);
        decl->b.accessFlags = modif;
        { if (!(s_jsl && s_jsl->classStat && s_jsl->classStat->thisClass)) internalCheckFail("s_jsl && s_jsl->classStat && s_jsl->classStat->thisClass", "jslsemact.c", 230);};
        if (s_jsl->classStat->thisClass->b.accessFlags & 0x200) {
                decl->b.accessFlags |= (0x001 | 0x400);
        }
        decl->b.storage = storage;
        newFun = javaSetFunctionLinkName(s_jsl->classStat->thisClass, decl, MEM_CF);
        if (decl->pos.file != s_olOriginalFileNumber && s_opt.cxrefs == OLO_PUSH) {
                addMethodCxReferences(modif, decl, s_jsl->classStat->thisClass);
        }
        if (newFun) {
                { if (s_opt.debug) { fprintf(dumpOut,"[jsl] adding method %s==%s to %s (at %x)\n",decl->name,decl->linkName,s_jsl->classStat->thisClass->linkName); fflush(dumpOut); }};
                { if ((s_jsl->classStat->thisClass->u.s->records)==NULL) s_jsl->classStat->thisClass->u.s->records = decl; else { register S_symbol *tempnsl; tempnsl = s_jsl->classStat->thisClass->u.s->records; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = decl; } };
        }
        decl->u.type->u.sig = strchr(decl->linkName, '(');
        return(decl);
}
void jslAddMapedImportTypeName(
                                                        char *file,
                                                        char *path,
                                                        char *pack,
                                                        S_completions *c,
                                                        void *vdirid,
                                                        int *storage
                                                ) {
        char *p,*suff;
        char ttt2[MAX_FILE_NAME_SIZE];
        int ii, len2, res;
        S_idIdentList *packid;
        packid = (S_idIdentList *) vdirid;
        for(p=file; *p && *p!='.' && *p!='$'; p++) ;
        if (*p != '.') return;
        if (strcmp(p,".class")!=0 && strcmp(p,".java")!=0) return;
        len2 = p - file;
        strncpy(ttt2, file, len2);
        { if (!(len2+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("len2+1 < MAX_FILE_NAME_SIZE", "jslsemact.c", 270);};
        ttt2[len2] = 0;
        jslTypeSymbolDefinition(ttt2, packid,TYPE_ADD_YES, ORDER_APPEND);
}
void jslAddToLoadWaitList( S_symbol *clas ) {
        S_symbolList *ll;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jslsemact.c", 277);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbolList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ll = (S_symbolList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbolList);};};};
        { (ll)->d = clas; (ll)->next = s_jsl->waitList;};
        s_jsl->waitList = ll;
}
void jslAddSuperClassOrInterface(S_symbol *memb,S_symbol *supp){
        int origin;
        S_symbolList *ll;
        { if (s_opt.debug) {fprintf(dumpOut,"loading super/interf %s of %s\n",supp->linkName,memb->linkName);fflush(dumpOut);}};
        javaLoadClassSymbolsFromFile(supp);
        origin = memb->u.s->classFile;
        addSuperClassOrInterface( memb, supp, origin);
}
void jslAddSuperClassOrInterfaceByName(S_symbol *memb,char *super){
        S_symbol *supp;
        supp = javaGetFieldClass(super,NULL);
        jslAddSuperClassOrInterface( memb, supp);
}
static void jslAddNestedClass(S_symbol *inner, S_symbol *outer, int memb,
                                           int accessFlags) {
        int i,n;
        { if (!(outer && outer->b.symType==TypeStruct && outer->u.s)) internalCheckFail("outer && outer->b.symType==TypeStruct && outer->u.s", "jslsemact.c", 302);};
        n = outer->u.s->nnested;
        { if (s_opt.debug) { fprintf(dumpOut,"adding nested %s of %s(at %d)[%d] --> %s to %s\n",inner->name,outer->name,outer,n,inner->linkName,outer->linkName); fflush(dumpOut); }};
        if (n == 0) {
                {{ { if (!((MAX_INNERS_CLASSES) >= 0)) internalCheckFail("(MAX_INNERS_CLASSES) >= 0", "jslsemact.c", 306);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(MAX_INNERS_CLASSES)*sizeof(S_nestedSpec) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } outer->u.s->nest = (S_nestedSpec*) (ppmMemory + ppmMemoryi); ppmMemoryi += (MAX_INNERS_CLASSES)*sizeof(S_nestedSpec);};};
        }
        { (&(outer->u.s->nest[n]))->cl = inner; (&(outer->u.s->nest[n]))->membFlag = memb; (&(outer->u.s->nest[n]))->accFlags = accessFlags;};
        outer->u.s->nnested ++;
        if (outer->u.s->nnested >= MAX_INNERS_CLASSES) {
                fatalError(ERR_ST,"number of nested classes overflowed over MAX_INNERS_CLASSES", 65);
        }
}
int jslRecordAccessible(S_symbol *cl, S_symbol *rec, unsigned recAccessFlags) {
        S_jslClassStat *cs, *lcs;
        S_symStructSpecific *nest;
        int i,in,len;
        if (cl == NULL) return(1);
        { if (!(s_jsl && s_jsl->classStat)) internalCheckFail("s_jsl && s_jsl->classStat", "jslsemact.c", 334);};
        if (recAccessFlags & 0x001) {
                return(1);
        }
        if (recAccessFlags & 0x004) {
                if (cl->u.s->currPackage) {
                        return(1);
                }
                for (cs=s_jsl->classStat; cs!=NULL && cs->thisClass!=NULL; cs=cs->next) {
                        if (cs->thisClass == cl) {
                                return(1);
                        }
                        if (cctIsMember(&cs->thisClass->u.s->casts, cl, 1)) {
                                return(1);
                        }
                }
                return(0);
        }
        if (recAccessFlags & 0x002) {
                for(lcs=cs=s_jsl->classStat; cs!=NULL && cs->thisClass!=NULL; cs=cs->next) {
                        lcs = cs;
                }
                if (lcs!=NULL && lcs->thisClass!=NULL) {
                        len = strlen(lcs->thisClass->linkName);
                        if (strncmp(lcs->thisClass->linkName, cl->linkName, len)==0) {
                                return(1);
                        }
                }
                return(0);
        }
        if (cl->u.s->currPackage) {
                return(1);
        }
        return(0);
}
void jslAddNestedClassesToJslTypeTab( S_symbol *str, int order) {
        S_symStructSpecific *ss;
        S_idIdent ocid;
        S_idIdentList oclassid;
        int i;
        { if (!(str && str->b.symType==TypeStruct)) internalCheckFail("str && str->b.symType==TypeStruct", "jslsemact.c", 397);};
        ss = str->u.s;
        { if (!(ss)) internalCheckFail("ss", "jslsemact.c", 399);};
        for(i=0; i<ss->nnested; i++) {
                if (ss->nest[i].membFlag && jslRecordAccessible(str, ss->nest[i].cl, ss->nest[i].accFlags)) {
                        { (&ocid)->name = str->linkName; (&ocid)->sd = NULL; (&ocid)->p = s_noPos;};
                        { (&oclassid)->idi = ocid; (&oclassid)->fname = str->linkName; (&oclassid)->nameType = TypeStruct; (&oclassid)->next = NULL;};
                        jslTypeSymbolDefinition(ss->nest[i].cl->name, &oclassid,
                                                                        TYPE_ADD_YES, order);
                }
        }
}
void jslAddSuperNestedClassesToJslTypeTab( S_symbol *cc) {
        S_symbolList *ss;
        for(ss=cc->u.s->super; ss!=NULL; ss=ss->next) {
                jslAddSuperNestedClassesToJslTypeTab(ss->d);
        }
        jslAddNestedClassesToJslTypeTab(cc, ORDER_PREPEND);
}
void jslNewClassDefinitionBegin(S_idIdent *name,
                                                                int accFlags,
                                                                S_symbol *anonInterf,
                                                                int position
        ) {
        char ttt[TMP_STRING_SIZE];
        char tttn[TMP_STRING_SIZE];
        char *annord;
        S_jslClassStat *nss;
        S_idIdent *inname, *ann;
        S_idIdentList *ill, *all, inn, mntmp;
        S_symbol *cc;
        S_symStructSpecific *ss;
        int i,n, fileInd, membflag,cn;
        inname = name;
        if (position==CPOS_FUNCTION_INNER || anonInterf!=NULL) {
                if (position==CPOS_FUNCTION_INNER) {
                        s_jsl->classStat->functionInnerCounter++;
                        sprintf(tttn, "%d", s_jsl->classStat->functionInnerCounter);
                        sprintf(ttt, "%s", inname->name);
                        { (&mntmp)->idi.name = tttn; (&mntmp)->idi.sd = NULL; (&mntmp)->idi.p.file = s_noPos.file; (&mntmp)->idi.p.line = s_noPos.line; (&mntmp)->idi.p.coll = s_noPos.coll; (&mntmp)->fname = tttn; (&mntmp)->nameType = TypeStruct; (&mntmp)->next = s_jsl->classStat->className;};
                        cc = jslTypeSymbolDefinition(ttt, &mntmp,
                                                                                 TYPE_ADD_YES, ORDER_PREPEND);
                } else {
                        s_jsl->classStat->annonInnerCounter++;
                        sprintf(ttt, "%d$%s", s_jsl->classStat->annonInnerCounter,
                                        inname->name);
                        cc = jslTypeSymbolDefinition(ttt,s_jsl->classStat->className,
                                                                                 TYPE_ADD_NO,ORDER_PREPEND);
                }
        } else {
                sprintf(ttt, "%s", inname->name);
                cc = jslTypeSymbolDefinition(ttt,s_jsl->classStat->className,
                                                                         TYPE_ADD_NO,ORDER_PREPEND);
        }
        cc->b.accessFlags = accFlags;
        if (s_jsl->classStat->next != NULL) {
                { if (!(s_jsl->classStat->thisClass)) internalCheckFail("s_jsl->classStat->thisClass", "jslsemact.c", 474);};
                if (s_jsl->classStat->thisClass->b.accessFlags & 0x200) {
                        accFlags |= (0x001 | 0x008);
                        cc->b.accessFlags = accFlags;
                }
                membflag = (anonInterf==NULL && position!=CPOS_FUNCTION_INNER);
                if (s_jsl->pass==1) {
                        jslAddNestedClass(cc, s_jsl->classStat->thisClass, membflag, accFlags);
                        cn = cc->u.s->classFile;
                        { if (!(s_fileTab.tab[cn])) internalCheckFail("s_fileTab.tab[cn]", "jslsemact.c", 483);};
                        if (! (accFlags & 0x008)) {
                                { if (!(s_jsl->classStat->thisClass && s_jsl->classStat->thisClass->u.s)) internalCheckFail("s_jsl->classStat->thisClass && s_jsl->classStat->thisClass->u.s", "jslsemact.c", 488);};
                                { if (!(s_jsl->classStat->thisClass->b.symType==TypeStruct)) internalCheckFail("s_jsl->classStat->thisClass->b.symType==TypeStruct", "jslsemact.c", 489);};
                                s_fileTab.tab[cn]->directEnclosingInstance
                                        = s_jsl->classStat->thisClass->u.s->classFile;
                        } else {
                                s_fileTab.tab[cn]->directEnclosingInstance = s_noneFileIndex;
                        }
                }
        }
        if (s_jsl->classStat->next==NULL && s_jsl->pass==1) {
                jslTypeSymbolDefinition(cc->name,s_jsl->classStat->className,
                                                                TYPE_ADD_YES, ORDER_PREPEND);
        }
        { if (!(cc && cc->u.s && s_fileTab.tab[cc->u.s->classFile])) internalCheckFail("cc && cc->u.s && s_fileTab.tab[cc->u.s->classFile]", "jslsemact.c", 506);};
        { if (!(s_jsl->sourceFileNumber>=0 && s_jsl->sourceFileNumber!=s_noneFileIndex)) internalCheckFail("s_jsl->sourceFileNumber>=0 && s_jsl->sourceFileNumber!=s_noneFileIndex", "jslsemact.c", 507);};
        { if (!(s_fileTab.tab[s_jsl->sourceFileNumber])) internalCheckFail("s_fileTab.tab[s_jsl->sourceFileNumber]", "jslsemact.c", 508);};
        fileInd = cc->u.s->classFile;
        s_fileTab.tab[fileInd]->b.sourceFile = s_jsl->sourceFileNumber;
        if (accFlags & 0x200) s_fileTab.tab[fileInd]->b.isInterface=1;
        addClassTreeHierarchyReference(fileInd,&inname->p,UsageClassTreeDefinition);
        if (inname->p.file != s_olOriginalFileNumber && s_opt.cxrefs == OLO_PUSH) {
                addCxReference(cc, &inname->p, UsageDefined,s_noneFileIndex, s_noneFileIndex);
        }
        if (s_jsl->pass==1) cc->u.s->nnested = 0;
        stackMemoryBlockStart();
        {ill = (S_idIdentList*) stackMemoryAlloc(sizeof(S_idIdentList)); };
        { (ill)->idi.name = cc->name; (ill)->idi.sd = inname->sd; (ill)->idi.p.file = inname->p.file; (ill)->idi.p.line = inname->p.line; (ill)->idi.p.coll = inname->p.coll; (ill)->fname = cc->name; (ill)->nameType = TypeStruct; (ill)->next = s_jsl->classStat->className;};
        {nss = (S_jslClassStat*) stackMemoryAlloc(sizeof(S_jslClassStat)); };
        { (nss)->className = ill; (nss)->thisClass = cc; (nss)->annonInnerCounter = 0; (nss)->functionInnerCounter = 0; (nss)->next = s_jsl->classStat;};
        s_jsl->classStat = nss;
        javaCreateClassFileItem(cc);
        cc->b.javaFileLoaded = 1;
        cc->b.javaSourceLoaded = 1;
        if (anonInterf!=NULL && s_jsl->pass==2) {
                if (anonInterf->b.accessFlags&0x200) {
                        jslAddSuperClassOrInterfaceByName(cc, s_javaLangObjectLinkName);
                }
                jslAddSuperClassOrInterfaceByName(cc, anonInterf->linkName);
        }
        if (s_jsl->pass==2) {
                jslAddToLoadWaitList(cc);
                jslAddSuperNestedClassesToJslTypeTab(cc);
        }
}
void jslNewClassDefinitionEnd() {
        S_symbol *cc;
        int fileInd;
        { if (!(s_jsl->classStat && s_jsl->classStat->next)) internalCheckFail("s_jsl->classStat && s_jsl->classStat->next", "jslsemact.c", 557);};
        cc = s_jsl->classStat->thisClass;
        fileInd = cc->u.s->classFile;
        if (s_fileTab.tab[fileInd]->b.cxLoading) {
                s_fileTab.tab[fileInd]->b.cxLoaded = 1;
        }
        s_jsl->classStat = s_jsl->classStat->next;
        stackMemoryBlockFree();
}
void jslNewAnonClassDefinitionBegin(S_idIdent *interfName) {
        S_idIdentList ll;
        S_symbol *interf,*str;
        { (&ll)->idi = *interfName; (&ll)->fname = interfName->name; (&ll)->nameType = TypeDefault; (&ll)->next = NULL;};
        jslClassifyAmbiguousTypeName(&ll, &str);
        interf = jslTypeNameDefinition(&ll);
        jslNewClassDefinitionBegin(&s_javaAnonymousClassName, 0x000,
                                                                  interf, CPOS_ST);
}
