
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
#if XREF_HUGE
#define PutLexFilePos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexFilePos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#ifdef XREF_HUGE
#define PutLexNumPos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexNumPos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#if XREF_HUGE
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#ifdef XREF_HUGE
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#if XREF_HUGE
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
#ifdef XREF_HUGE
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
static int charBuffReadFromFile(struct charBuf *bb, char *outBuffer, int max_size) {
        int n;
        if (bb->ff == NULL) n = 0;
        else n = fread(outBuffer, 1, max_size, bb->ff);
        return(n);
}
void charBuffClose(struct charBuf *bb) {
        fclose(bb->ff);
#if defined(USE_LIBZ)
        if (bb->inputMethod == INPUT_VIA_UNZIP) {
                inflateEnd(&bb->zipStream);
        }
#endif
}
voidpf zlibAlloc(voidpf opaque, uInt items, uInt size) {
        return(calloc(items, size));
}
void zlibFree(voidpf opaque, voidpf address) {
        free(address);
}
static int charBuffReadFromUnzipFilter(struct charBuf *bb, char *outBuffer, int max_size) {
        int n, fn, res, iii;
        bb->zipStream.next_out = outBuffer;
        bb->zipStream.avail_out = max_size;
#if defined(USE_LIBZ)
        do {
                if (bb->zipStream.avail_in == 0) {
                        fn = charBuffReadFromFile(bb, bb->z, CHAR_BUFF_SIZE);
                        bb->zipStream.next_in = bb->z;
                        bb->zipStream.avail_in = fn;
                }
                res = Z_DATA_ERROR;
                res = inflate(&bb->zipStream, Z_SYNC_FLUSH);
                if (res==Z_OK) {
                } else if (res==Z_STREAM_END) {
                } else {
                        sprintf(tmpBuff, "something is going wrong while reading zipped .jar archiv, res == %d", res);
                        error(ERR_ST, tmpBuff);
                        bb->zipStream.next_out = outBuffer;
                }
        } while (((char*)bb->zipStream.next_out)==outBuffer && res==Z_OK);
#endif
        n = ((char*)bb->zipStream.next_out) - outBuffer;
        return(n);
}
int getCharBuf(struct charBuf *bb) {
        char *dd;
        char *cc;
        char *fin;
        int n,c;
        int max_size;
        fin = bb->fin;
        cc = bb->cc;
        for(dd=bb->a+MAX_UNGET_CHARS; cc<fin; cc++,dd++) *dd = *cc;
        max_size = CHAR_BUFF_SIZE - (dd - bb->a);
        if (bb->inputMethod == INPUT_DIRECT) {
                n = charBuffReadFromFile(bb, dd, max_size);
        } else {
                n = charBuffReadFromUnzipFilter(bb, dd, max_size);
        }
        bb->filePos += n;
        bb->fin = dd+n;
        bb->cc = bb->a+MAX_UNGET_CHARS;
        return(bb->cc != bb->fin);
}
void switchToZippedCharBuff(struct charBuf *bb) {
        char *dd;
        char *cc;
        char *fin;
        int n,c;
        int max_size;
        getCharBuf(bb);
#if defined(USE_LIBZ)
        fin = bb->fin;
        cc = bb->cc;
        for(dd=bb->z; cc<fin; cc++,dd++) *dd = *cc;
        { (&bb->zipStream)->next_in = bb->z; (&bb->zipStream)->avail_in = dd-bb->z; (&bb->zipStream)->total_in = 0; (&bb->zipStream)->next_out = bb->a; (&bb->zipStream)->avail_out = CHAR_BUFF_SIZE; (&bb->zipStream)->total_out = 0; (&bb->zipStream)->msg = NULL; (&bb->zipStream)->state = NULL; (&bb->zipStream)->zalloc = zlibAlloc; (&bb->zipStream)->zfree = zlibFree; (&bb->zipStream)->opaque = NULL; (&bb->zipStream)->data_type = 0; (&bb->zipStream)->adler = 0; (&bb->zipStream)->reserved = 0;};
        bb->cc = bb->fin = bb->a;
        bb->inputMethod = INPUT_VIA_UNZIP;
        inflateInit2(&(bb->zipStream), -MAX_WBITS);
        if (bb->zipStream.msg!=NULL) {
                fprintf(stderr,"initialization: %s\n", bb->zipStream.msg);
                exit(1);
        }
#endif
}
int skipNCharsInCharBuf(struct charBuf *bb, unsigned count) {
        char *dd;
        char *cc;
        char *fin;
        int n,c;
        int max_size;
        fin = bb->fin;
        cc = bb->cc;
        if (cc+count < fin) {
                bb->cc = cc+count;
                return(1);
        }
        if (bb->inputMethod == INPUT_VIA_UNZIP) {
                count -= fin-cc;
                bb->cc = bb->fin;
                getCharBuf(bb);
                if (bb->fin != bb->cc) {
                        skipNCharsInCharBuf(bb, count);
                }
        } else {
                count -= fin-cc;
                fseek(bb->ff, count, SEEK_CUR);
                bb->filePos += count;
                dd=bb->a+MAX_UNGET_CHARS;
                max_size = CHAR_BUFF_SIZE-(dd - bb->a);
                if (bb->ff == NULL) n = 0;
                else n = fread(dd, 1, max_size, bb->ff);
                bb->filePos += n;
                bb->fin = dd+n;
                bb->cc = bb->a+MAX_UNGET_CHARS;
        }
        return(bb->cc != bb->fin);
}
static void dumpCharBuf(struct charBuf *bb) {
        char *cc;
        for (cc = bb->cc; cc<bb->fin; cc++) putchar(*cc);
}
void gotOnLineCxRefs( S_position *ps ) {
        if (creatingOlcxRefs()) {
                s_cache.activeCache = 0;
                s_cxRefPos = *ps;
        }
}
int getLexBuf(struct lexBuf *lb) {
        register int ch;
        struct charBuf *cb;
        register char *ccc, *cfin;
        register char *cc, *dd, *lmax, *lexStartDd;
        unsigned chval=0;
        int rlex;
        int cline,clo;
        char *clb;
        char oldCh;
        int line,size,cfile,column;
        if (s_cache.activeCache && inStacki==0 && macStacki==0) {
                cacheInput();
                s_cache.lexcc = lb->a;
        }
        lmax = lb->a + LEX_BUFF_SIZE - MAX_LEXEM_SIZE;
        for(dd=lb->a,cc=lb->cc; cc<lb->fin; cc++,dd++) *dd = *cc;
        lb->cc = lb->a;
        cb = &lb->cb;
        cline = cb->lineNum; clb = cb->lineBegin; clo = cb->collumnOffset;
        ccc = cb->cc; cfin = cb->fin; cfile = cb->fileNumber;
        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
contin:
        { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
        if (dd >= lmax) {
                {*--ccc = ch; };
                goto finish;
        }
        { int pi = lb->posi % LEX_POSITIONS_RING_SIZE; lb->fpRing[pi] = (cb->filePos - (cfin-ccc) - 1); lb->pRing[pi].file = cfile; lb->pRing[pi].line = cline; lb->pRing[pi].coll = (ccc-clb+clo-1); lb->posi ++;};
        lexStartDd = dd;
        if (ch == '_' || isalpha(ch) || (ch=='$' && (((s_language & (8)) != 0)||((s_language & (4)) != 0)))) {
                { int idcoll; char *ddd; ddd = dd; idcoll = (ccc-clb+clo-1); { *(dd)++ = ((unsigned)(437))%256; *(dd)++ = ((unsigned)(437))/256;}; do { {*(dd)++ = ch;}; identContlab2: { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } while (isalpha(ch) || isdigit(ch) || ch=='_' || (ch=='$' && (((s_language & (8)) != 0)||((s_language & (4)) != 0)))); if (ch == '@' && *(dd-1)=='C') { int i,len; len = strlen(s_editCommunicationString); {}; for (i=2;i<len;i++) { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch != s_editCommunicationString[i]) break; } if (i>=len) { dd --; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch == 'c') { { *(ddd)++ = ((unsigned)(442))%256; *(ddd)++ = ((unsigned)(442))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } else if (ch == 'x') { s_cache.activeCache = 0; { (&s_cxRefPos)->file = cfile; (&s_cxRefPos)->line = cline; (&s_cxRefPos)->coll = idcoll;}; goto identContlab2; } else error(ERR_INTERNAL,"unknown communication char"); } else { for(i--;i>=1;i--) { {*--ccc = ch; }; ch = s_editCommunicationString[i]; } } } {*(dd)++ = 0;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(idcoll,dd); };identEndlab2:;};
                goto nextLexem;
        } else if (isdigit(ch)) {
                register long unsigned val=0;
                if (ch=='0') {
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch=='x' || ch=='X') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                while (isdigit(ch)||(ch>='a'&&ch<='f')||(ch>='A'&&ch<='F')) {
                                        if (ch>='a') val = val*16+ch-'a'+10;
                                        else if (ch>='A') val = val*16+ch-'A'+10;
                                        else val = val*16+ch-'0';
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                }
                        } else {
                                while (isdigit(ch) && ch<='8') {
                                        val = val*8+ch-'0';
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                }
                        }
                } else {
                        while (isdigit(ch)) {
                                val = val*10+ch-'0';
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        }
                }
                if (ch == '.' || ch=='e' || ch=='E' || ch=='f' || ch=='F'
                        || ((ch=='d' || ch=='D') && ((s_language & (4)) != 0))) {
                        { rlex = 426; if (ch == '.') { do { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } while (isdigit(ch)); } if (ch == 'e' || ch == 'E') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch == '+' || ch=='-') { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; while (isdigit(ch)) { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } if (((s_language & (4)) != 0)) { if (ch == 'f' || ch == 'F' || ch == 'd' || ch == 'D') { if (ch == 'f' || ch == 'F') rlex = 425; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } } else { if (ch == 'f' || ch == 'F' || ch == 'l' || ch == 'L') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } }};
                        { *(dd)++ = ((unsigned)(rlex))%256; *(dd)++ = ((unsigned)(rlex))/256;};
                        goto nextLexem;
                }
                { rlex = 438; if (((s_language & (4)) != 0)) { if (ch=='l' || ch=='L') { rlex = 439; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } } else { for(; ch=='l'||ch=='L'||ch=='u'||ch=='U'; ){ if (ch=='l' || ch=='L') rlex = 439; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } }};
                { *(dd)++ = ((unsigned)(rlex))%256; *(dd)++ = ((unsigned)(rlex))/256;};
                { unsigned tmp; tmp = val; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;};
                goto nextLexem;
        } else switch (ch) {
                case '.':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '.' && ((s_language & (2|8|16)) != 0)) {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch == '.') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        { *(dd)++ = ((unsigned)(283))%256; *(dd)++ = ((unsigned)(283))/256;};
                                        goto nextLexem;
                                } else {
                                        {*--ccc = ch; };
                                        ch = '.';
                                }
                                { *(dd)++ = ((unsigned)('.'))%256; *(dd)++ = ((unsigned)('.'))/256;};
                                goto nextLexem;
                        } else if (ch=='*' && ((s_language & (16)) != 0)) {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                { *(dd)++ = ((unsigned)(289))%256; *(dd)++ = ((unsigned)(289))/256;};
                                goto nextLexem;
                        } else if (isdigit(ch)) {
                                {*--ccc = ch; };
                                ch = '.';
                                { rlex = 426; if (ch == '.') { do { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } while (isdigit(ch)); } if (ch == 'e' || ch == 'E') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch == '+' || ch=='-') { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; while (isdigit(ch)) { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } if (((s_language & (4)) != 0)) { if (ch == 'f' || ch == 'F' || ch == 'd' || ch == 'D') { if (ch == 'f' || ch == 'F') rlex = 425; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } } else { if (ch == 'f' || ch == 'F' || ch == 'l' || ch == 'L') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } }};
                                { *(dd)++ = ((unsigned)(rlex))%256; *(dd)++ = ((unsigned)(rlex))/256;};
                                goto nextLexem;
                        } else {
                                { *(dd)++ = ((unsigned)('.'))%256; *(dd)++ = ((unsigned)('.'))/256;};
                                goto nextLexem;
                        }
                case '-':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch=='=') {
                                { *(dd)++ = ((unsigned)(276))%256; *(dd)++ = ((unsigned)(276))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                goto nextLexem;
                        } else if (ch=='-') {{ *(dd)++ = ((unsigned)(263))%256; *(dd)++ = ((unsigned)(263))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                        else if (ch=='>' && ((s_language & (2|8|16)) != 0)) {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch=='*' && ((s_language & (16)) != 0)) {{ *(dd)++ = ((unsigned)(290))%256; *(dd)++ = ((unsigned)(290))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                                else {{ *(dd)++ = ((unsigned)(282))%256; *(dd)++ = ((unsigned)(282))/256;}; goto nextLexem;}
                        } else {{ *(dd)++ = ((unsigned)('-'))%256; *(dd)++ = ((unsigned)('-'))/256;}; goto nextLexem;}
                case '+':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '=') { { *(dd)++ = ((unsigned)(275))%256; *(dd)++ = ((unsigned)(275))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                        else if (ch == '+') { { *(dd)++ = ((unsigned)(262))%256; *(dd)++ = ((unsigned)(262))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('+'))%256; *(dd)++ = ((unsigned)('+'))/256;}; goto nextLexem;}
                case '>':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '>') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if(ch=='>' && ((s_language & (4)) != 0)){
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        if(ch=='='){{ *(dd)++ = ((unsigned)(285))%256; *(dd)++ = ((unsigned)(285))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                                        else {{ *(dd)++ = ((unsigned)(284))%256; *(dd)++ = ((unsigned)(284))/256;}; goto nextLexem;}
                                } else if(ch=='='){{ *(dd)++ = ((unsigned)(278))%256; *(dd)++ = ((unsigned)(278))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                                else {{ *(dd)++ = ((unsigned)(265))%256; *(dd)++ = ((unsigned)(265))/256;}; goto nextLexem;}
                        } else if (ch == '='){{ *(dd)++ = ((unsigned)(267))%256; *(dd)++ = ((unsigned)(267))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                        else {{ *(dd)++ = ((unsigned)('>'))%256; *(dd)++ = ((unsigned)('>'))/256;}; goto nextLexem;}
                case '<':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '<') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if(ch=='='){{ *(dd)++ = ((unsigned)(277))%256; *(dd)++ = ((unsigned)(277))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                                else {{ *(dd)++ = ((unsigned)(264))%256; *(dd)++ = ((unsigned)(264))/256;}; goto nextLexem;}
                        } else if (ch == '='){{ *(dd)++ = ((unsigned)(266))%256; *(dd)++ = ((unsigned)(266))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem;}
                        else {{ *(dd)++ = ((unsigned)('<'))%256; *(dd)++ = ((unsigned)('<'))/256;}; goto nextLexem;}
                case '*':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(272))%256; *(dd)++ = ((unsigned)(272))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('*'))%256; *(dd)++ = ((unsigned)('*'))/256;}; goto nextLexem;}
                case '%':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(274))%256; *(dd)++ = ((unsigned)(274))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('%'))%256; *(dd)++ = ((unsigned)('%'))/256;}; goto nextLexem;}
                case '&':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(279))%256; *(dd)++ = ((unsigned)(279))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else if (ch == '&'){ { *(dd)++ = ((unsigned)(270))%256; *(dd)++ = ((unsigned)(270))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else if (ch == '*') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch == '/') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        { if (s_opt.taskRegime==RegimeHtmlGenerate) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1); { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); if (s_opt.htmlNoColors==0) { addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageUsed); } if (0) { pos.coll -= 2; addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageJavaDoc); } }};
                                        goto nextLexem;
                                } else {
                                        {*--ccc = ch; }; ch = '*';
                                        { *(dd)++ = ((unsigned)('&'))%256; *(dd)++ = ((unsigned)('&'))/256;}; goto nextLexem;
                                }}
                        else {{ *(dd)++ = ((unsigned)('&'))%256; *(dd)++ = ((unsigned)('&'))/256;}; goto nextLexem;}
                case '^':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(280))%256; *(dd)++ = ((unsigned)(280))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('^'))%256; *(dd)++ = ((unsigned)('^'))/256;}; goto nextLexem;}
                case '|':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(281))%256; *(dd)++ = ((unsigned)(281))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else if (ch == '|'){ { *(dd)++ = ((unsigned)(271))%256; *(dd)++ = ((unsigned)(271))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('|'))%256; *(dd)++ = ((unsigned)('|'))/256;}; goto nextLexem;}
                case '=':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(268))%256; *(dd)++ = ((unsigned)(268))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('='))%256; *(dd)++ = ((unsigned)('='))/256;}; goto nextLexem;}
                case '!':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(269))%256; *(dd)++ = ((unsigned)(269))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)('!'))%256; *(dd)++ = ((unsigned)('!'))/256;}; goto nextLexem;}
                case ':':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == ':' && ((s_language & (16)) != 0)){ { *(dd)++ = ((unsigned)(288))%256; *(dd)++ = ((unsigned)(288))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else {{ *(dd)++ = ((unsigned)(':'))%256; *(dd)++ = ((unsigned)(':'))/256;}; goto nextLexem;}
                case '\'':
                        chval = 0;
                        do {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                while (ch=='\\') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                }
                                if (ch != '\'') chval = chval * 256 + ch;
                        } while (ch != '\'' && ch != '\n');
                        if (ch=='\'') {
                                { *(dd)++ = ((unsigned)(445))%256; *(dd)++ = ((unsigned)(445))/256;};
                                { unsigned tmp; tmp = chval; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;};
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        }
                        goto nextLexem;
                case '\"':
                        line = cline; size = 0;
                        { *(dd)++ = ((unsigned)(440))%256; *(dd)++ = ((unsigned)(440))/256;};
                        do {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; size ++;
                                if (ch!='\"' && ch!='\n' && size<MAX_LEXEM_SIZE-10) {*(dd)++ = ch;};
                                if (ch=='\\') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; size ++;
                                        if (size < MAX_LEXEM_SIZE-10) {*(dd)++ = ch;};
                                        if (ch == '\n') {cline ++; clb = ccc; clo = 0;}
                                        ch = 0;
                                }
                                if (ch == '\n') {
                                        cline ++; clb = ccc; clo = 0;
                                        if (s_opt.strictAnsi && (s_opt.debug || s_opt.err)) {
                                                warning(ERR_ST,"string constant through end of line");
                                        }
                                }
                        } while (ch != '\"' && ch != '\n' && ch != -1);
                        if (ch == -1 && s_opt.taskRegime!=RegimeEditServer) {
                                warning(ERR_ST,"string constant through EOF");
                        }
                        {*(dd)++ = 0;};
                        { if (cline-line!=0) { { *(dd)++ = ((unsigned)(441))%256; *(dd)++ = ((unsigned)(441))/256;}; { *(dd)++ = ((unsigned)(cline-line))%256; *(dd)++ = ((unsigned)(cline-line))/256;}; }};
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        goto nextLexem;
                case '/':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '='){ { *(dd)++ = ((unsigned)(273))%256; *(dd)++ = ((unsigned)(273))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; goto nextLexem; }
                        else if (ch=='*') {
                          int javadoc=0;
                                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1) -1; { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageDefined); }};
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch == '&') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        goto nextLexem;
                                } else {
                                  if (ch=='*' && ((s_language & (4)) != 0)) javadoc = 1;
                                        {*--ccc = ch; }; ch = '*';
                                }
                                { line = cline; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch=='\n') {cline ++; clb = ccc; clo = 0;} do { oldCh = ch; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch=='\n') {cline ++; clb = ccc; clo = 0;} } while ((oldCh != '*' || ch != '/') && ch != -1); if (ch == -1) error(ERR_ST,"comment through eof"); { if (cline-line!=0) { { *(dd)++ = ((unsigned)(441))%256; *(dd)++ = ((unsigned)(441))/256;}; { *(dd)++ = ((unsigned)(cline-line))%256; *(dd)++ = ((unsigned)(cline-line))/256;}; }}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };};
                                { if (s_opt.taskRegime==RegimeHtmlGenerate) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1); { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); if (s_opt.htmlNoColors==0) { addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageUsed); } if (javadoc) { pos.coll -= 2; addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageJavaDoc); } }};
                                goto nextLexem;
                        } else if (ch=='/' && s_opt.cpp_comment) {
                                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1) -1; { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageDefined); }};
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch == '&') {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        { if (s_opt.taskRegime==RegimeHtmlGenerate) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1); { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); if (s_opt.htmlNoColors==0) { addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageUsed); } if (0) { pos.coll -= 2; addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageJavaDoc); } }};
                                        goto nextLexem;
                                }
                                line = cline;
                                while (ch!='\n' && ch != -1) {
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        if (ch == '\\') {
                                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                                if (ch=='\n') {cline ++; clb = ccc; clo = 0;}
                                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        }
                                }
                                { if (s_opt.taskRegime==RegimeHtmlGenerate) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1); { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); if (s_opt.htmlNoColors==0) { addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageUsed); } if (0) { pos.coll -= 2; addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageJavaDoc); } }};
                                { if (cline-line!=0) { { *(dd)++ = ((unsigned)(441))%256; *(dd)++ = ((unsigned)(441))/256;}; { *(dd)++ = ((unsigned)(cline-line))%256; *(dd)++ = ((unsigned)(cline-line))/256;}; }};
                                goto nextLexem;
                        } else {
                                { *(dd)++ = ((unsigned)('/'))%256; *(dd)++ = ((unsigned)('/'))/256;};
                                goto nextLexem;
                        }
                case '\\':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '\n') {
                                cline ++; clb = ccc; clo = 0;
                                { if (1!=0) { { *(dd)++ = ((unsigned)(441))%256; *(dd)++ = ((unsigned)(441))/256;}; { *(dd)++ = ((unsigned)(1))%256; *(dd)++ = ((unsigned)(1))/256;}; }};
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        } else {
                                { *(dd)++ = ((unsigned)('\\'))%256; *(dd)++ = ((unsigned)('\\'))/256;};
                        }
                        goto nextLexem;
                case '\n':
                        column = (ccc-clb+clo-1);
                        if (column >= MAX_REFERENCABLE_COLUMN) {
                                fatalError(ERR_ST, "position over MAX_REFERENCABLE_COLUMN, read TROUBLES in README file", 65);
                        }
                        if (cline >= MAX_REFERENCABLE_LINE) {
                                fatalError(ERR_ST, "position over MAX_REFERENCABLE_LINE, read TROUBLES in README file", 65);
                        }
                        cline ++; clb = ccc; clo = 0;
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                        if (ch == '/') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                if (ch == '*') {
                                        { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1) -1; { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageDefined); }};
                                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        if (ch == '&') {
                                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                        } else {
                                                int javadoc=0;
                                                if (ch == '*' && ((s_language & (4)) != 0)) javadoc = 1;
                                                {*--ccc = ch; }; ch = '*';
                                                { line = cline; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch=='\n') {cline ++; clb = ccc; clo = 0;} do { oldCh = ch; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch=='\n') {cline ++; clb = ccc; clo = 0;} } while ((oldCh != '*' || ch != '/') && ch != -1); if (ch == -1) error(ERR_ST,"comment through eof"); { if (cline-line!=0) { { *(dd)++ = ((unsigned)(441))%256; *(dd)++ = ((unsigned)(441))/256;}; { *(dd)++ = ((unsigned)(cline-line))%256; *(dd)++ = ((unsigned)(cline-line))/256;}; }}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };};
                                                { if (s_opt.taskRegime==RegimeHtmlGenerate) { int lcoll; S_position pos; char ttt[TMP_STRING_SIZE]; lcoll = (ccc-clb+clo-1); { (&pos)->file = cfile; (&pos)->line = cline; (&pos)->coll = lcoll;}; sprintf(ttt,"%x/*",cfile); if (s_opt.htmlNoColors==0) { addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageUsed); } if (javadoc) { pos.coll -= 2; addTrivialCxReference(ttt,TypeComment,StorageDefault, &pos, UsageJavaDoc); } }};
                                                { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                                        }
                                } else {
                                        {*--ccc = ch; };
                                        ch = '/';
                                }
                        }
                        { *(dd)++ = ((unsigned)('\n'))%256; *(dd)++ = ((unsigned)('\n'))/256;};
                        if (ch == '#' && ((s_language & (2|16|8)) != 0)) {
                                { int pi = lb->posi % LEX_POSITIONS_RING_SIZE; lb->fpRing[pi] = (cb->filePos - (cfin-ccc) - 1); lb->pRing[pi].file = cfile; lb->pRing[pi].line = cline; lb->pRing[pi].coll = (ccc-clb+clo-1); lb->posi ++;};
                                { char *ddd,tt[10]; int i,lcoll; lcoll = (ccc-clb+clo-1); { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }}; for(i=0; i<9 && (isalpha(ch) || isdigit(ch) || ch=='_') ; i++) { tt[i] = ch; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } tt[i]=0; if (! strcmp(tt,"ifdef")) { { *(dd)++ = ((unsigned)(412))%256; *(dd)++ = ((unsigned)(412))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"ifndef")) { { *(dd)++ = ((unsigned)(413))%256; *(dd)++ = ((unsigned)(413))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"if")) { { *(dd)++ = ((unsigned)(414))%256; *(dd)++ = ((unsigned)(414))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"elif")) { { *(dd)++ = ((unsigned)(417))%256; *(dd)++ = ((unsigned)(417))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"undef")) { { *(dd)++ = ((unsigned)(418))%256; *(dd)++ = ((unsigned)(418))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"else")) { { *(dd)++ = ((unsigned)(415))%256; *(dd)++ = ((unsigned)(415))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"endif")) { { *(dd)++ = ((unsigned)(416))%256; *(dd)++ = ((unsigned)(416))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else if (! strcmp(tt,"include")) { char endCh; { *(dd)++ = ((unsigned)(410))%256; *(dd)++ = ((unsigned)(410))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }}; if (ch == '\"' || ch == '<') { if (ch == '\"') endCh = '\"'; else endCh = '>'; { *(dd)++ = ((unsigned)(440))%256; *(dd)++ = ((unsigned)(440))/256;}; do { {*(dd)++ = ch;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } while (ch!=endCh && ch!='\n'); {*(dd)++ = 0;}; if (ch == endCh) { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } } else if (! strcmp(tt,"define")) { ddd = dd; { *(dd)++ = ((unsigned)(421))%256; *(dd)++ = ((unsigned)(421))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }}; { int pi = lb->posi % LEX_POSITIONS_RING_SIZE; lb->fpRing[pi] = (cb->filePos - (cfin-ccc) - 1); lb->pRing[pi].file = cfile; lb->pRing[pi].line = cline; lb->pRing[pi].coll = (ccc-clb+clo-1); lb->posi ++;}; { int idcoll; char *ddd; ddd = dd; idcoll = (ccc-clb+clo-1); { *(dd)++ = ((unsigned)(437))%256; *(dd)++ = ((unsigned)(437))/256;}; do { {*(dd)++ = ch;}; identContlab1: { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } while (isalpha(ch) || isdigit(ch) || ch=='_' || (ch=='$' && (((s_language & (8)) != 0)||((s_language & (4)) != 0)))); if (ch == '@' && *(dd-1)=='C') { int i,len; len = strlen(s_editCommunicationString); {}; for (i=2;i<len;i++) { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch != s_editCommunicationString[i]) break; } if (i>=len) { dd --; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; if (ch == 'c') { { *(ddd)++ = ((unsigned)(442))%256; *(ddd)++ = ((unsigned)(442))/256;}; { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; } else if (ch == 'x') { s_cache.activeCache = 0; { (&s_cxRefPos)->file = cfile; (&s_cxRefPos)->line = cline; (&s_cxRefPos)->coll = idcoll;}; goto identContlab1; } else error(ERR_INTERNAL,"unknown communication char"); } else { for(i--;i>=1;i--) { {*--ccc = ch; }; ch = s_editCommunicationString[i]; } } } {*(dd)++ = 0;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(idcoll,dd); };identEndlab1:;}; if (ch == '(') { { *(ddd)++ = ((unsigned)(411))%256; *(ddd)++ = ((unsigned)(411))/256;}; } } else if (! strcmp(tt,"pragma")) { { *(dd)++ = ((unsigned)(419))%256; *(dd)++ = ((unsigned)(419))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; } else { { *(dd)++ = ((unsigned)(420))%256; *(dd)++ = ((unsigned)(420))/256;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos(lcoll,dd); }; }};
                        }
                        goto nextLexem;
                case '#':
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        if (ch == '#') {
                                { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                                { *(dd)++ = ((unsigned)(423))%256; *(dd)++ = ((unsigned)(423))/256;};
                        } else {
                                { *(dd)++ = ((unsigned)('#'))%256; *(dd)++ = ((unsigned)('#'))/256;};
                        }
                        goto nextLexem;
                case -1:
                        goto nextLexem;
                default:
                        if (ch >= 32) {
                                { *(dd)++ = ((unsigned)(ch))%256; *(dd)++ = ((unsigned)(ch))/256;};
                        }
                        { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } };
                        goto nextLexem;
        }
        { if (!(0)) internalCheckFail("0", "lex.c", 794);};
nextLexem:
        if (s_opt.taskRegime == RegimeEditServer) {
          int pi,lpi,len,lastlex,parChar,apos,idcoll;
                S_position *ps;
                int pos0,pos1,currentLexemPosition;
                pi = (lb->posi-1) % LEX_POSITIONS_RING_SIZE;
                ps = & lb->pRing[pi];
                currentLexemPosition = lb->fpRing[pi];
                if ( cfile == s_olOriginalFileNumber
                                && cfile != s_noneFileIndex
                                && cfile != -1
                                && s_jsl==NULL
                        ) {
                        if (s_opt.cxrefs == OLO_EXTRACT && lb->posi>=2) {
                                { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                                pos1 = (cb->filePos - (cfin-ccc) - 1);
                                if (pos1 >= s_opt.olCursorPos && ! s_cps.marker1Flag) {
                                        if (((s_language & (4)) != 0)) parChar = ';';
                                        else {
                                                if (s_cps.marker2Flag) parChar='}';
                                                else parChar = '{';
                                        }
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(';'))%256; *(dd)++ = ((unsigned)(';'))/256;};
                                        { *(dd)++ = ((unsigned)(';'))%256; *(dd)++ = ((unsigned)(';'))/256;};
                                        { *(dd)++ = ((unsigned)(429))%256; *(dd)++ = ((unsigned)(429))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        s_cps.marker1Flag=1;
                                } else if (pos1 >= s_opt.olMarkPos && ! s_cps.marker2Flag){
                                        if (((s_language & (4)) != 0)) parChar = ';';
                                        else {
                                                if (s_cps.marker1Flag) parChar='}';
                                                else parChar = '{';
                                        }
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(';'))%256; *(dd)++ = ((unsigned)(';'))/256;};
                                        { *(dd)++ = ((unsigned)(';'))%256; *(dd)++ = ((unsigned)(';'))/256;};
                                        { *(dd)++ = ((unsigned)(429))%256; *(dd)++ = ((unsigned)(429))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        { *(dd)++ = ((unsigned)(parChar))%256; *(dd)++ = ((unsigned)(parChar))/256;};
                                        s_cps.marker2Flag=1;
                                }
                        } else if ( s_opt.cxrefs == OLO_COMPLETION
                                           || s_opt.cxrefs == OLO_SEARCH) {
                                { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                                apos = (cb->filePos - (cfin-ccc) - 1);
                                if (currentLexemPosition < s_opt.olCursorPos
                                                && (apos >= s_opt.olCursorPos
                                                        || (ch == -1 && apos+1 == s_opt.olCursorPos))) {
                                        lastlex = ( *((unsigned char*)lexStartDd) + 256 * *(((unsigned char*)lexStartDd)+1));
                                        if (lastlex == 437) {
                                                len = s_opt.olCursorPos-currentLexemPosition;
                                                if (len <= strlen(lexStartDd+sizeof(short int))) {
                                                        if (s_opt.cxrefs == OLO_SEARCH) {
                                                                char *ddd;
                                                                ddd = lexStartDd;
                                                                { *(ddd)++ = ((unsigned)(442))%256; *(ddd)++ = ((unsigned)(442))/256;};
                                                        } else {
                                                                dd = lexStartDd;
                                                                { *(dd)++ = ((unsigned)(442))%256; *(dd)++ = ((unsigned)(442))/256;};
                                                                dd += len;
                                                                {*(dd)++ = 0;};
                                                                { PutLexFilePos(ps->file,dd); PutLexNumPos(ps->line,dd); PutLexNumPos(ps->coll,dd); };
                                                        }
                                                } else {
                                                        { { *(dd)++ = ((unsigned)(442))%256; *(dd)++ = ((unsigned)(442))/256;}; {*(dd)++ = 0;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos((ccc-clb+clo-1) - (apos-s_opt.olCursorPos),dd); };};
                                                }
                                        } else {
                                                { { *(dd)++ = ((unsigned)(442))%256; *(dd)++ = ((unsigned)(442))/256;}; {*(dd)++ = 0;}; { PutLexFilePos(cfile,dd); PutLexNumPos(cline,dd); PutLexNumPos((ccc-clb+clo-1) - (apos-s_opt.olCursorPos),dd); };};
                                        }
                                }
                        } else if (s_opt.cxrefs == OLO_SET_MOVE_TARGET
                                           || s_opt.cxrefs == OLO_GET_CURRENT_CLASS
                                           || s_opt.cxrefs == OLO_GET_CURRENT_SUPER_CLASS
                                           || s_opt.cxrefs == OLO_GET_METHOD_COORD
                                           || s_opt.cxrefs == OLO_GET_CLASS_COORD
                                           || s_opt.cxrefs == OLO_MAYBE_THIS
                                           || s_opt.cxrefs == OLO_NOT_FQT_REFS
                                           || s_opt.cxrefs == OLO_NOT_FQT_REFS_IN_CLASS
                                           || s_opt.cxrefs == OLO_USELESS_LONG_NAME
                                           || s_opt.cxrefs == OLO_USELESS_LONG_NAME_IN_CLASS
                                           || s_opt.cxrefs == OLO_PUSH_ALL_IN_METHOD
                                ) {
                                if (s_opt.cxrefs == OLO_PUSH_ALL_IN_METHOD) {
                                        if (currentLexemPosition <= s_opt.olCursorPos
                                                && (cb->filePos - (cfin-ccc) - 1) >= s_opt.olCursorPos) {
                                                gotOnLineCxRefs( ps);
                                        }
                                }
                                { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                                apos = (cb->filePos - (cfin-ccc) - 1);
                                if (apos >= s_opt.olCursorPos && ! s_cps.marker1Flag) {
                                        { *(dd)++ = ((unsigned)(429))%256; *(dd)++ = ((unsigned)(429))/256;};
                                        s_cps.marker1Flag=1;
                                }
                        } else if (s_opt.cxrefs == OLO_TRIVIAL_PRECHECK
                                && (s_opt.trivialPreCheckCode == TPC_PULL_UP_METHOD
                                        || s_opt.trivialPreCheckCode == TPC_MOVE_CLASS
                                        || s_opt.trivialPreCheckCode == TPC_TURN_DYN_METHOD_TO_STATIC
                                        || s_opt.trivialPreCheckCode == TPC_PUSH_DOWN_METHOD_POST_CHECK )) {
                                if (currentLexemPosition <= s_opt.olCursorPos
                                        && (cb->filePos - (cfin-ccc) - 1) >= s_opt.olCursorPos) {
                                        gotOnLineCxRefs( ps);
                                }
                                { while (ch==' '|| ch=='\t' || ch=='\004') { { if (ccc >= cfin) { cb->cc = ccc; clo = ccc-clb; if (cb->isAtEOF || getCharBuf(cb) == 0) { { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }}; ch = -1; cb->isAtEOF = 1; } else { ccc = cb->cc; cfin = cb->fin; clb = ccc; ch = * ((unsigned char *)ccc) ++; } } else { ch = * ((unsigned char *)ccc) ++; } }; }};
                                apos = (cb->filePos - (cfin-ccc) - 1);
                                if (apos >= s_opt.olCursorPos && ! s_cps.marker1Flag) {
                                        { *(dd)++ = ((unsigned)(429))%256; *(dd)++ = ((unsigned)(429))/256;};
                                        s_cps.marker1Flag=1;
                                }
                        } else if (currentLexemPosition <= s_opt.olCursorPos
                                        && (cb->filePos - (cfin-ccc) - 1) >= s_opt.olCursorPos) {
                                gotOnLineCxRefs( ps);
                        }
                }
        }
        if (ch != -1) goto contin;
finish:
        cb->cc = ccc; cb->fin = cfin;
        cb->lineNum = cline; cb->lineBegin = clb; cb->collumnOffset = clo;
        lb->fin = dd;
        if (lb->fin == lb->a) return(0);
        return(1);
}
