
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
#ifdef __QNX__
#include <sys/kernel.h>
#endif
static int s_stdfFlag;
static char olExtractAddrParPrefixStatChar[TMP_STRING_SIZE];
static char oldStdopFile[MAX_FILE_NAME_SIZE];
static char oldStdopSection[MAX_FILE_NAME_SIZE];
static char oldOnLineClassPath[MAX_OPTION_LEN];
static time_t oldStdopTime;
static int oldLanguage;
static int oldCppPass;
static char qnxMsgBuff[QNX_MSG_BUF_SIZE];
static S_options s_cachedOptions;
static S_options s_tmpOptions;
static void usage(char *s) {
        fprintf(stdout,"usage: \t\t%s <option>+ ",s);
        fprintf(stdout,"<input files>");
        fprintf(stdout,"\n");
        fprintf(stdout,"options:\n");
        fprintf(stdout,"\t-r                    - recursively descent directories\n");
        fprintf(stdout,"\t-html                 - convert sources to html format\n");
        fprintf(stdout,"\t-htmlroot=<dir>       - specifies root dir. for html output\n");
        fprintf(stdout,"\t-htmltab=<n>          - set tabulator to <n> in htmls\n");
        fprintf(stdout,"\t-htmlgxlist           - generate xref-lists for global symbols\n");
        fprintf(stdout,"\t-htmllxlist           - generate xref-lists for local symbols\n");
        fprintf(stdout,"\t-htmldirectx          - link first character to cross references\n");
        fprintf(stdout,"\t-htmlfunseparate      - separate functions by a bar\n");
        fprintf(stdout,"\t-htmlzip=<command>    - zip command, ! stands for the file name\n");
        fprintf(stdout,"\t-htmllinksuffix=<suf> - add this suffix to file links\n");
        fprintf(stdout,"\t-htmllinenums         - generate line numbers in HTML\n");
        fprintf(stdout,"\t-htmlnocolors         - do not generate colors in HTML\n");
        fprintf(stdout,"\t-htmlnounderline      - not underlined HTML links\n");
        fprintf(stdout,"\t-htmlcutpath=<path>   - cut path in generated html\n");
        fprintf(stdout,"\t-htmlcutcwd           - cut current dir in html\n");
        fprintf(stdout,"\t-htmlcutsourcepaths   - cut source paths in html\n");
        fprintf(stdout,"\t-htmlcutsuffix        - cut language suffix in html\n");
        fprintf(stdout,"\t-htmllinkcolor=<color>- color of HTML links\n");
        fprintf(stdout,"\t-htmllinenumcolor=<color>- color of line numbers in HTML links\n");
        fprintf(stdout,"\t-htmlgenjavadoclinks  - gen links to javadoc if no definition\n");
        fprintf(stdout,"\t                      - only for packages from -htmljavadocavailable\n");
        fprintf(stdout,"\t-javadocurl=<http>    - url to existing java docs\n");
        fprintf(stdout,"\t-javadocpath=<path>   - paths to existing java docs\n");
        fprintf(stdout,"\t-javadocavailable=<packs> - packages for which javadoc is available\n");
        fprintf(stdout,"\t-p <prj>              - read options from <prj> section\n");
        fprintf(stdout,"\t-I <dir>              - search for includes in <dir>\n");
        fprintf(stdout,"\t-D<mac>[=<body>]      - define macro <mac> with body <body>\n");
        fprintf(stdout,"\t-packages             - allow packages as input files\n");
        fprintf(stdout,"\t-sourcepath <path>    - set java sources paths\n");
        fprintf(stdout,"\t-classpath <path>     - set java class path\n");
        fprintf(stdout,"\t-filescasesensitive   - file names are case sensitive\n");
        fprintf(stdout,"\t-filescaseunsensitive - file names are case unsensitive\n");
        fprintf(stdout,"\t-csuffixes=<paths>    - list of C files suffixes separated by : (or ;)");
        fprintf(stdout,"\t-javasuffixes=<paths> - list of Java files suffixes separated by : (or ;)\n");
        fprintf(stdout,"\t-stdop <file>         - read options from <file>\n");
        fprintf(stdout,"\t-no_cpp_comment       - C++ like comments // not admitted\n");
        fprintf(stdout,"\t-license=<string>     - license string\n");
        fprintf(stdout,"\t-refs <file>          - name of file with cxrefs\n");
        fprintf(stdout,"\t-refnum=<n>           - number of cxref files\n");
        fprintf(stdout,"\t-refalphahash         - split references alphabetically (-refnum=28)\n");
        fprintf(stdout,"\t-refalpha2hash        - split references alphabetically (-refnum=28*28)\n");
        fprintf(stdout,"\t-exactpositionresolve - resolve symbols by def. position\n");
        fprintf(stdout,"\t-mf<n>                - factor increasing cxMemory\n");
        fprintf(stdout,"\t-debug                - produce debug trace of the execution\n");
        fprintf(stdout,"\t-no_enum         - don't cross reference enumeration constants\n");
        fprintf(stdout,"\t-no_mac          - don't cross reference macros\n");
        fprintf(stdout,"\t-no_type         - don't cross reference type names\n");
        fprintf(stdout,"\t-no_str          - don't cross reference str. records\n");
        fprintf(stdout,"\t-no_local        - don't cross reference local vars\n");
        fprintf(stdout,"\t-nobrief         - generate cxrefs in long format\n");
        fprintf(stdout,"\t-update          - update old 'refs' reference file\n");
        fprintf(stdout,"\t-fastupdate      - fast update (modified files only)\n");
        fprintf(stdout,"\t-no_stdop        - don't read the '~/.xrefrc' option file \n");
        fprintf(stdout,"\t-errors          - report all error messages\n");
        fprintf(stdout,"\t-version         - give this release version number\n");
}
static void aboutMessage() {
        time_t tt;
        int j;
        fprintf(stdout,"This is Xrefactory version %s (%s).\n",
                        "1.5.10", "Mar 21 2003");
        tt = 1067641200;
        fprintf(stdout,"Time limit: %s",ctime(&tt));
        fprintf(stdout,"(c) 1997-2002 by Xref-Tech, http://www.xref-tech.com\n");
        exit(0);
}
void dirInputFile(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5) {
        char *dir,*fname,*fin,*suff;
        void *recurseFlag;
        struct stat st;
        char fn[MAX_FILE_NAME_SIZE];
        char ttt[MAX_FILE_NAME_SIZE];
        int ii,len,topCallFlag,stt;
        dir = a1; fname = file; recurseFlag = a4; topCallFlag = *a5;
        if (topCallFlag == 0) {
                if (strcmp(fname,".")==0) return;
                if (strcmp(fname,"..")==0) return;
                sprintf(fn,"%s%c%s",dir,SLASH,fname);
        } else {
                strcpy(fn,fname);
        }
        strcpy(fn, normalizeFileName(fn,s_cwd));
        suff = getFileSuffix(fname);
        stt = stat(fn, &st);
        if (stt==0 && (st.st_mode & S_IFMT)==S_IFDIR) {
                if (recurseFlag!=NULL) {
                        topCallFlag = 0;
                        mapDirectoryFiles(fn, dirInputFile, fn,
                                                                NULL, NULL, recurseFlag, &topCallFlag);
                } else {
                        sprintf(tmpBuff,"omitting directory %s, missing '-r' option ?",fn);
                        warning(ERR_ST,tmpBuff);
                }
        } else if (stt==0) {
                if ( topCallFlag==0
                                && (! fileNameHasOneOfSiffixes(fname, s_opt.cFilesSuffixes))
                                && (! fileNameHasOneOfSiffixes(fname, s_opt.javaFilesSuffixes))
                                && fnCmp(suff,".y")!=0
                        ) {
                                return;
                }
                if (s_opt.javaFilesOnly && s_opt.taskRegime!=RegimeEditServer
                        && (! fileNameHasOneOfSiffixes(fname, s_opt.javaFilesSuffixes))
                        && (! fileNameHasOneOfSiffixes(fname, "jar:class"))) return;
                addFileTabItem(fn,&ii);
                s_fileTab.tab[ii]->b.commandLineEntered = 1;
                if (s_opt.updateOnlyModifiedFiles==0) {
                        s_fileTab.tab[ii]->b.scheduledToProcess = 1;
                }
#ifdef __WIN32__
          } else if (strchr(fn,'*')!=NULL) {
                  copyDir(ttt, fn, &ii);
                  mapPatternFiles(fn, dirInputFile, ttt,
                                                  NULL, NULL, recurseFlag, &topCallFlag);
#endif
          } else if (topCallFlag
                                 && ((!s_opt.allowPackagesOnCl)
                                         || packageOnCommandLine(fname)==0)) {
                  error(ERR_CANT_OPEN, fn);
          }
}
void xrefSetenv(char *name, char *val) {
        S_setGetEnv *sge;
        int j, n;
        sge = &s_opt.setGetEnv;
        n = sge->num;
        if (n+1>=MAX_SET_GET_OPTIONS) {
                sprintf(tmpBuff, "maximum of %d -set options reached", MAX_SET_GET_OPTIONS);
                error(ERR_ST, tmpBuff);
                sge->num--; n--;
        }
        for(j=0; j<n; j++) {
                { if (!(sge->name[j])) internalCheckFail("sge->name[j]", "main.c", 247);};
                if (strcmp(sge->name[j], name)==0) break;
        }
        sge->name[j] = name;
        sge->value[j] = val;
        if (j==n) sge->num ++;
}
int mainHandleSetOption( int argc, char **argv, int i ) {
        S_setGetEnv *sge;
        char *name, *val;
        int j,n;
        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
        name = argv[i];
        { if (!(name)) internalCheckFail("name", "main.c", 263);};
        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
        val = argv[i];
        xrefSetenv(name, val);
        return(i);
}
static void optionAddIncludeDir(char *argvi) {
        S_stringList *ll;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "main.c", 272);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_stringList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ll = (S_stringList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_stringList);};};};
        {{ { if (!((strlen(argvi)+1) >= 0)) internalCheckFail("(strlen(argvi)+1) >= 0", "main.c", 273);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(argvi)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ll->d = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(argvi)+1)*sizeof(char);};};
        strcpy(ll->d, argvi);
        ll->next = NULL;
        { if ((s_opt.includeDirs)==NULL) s_opt.includeDirs = ll; else { register S_stringList *tempnsl; tempnsl = s_opt.includeDirs; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = ll; } };
}
static void processOptions(int argc, char **argv, int infilesFlag) {
        S_stringList *ll;
        S_fileItem *fi,ffi;
        char *fin,*ftin;
        int i,ii,newRefNum,ln,topCallFlag,processed,tmp;
        void *recursFlag;
        for (i=1; i<argc; i++) {
                processed = processInteractiveFlagOption(argv[i]);
                if (processed) { }
                else if (strcmp(argv[i],"-task_regime_server")==0) {
                        s_opt.taskRegime = RegimeEditServer;
                }
                else if (strcmp(argv[i],"-task_regime_generate")==0) {
                        s_opt.taskRegime = RegimeGenerate;
                }
                else if (strcmp(argv[i],"-html")==0) {
                        s_opt.taskRegime = RegimeHtmlGenerate;
                        s_opt.multiHeadRefsCare = 0;
                }
                else if (*argv[i] != '-') {
                        if (infilesFlag == INFILES_ENABLED) {
                                if (argv[i][0]=='`' && argv[i][strlen(argv[i])-1]=='`') {
                                        int nargc,aaa;
                                        char **nargv, *pp;
                                        char command[MAX_OPTION_LEN];
                                        if (infilesFlag==INFILES_ENABLED) {
                                                s_stdfFlag = 1;
                                                strcpy(command, argv[i]+1);
                                                pp = strchr(command, '`');
                                                if (pp!=NULL) *pp = 0;
                                                readOptionPipe(command, &nargc, &nargv, "");
                                                processOptions(nargc, nargv, INFILES_ENABLED);
                                                s_stdfFlag = 0;
                                        }
                                } else {
                                        topCallFlag = 1;
                                        if (s_opt.recursivelyDirs) recursFlag = &topCallFlag;
                                        else recursFlag = NULL;
                                        dirInputFile(argv[i],"",NULL,NULL,recursFlag,&topCallFlag);
                                }
                        }
                }
                else if (strncmp(argv[i],"-pass",5)==0) {
                        error(ERR_ST,"'-pass' option can't be entered from command line");
                }
                else if (strcmp(argv[i],"-r")==0) {
                        if (infilesFlag == INFILES_ENABLED) s_opt.recursivelyDirs = 1;
                }
                else if (strncmp(argv[i],"-htmlroot=",10)==0) {
                        ln=strlen(argv[i]);
                        if (ln>11 && argv[i][ln-1] == SLASH) {
                                warning(ERR_ST,"slash at the end of -htmlroot path");
                        }
                        s_opt.htmlRoot = argv[i]+10;
                }
                else if (strcmp(argv[i],"-d")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        ln=strlen(argv[i]);
                        if (ln>1 && argv[i][ln-1] == SLASH) {
                                warning(ERR_ST,"slash at the end of -d path");
                        }
                        if (! isAbsolutePath(argv[i])) {
                                warning(ERR_ST,"'-d' option should be followed by an ABSOLUTE path!");
                        }
                        s_opt.htmlRoot = argv[i];
                }
                else if (strncmp(argv[i],"-jdoctmpdir=",12)==0) {
                        ln=strlen(argv[i]);
                        if (ln>13 && argv[i][ln-1] == SLASH) {
                                warning(ERR_ST,"slash at the end of -jdoctmpdir path");
                        }
                        s_opt.jdocTmpDir = argv[i]+12;
                }
                else if (strcmp(argv[i],"-htmlgenjavadoclinks")==0) {
                        s_opt.htmlGenJdkDocLinks = 1;
                }
                else if (strncmp(argv[i],"-htmljavadocavailable=",22)==0) {
                        s_opt.htmlJdkDocAvailable = argv[i]+22;
                }
                else if (strncmp(argv[i],"-javadocavailable=",18)==0) {
                        s_opt.htmlJdkDocAvailable = argv[i]+18;
                }
                else if (strncmp(argv[i],"-htmljavadocpath=",17)==0) {
                        s_opt.htmlJdkDocUrl = argv[i]+17;
                }
                else if (strncmp(argv[i],"-javadocurl=",12)==0) {
                        s_opt.htmlJdkDocUrl = argv[i]+12;
                }
                else if (strncmp(argv[i],"-javadocpath=",13)==0) {
                        s_opt.javaDocPath = argv[i]+13;
                } else if (strcmp(argv[i],"-javadocpath")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.javaDocPath = argv[i];
                }
                else if (strncmp(argv[i],"-htmlcutpath=",13)==0) {
                        addHtmlCutPath(argv[i]+13);
                }
                else if (strcmp(argv[i],"-htmlcutcwd")==0) {
                        tmp = addHtmlCutPath(s_cwd);
                        if (s_opt.java2html && tmp) {
                                fatalError(ERR_ST, "a path clash occurred, please, run java2html from different directory", 65);
                        }
                }
                else if (strcmp(argv[i],"-htmlcutsourcepaths")==0) {
                        addSourcePathesCut();
                }
                else if (strcmp(argv[i],"-htmlcutsourcepathes")==0) {
                        addSourcePathesCut();
                }
                else if (strcmp(argv[i],"-htmlcutsuffix")==0) {
                        s_opt.htmlCutSuffix = 1;
                }
                else if (strncmp(argv[i],"-htmllinenumlabel=", 18)==0) {
                        s_opt.htmlLineNumLabel = argv[i]+18;
                }
                else if (strcmp(argv[i],"-htmlnounderline")==0) {
                        s_opt.htmlNoUnderline = 1;
                }
                else if (strcmp(argv[i],"-htmldirectx")==0) {
                        s_opt.htmlDirectX = 1;
                }
                else if (strncmp(argv[i],"-htmllinkcolor=",15)==0) {
                        s_opt.htmlLinkColor = argv[i]+15;
                }
                else if (strncmp(argv[i],"-htmllinenumcolor=",18)==0) {
                        s_opt.htmlLineNumColor = argv[i]+18;
                }
                else if (strncmp(argv[i],"-htmlcxlinelen=",15)==0) {
                        sscanf(argv[i]+15, "%d", &s_opt.htmlCxLineLen);
                }
                else if (strncmp(argv[i],"-htmlzip=",9)==0) {
                        s_opt.htmlZipCommand = argv[i]+9;
                }
                else if (strncmp(argv[i],"-htmllinksuffix=",16)==0) {
                        s_opt.htmlLinkSuffix = argv[i]+16;
                }
                else if (strncmp(argv[i],"-D",2)==0)addMacroDefinedByOption(argv[i]+2);
                else if (strcmp(argv[i],"-stderr")==0) errOut = stdout;
                else if (strcmp(argv[i],"-classpath")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        if (s_opt.classpath!=NULL && *s_opt.classpath!=0
                                && strcmp(s_opt.classpath,argv[i])!=0) {
                                if (s_opt.taskRegime != RegimeEditServer) {
                                        warning(ERR_ST,"redefinition of classpath, new value ignored");
                                }
                        } else {
                                s_opt.classpath=argv[i];
                        }
                }
                else if (strcmp(argv[i],"-filescasesensitive")==0) {
                        s_opt.fileNamesCaseSensitive = 1;
                }
                else if (strcmp(argv[i],"-filescaseunsensitive")==0) {
                        s_opt.fileNamesCaseSensitive = 0;
                }
                else if (strncmp(argv[i],"-csuffixes=",11)==0) {
                        s_opt.cFilesSuffixes = argv[i]+11;
                }
                else if (strncmp(argv[i],"-javasuffixes=",14)==0) {
                        s_opt.javaFilesSuffixes = argv[i]+14;
                }
                else if (strcmp(argv[i],"-packages")==0) {
                        s_opt.allowPackagesOnCl = 1;
                }
                else if (strcmp(argv[i],"-javafilesonly")==0) {
                        s_opt.javaFilesOnly = 1;
                }
                else if (strcmp(argv[i],"-noautoupdatefromsrc")==0) {
                        s_opt.javaSlAllowed = 0;
                }
                else if (strcmp(argv[i],"-sourcepath")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.sourcePath=argv[i];
                        xrefSetenv("-sourcepath", s_opt.sourcePath);
                }
                else if (strcmp(argv[i],"-jdkclasspath")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.jdkClassPath=argv[i];
                }
                else if (strcmp(argv[i],"-I")==0) {
                        i++;
                        if (i >= argc) {
                                sprintf(tmpBuff,"directory name expected after -I\n");
                                error(ERR_ST,tmpBuff);
                                usage(argv[0]);
                        }
                        optionAddIncludeDir(argv[i]);
                }
                else if (strncmp(argv[i],"-I",2)==0) {
                        optionAddIncludeDir(argv[i]+2);
                }
                else if (strcmp(argv[i],"-resetIncludeDirs")==0) {
                        s_opt.includeDirs = NULL;
                }
                else if (strcmp(argv[i],"-stdop")==0 || strcmp(argv[i],"-include")==0) {
                        int nargc,aaa;
                        char **nargv;
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_stdfFlag = 1;
                        readOptionFile(argv[i],&nargc,&nargv,"",NULL);
                        processOptions(nargc, nargv, INFILES_DISABLED);
                        s_stdfFlag = 0;
                }
                else if (strcmp(argv[i],"-p")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.project = argv[i];
                }
                else if (strncmp(argv[i],"-olinelen=",10)==0) {
                        sscanf(argv[i]+10,"%d",&s_opt.olineLen);
                        if (s_opt.olineLen == 0) s_opt.olineLen =79;
                        else s_opt.olineLen--;
                }
                else if (strncmp(argv[i],"-olcursor=",10)==0) {
                        sscanf(argv[i]+10,"%d",&s_opt.olCursorPos);
                }
                else if (strncmp(argv[i],"-olmark=",8)==0) {
                        sscanf(argv[i]+8,"%d",&s_opt.olMarkPos);
                }
                else if (strcmp(argv[i],"-kawa")==0) {
                        s_opt.editor = ED_KAWA;
                        s_opt.olineLen = 250;
                }
                else if (strcmp(argv[i],"-emacs")==0) {
                        s_opt.editor = ED_EMACS;
                }
                else if (strncmp(argv[i],"-maxCompls=",11)==0) {
                        sscanf(argv[i]+11, "%d", &s_opt.maxCompletions);
                }
                else if (strncmp(argv[i],"-browsedsym=",12)==0) {
                        s_opt.browsedSymName = argv[i]+12;
                }
                else if (strncmp(argv[i],"-olcxrefsuffix=",15)==0) {
                        s_opt.olcxRefSuffix = argv[i]+15;
                }
                else if (strncmp(argv[i],"-olcxresetrefsuffix=",20)==0) {
                        s_opt.cxrefs = OLO_RESET_REF_SUFFIX;
                        s_opt.olcxRefSuffix = argv[i]+20;
                }
                else if (strncmp(argv[i],"-olcxextract=",13)==0) {
                        s_opt.cxrefs = OLO_EXTRACT;
                        s_opt.extractName = argv[i]+13;
                }
                else if (strcmp(argv[i],"-olcxtrivialprecheck")==0) {
                        s_opt.cxrefs = OLO_TRIVIAL_PRECHECK;
                }
                else if (strcmp(argv[i],"-getlastimportline")==0) {
                        s_opt.trivialPreCheckCode = TPC_GET_LAST_IMPORT_LINE;
                }
                else if (strcmp(argv[i],"-tpchrenamepackage")==0) {
                        s_opt.trivialPreCheckCode = TPC_RENAME_PACKAGE;
                }
                else if (strcmp(argv[i],"-tpchrenameclass")==0) {
                        s_opt.trivialPreCheckCode = TPC_RENAME_CLASS;
                }
                else if (strcmp(argv[i],"-tpchmoveclass")==0) {
                        s_opt.trivialPreCheckCode = TPC_MOVE_CLASS;
                }
                else if (strcmp(argv[i],"-tpchmovefield")==0) {
                        s_opt.trivialPreCheckCode = TPC_MOVE_FIELD;
                }
                else if (strcmp(argv[i],"-tpchmovestaticfield")==0) {
                        s_opt.trivialPreCheckCode = TPC_MOVE_STATIC_FIELD;
                }
                else if (strcmp(argv[i],"-tpchmovestaticmethod")==0) {
                        s_opt.trivialPreCheckCode = TPC_MOVE_STATIC_METHOD;
                }
                else if (strcmp(argv[i],"-tpchturndyntostatic")==0) {
                        s_opt.trivialPreCheckCode = TPC_TURN_DYN_METHOD_TO_STATIC;
                }
                else if (strcmp(argv[i],"-tpchturnstatictodyn")==0) {
                        s_opt.trivialPreCheckCode = TPC_TURN_STATIC_METHOD_TO_DYN;
                }
                else if (strcmp(argv[i],"-tpchpullupmethod")==0) {
                        s_opt.trivialPreCheckCode = TPC_PULL_UP_METHOD;
                }
                else if (strcmp(argv[i],"-tpchpushdownmethod")==0) {
                        s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_METHOD;
                }
                else if (strcmp(argv[i],"-tpchpushdownmethodpostcheck")==0) {
                        s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_METHOD_POST_CHECK;
                }
                else if (strcmp(argv[i],"-tpchpullupfield")==0) {
                        s_opt.trivialPreCheckCode = TPC_PULL_UP_FIELD;
                }
                else if (strcmp(argv[i],"-tpchpushdownfield")==0) {
                        s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_FIELD;
                }
                else if (strncmp(argv[i],"-movetargetclass=",17)==0) {
                        s_opt.moveTargetClass = argv[i]+17;
                }
                else if (strncmp(argv[i],"-movetargetfile=",16)==0) {
                        s_opt.moveTargetFile = argv[i]+16;
                }
                else if (strcmp(argv[i],"-olmanualresolve")==0) {
                        s_opt.manualResolve = RESOLVE_DIALOG_ALLWAYS;
                }
                else if (strcmp(argv[i],"-olnodialog")==0) {
                        s_opt.manualResolve = RESOLVE_DIALOG_NEVER;
                }
                else if (strcmp(argv[i],"-olexaddress")==0) {
                        s_opt.extractMode = EXTR_FUNCTION_ADDRESS_ARGS;
                }
                else if (strcmp(argv[i],"-olchecklinkage")==0) {
                        s_opt.ooChecksBits |= 00001;
                }
                else if (strcmp(argv[i],"-olnocheckaccess")==0) {
                        s_opt.ooChecksBits &= ~00002;
                }
                else if (strcmp(argv[i],"-olallchecks")==0) {
                        s_opt.ooChecksBits |= 00010;
                }
                else if (strcmp(argv[i],"-olfqtnametocompletions")==0) {
                        s_opt.fqtNameToCompletions = 1;
                }
                else if (strncmp(argv[i],"-extractAddrParPrefix=",22)==0) {
                        olExtractAddrParPrefixStatChar[0]='*';
                        strcpy(olExtractAddrParPrefixStatChar+1, argv[i]+22);
                        s_opt.olExtractAddrParPrefix = olExtractAddrParPrefixStatChar;
                }
                else if (strcmp(argv[i],"-olexmacro")==0) s_opt.extractMode=EXTR_MACRO;
                else if (strcmp(argv[i],"-olcxunmodified")==0) {
                        s_opt.modifiedFlag = 0;
                }
                else if (strcmp(argv[i],"-olcxmodified")==0) {
                        s_opt.modifiedFlag = 1;
                }
                else if (strcmp(argv[i],"-urlmanualredirect")==0) {
                        s_opt.urlAutoRedirect = 0;
                }
                else if (strcmp(argv[i],"-set")==0) {
                        i = mainHandleSetOption( argc, argv, i);
                }
                else if (strcmp(argv[i],"-get")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.getValue = argv[i];
                        s_opt.cxrefs = OLO_GET_ENV_VALUE;
                }
                else if (strcmp(argv[i],"-olcxrename")==0) s_opt.cxrefs = OLO_RENAME;
                else if (strcmp(argv[i],"-olcxencapsulate")==0) s_opt.cxrefs = OLO_ENCAPSULATE;
                else if (strcmp(argv[i],"-olcxargmanip")==0) s_opt.cxrefs = OLO_ARG_MANIP;
                else if (strcmp(argv[i],"-olcxdynamictostatic1")==0) s_opt.cxrefs = OLO_VIRTUAL2STATIC_PUSH;
                else if (strcmp(argv[i],"-olcxsafetycheckinit")==0) s_opt.cxrefs = OLO_SAFETY_CHECK_INIT;
                else if (strcmp(argv[i],"-olcxsafetycheck1")==0) s_opt.cxrefs = OLO_SAFETY_CHECK1;
                else if (strcmp(argv[i],"-olcxsafetycheck2")==0) s_opt.cxrefs = OLO_SAFETY_CHECK2;
                else if (strcmp(argv[i],"-olcxintersection")==0) s_opt.cxrefs = OLO_INTERSECTION;
                else if (strcmp(argv[i],"-olcxsafetycheckmovedfile")==0
                                 || strcmp(argv[i],"-olcxsafetycheckmoved")==0
                        ) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.checkFileMovedFrom = argv[i];
                        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.checkFileMovedTo = argv[i];
                }
                else if (strcmp(argv[i],"-olcxwindel")==0) {
                        s_opt.cxrefs = OLO_REMOVE_WIN;
                }
                else if (strcmp(argv[i],"-olcxwindelfile")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.olcxWinDelFile = argv[i];
                }
                else if (strncmp(argv[i],"-olcxwindelwin=",15)==0) {
                        s_opt.olcxWinDelFromLine = s_opt.olcxWinDelToLine = 0;
                        s_opt.olcxWinDelFromCol = s_opt.olcxWinDelToCol = 0;
                        sscanf(argv[i]+15,"%d:%dx%d:%d",
                                   &s_opt.olcxWinDelFromLine, &s_opt.olcxWinDelFromCol,
                                   &s_opt.olcxWinDelToLine, &s_opt.olcxWinDelToCol);
                }
                else if (strncmp(argv[i],"-olcxsafetycheckmovedblock=",27)==0) {
                        sscanf(argv[i]+27, "%d:%d:%d", &s_opt.checkFirstMovedLine,
                                   &s_opt.checkLinesMoved, &s_opt.checkNewLineNumber);
                }
                else if (strcmp(argv[i],"-olcxgotodef")==0) s_opt.cxrefs = OLO_GOTO_DEF;
                else if (strcmp(argv[i],"-olcxgotocaller")==0) s_opt.cxrefs = OLO_GOTO_CALLER;
                else if (strcmp(argv[i],"-olcxgotocurrent")==0) s_opt.cxrefs = OLO_GOTO_CURRENT;
                else if (strncmp(argv[i],"-olcxgotoparname",16)==0) {
                        s_opt.cxrefs = OLO_GOTO_PARAM_NAME;
                        s_opt.olcxGotoVal = 0;
                        sscanf(argv[i]+16, "%d", &s_opt.olcxGotoVal);
                }
                else if (strcmp(argv[i],"-olcxtops")==0) s_opt.cxrefs = OLO_SHOW_TOP;
                else if (strcmp(argv[i],"-olcxtoptype")==0) s_opt.cxrefs = OLO_SHOW_TOP_TYPE;
                else if (strcmp(argv[i],"-olcxtopapplcl")==0) s_opt.cxrefs = OLO_SHOW_TOP_APPL_CLASS;
                else if (strcmp(argv[i],"-olcxshowctree")==0) s_opt.cxrefs = OLO_SHOW_CLASS_TREE;
                else if (strcmp(argv[i],"-olcxedittop")==0) s_opt.cxrefs = OLO_TOP_SYMBOL_RES;
                else if (strcmp(argv[i],"-olcxclasstree")==0) s_opt.cxrefs = OLO_CLASS_TREE;
                else if (strcmp(argv[i],"-olcxuselesslongnames")==0) s_opt.cxrefs = OLO_USELESS_LONG_NAME;
                else if (strcmp(argv[i],"-olcxuselesslongnamesinclass")==0) s_opt.cxrefs = OLO_USELESS_LONG_NAME_IN_CLASS;
                else if (strcmp(argv[i],"-olcxmaybethis")==0) s_opt.cxrefs = OLO_MAYBE_THIS;
                else if (strcmp(argv[i],"-olcxnotfqt")==0) s_opt.cxrefs = OLO_NOT_FQT_REFS;
                else if (strcmp(argv[i],"-olcxnotfqtinclass")==0) s_opt.cxrefs = OLO_NOT_FQT_REFS_IN_CLASS;
                else if (strcmp(argv[i],"-olcxpush")==0) s_opt.cxrefs = OLO_PUSH;
                else if (strcmp(argv[i],"-olcxrepush")==0) s_opt.cxrefs = OLO_REPUSH;
                else if (strcmp(argv[i],"-olcxpushonly")==0) s_opt.cxrefs = OLO_PUSH_ONLY;
                else if (strcmp(argv[i],"-olcxencapsulatesc1")==0) s_opt.cxrefs = OLO_PUSH_ENCAPSULATE_SAFETY_CHECK;
                else if (strcmp(argv[i],"-olcxencapsulatesc2")==0) s_opt.cxrefs = OLO_ENCAPSULATE_SAFETY_CHECK;
                else if (strcmp(argv[i],"-olcxpushallinmethod")==0) s_opt.cxrefs = OLO_PUSH_ALL_IN_METHOD;
                else if (strcmp(argv[i],"-olcxmmprecheck")==0) s_opt.cxrefs = OLO_MM_PRE_CHECK;
                else if (strcmp(argv[i],"-olcxppprecheck")==0) s_opt.cxrefs = OLO_PP_PRE_CHECK;
                else if (strcmp(argv[i],"-olcxpushforlm")==0) s_opt.cxrefs = OLO_PUSH_FOR_LOCALM;
                else if (strcmp(argv[i],"-olcxlist")==0) s_opt.cxrefs = OLO_LIST;
                else if (strcmp(argv[i],"-olcxlisttop")==0) s_opt.cxrefs = OLO_LIST_TOP;
                else if (strcmp(argv[i],"-olcxpop")==0) s_opt.cxrefs = OLO_POP;
                else if (strcmp(argv[i],"-olcxpoponly")==0) s_opt.cxrefs = OLO_POP_ONLY;
                else if (strcmp(argv[i],"-olcxplus")==0) s_opt.cxrefs = OLO_PLUS;
                else if (strcmp(argv[i],"-olcxminus")==0) s_opt.cxrefs = OLO_MINUS;
                else if (strcmp(argv[i],"-olcxsearch")==0) s_opt.cxrefs = OLO_SEARCH;
                else if (strncmp(argv[i],"-olcxpushname=",14)==0) {
                        s_opt.cxrefs = OLO_PUSH_NAME;
                        s_opt.pushName = argv[i]+14;
                }
                else if (strcmp(argv[i],"-searchdef")==0) {
                        s_opt.tagSearchSpecif = TSS_SEARCH_DEFS_ONLY;
                }
                else if (strcmp(argv[i],"-searchshortlist")==0) {
                        s_opt.tagSearchSpecif = TSS_FULL_SEARCH_SHORT;
                }
                else if (strcmp(argv[i],"-searchdefshortlist")==0) {
                        s_opt.tagSearchSpecif = TSS_SEARCH_DEFS_ONLY_SHORT;
                }
                else if (strcmp(argv[i],"-olcxcomplet")==0)s_opt.cxrefs=OLO_COMPLETION;
                else if (strcmp(argv[i],"-noerrors")==0) s_opt.noErrors=1;
                else if (strcmp(argv[i],"-olcxtarget")==0) s_opt.cxrefs=OLO_SET_MOVE_TARGET;
                else if (strcmp(argv[i],"-olcxcurrentclass")==0) s_opt.cxrefs=OLO_GET_CURRENT_CLASS;
                else if (strcmp(argv[i],"-olcxcurrentsuperclass")==0) s_opt.cxrefs=OLO_GET_CURRENT_SUPER_CLASS;
                else if (strcmp(argv[i],"-olcxmethodlines")==0) s_opt.cxrefs=OLO_GET_METHOD_COORD;
                else if (strcmp(argv[i],"-olcxclasslines")==0) s_opt.cxrefs=OLO_GET_CLASS_COORD;
                else if (strcmp(argv[i],"-olcxgetsymboltype")==0) s_opt.cxrefs=OLO_GET_SYMBOL_TYPE;
                else if (strcmp(argv[i],"-olcxgetprojectname")==0) {
                        s_opt.cxrefs=OLO_ACTIVE_PROJECT;
                }
                else if (strcmp(argv[i],"-olcxgetjavahome")==0) {
                        s_opt.cxrefs=OLO_JAVA_HOME;
                }
                else if (strncmp(argv[i],"-olcxlccursor=",14)==0) {
                        s_opt.olcxlccursor = argv[i]+14;
                }
                else if (strncmp(argv[i],"-olcxcplsearch=",15)==0) {
                        s_opt.cxrefs=OLO_SEARCH;
                        s_opt.olcxSearchString = argv[i]+15;
                }
                else if (strncmp(argv[i],"-olcxtagsearch=",15)==0) {
                        s_opt.cxrefs=OLO_TAG_SEARCH;
                        s_opt.olcxSearchString = argv[i]+15;
                }
                else if (strncmp(argv[i],"-olcomplselect",14)==0) {
                        s_opt.cxrefs=OLO_CSELECT;
                        s_opt.olcxGotoVal = 0;
                        sscanf(argv[i]+14,"%d",&s_opt.olcxGotoVal);
                }
                else if (strncmp(argv[i],"-olcxcgoto",10)==0) {
                        s_opt.cxrefs = OLO_CGOTO;
                        s_opt.olcxGotoVal = 0;
                        sscanf(argv[i]+10,"%d",&s_opt.olcxGotoVal);
                }
                else if (strncmp(argv[i],"-olcxcbrowse",12)==0) {
                        s_opt.cxrefs = OLO_CBROWSE;
                        s_opt.olcxGotoVal = 0;
                        sscanf(argv[i]+12,"%d",&s_opt.olcxGotoVal);
                }
                else if (strncmp(argv[i],"-olcxgoto",9)==0) {
                        s_opt.cxrefs = OLO_GOTO;
                        s_opt.olcxGotoVal = 0;
                        sscanf(argv[i]+9,"%d",&s_opt.olcxGotoVal);
                }
                else if (strncmp(argv[i],"-olcxfilter=",12)==0) {
                        s_opt.cxrefs = OLO_REF_FILTER_SET;
                        sscanf(argv[i]+12,"%d",&s_opt.filterValue);
                }
                else if (strncmp(argv[i],"-olcxmenuselect",15)==0) {
                        s_opt.cxrefs = OLO_MENU_SELECT;
                        s_opt.olcxMenuSelectLineNum = 0;
                        sscanf(argv[i]+15,"%d",&s_opt.olcxMenuSelectLineNum);
                }
                else if (strncmp(argv[i],"-olcxmenuinspectdef",19)==0) {
                        s_opt.cxrefs = OLO_MENU_INSPECT_DEF;
                        s_opt.olcxMenuSelectLineNum = 0;
                        sscanf(argv[i]+19,"%d",&s_opt.olcxMenuSelectLineNum);
                }
                else if (strncmp(argv[i],"-olcxmenuinspectclass",21)==0) {
                        s_opt.cxrefs = OLO_MENU_INSPECT_CLASS;
                        s_opt.olcxMenuSelectLineNum = 0;
                        sscanf(argv[i]+21,"%d",&s_opt.olcxMenuSelectLineNum);
                }
                else if (strncmp(argv[i],"-olcxctinspectdef",17)==0) {
                        s_opt.cxrefs = OLO_CT_INSPECT_DEF;
                        s_opt.olcxMenuSelectLineNum = 0;
                        sscanf(argv[i]+17,"%d",&s_opt.olcxMenuSelectLineNum);
                }
                else if (strcmp(argv[i],"-olcxmenuall")==0) {
                        s_opt.cxrefs = OLO_MENU_SELECT_ALL;
                }
                else if (strcmp(argv[i],"-olcxmenunone")==0) {
                        s_opt.cxrefs = OLO_MENU_SELECT_NONE;
                }
                else if (strcmp(argv[i],"-olcxmenugo")==0) {
                        s_opt.cxrefs = OLO_MENU_GO;
                }
                else if (strncmp(argv[i],"-olcxmenufilter=",16)==0) {
                        s_opt.cxrefs = OLO_MENU_FILTER_SET;
                        sscanf(argv[i]+16,"%d",&s_opt.filterValue);
                }
                else if (strcmp(argv[i],"-user")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.user=argv[i];
                }
                else if (strcmp(argv[i],"-movefromuser")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.moveFromUser=argv[i];
                        s_opt.cxrefs = OLO_MOVE_FROM_USER;
                }
                else if (strcmp(argv[i],"-o")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.outputFileName=argv[i];
                }
                else if (strcmp(argv[i],"-fastupdate")==0) {
                        s_opt.update = UP_FAST_UPDATE;
                        s_opt.updateOnlyModifiedFiles = 1;
                }
                else if (strcmp(argv[i],"-update")==0) {
                        s_opt.update = UP_FULL_UPDATE;
                        s_opt.updateOnlyModifiedFiles = 1;
                }
                else if (strcmp(argv[i],"-updatem")==0) {
                        s_opt.update = UP_FULL_UPDATE;
                        s_opt.updateOnlyModifiedFiles = 1;
                }
                else if (strcmp(argv[i],"-fupdate")==0) {
                        s_opt.update = UP_FULL_UPDATE;
                        s_opt.updateOnlyModifiedFiles = 0;
                }
                else if (strcmp(argv[i],"-keep_old")==0) s_opt.keep_old = 1;
                else if (strcmp(argv[i],"-optionsVEdit")==0) s_opt.optionsVisualEdit=1;
                else if (strcmp(argv[i],"-create")==0) s_opt.create = 1;
                else if (strcmp(argv[i],"-exactpositionresolve")==0) {
                        s_opt.exactPositionResolve = 1;
                }
                else if (strncmp(argv[i],"-last_message=",14)==0) {
                        s_opt.last_message = argv[i]+14;
                } else if (strcmp(argv[i],"-version")==0||strcmp(argv[i],"-about")==0){
                        s_opt.aboutOption = 1;
                }
# ifdef __QNX__
                else if (strcmp(argv[i],"-qnxmsg")==0) s_opt.qnxMessages = 1;
# endif
                else if (strcmp(argv[i],"-refs")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.cxrefFileName = argv[i];
                }
                else if (strncmp(argv[i],"-refs=",6)==0) {
                        s_opt.cxrefFileName = argv[i]+6;
                }
                else if (strcmp(argv[i],"-file")==0) {
                        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        s_opt.lineFileName = argv[i];
                }
                else if (strcmp(argv[i],"-body")==0) s_opt.body = 1;
                else if (strcmp(argv[i],"-header")==0) s_opt.header = 1;
                else if (strcmp(argv[i],"-help")==0) {
                        usage(argv[0]);
                        exit(0);
                } else {
                        sprintf(tmpBuff,"unknown option %s, (try xref -help)\n",argv[i]);
                        error(ERR_ST,tmpBuff);
                        if ( s_opt.taskRegime==RegimeXref
                                        || s_opt.taskRegime==RegimeHtmlGenerate) {
                                exit(65);
                        }
                }
        }
}
static char * getInputFileFromFtab(int *fArgCount, int flag) {
        char *res;
        int i;
        S_fileItem *fi;
        for(i= *fArgCount; i<s_fileTab.size; i++) {
                fi = s_fileTab.tab[i];
                if (fi!=NULL) {
                        if (flag==FF_SCHEDULED_TO_PROCESS&&fi->b.scheduledToProcess)break;
                        if (flag==FF_COMMAND_LINE_ENTERED&&fi->b.commandLineEntered)break;
                }
        }
        *fArgCount = i;
        if (i<s_fileTab.size) return(s_fileTab.tab[i]->name);
        else return(NULL);
}
static char * getInputFile(int *fArgCount) {
        return(getInputFileFromFtab(fArgCount,FF_SCHEDULED_TO_PROCESS));
}
static char * getCommandLineFile(int *fArgCount) {
        return(getInputFileFromFtab(fArgCount,FF_COMMAND_LINE_ENTERED));
}
static void mainGenerateReferenceFile() {
        char *inputRefFile;
        static int updateFlag = 0;
        if (s_opt.cxrefFileName == NULL) return;
        if (updateFlag == 0 && s_opt.update == 0) {
                genReferenceFile(0, s_opt.cxrefFileName);
                updateFlag = 1;
        } else {
                genReferenceFile(1,s_opt.cxrefFileName);
        }
}
static void schedulingUpdateToProcess(S_fileItem *p) {
        if (p->b.scheduledToUpdate && p->b.commandLineEntered) {
                p->b.scheduledToProcess = 1;
        }
}
static void schedulingToUpdate(S_fileItem *p, void *rs) {
        struct stat fstat,hstat,*refStat;
        char sss[MAX_FILE_NAME_SIZE];
        refStat = (struct stat *) rs;
        if (p == s_fileTab.tab[s_noneFileIndex]) return;
        if (stat(p->name, &fstat)) {
                if (p->b.commandLineEntered) {
                        sprintf(tmpBuff,"file %s not accessible\n", p->name);
                        warning(ERR_ST, tmpBuff);
                }
                p->b.commandLineEntered = 0;
                p->b.scheduledToProcess = 0;
                p->b.scheduledToUpdate = 0;
                if (p->name[0] != ';') {
                        p->b.cxLoading = 1;
                }
        } else if (s_opt.taskRegime == RegimeHtmlGenerate) {
                concatPathes(sss,MAX_FILE_NAME_SIZE,s_opt.htmlRoot,p->name,".html");
                strcat(sss, s_opt.htmlLinkSuffix);
                { if (!(strlen(sss) < MAX_FILE_NAME_SIZE-2)) internalCheckFail("strlen(sss) < MAX_FILE_NAME_SIZE-2", "main.c", 925);};
                if (stat(sss, &hstat) || fstat.st_mtime >= hstat.st_mtime) {
                        p->b.scheduledToUpdate = 1;
                }
        } else if (s_opt.update == UP_FULL_UPDATE) {
                if (fstat.st_mtime!=p->lastFullUpdateMtime) p->b.scheduledToUpdate=1;
        } else {
                if (fstat.st_mtime >= refStat->st_mtime) p->b.scheduledToUpdate = 1;
        }
}
void searchDefaultOptionsFile(char *file, char *ttt, char *sect) {
        struct stat fst;
        int ii,findFlag=0;
        FILE *ff=NULL;
        FILE *ffn;
        int nargc,aaa,hlen;
        char **nargv,*hh;
        ttt[0] = 0; sect[0]=0;
        if (file == NULL) return;
        if (s_stdfFlag || s_opt.no_stdop) return;
        getXrefrcFileName( ttt);
        ff = fopen(ttt,"r");
        if (ff!=NULL) {
                findFlag = readOptionFromFile(ff,&nargc,&nargv,MEM_NO_ALLOC,file,s_opt.project,sect);
                if (findFlag) {
                        { if (s_opt.debug) {fprintf(dumpOut,"options file '%s' section '%s'\n",ttt,sect);fflush(dumpOut);}};
                }
                fclose(ff);
        }
        if (findFlag) return;
        strcpy(ttt,normalizeFileName(file,s_cwd));
        for(; findFlag==0; ) {
                copyDir(ttt,ttt,&ii);
                if (ii == 0) break;
                { if (!(ii+15<MAX_FILE_NAME_SIZE)) internalCheckFail("ii+15<MAX_FILE_NAME_SIZE", "main.c", 963);};
                sprintf(ttt+ii,"Xref.opt");
                if (stat(ttt,&fst)==0 && (fst.st_mode & S_IFMT) != S_IFDIR) {
                        { if (s_opt.debug) {fprintf(dumpOut,"options file '%s'\n",ttt);fflush(dumpOut);}};
                        findFlag = 1;
                } else {
                        ttt[ii-1]=0;
                }
        }
        if (findFlag) {
                if (s_opt.taskRegime!=RegimeEditServer) {
                        sprintf(tmpBuff,"%s\n\t\t%s",
                                        "using of 'Xref.opt' file is an obsolete way of passing",
#ifdef __WIN32__
                                        "options to xref task. Please, use '\\_xrefrc' file"
#else
                                        "options to xref task. Please, use '~/.xrefrc' file"
#endif
                                        );
                        error(ERR_ST, tmpBuff);
                }
                return;
        }
        if (s_opt.project==NULL) {
                strcpy(ttt, oldStdopFile);
                strcpy(sect, oldStdopSection);
                return;
        }
        ttt[0]=0;
        return;
}
static void writeOptionsFileMessage( char *file,
                                                                         char *outFName, char *outSect ) {
        if (s_opt.taskRegime==RegimeEditServer && s_opt.editor==ED_KAWA) return;
        if (s_opt.aboutOption) return;
        if (outFName[0]==0) {
                if (s_opt.project!=NULL) {
                        sprintf(tmpBuff,"'%s' project options not found",
                                        s_opt.project);
                        if (s_opt.taskRegime == RegimeEditServer) {
                                error(ERR_ST, tmpBuff);
                        } else {
                                fatalError(ERR_ST, tmpBuff, 66);
                        }
                } else if (! (s_opt.java2html)) {
                        sprintf(tmpBuff,"no project name covers '%s'",file);
                        warning(ERR_ST, tmpBuff);
                }
        } else if (s_opt.taskRegime==RegimeXref) {
                fprintf(dumpOut,"[Xref] active project: '%s'\n", outSect);
                fflush(dumpOut);
        }
}
static void handlePathologicProjectCases(char *file,char *outFName,char *outSect,int errMessage){
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1022);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (errMessage!=NO_ERROR_MESSAGE) {
                        writeOptionsFileMessage(file, outFName, outSect);
                }
        } else {
                if (*oldStdopFile == 0) {
                        static int messageYetWritten=0;
                        if (messageYetWritten == 0) {
                                messageYetWritten = 1;
                                writeOptionsFileMessage( file, outFName, outSect);
                        }
                } else {
                        if ((outFName[0]==0 || outSect[0]==0) && s_opt.editor!=ED_KAWA) {
                                warning(ERR_ST,"no project name covers this file");
                        }
                        if (outFName[0]==0 && outSect[0]==0) {
                                strcpy(outSect, oldStdopSection);
                        }
                        if (outFName[0]==0) {
                                strcpy(outFName, oldStdopFile);
                        }
                        if(strcmp(oldStdopFile,outFName)||strcmp(oldStdopSection,outSect)){
                                fprintf(dumpOut,"[Xref] new project: '%s'\n", outSect);
                        }
                }
        }
}
static void getOptionsFile(char *file, char *outFName, char *outSect,int errMessage) {
        searchDefaultOptionsFile(file, outFName, outSect);
        handlePathologicProjectCases(file, outFName, outSect, errMessage);
        return;
}
static char *getNameOfInput() {
        if (s_opt.lineFileName!=NULL && s_olStringSecondProcessing==0) {
                return(s_opt.lineFileName);
        } else {
                return(s_input_file_name);
        }
}
static FILE * computeAndOpenInputFile() {
        FILE *inputIn;
        { if (!(s_language)) internalCheckFail("s_language", "main.c", 1067);};
        if (((s_language & (32)) != 0) || ((s_language & (64)) != 0)) return(NULL);
        if (s_input_file_name == NULL) {
                inputIn = stdin;
                if (s_opt.lineFileName!=NULL) {
                        s_input_file_name = s_opt.lineFileName;
                } else {
                        s_input_file_name = "__none__";
                }
        } else if (s_opt.cxrefs == OLO_GET_ENV_VALUE) {
                s_input_file_name = getNameOfInput();
                return(NULL);
        } else {
                if (s_opt.editor == ED_KAWA) {
                        inputIn = fopen(s_input_file_name,"rb");
                } else {
#ifdef __WIN32__
                        inputIn = fopen(s_input_file_name,"rb");
#else
                        inputIn = fopen(s_input_file_name,"r");
#endif
                }
                if (inputIn == NULL) {
                        error(ERR_CANT_OPEN, s_input_file_name);
                }
                s_input_file_name = getNameOfInput();
        }
        initInput(inputIn, "\n", s_input_file_name);
        return(inputIn);
}
static void initOptions() {
        s_opt = s_initOpt;
        s_stdfFlag = 0;
        s_input_file_number = s_noneFileIndex;
}
static void initDefaultCxrefFileName(char *inputfile) {
        int ii;
        static char dcx[MAX_FILE_NAME_SIZE];
        copyDir(dcx, normalizeFileName(inputfile, s_cwd), &ii);
        { if (!(ii < MAX_FILE_NAME_SIZE)) internalCheckFail("ii < MAX_FILE_NAME_SIZE", "main.c", 1111);};
        strcpy(&dcx[ii], DEFAULT_CXREF_FILE);
        { if (!(strlen(dcx) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(dcx) < MAX_FILE_NAME_SIZE", "main.c", 1113);};
        strcpy(dcx, getRealFileNameStatic(normalizeFileName(dcx, s_cwd)));
        { if (!(strlen(dcx) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(dcx) < MAX_FILE_NAME_SIZE", "main.c", 1115);};
        s_opt.cxrefFileName = dcx;
}
static void initializationsPerInvocation() {
        s_cp = s_cpInit;
        s_cps = s_cpsInit;
        s_cxRefFlag=0;
        s_cxRefPos = s_noPos;
        s_olstringFound = 0;
        s_olstringServed = 0;
        s_olstringInMbody = NULL;
        s_jsl = NULL;
}
static void fileTabInit() {
        int len;
        char *ff;
        struct fileItem ffi,*ffii;
        idTabNAInit( &s_fileTab,MAX_FILES);
        len = strlen("___None___");
        {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "main.c", 1136);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(len+1)*sizeof(char) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ff = (char*) (ftMemory + ftMemoryi); ftMemoryi += (len+1)*sizeof(char);};};
        strcpy(ff, "___None___");
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "main.c", 1138);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(1)*sizeof(S_fileItem) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ffii = (S_fileItem*) (ftMemory + ftMemoryi); ftMemoryi += (1)*sizeof(S_fileItem);};};};
        { (ffii)->name = ff; (ffii)->lastModif = 0; (ffii)->lastInspect = 0; (ffii)->lastFullUpdateMtime = 0; (ffii)->b.cxLoading = 0; (ffii)->b.cxLoaded = 0; (ffii)->b.cxSaved = 0; (ffii)->b.commandLineEntered = 0; (ffii)->b.scheduledToProcess = 0; (ffii)->b.scheduledToUpdate = 0; (ffii)->b.fullUpdateIncludesProcessed = 0; (ffii)->b.isInterface = 0; (ffii)->b.sourceFile = s_noneFileIndex; (ffii)->sups = NULL; (ffii)->infs = NULL; (ffii)->directEnclosingInstance = s_noneFileIndex;};
        idTabAdd(&s_fileTab, ffii, &s_noneFileIndex);
}
static void mainParseInputFile() {
        if (s_language == 4) javayyparse();
        else if (s_language == 8) yaccyyparse();
        else cyyparse();
        s_cache.activeCache = 0;
        cFile.fileName = NULL;
}
static void mainSetLanguage( char *inFileName,
                                                                int *outLanguage,
                                                                YYSTYPE **outUniyylval
                                                        ) {
        char *suff;
        suff = getFileSuffix(inFileName);
        if (fileNameHasOneOfSiffixes(inFileName, s_opt.javaFilesSuffixes)) {
                *outLanguage = 4;
                *outUniyylval = & javayylval;
                typesName[TypeStruct] = "class";
        } else if (fnCmp(suff,".zip")==0 || fnCmp(suff,".jar")==0) {
                *outLanguage = 32;
        } else if (fnCmp(suff,".class")==0) {
                *outLanguage = 64;
        } else if (fnCmp(suff,".y")==0) {
                *outLanguage = 8;
                *outUniyylval = & yaccyylval;
                typesName[TypeStruct] = "struct";
        } else {
                *outLanguage = 2;
                *outUniyylval = & cyylval;
                typesName[TypeStruct] = "struct";
        }
}
void getAndProcessXrefrcOptions(char *dffname, char *dffsect,char *project) {
        int dfargc;
        char **dfargv;
        if (*dffname != 0 && s_stdfFlag==0 && s_opt.no_stdop==0) {
                readOptionFile(dffname,&dfargc,&dfargv,dffsect,project);
                processOptions(dfargc, dfargv, INFILES_DISABLED);
        }
}
static void mainFileProcessingInitialisations(
                                        int *firstPassing,
                                        int argc, char **argv,
                                        int nargc, char **nargv,
                                        FILE **outInputIn,
                                        int *outLanguage,
                                        YYSTYPE **outUniyylval
        ) {
        int stargc;
        char **stargv;
        int dfargc;
        char **dfargv;
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        char *ss;
        struct stat dffstat;
        char *fileName;
        int lc;
        fileName = getNameOfInput();
        mainSetLanguage(fileName, outLanguage, outUniyylval);
        getOptionsFile(fileName, dffname, dffsect,DEFAULT_VALUE);
        if (! (s_opt.java2html)) {
                {lc=0;};
                if (lc!=0) {
                                fprintf(errOut,"\n");
                                error(ERR_BIN_LICENSE,"");
                                fprintf(errOut,"\t\tExiting, context will be lost.\n");
                                exit(67);
                }
        }
        initAllInputs();
        if (dffname[0] != 0 ) stat(dffname, &dffstat);
        else dffstat.st_mtime = oldStdopTime;
        if ( *firstPassing
                        || oldCppPass != s_currCppPass
                        || strcmp(oldStdopFile,dffname)
                        || strcmp(oldStdopSection,dffsect)
                        || oldStdopTime != dffstat.st_mtime
                        || oldLanguage!= *outLanguage
                        || strcmp(oldOnLineClassPath, s_opt.classpath)
                        || s_cache.cpi == 1
                ) {
                if (*firstPassing) {
                        initCaching();
                        *firstPassing = 0;
                } else {
                        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
                }
                strcpy(oldOnLineClassPath, s_opt.classpath);
                { if (!(strlen(oldOnLineClassPath)<MAX_OPTION_LEN-1)) internalCheckFail("strlen(oldOnLineClassPath)<MAX_OPTION_LEN-1", "main.c", 1316);};
                s_stdfFlag = 0;
                initPreCreatedTypes();
                initOptions();
                initDefaultCxrefFileName(fileName);
                mainSetLanguage(fileName, outLanguage, outUniyylval);
                getStandardOptions(&stargc,&stargv);
                processOptions(stargc,stargv, INFILES_DISABLED);
                processOptions(argc, argv, INFILES_DISABLED);
                s_tmpOptions = s_opt;
                processOptions(nargc, nargv, INFILES_DISABLED);
                strcpy(oldStdopFile,dffname);
                strcpy(oldStdopSection,dffsect);
                getOptionsFile(fileName, dffname, dffsect,DEFAULT_VALUE);
                s_opt = s_tmpOptions;
                getAndProcessXrefrcOptions(dffname, dffsect, dffsect);
                if (s_opt.taskRegime != RegimeEditServer) {
                        if (s_input_file_name == NULL) {
                                *outInputIn = NULL;
                                goto fini;
                        }
                }
                s_cachedOptions = s_opt;
                processOptions(nargc, nargv, INFILES_DISABLED);
                getJavaClassAndSourcePath();
                initTokenNameTab();
                *outInputIn = computeAndOpenInputFile();
                strcpy(oldStdopFile,dffname);
                strcpy(oldStdopSection,dffsect);
                oldStdopTime = dffstat.st_mtime;
                oldLanguage = *outLanguage;
                oldCppPass = s_currCppPass;
                s_cache.activeCache = 1;
                poseCachePoint(0);
                s_cache.activeCache = 0;
                { if (!(s_cache.lbcc == s_cache.cp[0].lbcc)) internalCheckFail("s_cache.lbcc == s_cache.cp[0].lbcc", "main.c", 1363);};
                { if (!(s_cache.lbcc == s_cache.cp[1].lbcc)) internalCheckFail("s_cache.lbcc == s_cache.cp[1].lbcc", "main.c", 1364);};
        } else {
                s_opt = s_cachedOptions;
                processOptions(nargc, nargv, INFILES_DISABLED);
                *outInputIn = computeAndOpenInputFile();
        }
        mainSetLanguage(fileName, outLanguage, outUniyylval);
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1375);};
        if ( s_opt.taskRegime==RegimeXref
                        || s_opt.taskRegime==RegimeHtmlGenerate) {
                fprintf(dumpOut,"'%s'\n", getRealFileNameStatic(s_input_file_name));
                fflush(dumpOut);
        }
 fini:
        initializationsPerInvocation();
        if (s_opt.keep_old) {
                s_opt.update = UP_FAST_UPDATE;
                s_opt.updateOnlyModifiedFiles = 0;
        }
        if (s_opt.brief) s_opt.long_cxref = 0;
        else s_opt.long_cxref = 1;
        if (s_opt.debug) errOut = dumpOut;
        s_input_file_number = cFile.lb.cb.fileNumber;
        if (s_opt.update == UP_FAST_UPDATE && s_opt.exactPositionResolve) {
                s_opt.update = UP_FULL_UPDATE;
        }
}
static int power(int x, int y) {
        int i,res = 1;
        for(i=0; i<y; i++) res *= x;
        return(res);
}
static void mainTaskEntryInitialisations(int argc, char **argv) {
        char tt[MAX_FILE_NAME_SIZE];
        char ttt[MAX_FILE_NAME_SIZE];
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        char *ss;
        int dfargc;
        char **dfargv;
        int argcount;
        char *sss,*cmdlnInputFile;
        int inmode,ii,topCallFlag;
        void *recursFlag;
        static int firstmemory=0;
        { if (!(MAX_TYPE < power(2,8))) internalCheckFail("MAX_TYPE < power(2,8)", "main.c", 1457);};
        { if (!(MAX_STORAGE < power(2,5))) internalCheckFail("MAX_STORAGE < power(2,5)", "main.c", 1458);};
        { if (!(MAX_SCOPES < power(2,3))) internalCheckFail("MAX_SCOPES < power(2,3)", "main.c", 1459);};
        errOut = stderr;
        dumpOut = stdout;
        memset(&s_count, 0, sizeof(S_counters));
        s_opt.includeDirs = NULL;
        {ftMemoryi = 0;};
        {{ { if (!((MAX_FILES) >= 0)) internalCheckFail("(MAX_FILES) >= 0", "main.c", 1472);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(MAX_FILES)*sizeof(struct fileItem *) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } s_fileTab.tab = (struct fileItem **) (ftMemory + ftMemoryi); ftMemoryi += (MAX_FILES)*sizeof(struct fileItem *);};}; {}; fileTabInit(); { (&s_noPos)->file = s_noneFileIndex; (&s_noPos)->line = 0; (&s_noPos)->coll = 0;};
        { (&s_noRef)->usage = UsageNone; (&s_noRef)->p = s_noPos; (&s_noRef)->next = NULL;};
        s_input_file_number = s_noneFileIndex;
        s_javaAnonymousClassName.p = s_noPos;
        {cxMemory.i = 0;};
        {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 1481);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
        {{ { if (!((sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i)) internalCheckFail("(sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i", "main.c", 1482);}; cxMemory.i = ((char*)(sss))-cxMemory.b;};};
        {{ { if (!((MAX_CXREF_SYMBOLS) >= 0)) internalCheckFail("(MAX_CXREF_SYMBOLS) >= 0", "main.c", 1483);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(MAX_CXREF_SYMBOLS)*sizeof(struct symbolRefItem *) >= cxMemory.size) { if (cxMemory.overflowHandler(MAX_CXREF_SYMBOLS)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } s_cxrefTab.tab = (struct symbolRefItem **) (cxMemory.b + cxMemory.i); cxMemory.i += (MAX_CXREF_SYMBOLS)*sizeof(struct symbolRefItem *);};}; refTabNAInit( &s_cxrefTab,MAX_CXREF_SYMBOLS); if (firstmemory==0) {firstmemory=1;{next=time(NULL);};} {ppmMemoryi = 0;};
        ppMemInit();
        stackMemoryInit();
        {s_symTab = (S_symTab*) stackMemoryAlloc(sizeof(S_symTab)); };
        symTabInit( s_symTab, MAX_SYMBOLS);
        { (&s_initJavaStat)->className = NULL; (&s_initJavaStat)->thisType = NULL; (&s_initJavaStat)->thisClass = NULL; (&s_initJavaStat)->currentNestIndex = 0; (&s_initJavaStat)->unNamedPackageDir = NULL; (&s_initJavaStat)->namedPackageDir = NULL; (&s_initJavaStat)->locals = s_symTab; (&s_initJavaStat)->lastParsedName = NULL; (&s_initJavaStat)->cpMethodMods = 0x000; (&s_initJavaStat)->cp = s_cpInit; (&s_initJavaStat)->classFileInd = s_noneFileIndex; (&s_initJavaStat)->next = NULL;};
        {s_javaStat = (S_javaStat*) stackMemoryAlloc(sizeof(S_javaStat)); };
        *s_javaStat = s_initJavaStat;
        javaFqtTabInit( &s_javaFqtTab, MAX_SYMBOLS);
        cxOut = stdout;
        ccOut = stdout;
        initOptions();
        initAllInputs();
        oldStdopFile[0] = 0; oldStdopSection[0] = 0;
        initCwd();
        initTypeCharCodeTab();
        initTypeModifiersTabs();
        initJavaTypePCTIConvertIniTab();
        initTypesNamesTab();
        initExtractStoragesNameTab();
        olcxInit();
        { (&s_cache)->activeCache = 0; (&s_cache)->cpi = 0; (&s_cache)->ibi = 0; (&s_cache)->lbcc = NULL; (&s_cache)->lexcc = NULL; (&s_cache)->cc = NULL; (&s_cache)->cfin = NULL;};
        initArchaicTypes();
        oldStdopFile[0] = oldStdopSection[0] = 0;
        processOptions(argc, argv, INFILES_ENABLED);
        if (s_opt.taskRegime == RegimeEditServer) errOut = stdout;
        if (s_opt.cxMemoryFaktor > 1) {
                {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 1517);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 1518);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } ss = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i)) internalCheckFail("(sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i", "main.c", 1519);}; cxMemory.i = ((char*)(sss))-cxMemory.b;};};
        }
        if (s_opt.taskRegime==RegimeXref || s_opt.taskRegime==RegimeHtmlGenerate) {
                {{ { if (!((3*CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(3*CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 1523);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(3*CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(3*CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (3*CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i)) internalCheckFail("(sss)>=cxMemory.b && (sss)<= cxMemory.b+cxMemory.i", "main.c", 1524);}; cxMemory.i = ((char*)(sss))-cxMemory.b;};};
        }
        initCaching();
        argcount = 0;
        s_input_file_name = cmdlnInputFile = getCommandLineFile(&argcount);
        if (s_input_file_name==NULL) {
                ss = strmcpy(tt,s_cwd);
                if (ss!=tt && ss[-1] == SLASH) ss[-1]=0;
                { if (!(strlen(tt)+1<MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(tt)+1<MAX_FILE_NAME_SIZE", "main.c", 1534);};
                s_input_file_name=tt;
        } else {
                strcpy(tt, s_input_file_name);
        }
        getOptionsFile(tt, dffname, dffsect, NO_ERROR_MESSAGE);
        if (dffname[0]!=0) {
                readOptionFile(dffname, &dfargc, &dfargv, dffsect, dffsect);
                if (s_opt.taskRegime==RegimeEditServer) {
                        inmode = INFILES_DISABLED;
                } else if (s_opt.create || s_opt.project!=NULL || s_opt.update) {
                        inmode = INFILES_ENABLED;
                } else {
                        inmode = INFILES_DISABLED;
                }
                if (inmode==INFILES_ENABLED && s_opt.update && !s_opt.create) {
                        processOptions(dfargc, dfargv, INFILES_DISABLED);
                        smartReadFileTabFile();
                }
                processOptions(dfargc, dfargv, inmode);
        }
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
        if (s_opt.aboutOption) aboutMessage();
        s_stdfFlag = 0;
        initCaching();
# if defined(__QNX__)
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1572);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (qnx_name_attach(0, QNX_COMPL_SRV_NAME) == -1){
                        fatalError(ERR_ST,"Can't attach name to server");
                }
        }
# endif
}
static void mainReferencesOverflowed(char *cxMemFreeBase, int mess) {
        int i,fi,savingFlag;
        if (mess!=MESS_NONE && s_opt.taskRegime!=RegimeHtmlGenerate) {
                fprintf(dumpOut,"\nswapping references on disk (please wait)\n");
                fflush(dumpOut);
        }
        if (s_opt.cxrefFileName == NULL) {
                fatalError(ERR_ST,"sorry no file for cxrefs, use -refs option", 65);
        }
        for(i=0; i<inStacki; i++) {
                if (inStack[i].lb.cb.ff != stdin) {
                        fi = inStack[i].lb.cb.fileNumber;
                        { if (!(s_fileTab.tab[fi])) internalCheckFail("s_fileTab.tab[fi]", "main.c", 1593);};
                        s_fileTab.tab[fi]->b.cxLoading = 0;
                        if (inStack[i].lb.cb.ff!=NULL) charBuffClose(&inStack[i].lb.cb);
                }
        }
        if (cFile.lb.cb.ff != stdin) {
                fi = cFile.lb.cb.fileNumber;
                { if (!(s_fileTab.tab[fi])) internalCheckFail("s_fileTab.tab[fi]", "main.c", 1600);};
                s_fileTab.tab[fi]->b.cxLoading = 0;
                if (cFile.lb.cb.ff!=NULL) charBuffClose(&cFile.lb.cb);
        }
        if (s_opt.taskRegime==RegimeHtmlGenerate) {
          if (s_opt.noCxFile) {
                sprintf(tmpBuff,"cross-references overflowed, use -mf<n> option");
                fatalError(ERR_ST, tmpBuff, 65);
          }
          generateHtml();
        }
        if (s_opt.taskRegime==RegimeXref) mainGenerateReferenceFile();
        recoverMemoriesAfterOverflow(cxMemFreeBase);
        savingFlag = 0;
        for(i=0; i<s_fileTab.size; i++) {
                if (s_fileTab.tab[i]!=NULL) {
                        if (s_fileTab.tab[i]->b.cxLoading) {
                                s_fileTab.tab[i]->b.cxLoading = 0;
                                s_fileTab.tab[i]->b.cxSaved = 1;
                                if (s_fileTab.tab[i]->b.scheduledToProcess
                                        || !s_opt.multiHeadRefsCare) savingFlag = 1;
                        }
                }
        }
        if (savingFlag==0 && mess!=MESS_FILE_ABORT) {
                fatalError(ERR_NO_MEMORY,"cxMemory", 65);
        }
}
static void getPipedOptions(int *outNargc,char ***outNargv,pid_t*qnxClientPid){
        char nsect[MAX_FILE_NAME_SIZE];
        int c;
        *outNargc = 0;
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1636);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (s_opt.qnxMessages) {
# ifdef __QNX__
                        *qnxClientPid = Receive(0, qnxMsgBuff, QNX_MSG_BUF_SIZE);
                        getOptionsFromMessage(qnxMsgBuff, outNargc, outNargv);
# endif
                } else {
                    readOptionFromFile(stdin,outNargc,outNargv,MEM_ALLOC_ON_SM,
                                                                "",NULL,nsect);
                        c = getc(stdin);
                        if (c==EOF) fatalError(ERR_INTERNAL, "broken input pipe", 65);
                }
        }
}
static void fillIncludeRefItem( S_symbolRefItem *ddd , int fnum) {
        { (&ddd->b)->symType = TypeCppInclude; (&ddd->b)->storage = StorageExtern; (&ddd->b)->scope = ScopeGlobal; (&ddd->b)->accessFlags = 0x000; (&ddd->b)->category = CatGlobal; (&ddd->b)->htmlWasLn = 0;};
        { (ddd)->name = "%%%i"; (ddd)->fileHash = cxFileHashNumber("%%%i"); (ddd)->vApplClass = fnum; (ddd)->vFunClass = fnum; (ddd)->b = ddd->b; (ddd)->refs = NULL; (ddd)->next = NULL;};
}
static void makeIncludeClosureOfFilesToUpdate() {
        char *cxFreeBase;
        int i,ii,fileAddedFlag, isJavaFileFlag;
        S_fileItem *fi,*includer;
        S_symbolRefItem sri,ddd,*memb;
        S_reference *rr;
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 1668);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(0)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (0)*sizeof(char);};};
        readOneAppropReferenceFile("%%%i",
                                                           s_cxFullUpdateScanFunTab);
        fileAddedFlag = 1;
        while (fileAddedFlag) {
                fileAddedFlag = 0;
                for(i=0; i<s_fileTab.size; i++) {
                        fi = s_fileTab.tab[i];
                        if (fi!=NULL && fi->b.scheduledToUpdate
                                && !fi->b.fullUpdateIncludesProcessed) {
                                fi->b.fullUpdateIncludesProcessed = 1;
                                isJavaFileFlag = fileNameHasOneOfSiffixes(fi->name, s_opt.javaFilesSuffixes);
                                fillIncludeRefItem( &ddd, i);
                                if (refTabIsMember(&s_cxrefTab, &ddd, &ii,&memb)) {
                                        for(rr=memb->refs; rr!=NULL; rr=rr->next) {
                                                includer = s_fileTab.tab[rr->p.file];
                                                { if (!(includer)) internalCheckFail("includer", "main.c", 1685);};
                                                if (includer->b.scheduledToUpdate == 0) {
                                                        includer->b.scheduledToUpdate = 1;
                                                        fileAddedFlag = 1;
                                                        if (isJavaFileFlag) {
                                                                includer->b.fullUpdateIncludesProcessed = 1;
                                                        }
                                                }
                                        }
                                }
                        }
                }
        }
        recoverMemoriesAfterOverflow(cxFreeBase);
}
static void scheduleModifiedFilesToUpdate() {
        char ttt[MAX_FILE_NAME_SIZE];
        char *filestab;
        struct stat refStat;
        char *fnamesuff;
        if (s_opt.update==UP_FAST_UPDATE && s_opt.exactPositionResolve) {
                warning(ERR_ST,"-exactpositionresolve implies full update");
                s_opt.update = UP_FULL_UPDATE;
        }
        if (s_opt.refnum <= 1) {
                fnamesuff = "";
                filestab = s_opt.cxrefFileName;
        } else {
                fnamesuff = PRF_FILES;
                sprintf(ttt,"%s%s", s_opt.cxrefFileName, fnamesuff);
                { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "main.c", 1717);};
                filestab = ttt;
        }
        if (stat(filestab, &refStat)) refStat.st_mtime = 0;
        scanReferenceFile(s_opt.cxrefFileName,fnamesuff,"", s_cxScanFileTab);
        idTabMap2(&s_fileTab, schedulingToUpdate, &refStat);
        if (s_opt.update==UP_FULL_UPDATE ) {
                makeIncludeClosureOfFilesToUpdate();
        }
        idTabMap(&s_fileTab, schedulingUpdateToProcess);
}
void resetPendingSymbolMenuData() {
        S_olcxReferences *rstack;
        s_olcxCurrentUser = olcxGetUser(s_opt.user);
        rstack = s_olcxCurrentUser->tops;
        if (rstack == NULL) return;
        if (rstack->menuSym != NULL) {
                olcxFreeResolutionMenu(rstack->menuSym);
                rstack->menuSym = NULL;
        }
}
static void mainOpenOutputFile() {
        if (s_opt.outputFileName!=NULL) {
#ifdef __WIN32__
                ccOut = fopen(s_opt.outputFileName,"wt");
#else
                ccOut = fopen(s_opt.outputFileName,"w");
#endif
        } else {
                ccOut = stdout;
        }
        if (ccOut == NULL) {
                error(ERR_CANT_OPEN,s_opt.outputFileName);
                ccOut = stdout;
        }
        errOut = ccOut;
        dumpOut = ccOut;
}
static int scheduleFileUsingTheMacro() {
        int rr,ii;
        S_symbolRefItem ddd,*memb;
        S_olSymbolsMenu mm, *oldMenu;
        S_olcxReferences *tmpc;
        { if (!(s_olstringInMbody)) internalCheckFail("s_olstringInMbody", "main.c", 1764);};
        tmpc = NULL;
        { (&ddd.b)->symType = TypeMacro; (&ddd.b)->storage = StorageExtern; (&ddd.b)->scope = ScopeGlobal; (&ddd.b)->accessFlags = 0x000; (&ddd.b)->category = CatGlobal; (&ddd.b)->htmlWasLn = 0;};
        { (&ddd)->name = s_olstringInMbody; (&ddd)->fileHash = cxFileHashNumber(s_olstringInMbody); (&ddd)->vApplClass = s_noneFileIndex; (&ddd)->vFunClass = s_noneFileIndex; (&ddd)->b = ddd.b; (&ddd)->refs = NULL; (&ddd)->next = NULL;};
        { (&mm)->s = ddd; (&mm)->selected = 1; (&mm)->visible = 1; (&mm)->ooBits = 0; (&mm)->olUsage = UsageUsed; (&mm)->vlevel = 0; (&mm)->refn = 0; (&mm)->defRefn = 0; (&mm)->defUsage = UsageNone; (&mm)->defpos = s_noPos; (&mm)->outOnLine = 0; (&mm)->next = NULL;};
        if (s_olcxCurrentUser==NULL || s_olcxCurrentUser->tops==NULL) {
                olcxPushUser();
                { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "main.c", 1779);};
                tmpc = s_olcxCurrentUser->tops;
        }
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "main.c", 1782);};
        oldMenu = s_olcxCurrentUser->tops->menuSym;
        s_olcxCurrentUser->tops->menuSym = &mm;
        s_olMacro2PassFile = s_noneFileIndex;
        readOneAppropReferenceFile(s_olstringInMbody,s_cxScanFunTabFor2PassMacroUsage);
        s_olcxCurrentUser->tops->menuSym = oldMenu;
        if (tmpc!=NULL) {
                olStackDeleteSymbol(tmpc);
        }
        if (s_olMacro2PassFile == s_noneFileIndex) return(s_noneFileIndex);
        return(s_olMacro2PassFile);
}
static void setFullUpdateMtimesInFileTab(S_fileItem *fi) {
        if (fi->lastModif > fi->lastFullUpdateMtime) {
                fi->lastFullUpdateMtime = fi->lastModif;
        }
}
static void mainCloseInputFile( FILE *inputIn ) {
        if (inputIn != NULL && inputIn != stdin) {
                fclose(inputIn);
                inputIn=stdin;
        }
}
static void mainEditSrvParseInputFile( int *firstPassing, FILE *inputIn ) {
        { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
        if (inputIn != NULL) {
                if (s_opt.cxrefs!=OLO_TAG_SEARCH && s_opt.cxrefs != OLO_PUSH_NAME) {
                        recoverFromCache();
                        mainParseInputFile();
                        *firstPassing = 0;
                }
                cFile.lb.cb.isAtEOF = 0;
        }
        mainCloseInputFile( inputIn);
}
static void mainPushThisFileIncludeReferences(int fnum) {
        S_symbolRefItem sref;
        fillIncludeRefItem( &sref,fnum);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "main.c", 1831);};
        olAddBrowsedSymbol(&sref, &s_olcxCurrentUser->tops->hkSelectedSym,
                                           1, 1, 0, UsageDefined,0,&s_noPos,UsageNone);
}
static int mainSymbolCanBeIdentifiedByPosition(int fnum) {
        int line,col;
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        if (!creatingOlcxRefs()) return(0);
        if (s_opt.browsedSymName == NULL) return(0);
        if (s_opt.modifiedFlag == 1) return(0);
        if (s_fileTab.tab[fnum]->b.commandLineEntered) return(0);
        if (s_fileTab.tab[fnum]->lastModif!=s_fileTab.tab[fnum]->lastFullUpdateMtime) return(0);
        getLineColCursorPositionFromCommandLineOption( &line, &col);
        { (&s_olcxByPassPos)->file = fnum; (&s_olcxByPassPos)->line = line; (&s_olcxByPassPos)->coll = col;};
        olSetCallerPosition(&s_olcxByPassPos);
        readOneAppropReferenceFile(s_opt.browsedSymName, s_cxByPassFunTab);
        if (s_olcxCurrentUser->tops->hkSelectedSym==NULL) return(0);
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
    return(1);
}
static void mainEditSrvFileSingleCppPass( int argc, char **argv,
                                                                                  int nargc, char **nargv,
                                                                                  int *firstPassing
        ) {
        FILE *inputIn;
        int ol2procfile,line,col;
        inputIn = stdin;
        s_olStringSecondProcessing = 0;
        mainFileProcessingInitialisations(firstPassing, argc, argv,
                                          nargc, nargv, &inputIn, &s_language, &uniyylval);
        smartReadFileTabFile();
        s_olOriginalFileNumber = s_input_file_number;
        if (mainSymbolCanBeIdentifiedByPosition(s_input_file_number)) {
                mainCloseInputFile(inputIn);
                return;
        }
        mainEditSrvParseInputFile( firstPassing, inputIn);
        if (s_opt.olCursorPos==0 && !((s_language & (4)) != 0)) {
                if (creatingOlcxRefs()) {
                        S_position dpos;
                        { (&dpos)->file = s_input_file_number; (&dpos)->line = 1; (&dpos)->coll = 0;};
                        gotOnLineCxRefs(&dpos);
                }
                addThisFileDefineIncludeReference(s_input_file_number);
        }
        if (s_olstringFound && s_olstringServed==0) {
                ol2procfile = scheduleFileUsingTheMacro();
                if (ol2procfile!=s_noneFileIndex) {
                        s_input_file_name = s_fileTab.tab[ol2procfile]->name;
                        inputIn = stdin;
                        s_olStringSecondProcessing=1;
                        mainFileProcessingInitialisations(firstPassing, argc, argv,
                                          nargc, nargv, &inputIn, &s_language, &uniyylval);
                        mainEditSrvParseInputFile( firstPassing, inputIn);
                }
        }
}
static void mainEditServerProcessFile( int argc, char **argv,
                                                                           int nargc, char **nargv,
                                                                           int *firstPassing
        ) {
        FILE *inputIn;
        int ol2procfile;
        { if (!(s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess)) internalCheckFail("s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess", "main.c", 1924);};
        s_maximalCppPass = 1;
        s_currCppPass = 1;
        for(s_currCppPass=1; s_currCppPass<=s_maximalCppPass; s_currCppPass++) {
                s_input_file_name = s_fileTab.tab[s_olOriginalComFileNumber]->name;
                { if (!(s_input_file_name!=NULL)) internalCheckFail("s_input_file_name!=NULL", "main.c", 1929);};
                mainEditSrvFileSingleCppPass( argc, argv, nargc, nargv, firstPassing);
                if (s_opt.cxrefs==OLO_EXTRACT
                        || (s_olstringServed && ! creatingOlcxRefs())) goto fini;
        }
        fini:
        s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess = 0;
}
char * presetFewFileDependingStatics() {
        int fArgCount;
        char *fileName;
        s_fileProcessStartTime = time(NULL);
        fArgCount = 0; s_input_file_name = getInputFile(&fArgCount);
        { if (!(fArgCount>=0 && fArgCount<s_fileTab.size && s_fileTab.tab[fArgCount]->b.scheduledToProcess)) internalCheckFail("fArgCount>=0 && fArgCount<s_fileTab.size && s_fileTab.tab[fArgCount]->b.scheduledToProcess", "main.c", 1943);};
        s_olOriginalComFileNumber = fArgCount;
        fileName = getNameOfInput();
        mainSetLanguage(fileName, &s_language, &uniyylval);
        s_paramPosition = s_noPos;
        return(fileName);
}
static int dummy( char **cxFreeBase0, char **cxFreeBase, char **fn, int *fc,
                                        FILE **inputIn, int *firstPassing) {
        return(0);
}
static void mainXrefProcessInputFile( int argc, char **argv, FILE **_inputIn, int *_firstPassing, int *_atLeastOneProcessed ) {
        FILE *inputIn = *_inputIn;
        int firstPassing = *_firstPassing;
        int atLeastOneProcessed = *_atLeastOneProcessed;
        s_maximalCppPass = 1;
        for(s_currCppPass=1; s_currCppPass<=s_maximalCppPass;
                s_currCppPass++) {
                if (! firstPassing) s_opt = s_cachedOptions;
                mainFileProcessingInitialisations(&firstPassing,
                                                                                  argc, argv, 0, NULL, &inputIn,
                                                                                  &s_language, &uniyylval);
                s_olOriginalFileNumber = s_input_file_number;
                s_olOriginalComFileNumber = s_olOriginalFileNumber;
                { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
                if (inputIn != NULL) {
                        recoverFromCache();
                        s_cache.activeCache = 0;
                        mainParseInputFile();
                        if (inputIn != stdin) {
                                { if (!(cFile.lb.cb.ff == inputIn)) internalCheckFail("cFile.lb.cb.ff == inputIn", "main.c", 1978);};
                                charBuffClose(&cFile.lb.cb);
                                inputIn = cFile.lb.cb.ff = stdin;
                        }
                        atLeastOneProcessed=1;
                } else if (((s_language & (32)) != 0)) {
                        jarFileParse();
                        atLeastOneProcessed=1;
                } else if (((s_language & (64)) != 0)) {
                        classFileParse();
                        atLeastOneProcessed=1;
                } else {
                        error(ERR_CANT_OPEN,s_input_file_name);
                        fprintf(dumpOut,"\tmaybe forgotten -p option?\n");
                }
                firstPassing = 0;
                cFile.lb.cb.isAtEOF = 0;
        }
        *_inputIn = inputIn;
        *_firstPassing = firstPassing;
        *_atLeastOneProcessed = atLeastOneProcessed;
}
static void mainXref(int argc, char **argv) {
        static char *cxFreeBase0, *cxFreeBase, *fn;
        static int fc,lc;
        static FILE *inputIn;
        static int firstPassing,mess,atLeastOneProcessed;
        dummy(&cxFreeBase0, &cxFreeBase, &fn, &fc, &inputIn, &firstPassing);
        if (s_opt.taskRegime != RegimeHtmlGenerate) {
          {lc=0;};
          if (lc != 0) {
                  fprintf(errOut,"\n");
                  fatalError(ERR_LICENSE,"", 67);
          }
        }
        s_currCppPass = (-1);
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2026);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(0)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase0 = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (0)*sizeof(char);};};
        if (s_opt.taskRegime == RegimeHtmlGenerate && ! s_opt.noCxFile) {
                htmlGetDefinitionReferences();
        }
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2030);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(0)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (0)*sizeof(char);};};
        s_cxResizingBlocked = 1;
        if (s_opt.update) scheduleModifiedFilesToUpdate();
        if (s_opt.optionsVisualEdit) optionsVisualEdit();
        fc = 0; atLeastOneProcessed = 0;
        for(;;) {
                s_currCppPass = (-1);
                inputIn = stdin;
                firstPassing = 1;
                if ((mess=setjmp(cxmemOverflow))!=0) {
                        mainReferencesOverflowed(cxFreeBase,mess);
                        if (mess==MESS_FILE_ABORT) {
                                fc++;
                        }
                } else {
                        for(fn=getInputFile(&fc); fn!=NULL; fc++,fn=getInputFile(&fc)) {
                                s_input_file_name = fn;
                                s_fileProcessStartTime = time(NULL);
                                mainXrefProcessInputFile(argc, argv, &inputIn,
                                                                        &firstPassing, &atLeastOneProcessed);
                        }
                        goto regime1fini;
                }
        }
regime1fini:
        if (atLeastOneProcessed) {
                if (s_opt.taskRegime==RegimeHtmlGenerate) {
                        atLeastOneProcessed = 0;
                        generateHtml();
                        if (s_opt.noCxFile) {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2061);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(0)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase0 = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (0)*sizeof(char);};};
                        htmlGenGlobalReferenceLists(cxFreeBase0);
                }
                if (s_opt.taskRegime==RegimeXref) {
                        if (s_opt.update==0 || s_opt.update==UP_FULL_UPDATE) {
                                idTabMap(&s_fileTab, setFullUpdateMtimesInFileTab);
                        }
                        fprintf(dumpOut, "Generating '%s'\n",s_opt.cxrefFileName);
                        fflush(dumpOut);
                        mainGenerateReferenceFile();
                }
        } else if (! s_opt.update) {
                sprintf(tmpBuff,"no input file");
                error(ERR_ST, tmpBuff);
        }
        if (s_opt.last_message!=NULL) {
                fflush(dumpOut);
                fprintf(dumpOut,"%s\n\n", s_opt.last_message); fflush(dumpOut);
                fflush(dumpOut);
        }
}
static void mainEditServer(int argc, char **argv) {
        int nargc; char **nargv;
        FILE *inputIn;
        int firstPassing, fArgCount;
        pid_t qnxClientPid;
        s_cxResizingBlocked = 1;
        firstPassing = 1;
        s_cachedOptions = s_opt;
        for(;;) {
                s_currCppPass = (-1);
                s_opt = s_cachedOptions;
                getPipedOptions(&nargc, &nargv, &qnxClientPid);
                s_opt.classpath = "";
                processOptions(nargc, nargv, INFILES_ENABLED);
                if (s_opt.cxrefs == OLO_EXTRACT) s_cache.cpi = 2;
                s_olcxCurrentUser = olcxGetUser(s_opt.user);
                { (&s_completions)->idToProcessLen = 0; (&s_completions)->idToProcessPos = s_noPos; (&s_completions)->fullMatchFlag = 0; (&s_completions)->isCompleteFlag = 0; (&s_completions)->maxLen = 0; (&s_completions)->ai = 0;};
                mainOpenOutputFile();
                if ( s_opt.cxrefs==OLO_COMPLETION || s_opt.cxrefs==OLO_SEARCH
                        || s_opt.cxrefs==OLO_EXTRACT || s_opt.cxrefs==OLO_TAG_SEARCH
                        || s_opt.cxrefs==OLO_SET_MOVE_TARGET
                        || s_opt.cxrefs==OLO_GET_CURRENT_CLASS
                        || s_opt.cxrefs==OLO_GET_CURRENT_SUPER_CLASS
                        || s_opt.cxrefs==OLO_GET_METHOD_COORD
                        || s_opt.cxrefs==OLO_GET_CLASS_COORD
                        || s_opt.cxrefs==OLO_GET_ENV_VALUE
                        || creatingOlcxRefs()) {
                        presetFewFileDependingStatics();
                        if (creatingOlcxRefs()) olcxPushUser();
                        mainEditServerProcessFile(argc,argv,nargc,nargv,&firstPassing);
                }
                mainAnswerEditAction(qnxClientPid);
                s_opt.outputFileName = NULL;
                if (s_opt.cxrefs == OLO_EXTRACT) s_cache.cpi = 2;
        }
        { if (!(0)) internalCheckFail("0", "main.c", 2128);};
}
static void mainGenerate(int argc, char **argv) {
        FILE *inputIn;
        int fArgCount, firstPassing;
        s_currCppPass = (-1);
        inputIn = stdin;
        s_fileProcessStartTime = time(NULL);
        fArgCount = 0; s_input_file_name = getInputFile(&fArgCount);
        s_maximalCppPass = 0;
        firstPassing = 1;
        mainFileProcessingInitialisations(&firstPassing, argc, argv, 0, NULL,
                                &inputIn, &s_language, &uniyylval);
        s_olOriginalFileNumber = s_input_file_number;
        s_olOriginalComFileNumber = s_olOriginalFileNumber;
        { if ((((unsigned)time(NULL))>(unsigned)1067641200) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
        if (inputIn != NULL) {
                recoverFromCache();
                mainParseInputFile();
                if (inputIn != stdin) {fclose(inputIn);inputIn=stdin;}
                cFile.lb.cb.isAtEOF = 0;
        }
        if (s_opt.str_fill) genProjections(20);
        symTabMap(s_symTab, generate);
}
int main(int argc, char **argv) {
        setjmp(s_memoryResize);
        if (s_cxResizingBlocked) {
                fatalError(ERR_ST,"cx_memory resizing required, see the TROUBLES section of README file", 65);
        }
        s_currCppPass = (-1);
        mainTaskEntryInitialisations(argc, argv);
        if (s_opt.taskRegime == RegimeXref) mainXref(argc, argv);
        if (s_opt.taskRegime == RegimeHtmlGenerate) mainXref(argc, argv);
        if (s_opt.taskRegime == RegimeEditServer) mainEditServer(argc, argv);
        if (s_opt.taskRegime == RegimeGenerate) mainGenerate(argc, argv);
        return(0);
}
