
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
int testFileModifTime(int ii) {
        struct stat fst;
        int res;
        time_t t0;
        { if (!(s_fileTab.tab[ii] != NULL)) internalCheckFail("s_fileTab.tab[ii] != NULL", "caching.c", 24);};
        t0 = time(NULL);
        if (s_fileTab.tab[ii]->lastInspect >= s_fileProcessStartTime
                && s_fileTab.tab[ii]->lastInspect <= t0) {
                res = 1;
                goto fini;
        }
        if (stat(s_fileTab.tab[ii]->name, &fst)) {
                res = 0;
                goto fini;
        }
        s_fileTab.tab[ii]->lastInspect = t0;
        if (fst.st_mtime == s_fileTab.tab[ii]->lastModif) {
                res = 1;
        } else {
                s_fileTab.tab[ii]->lastModif = fst.st_mtime;
                res = 0;
        }
fini:
        return(res);
}
static void deleteReferencesOutOfMemory(S_reference **rr) {
        while (*rr!=NULL) {
                if (( ((char*)*rr) >= cxMemory.b + (cxMemory.i) && ((char*)*rr) < cxMemory.b + (cxMemory.size) )) {
                        *rr = (*rr)->next;
                        continue;
                }
                rr= &(*rr)->next;
        }
}
static void cxrefTabDeleteOutOfMemory(int i) {
        S_symbolRefItem **pp;
        pp = &s_cxrefTab.tab[i];
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= cxMemory.b + (cxMemory.i) && ((char*)*pp) < cxMemory.b + (cxMemory.size) )) {
                        *pp = (*pp)->next;
                        continue;
                } else {
                        deleteReferencesOutOfMemory(&(*pp)->refs);
                }
                pp= &(*pp)->next;
        }
}
static void fileTabDeleteOutOfMemory(S_fileItem *p, int i) {
        S_chReference **hh;
        hh = &p->sups;
        while (*hh!=NULL) {
                if (( ((char*)*hh) >= cxMemory.b + (cxMemory.i) && ((char*)*hh) < cxMemory.b + (cxMemory.size) )) {
            *hh = (*hh)->next;
            goto contlabel;
                }
                hh= &(*hh)->next;
        contlabel:;
        }
        hh = &p->infs;
        while (*hh!=NULL) {
                if (( ((char*)*hh) >= cxMemory.b + (cxMemory.i) && ((char*)*hh) < cxMemory.b + (cxMemory.size) )) {
            *hh = (*hh)->next;
            goto contlabel2;
                }
                hh= &(*hh)->next;
        contlabel2:;
        }
}
static void structCachingFree(S_symbol *pp) {
        S_symbolList **tp;
        { if (!(pp->u.s)) internalCheckFail("pp->u.s", "caching.c", 112);};
        if (( ((char*)pp->u.s->records) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->records) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->records) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->records) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->records = NULL;
        }
        if (( ((char*)pp->u.s->casts.node) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->casts.node) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->casts.node) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->casts.node) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->casts.node = NULL;
        }
        if (( ((char*)pp->u.s->casts.sub) >= memory+s_topBlock->firstFreeIndex && ((char*)pp->u.s->casts.sub) < memory+SIZE_workMemory) ||
                ( ((char*)pp->u.s->casts.sub) >= ppmMemory + ppmMemoryi && ((char*)pp->u.s->casts.sub) < ppmMemory + SIZE_ppmMemory )) {
                pp->u.s->casts.sub = NULL;
        }
        tp = &pp->u.s->super;
        while (*tp!=NULL) {
                if (( ((char*)*tp) >= memory+s_topBlock->firstFreeIndex && ((char*)*tp) < memory+SIZE_workMemory) ||
                        ( ((char*)*tp) >= ppmMemory + ppmMemoryi && ((char*)*tp) < ppmMemory + SIZE_ppmMemory )) {
                        *tp = (*tp)->next;
            goto contlabel;
                }
                tp = &(*tp)->next;
        contlabel:;
        }
}
static void symTabDeleteOutOfMemory(int i) {
        S_symbol **pp;
        pp = &s_symTab->tab[i];
        while (*pp!=NULL) {
                switch ((*pp)->b.symType) {
                case TypeMacro:
                        if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                        }
                        break;
                case TypeStruct: case TypeUnion:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory) || ( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                        } else {
                                structCachingFree(*pp);
                        }
                        break;
                case TypeEnum:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                                *pp = (*pp)->next; continue;
                        } else if (( ((char*)(*pp)->u.enums) >= memory+s_topBlock->firstFreeIndex && ((char*)(*pp)->u.enums) < memory+SIZE_workMemory)) {
                                (*pp)->u.enums = NULL;
                        }
                        break;
                default:
                        if (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                                *pp = (*pp)->next; continue;
                        }
                        break;
                }
                pp= &(*pp)->next;
        }
}
static void javaFqtTabDeleteOutOfMemory(int i) {
        S_symbolList **pp;
        pp = &s_javaFqtTab.tab[i];
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                } else if (( ((char*)(*pp)->d) >= memory+s_topBlock->firstFreeIndex && ((char*)(*pp)->d) < memory+SIZE_workMemory)
                                        || ( ((char*)(*pp)->d) >= ppmMemory + ppmMemoryi && ((char*)(*pp)->d) < ppmMemory + SIZE_ppmMemory )) {
                                *pp = (*pp)->next; continue;
                } else {
                        structCachingFree((*pp)->d);
                }
                pp= &(*pp)->next;
        }
}
static void trailDeleteOutOfMemory() {
        S_freeTrail **pp;
        pp = & s_topBlock->trail;
        while (( ((char*)*pp) >= memory+s_topBlock->firstFreeIndex && ((char*)*pp) < memory+SIZE_workMemory)) {
                *pp = (*pp)->next;
        }
}
static void includeListDeleteOutOfMemory() {
        S_stringList **pp;
        pp = & s_opt.includeDirs;
        while (*pp!=NULL) {
                if (( ((char*)*pp) >= ppmMemory + ppmMemoryi && ((char*)*pp) < ppmMemory + SIZE_ppmMemory )) {
                        *pp = (*pp)->next; continue;
                }
                pp= &(*pp)->next;
        }
}
static int cachedIncludedFilePass(int cpi) {
        int i,mi,mt;
        { if (!(cpi > 0)) internalCheckFail("cpi > 0", "caching.c", 214);};
        mi = s_cache.cp[cpi].ibi;
        for(i=s_cache.cp[cpi-1].ibi; i<mi; i++) {
                mt = testFileModifTime(s_cache.ib[i]);
                if (mt == 0) return(0);
        }
        return(1);
}
void recoverCxMemory(char *cxMemFreeBase) {
        {{ { if (!((cxMemFreeBase)>=cxMemory.b && (cxMemFreeBase)<= cxMemory.b+cxMemory.i)) internalCheckFail("(cxMemFreeBase)>=cxMemory.b && (cxMemFreeBase)<= cxMemory.b+cxMemory.i", "caching.c", 228);}; cxMemory.i = ((char*)(cxMemFreeBase))-cxMemory.b;};};
        idTabMap3(&s_fileTab, fileTabDeleteOutOfMemory);
        refTabMap3(&s_cxrefTab, cxrefTabDeleteOutOfMemory);
}
void recoverMemoriesAfterOverflow(char *cxMemFreeBase) {
        recoverCxMemory(cxMemFreeBase);
        initAllInputs();
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
}
void recoverCachePoint(int i, char *readedUntil, int activeCaching) {
        S_cachePoint *cp;
        cp = &s_cache.cp[i];
        ppmMemoryi = cp->ppmMemoryi;
        mbMemoryi = cp->mbMemoryi;
        s_topBlock = cp->topBlock;
        tmpWorkMemoryi = 0;
        *s_topBlock = cp->starTopBlock;
        s_javaStat = cp->javaCached;
        s_count = cp->counts;
        trailDeleteOutOfMemory();
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "caching.c", 252);};
        if (s_opt.taskRegime==RegimeEditServer && s_currCppPass==1) {
                cxMemory.i = cp->cxMemoryi;
                refTabMap3(&s_cxrefTab, cxrefTabDeleteOutOfMemory);
                idTabMap3(&s_fileTab, fileTabDeleteOutOfMemory);
        }
        symTabMap3(s_symTab, symTabDeleteOutOfMemory);
        javaFqtTabMap3(&s_javaFqtTab, javaFqtTabDeleteOutOfMemory);
        includeListDeleteOutOfMemory();
        cFile.lineNumber = cp->lineNumber;
        cFile.ifDeep = cp->ifDeep;
        cFile.ifstack = cp->ifstack;
        { (&cInput)->cc = cp->lbcc; (&cInput)->fin = readedUntil; (&cInput)->a = s_cache.lb; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_CACHE;};
        { (&s_cache)->activeCache = activeCaching; (&s_cache)->cpi = i+1; (&s_cache)->ibi = cp->ibi; (&s_cache)->lbcc = cp->lbcc; (&s_cache)->lexcc = cInput.cc; (&s_cache)->cc = cInput.cc; (&s_cache)->cfin = cInput.fin;};
}
void recoverFromCache() {
        int i;
        char *readedUntil;
        { if (!(s_cache.cpi >= 1)) internalCheckFail("s_cache.cpi >= 1", "caching.c", 292);};
        s_cache.activeCache = 0;
        { if (s_opt.debug) {fprintf(dumpOut,": reading from cache\n");fflush(dumpOut);}};
        readedUntil = s_cache.cp[0].lbcc;
        for(i=1; i<s_cache.cpi; i++) {
                if (cachedInputPass(i,&readedUntil) == 0) break;
                if (cachedIncludedFilePass(i) == 0) break;
        }
        { if (!(i > 1)) internalCheckFail("i > 1", "caching.c", 302);};
        { if (s_opt.debug) {fprintf(dumpOut,"recovering cache point %d\n",i-1);fflush(dumpOut);}};
        recoverCachePoint(i-1, readedUntil, 1);
}
void initCaching() {
        { (&s_cache)->activeCache = 1; (&s_cache)->cpi = 0; (&s_cache)->ibi = 0; (&s_cache)->lbcc = s_cache.lb; (&s_cache)->lexcc = cFile.lb.cc; (&s_cache)->cc = NULL; (&s_cache)->cfin = NULL;};
        poseCachePoint(0);
        s_cache.activeCache = 0;
}
void cacheInput() {
        int size;
        if (s_cache.activeCache == 0) return;
        if (inStacki != 0 || macStacki != 0) return;
        size = cInput.cc - s_cache.lexcc;
        if ( s_cache.lbcc - s_cache.lb + size >= LEX_BUF_CACHE_SIZE) {
                s_cache.activeCache = 0;
                return;
        }
        if (cInput.margExpFlag != II_CACHE) memcpy(s_cache.lbcc, s_cache.lexcc, size);
        s_cache.lbcc += size;
        s_cache.lexcc = cInput.cc;
}
void cacheInclude(int fileNum) {
        if (s_cache.activeCache == 0) return;
        testFileModifTime(fileNum);
        { if (!(s_cache.ibi < INCLUDE_CACHE_SIZE)) internalCheckFail("s_cache.ibi < INCLUDE_CACHE_SIZE", "caching.c", 341);};
        s_cache.ib[s_cache.ibi] = fileNum;
        s_cache.ibi ++;
        if (s_cache.ibi >= INCLUDE_CACHE_SIZE) s_cache.activeCache = 0;
}
void poseCachePoint(int inputCaching) {
        struct cachePoint *pp;
        if (s_cache.activeCache == 0) return;
        if (inStacki != 0 || macStacki != 0) return;
        if (s_cache.cpi >= MAX_CACHE_POINTS) {
                s_cache.activeCache = 0;
                return;
        }
        if (inputCaching) cacheInput();
        if (s_cache.activeCache == 0) return;
        if (tmpWorkMemoryi != 0) return;
        pp = &s_cache.cp[s_cache.cpi];
        { if (s_opt.debug) {fprintf(dumpOut,"posing cache point %d \n",s_cache.cpi);fflush(dumpOut);}};
        { (pp)->topBlock = s_topBlock; (pp)->starTopBlock = *s_topBlock; (pp)->ppmMemoryi = ppmMemoryi; (pp)->cxMemoryi = cxMemory.i; (pp)->mbMemoryi = mbMemoryi; (pp)->lbcc = s_cache.lbcc; (pp)->ibi = s_cache.ibi; (pp)->lineNumber = cFile.lineNumber; (pp)->ifDeep = cFile.ifDeep; (pp)->ifstack = cFile.ifstack; (pp)->javaCached = s_javaStat; (pp)->counts = s_count;};
        s_cache.cpi ++;
}
