
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
struct javaCpClassInfo {
        short int nameIndex;
};
struct javaCpNameAndTypeInfo {
        short int nameIndex;
        short int signatureIndex;
};
struct javaCpRecordInfo {
        short int classIndex;
        short int nameAndTypeIndex;
};
union constantPoolUnion {
        char *asciz;
        struct javaCpClassInfo clas;
        struct javaCpNameAndTypeInfo nt;
        struct javaCpRecordInfo rec;
};
struct zipIndexItem {
        unsigned offset;
        char name;
};
static int zipReadLocalFileHeader(char **accc, char **affin, S_charBuf *iBuf,
                                                                char *fn, unsigned *fsize, unsigned *lastSig,
                                                                char *archivename, unsigned fileOffset) {
        int res;
        register char *ccc, *ffin;
        register int i,offset;
        int headSig,extractVersion,bitFlags,compressionMethod;
        int lastModTime,lastModDate,fnameLen,extraLen;
        unsigned crc32,compressedSize,unCompressedSize;
        static int compressionErrorWritten=0;
        char *zzz, ttt[MAX_FILE_NAME_SIZE];
        res = 1;
        ccc = *accc; ffin = *affin;
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { headSig = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; headSig = * ((unsigned char*)ccc); ccc ++; } } else { headSig = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<24);};
        *lastSig = headSig;
        if (headSig != 0x04034b50) {
                static int messagePrinted = 0;
                if (messagePrinted==0) {
                        messagePrinted = 1;
                        sprintf(tmpBuff,
                                "archiv %s is corrupted or modified while xref task running",
                                archivename);
                        error(ERR_ST, tmpBuff);
                        if (s_opt.taskRegime == RegimeEditServer) {
                                fprintf(errOut,"\t\tplease, kill xref process and retry.\n");
                        }
                }
                res = 0;
                goto fin;
        }
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extractVersion = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extractVersion = * ((unsigned char*)ccc); ccc ++; } } else { extractVersion = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extractVersion = extractVersion+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { bitFlags = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; bitFlags = * ((unsigned char*)ccc); ccc ++; } } else { bitFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; bitFlags = bitFlags+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressionMethod = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressionMethod = * ((unsigned char*)ccc); ccc ++; } } else { compressionMethod = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressionMethod = compressionMethod+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModTime = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModTime = * ((unsigned char*)ccc); ccc ++; } } else { lastModTime = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModTime = lastModTime+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModDate = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModDate = * ((unsigned char*)ccc); ccc ++; } } else { lastModDate = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModDate = lastModDate+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { crc32 = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; crc32 = * ((unsigned char*)ccc); ccc ++; } } else { crc32 = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<24);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressedSize = * ((unsigned char*)ccc); ccc ++; } } else { compressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<24);};
        *fsize = compressedSize;
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { unCompressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; unCompressedSize = * ((unsigned char*)ccc); ccc ++; } } else { unCompressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<24);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fnameLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fnameLen = * ((unsigned char*)ccc); ccc ++; } } else { fnameLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; fnameLen = fnameLen+(chh<<8);};
        if (fnameLen >= MAX_FILE_NAME_SIZE) {
                fatalError(ERR_INTERNAL,"file name too long", 65);
        }
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extraLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extraLen = * ((unsigned char*)ccc); ccc ++; } } else { extraLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extraLen = extraLen+(chh<<8);};
        for(i=0; i<fnameLen; i++) {
                { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fn[i] = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fn[i] = * ((unsigned char*)ccc); ccc ++; } } else { fn[i] = * ((unsigned char*)ccc); ccc++; } };
        }
        fn[i] = 0;
        { register int ccount,i,ch; ccount = (extraLen); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(extraLen)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }};
        if (compressionMethod == 0) {
        }
#if defined(USE_LIBZ)
        else if (compressionMethod == Z_DEFLATED) {
                iBuf->cc = ccc;
                iBuf->fin = ffin;
                switchToZippedCharBuff(iBuf);
                ccc = iBuf->cc;
                ffin = iBuf->fin;
        }
#endif
        else {
                res = 0;
                if (compressionErrorWritten==0) {
                        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cfread.c", 202);};
                                strcpy(ttt, archivename);
                                zzz = strchr(ttt, ';');
                                if (zzz!=NULL) *zzz = 0;
                                sprintf(tmpBuff,"\n\tfiles in %s are compressed by unknown method #%d\n", ttt, compressionMethod);
                                sprintf(tmpBuff+strlen(tmpBuff),
                                        "\tRun 'jar2jar0 %s' command to uncompress them.\n", ttt);
                                { if (!(strlen(tmpBuff)+1 < TMP_BUFF_SIZE)) internalCheckFail("strlen(tmpBuff)+1 < TMP_BUFF_SIZE", "cfread.c", 211);};
                                error(ERR_ST,tmpBuff);
                        compressionErrorWritten = 1;
                }
        }
        goto fin;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fin:
        *accc = ccc; *affin = ffin;
        return(res);
}
static int zipFindFileInCd(char **accc, char **affin, S_charBuf *iBuf,
                                                        char *fname, unsigned *foffset
                                                        ) {
        char fn[MAX_FILE_NAME_SIZE];
        int headSig,madeByVersion,extractVersion,bitFlags,compressionMethod;
        int lastModTime,lastModDate,fnameLen,extraLen,fcommentLen,diskNumber;
        int i,internFileAttribs;
        unsigned externFileAttribs,localHeaderOffset;
        unsigned crc32,compressedSize,unCompressedSize;
        char *ccc, *ffin;
        unsigned fsize, lastSig;
        int res = 0;
        unsigned offset;
        ccc = *accc; ffin = *affin;
        for(;;) {
                { { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { headSig = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; headSig = * ((unsigned char*)ccc); ccc ++; } } else { headSig = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<24);}; if (headSig != 0x02014b50) goto endcd; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { madeByVersion = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; madeByVersion = * ((unsigned char*)ccc); ccc ++; } } else { madeByVersion = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; madeByVersion = madeByVersion+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extractVersion = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extractVersion = * ((unsigned char*)ccc); ccc ++; } } else { extractVersion = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extractVersion = extractVersion+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { bitFlags = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; bitFlags = * ((unsigned char*)ccc); ccc ++; } } else { bitFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; bitFlags = bitFlags+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressionMethod = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressionMethod = * ((unsigned char*)ccc); ccc ++; } } else { compressionMethod = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressionMethod = compressionMethod+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModTime = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModTime = * ((unsigned char*)ccc); ccc ++; } } else { lastModTime = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModTime = lastModTime+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModDate = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModDate = * ((unsigned char*)ccc); ccc ++; } } else { lastModDate = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModDate = lastModDate+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { crc32 = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; crc32 = * ((unsigned char*)ccc); ccc ++; } } else { crc32 = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressedSize = * ((unsigned char*)ccc); ccc ++; } } else { compressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { unCompressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; unCompressedSize = * ((unsigned char*)ccc); ccc ++; } } else { unCompressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fnameLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fnameLen = * ((unsigned char*)ccc); ccc ++; } } else { fnameLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; fnameLen = fnameLen+(chh<<8);}; if (fnameLen >= MAX_FILE_NAME_SIZE) { fatalError(ERR_INTERNAL,"file name in .zip archive too long", 65); } { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extraLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extraLen = * ((unsigned char*)ccc); ccc ++; } } else { extraLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extraLen = extraLen+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fcommentLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fcommentLen = * ((unsigned char*)ccc); ccc ++; } } else { fcommentLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; fcommentLen = fcommentLen+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { diskNumber = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; diskNumber = * ((unsigned char*)ccc); ccc ++; } } else { diskNumber = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; diskNumber = diskNumber+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { internFileAttribs = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; internFileAttribs = * ((unsigned char*)ccc); ccc ++; } } else { internFileAttribs = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; internFileAttribs = internFileAttribs+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { externFileAttribs = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; externFileAttribs = * ((unsigned char*)ccc); ccc ++; } } else { externFileAttribs = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { localHeaderOffset = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; localHeaderOffset = * ((unsigned char*)ccc); ccc ++; } } else { localHeaderOffset = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<24);}; for(i=0; i<fnameLen; i++) { { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fn[i] = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fn[i] = * ((unsigned char*)ccc); ccc ++; } } else { fn[i] = * ((unsigned char*)ccc); ccc++; } }; } fn[i] = 0; { register int ccount,i,ch; ccount = (extraLen+fcommentLen); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(extraLen+fcommentLen)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }};};
                if (strcmp(fn,fname)==0) {
                        *foffset = localHeaderOffset;
                        res = 1;
                        goto fin;
                }
        } endcd:
        { if (!(headSig == 0x06054b50 || headSig == 0x02014b50)) internalCheckFail("headSig == 0x06054b50 || headSig == 0x02014b50", "cfread.c", 281);};
        goto fin;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fin:
        *accc = ccc; *affin = ffin;
        return(res);
}
static S_charBuf s_zipTmpBuff;
int fsIsMember(S_zipArchiveDir **dir, char *fn, unsigned offset,
                                                int addFlag, S_zipArchiveDir **place) {
        S_zipArchiveDir *aa, **aaa, *p;
        int itemlen, res;
        char *ss;
        if (dir == NULL) return(0);
        *place = *dir;
        res = 1;
        if (fn[0] == 0) {
                error(ERR_INTERNAL,"looking for empty file name in 'fsdir'");
                return(0);
        }
        if (fn[0]=='/' && fn[1]==0) {
                error(ERR_INTERNAL,"looking for root in 'fsdir'");
                return(0);
        }
lastrecLabel:
        ss = strchr(fn,'/');
        if (ss == NULL) {
                itemlen = strlen(fn);
                if (itemlen == 0) return(res);
        } else {
                itemlen = (ss-fn) + 1;
        }
        for(aaa=dir, aa= *aaa; aa!=NULL; aaa= &(aa->next), aa = *aaa) {
                if (strncmp(fn,aa->name,itemlen)==0 && aa->name[itemlen]==0) break;
        }
        { if (!(itemlen > 0)) internalCheckFail("itemlen > 0", "cfread.c", 320);};
        if (aa==NULL) {
                res = 0;
                if (addFlag == ADD_YES) {
                        {ss = (char*) stackMemoryAlloc((sizeof(S_zipArchiveDir)+itemlen+1)*sizeof(char)); };
                        p = (S_zipArchiveDir*)ss;
                        { (p)->u.sub = NULL; (p)->next = NULL;};
                        strncpy(p->name, fn, itemlen);
                        p->name[itemlen]=0;
                        if (fn[itemlen-1] == '/') {
                                p->u.sub = NULL;
                        } else {
                                p->u.offset = offset;
                        }
                        *aaa = aa = p;
                } else {
                        return(0);
                }
        }
        *place = aa;
        if (fn[itemlen-1] == '/') {
                dir = &(aa->u.sub);
                fn = fn+itemlen;
                goto lastrecLabel;
        } else {
                return(res);
        }
}
void fsRecMapOnFiles(S_zipArchiveDir *dir, char *zip, char *path, void (*fun)(char *zip, char *file, void *arg), void *arg) {
        S_zipArchiveDir *aa;
        char *fn;
        char npath[MAX_FILE_NAME_SIZE];
        int len;
        if (dir == NULL) return;
        for(aa=dir; aa!=NULL; aa=aa->next) {
                fn = aa->name;
                len = strlen(fn);
                sprintf(npath, "%s%s", path, fn);
                if (len==0 || fn[len-1]=='/') {
                        fsRecMapOnFiles(aa->u.sub, zip, npath, fun, arg);
                } else {
                        (*fun)(zip, npath, arg);
                }
        }
}
static int findEndOfCentralDirectory(char **accc, char **affin,
                                                                S_charBuf *iBuf, int fsize) {
        int offset,res;
        char *ccc, *ffin;
        res = 1;
        if (fsize < CHAR_BUFF_SIZE) offset = 0;
        else offset = fsize-(CHAR_BUFF_SIZE-MAX_UNGET_CHARS);
        fseek(iBuf->ff, offset, SEEK_SET);
        iBuf->cc = iBuf->fin;
        getCharBuf(iBuf);
        ccc = ffin = iBuf->fin;
        for (ccc-=4; ccc>iBuf->a && strncmp(ccc,"\120\113\005\006",4)!=0; ccc--) {
        }
        if (ccc <= iBuf->a) {
                res = 0;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cfread.c", 383);};
                if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_INTERNAL,"can't find end of central dir in archive");
                }
                goto fini;
        }
fini:
        *accc = ccc; *affin = ffin;
        return(res);
}
static void zipArchiveScan(char **accc, char **affin, S_charBuf *iBuf,
                                                                S_zipFileTabItem *zip, int fsize) {
        char fn[MAX_FILE_NAME_SIZE];
        char *ccc, *ffin;
        S_zipArchiveDir *place;
        int headSig,madeByVersion,extractVersion,bitFlags,compressionMethod;
        int lastModTime,lastModDate,fnameLen,extraLen,fcommentLen,diskNumber;
        int i,internFileAttribs,tmp;
        unsigned externFileAttribs,localHeaderOffset, cdOffset;
        unsigned crc32,compressedSize,unCompressedSize;
        unsigned foffset;
        ccc = *accc; ffin = *affin;
        zip->dir = NULL;
        if (findEndOfCentralDirectory(&ccc, &ffin, iBuf, fsize)==0) goto fini;
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { headSig = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; headSig = * ((unsigned char*)ccc); ccc ++; } } else { headSig = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<24);};
        { if (!(headSig == 0x06054b50)) internalCheckFail("headSig == 0x06054b50", "cfread.c", 409);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tmp = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tmp = * ((unsigned char*)ccc); ccc ++; } } else { tmp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tmp = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tmp = * ((unsigned char*)ccc); ccc ++; } } else { tmp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tmp = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tmp = * ((unsigned char*)ccc); ccc ++; } } else { tmp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tmp = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tmp = * ((unsigned char*)ccc); ccc ++; } } else { tmp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<8);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tmp = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tmp = * ((unsigned char*)ccc); ccc ++; } } else { tmp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; tmp = tmp+(chh<<24);};
        { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { cdOffset = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; cdOffset = * ((unsigned char*)ccc); ccc ++; } } else { cdOffset = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cdOffset = cdOffset+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cdOffset = cdOffset+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cdOffset = cdOffset+(chh<<24);};
        { fseek((iBuf)->ff,cdOffset,SEEK_SET); ccc = ffin = (iBuf)->cc = (iBuf)->fin = (iBuf)->lineBegin = (iBuf)->a;};
        for(;;) {
                { foffset = ftell((iBuf)->ff) - (ffin-ccc);};
                { { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { headSig = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; headSig = * ((unsigned char*)ccc); ccc ++; } } else { headSig = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; headSig = headSig+(chh<<24);}; if (headSig != 0x02014b50) goto endcd; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { madeByVersion = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; madeByVersion = * ((unsigned char*)ccc); ccc ++; } } else { madeByVersion = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; madeByVersion = madeByVersion+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extractVersion = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extractVersion = * ((unsigned char*)ccc); ccc ++; } } else { extractVersion = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extractVersion = extractVersion+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { bitFlags = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; bitFlags = * ((unsigned char*)ccc); ccc ++; } } else { bitFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; bitFlags = bitFlags+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressionMethod = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressionMethod = * ((unsigned char*)ccc); ccc ++; } } else { compressionMethod = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressionMethod = compressionMethod+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModTime = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModTime = * ((unsigned char*)ccc); ccc ++; } } else { lastModTime = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModTime = lastModTime+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { lastModDate = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; lastModDate = * ((unsigned char*)ccc); ccc ++; } } else { lastModDate = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; lastModDate = lastModDate+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { crc32 = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; crc32 = * ((unsigned char*)ccc); ccc ++; } } else { crc32 = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; crc32 = crc32+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { compressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; compressedSize = * ((unsigned char*)ccc); ccc ++; } } else { compressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; compressedSize = compressedSize+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { unCompressedSize = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; unCompressedSize = * ((unsigned char*)ccc); ccc ++; } } else { unCompressedSize = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; unCompressedSize = unCompressedSize+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fnameLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fnameLen = * ((unsigned char*)ccc); ccc ++; } } else { fnameLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; fnameLen = fnameLen+(chh<<8);}; if (fnameLen >= MAX_FILE_NAME_SIZE) { fatalError(ERR_INTERNAL,"file name in .zip archive too long", 65); } { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { extraLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; extraLen = * ((unsigned char*)ccc); ccc ++; } } else { extraLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; extraLen = extraLen+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fcommentLen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fcommentLen = * ((unsigned char*)ccc); ccc ++; } } else { fcommentLen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; fcommentLen = fcommentLen+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { diskNumber = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; diskNumber = * ((unsigned char*)ccc); ccc ++; } } else { diskNumber = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; diskNumber = diskNumber+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { internFileAttribs = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; internFileAttribs = * ((unsigned char*)ccc); ccc ++; } } else { internFileAttribs = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; internFileAttribs = internFileAttribs+(chh<<8);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { externFileAttribs = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; externFileAttribs = * ((unsigned char*)ccc); ccc ++; } } else { externFileAttribs = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; externFileAttribs = externFileAttribs+(chh<<24);}; { register unsigned chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { localHeaderOffset = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; localHeaderOffset = * ((unsigned char*)ccc); ccc ++; } } else { localHeaderOffset = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<8); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<16); { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; localHeaderOffset = localHeaderOffset+(chh<<24);}; for(i=0; i<fnameLen; i++) { { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { fn[i] = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; fn[i] = * ((unsigned char*)ccc); ccc ++; } } else { fn[i] = * ((unsigned char*)ccc); ccc++; } }; } fn[i] = 0; { register int ccount,i,ch; ccount = (extraLen+fcommentLen); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(extraLen+fcommentLen)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }};};
                if (strncmp(fn,"META-INF/",9)!=0) {
                        fsIsMember(&zip->dir, fn, localHeaderOffset, ADD_YES, &place);
                }
        } endcd:;
        goto fini;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fini:
        *accc = ccc; *affin = ffin;
}
int zipIndexArchive(char *name) {
        int archi,namelen,fsize;
        FILE *ff;
        S_charBuf *bbb;
        struct stat fst;
        bbb = &s_zipTmpBuff;
        namelen = strlen(name);
        for(archi=0;
                archi<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[archi].fn[0]!=0;
                archi++) {
                if (strncmp(s_zipArchivTab[archi].fn,name,namelen)==0
                                && s_zipArchivTab[archi].fn[namelen]==';') {
                        goto forend;
                }
        }
 forend:;
        if (archi<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[archi].fn[0] == 0) {
                { if (s_opt.debug) {fprintf(dumpOut,"adding %s into index \n",name);fflush(dumpOut);}};
                if (stat(name ,&fst)!=0) {
                        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cfread.c", 476);};
                        if (s_opt.taskRegime!=RegimeEditServer) {
                                static int singleOut=0;
                                if (singleOut==0) warning(ERR_CANT_OPEN, name);
                                singleOut=1;
                        }
                        return(-1);
                }
#ifdef __WIN32__
                ff = fopen(name,"rb");
#else
                ff = fopen(name,"r");
#endif
                if (ff == NULL) {
                        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cfread.c", 490);};
                        if (s_opt.taskRegime!=RegimeEditServer) {
                                warning(ERR_CANT_OPEN, name);
                        }
                        return(-1);
                }
                { (bbb)->cc = bbb->a; (bbb)->fin = bbb->a; (bbb)->ff = ff; (bbb)->filePos = 0; (bbb)->fileNumber = 0; (bbb)->lineNum = 0; (bbb)->lineBegin = bbb->a; (bbb)->collumnOffset = 0; (bbb)->isAtEOF = 0; (bbb)->inputMethod = INPUT_DIRECT; (bbb)->zipStream = s_defaultZStream;};
                { if (!(namelen+2 < MAX_FILE_NAME_SIZE)) internalCheckFail("namelen+2 < MAX_FILE_NAME_SIZE", "cfread.c", 497);};
                strcpy(s_zipArchivTab[archi].fn, name);
                s_zipArchivTab[archi].fn[namelen] = ';';
                s_zipArchivTab[archi].fn[namelen+1] = 0;
                { (&s_zipArchivTab[archi])->st = fst; (&s_zipArchivTab[archi])->dir = NULL;};
                zipArchiveScan(&bbb->cc,&bbb->fin,bbb,&s_zipArchivTab[archi], fst.st_size);
                fclose(ff);
        }
        return(archi);
}
static int zipSeekToFile(char **accc, char **affin, S_charBuf *iBuf,
                                                char *name
                                                ) {
        char *sep;
        char *ccc, *ffin;
        int i,namelen,res = 0;
        unsigned lastSig,fsize,lhoffset;
        char fn[MAX_FILE_NAME_SIZE];
        S_zipArchiveDir *place;
        ccc = *accc; ffin = *affin;
        sep = strchr(name,';');
        if (sep == NULL) {return(0);}
        *sep = 0;
        namelen = strlen(name);
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                if (strncmp(s_zipArchivTab[i].fn, name,namelen)==0
                                && s_zipArchivTab[i].fn[namelen] == ';') {
                        break;
                }
        }
        *sep = ';';
        if (i>=MAX_JAVA_ZIP_ARCHIVES || s_zipArchivTab[i].fn[0]==0) {
                error(ERR_INTERNAL, "archive not indexed\n");
                goto fini;
        }
        if (fsIsMember(&s_zipArchivTab[i].dir,sep+1,0,ADD_NO,&place)==0) goto fini;
        { fseek((iBuf)->ff,place->u.offset,SEEK_SET); ccc = ffin = (iBuf)->cc = (iBuf)->fin = (iBuf)->lineBegin = (iBuf)->a;};
        if (zipReadLocalFileHeader(&ccc, &ffin, iBuf, fn, &fsize,
                                        &lastSig, s_zipArchivTab[i].fn, place->u.offset) == 0) goto fini;
        { if (!(lastSig == 0x04034b50)) internalCheckFail("lastSig == 0x04034b50", "cfread.c", 537);};
        { if (!(strcmp(fn,sep+1)==0)) internalCheckFail("strcmp(fn,sep+1)==0", "cfread.c", 538);};
        res = 1;
fini:
        *accc = ccc; *affin = ffin;
        return(res);
}
int zipFindFile(char *name,
                                char **resName,
                                S_zipFileTabItem *zipfile
                                ) {
        char *pp,*ccc,*ffin;
        char fname[MAX_FILE_NAME_SIZE];
        S_charBuf *bbb;
        S_zipArchiveDir *place;
        bbb = &s_zipTmpBuff;
        strcpy(fname,name);
        strcat(fname,".class");
        { if (!(strlen(fname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(fname)+1 < MAX_FILE_NAME_SIZE", "cfread.c", 556);};
        if (fsIsMember(&zipfile->dir,fname,0,ADD_NO,&place)==0) return(0);
        if (resName != NULL) {
                {*resName = (char*) stackMemoryAlloc((strlen(zipfile->fn)+strlen(fname)+2)*sizeof(char)); };
                pp = strmcpy(*resName, zipfile->fn);
                strcpy(pp, fname);
        }
        return(1);
}
void javaMapZipDirFile(
                S_zipFileTabItem *zipfile,
                char *packfile,
                S_completions *a1,
                void *a2,
                int *a3,
                void (*fun)(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5),
                char *classPath,
                char *dirname
                ) {
        char fn[MAX_FILE_NAME_SIZE];
        char dirn[MAX_FILE_NAME_SIZE];
        S_zipArchiveDir *place,*aa;
        char *pp,*ccc,*ffin,*tmpp,*ss;
        int dirlen;
        dirlen = strlen(dirname);
        strcpy(dirn,dirname);
        dirn[dirlen]='/'; dirn[dirlen+1]=0;
        if (dirlen == 0) {
                aa = zipfile->dir;
        } else if (fsIsMember(&zipfile->dir, dirn, 0, ADD_NO, &place)==1) {
                aa=place->u.sub;
        } else {
                return;
        }
        for(; aa!=NULL; aa=aa->next) {
                ss = strmcpy(fn, aa->name);
                if (fn[0]==0) {
                        error(ERR_INTERNAL,"empty name in .zip directory structure");
                        continue;
                }
                if (*(ss-1) == '/') *(ss-1) = 0;
                (*fun)(fn, classPath, packfile, a1, a2, a3);
        }
}
static union constantPoolUnion * cfReadConstantPool(
                                                char **accc, char **affin, S_charBuf *iBuf,
                                                int *cpSize
                                                ) {
        register char *ccc, *ffin;
        register int cval;
        int count,tag,ind,classind,nameind,typeind,strind;
        int size,i;
        union constantPoolUnion *cp=NULL;
        char *str;
        ccc = *accc; ffin = *affin;
        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { count = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;};
        {{ { if (!((count) >= 0)) internalCheckFail("(count) >= 0", "cfread.c", 621);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(count)*sizeof(union constantPoolUnion) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } cp = (union constantPoolUnion*) (ppmMemory + ppmMemoryi); ppmMemoryi += (count)*sizeof(union constantPoolUnion);};};
        for(ind=1; ind<count; ind++) {
                { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { tag = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; tag = * ((unsigned char*)ccc); ccc ++; } } else { tag = * ((unsigned char*)ccc); ccc++; } };
                switch (tag) {
                case 0:
                        { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { cval = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } };
                        break;
                case 1:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { size = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; size = * ((unsigned char*)ccc); ccc ++; } } else { size = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; size = size*256+chh;};
                        {{ { if (!((size+1) >= 0)) internalCheckFail("(size+1) >= 0", "cfread.c", 631);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(size+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } str = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (size+1)*sizeof(char);};};
                        for(i=0; i<size; i++) { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { str[i] = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; str[i] = * ((unsigned char*)ccc); ccc ++; } } else { str[i] = * ((unsigned char*)ccc); ccc++; } };
                        str[i]=0;
                        cp[ind].asciz = str;
                        break;
                case 2:
                        error(ERR_ST,"[cfReadConstantPool] Unicode not yet implemented");
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { size = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; size = * ((unsigned char*)ccc); ccc ++; } } else { size = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; size = size*256+chh;};
                        { register int ccount,i,ch; ccount = (size*2); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(size*2)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }};
                        cp[ind].asciz = "Unicode ??";
                        break;
                case 7:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { classind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; classind = * ((unsigned char*)ccc); ccc ++; } } else { classind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; classind = classind*256+chh;};
                        cp[ind].clas.nameIndex = classind;
                        break;
                case 9:
                case 10:
                case 11:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { classind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; classind = * ((unsigned char*)ccc); ccc ++; } } else { classind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; classind = classind*256+chh;};
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { nameind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; nameind = * ((unsigned char*)ccc); ccc ++; } } else { nameind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; nameind = nameind*256+chh;};
                        cp[ind].rec.classIndex = classind;
                        cp[ind].rec.nameAndTypeIndex = nameind;
                        break;
                case 12:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { nameind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; nameind = * ((unsigned char*)ccc); ccc ++; } } else { nameind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; nameind = nameind*256+chh;};
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { typeind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; typeind = * ((unsigned char*)ccc); ccc ++; } } else { typeind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; typeind = typeind*256+chh;};
                        cp[ind].nt.nameIndex = nameind;
                        cp[ind].nt.signatureIndex = typeind;
                        break;
                case 8:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { strind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; strind = * ((unsigned char*)ccc); ccc ++; } } else { strind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; strind = strind*256+chh;};
                        break;
                case 3:
                case 4:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { cval = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
                        break;
                case 5:
                case 6:
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { cval = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
                        ind ++;
                        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { cval = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
                        break;
                default:
                        sprintf(tmpBuff,"unknown tag %d in constant pool of %s\n",tag,cFile.fileName);
                        error(ERR_ST,tmpBuff);
                }
        }
        goto fin;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fin:
        *accc = ccc; *affin = ffin; *cpSize = count;
        return(cp);
}
void javaHumanizeLinkName( char *inn, char *outn, int size) {
        int i;
        char *cut;
        cut = strchr(inn, '!');
        if (cut==NULL) cut = inn;
        else cut ++;
        for(i=0; cut[i]; i++) {
                outn[i] = cut[i];
                        if (outn[i]=='/') outn[i]='.';
                { if (!(i<size-1)) internalCheckFail("i<size-1", "cfread.c", 697);};
        }
        outn[i] = 0;
}
char * cfSkipFirstArgumentInSigString(char *sig) {
        char *ssig;
        ssig = sig;
        { if (!(ssig)) internalCheckFail("ssig", "cfread.c", 705);};
        if (*ssig != '(') return(ssig);
        ssig ++;
        { if (!(*ssig)) internalCheckFail("*ssig", "cfread.c", 709);};
        switch (*ssig) {
        case ')':
                break;
        case '[':
                for(ssig++; *ssig && isdigit(*ssig); ssig++) ;
                break;
        case 'L':
                for(; *ssig && *ssig!=';'; ssig++) ;
                ssig++;
                break;
        default:
                ssig++;
        }
        return(ssig);
}
S_typeModifiers * cfUnPackResultType(char *sig, char **restype) {
        S_typeModifiers *res,**ares,*tt;
        S_symbol dd,*pdd;
        S_symbolList ddl,*memb;
        int typ,ii,nmlen;
        char *fqname,*nnn;
        char *ssig,*ccname;
        int ccnameOffset;
        res = NULL;
        ares = &res;
        ssig = sig;
        { if (!(ssig)) internalCheckFail("ssig", "cfread.c", 737);};
        if (*ssig == '(') {
                while (*ssig && *ssig!=')') ssig++;
                *restype = ssig+1;
        } else {
                *restype = ssig;
        }
        { if (!(*ssig)) internalCheckFail("*ssig", "cfread.c", 745);};
        for(; *ssig; ssig++) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 747);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } tt = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
                *ares = tt;
                ares = &(tt->next);
                switch (*ssig) {
                case ')':
                        { (tt)->m = TypeFunction; { (&((&(tt)->u)->f))->args = NULL; (&((&(tt)->u)->f))->thisFunList = NULL;}; (tt)->typedefin = NULL; (tt)->next = NULL;};
                        { if (!(*sig == '(')) internalCheckFail("*sig == '('", "cfread.c", 753);};
                        tt->u.sig = NULL;
                        break;
                case '[':
                        { (tt)->m = TypeArray; { (&((&(tt)->u)->f))->args = NULL; (&((&(tt)->u)->f))->thisFunList = NULL;}; (tt)->typedefin = NULL; (tt)->next = NULL;};
                        for(ssig++; *ssig && isdigit(*ssig); ssig++) ;
                        ssig --;
                        break;
                case 'L':
                        { (tt)->m = TypeStruct; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = NULL;};
                        fqname = ++ssig;
                        ccname = fqname;
                        for(; *ssig && *ssig!=';'; ssig++) {
                                if (*ssig == '/' || *ssig == '$') ccname = ssig+1;
                        }
                        { if (!(*ssig == ';')) internalCheckFail("*ssig == ';'", "cfread.c", 768);};
                        nmlen = ssig-fqname;
                        ccnameOffset = ccname - fqname;
                        *ssig = 0;
                        { (&dd.b)->record = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeStruct; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                        { (&dd)->name = ccname; (&dd)->linkName = fqname; (&dd)->pos = s_noPos; (&dd)->b = dd.b; (&dd)->u.s = NULL; (&dd)->next = NULL;};
                        { (&ddl)->d = &dd; (&ddl)->next = NULL;};
                        if (! javaFqtTabIsMember(&s_javaFqtTab,&ddl,&ii,&memb)) {
                                {{ { if (!((nmlen+1) >= 0)) internalCheckFail("(nmlen+1) >= 0", "cfread.c", 777);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(nmlen+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } nnn = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (nmlen+1)*sizeof(char);};};
                                strcpy(nnn,fqname);
                                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 779);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pdd = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
                                { (&pdd->b)->record = 0; (&pdd->b)->accessFlags = 0; (&pdd->b)->javaSourceLoaded = 0; (&pdd->b)->javaFileLoaded = 0; (&pdd->b)->symType = TypeStruct; (&pdd->b)->storage = StorageNone; (&pdd->b)->npointers = 0;};
                                { (pdd)->name = nnn+ccnameOffset; (pdd)->linkName = nnn; (pdd)->pos = s_noPos; (pdd)->b = pdd->b; (pdd)->u.s = NULL; (pdd)->next = NULL;};
                                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 782);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symStructSpecific) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pdd->u.s = (S_symStructSpecific*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symStructSpecific);};};};
                                { (pdd->u.s)->super = NULL; (pdd->u.s)->records = NULL; (pdd->u.s)->casts.node = NULL; (pdd->u.s)->casts.sub = NULL; (pdd->u.s)->nnested = 0; (pdd->u.s)->nest = NULL; (pdd->u.s)->stype.m = TypeStruct; (&(pdd->u.s)->stype.u)->t = NULL;; (pdd->u.s)->stype.typedefin = NULL; (pdd->u.s)->stype.next = NULL; (pdd->u.s)->sptrtype.m = TypePointer; { (&((&(pdd->u.s)->sptrtype.u)->f))->args = NULL; (&((&(pdd->u.s)->sptrtype.u)->f))->thisFunList = NULL;}; (pdd->u.s)->sptrtype.typedefin = NULL; (pdd->u.s)->sptrtype.next = &pdd->u.s->stype; (pdd->u.s)->currPackage = javaIsInCurrentPackage(nnn); (pdd->u.s)->existsDEIarg = 0; (pdd->u.s)->classFile = -1; (pdd->u.s)->recSearchCounter = 0;};
                                pdd->u.s->stype.u.t = pdd;
                                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 789);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbolList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } memb = (S_symbolList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbolList);};};};
                                { (memb)->d = pdd; (memb)->next = NULL;};
                                javaFqtTabSet(&s_javaFqtTab,memb,ii);
                                javaCreateClassFileItem(memb->d);
                        }
                        *ssig = ';';
                        tt->u.t = memb->d;
                        break;
                default:
                        typ = s_javaCharCodeBaseTypes[*ssig];
                        { if (!(typ != 0)) internalCheckFail("typ != 0", "cfread.c", 800);};
                        { (tt)->m = typ; { (&((&(tt)->u)->f))->args = NULL; (&((&(tt)->u)->f))->thisFunList = NULL;}; (tt)->typedefin = NULL; (tt)->next = NULL;};
                }
        }
        return(res);
}
static void cfAddRecordToClass( char *name,
                                                                char *sig,
                                                                S_symbol *clas,
                                                                int accessFlags,
                                                                int storage
                                                                ) {
        static char pp[MAX_PROFILE_SIZE];
        S_symbol *d,*memb;
        S_symbolList *dl;
        char *ln,*prof;
        S_typeModifiers *tt;
        char *restype;
        int len, vFunCl;
        int rr,bc;
        S_position dpos;
        tt = cfUnPackResultType(sig, &restype);
        if (tt->m==TypeFunction) {
                bc = *restype; *restype = 0;
                if ((accessFlags & 0x008)) {
                }
                sprintf(pp,"%s%s", name, sig);
                vFunCl = clas->u.s->classFile;
                *restype = bc;
        } else {
                sprintf(pp,"%s", name);
                vFunCl = clas->u.s->classFile;
        }
        rr = javaIsYetInTheClass(clas, pp, &memb);
        if (rr) {
                ln = memb->linkName;
        } else {
                len = strlen(pp);
                {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "cfread.c", 851);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(len+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ln = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (len+1)*sizeof(char);};};
                strcpy(ln, pp);
        }
        prof = strchr(ln,'(');
        if (tt->m == TypeFunction) {
                { if (!(*sig == '(')) internalCheckFail("*sig == '('", "cfread.c", 856);};
                { if (!(*prof == '(')) internalCheckFail("*prof == '('", "cfread.c", 857);};
                tt->u.sig = prof;
        }
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 861);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } d = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&d->b)->record = 0; (&d->b)->accessFlags = accessFlags; (&d->b)->javaSourceLoaded = 0; (&d->b)->javaFileLoaded = 0; (&d->b)->symType = TypeDefault; (&d->b)->storage = storage; (&d->b)->npointers = 0;};
        { (d)->name = name; (d)->linkName = ln; (d)->pos = s_noPos; (d)->b = d->b; (d)->u.type = tt; (d)->next = NULL;};
        d->u.type = tt;
        { if (!(clas->u.s)) internalCheckFail("clas->u.s", "cfread.c", 865);};
        { if ((clas->u.s->records)==NULL) clas->u.s->records = d; else { register S_symbol *tempnsl; tempnsl = clas->u.s->records; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = d; } };
        if (s_opt.allowClassFileRefs) {
                { (&dpos)->file = clas->u.s->classFile; (&dpos)->line = 1; (&dpos)->coll = 0;};
                addCxReference(d, &dpos, UsageClassFileDefinition, vFunCl, vFunCl);
        }
}
static void cfReadFieldInfos( char **accc,
                                                                char **affin,
                                                                S_charBuf *iBuf,
                                                                S_symbol *memb,
                                                                union constantPoolUnion *cp
                                                        ) {
        register char *ccc, *ffin;
        register int cval,count,ind;
        int size,i,accesFlags,nameind,sigind;
        ccc = *accc; ffin = *affin;
        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { count = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;};
        for(ind=0; ind<count; ind++) {
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { accesFlags = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; accesFlags = * ((unsigned char*)ccc); ccc ++; } } else { accesFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; accesFlags = accesFlags*256+chh;};
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { nameind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; nameind = * ((unsigned char*)ccc); ccc ++; } } else { nameind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; nameind = nameind*256+chh;};
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { sigind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; sigind = * ((unsigned char*)ccc); ccc ++; } } else { sigind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; sigind = sigind*256+chh;};
                cfAddRecordToClass(cp[nameind].asciz,cp[sigind].asciz,memb,accesFlags,
                                                   StorageField);
                { register int ind,count,aname,alen; { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { count = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;}; for(ind=0; ind<count; ind++) { { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { aname = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; aname = * ((unsigned char*)ccc); ccc ++; } } else { aname = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; aname = aname*256+chh;}; { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { alen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; alen = * ((unsigned char*)ccc); ccc ++; } } else { alen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh;}; { register int ccount,i,ch; ccount = (alen); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(alen)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }}; }};
        }
        goto fin;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fin:
        *accc = ccc; *affin = ffin;
}
static void cfReadMethodInfos( char **accc,
                                                                char **affin,
                                                                S_charBuf *iBuf,
                                                                S_symbol *memb,
                                                                union constantPoolUnion *cp
                                                        ) {
        register char *ccc, *ffin, *name, *sign, *sign2;
        register int cval,count,ind;
        int size,i,accesFlags,nameind,sigind,storage;
        ccc = *accc; ffin = *affin;
        { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { count = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;};
        for(ind=0; ind<count; ind++) {
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { accesFlags = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; accesFlags = * ((unsigned char*)ccc); ccc ++; } } else { accesFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; accesFlags = accesFlags*256+chh;};
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { nameind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; nameind = * ((unsigned char*)ccc); ccc ++; } } else { nameind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; nameind = nameind*256+chh;};
                { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { sigind = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; sigind = * ((unsigned char*)ccc); ccc ++; } } else { sigind = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; sigind = sigind*256+chh;};
                name = cp[nameind].asciz;
                sign = cp[sigind].asciz;
                storage = StorageMethod;
                if (strcmp(name, "<init>")==0
                        || strcmp(name, "<clinit>")==0) {
                        char ttt[TMP_STRING_SIZE];
                        { if (!(memb && memb->b.symType==TypeStruct && memb->u.s)) internalCheckFail("memb && memb->b.symType==TypeStruct && memb->u.s", "cfread.c", 931);};
                        name = memb->name;
                        storage = StorageConstructor;
                        if (memb->u.s->existsDEIarg) {
                                sign2 = cfSkipFirstArgumentInSigString(sign);
                                {{ { if (!((strlen(sign2)+2) >= 0)) internalCheckFail("(strlen(sign2)+2) >= 0", "cfread.c", 943);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(sign2)+2)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } sign = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(sign2)+2)*sizeof(char);};};
                                sign[0] = '('; strcpy(sign+1, sign2);
                        }
                } else if (name[0] == '<') {
                        storage = StorageConstructor;
                }
                cfAddRecordToClass(name, sign, memb, accesFlags, storage);
                { register int ind,count,aname,alen; { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { count = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;}; for(ind=0; ind<count; ind++) { { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { aname = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; aname = * ((unsigned char*)ccc); ccc ++; } } else { aname = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; aname = aname*256+chh;}; { register int chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { alen = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; alen = * ((unsigned char*)ccc); ccc ++; } } else { alen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (iBuf)->cc = ccc; if ((iBuf)->isAtEOF || getCharBuf(iBuf) == 0) { chh = -1; (iBuf)->isAtEOF = 1; goto endOfFile; } else { ccc = (iBuf)->cc; ffin = (iBuf)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh;}; { register int ccount,i,ch; ccount = (alen); if (ccc + ccount < ffin) ccc += ccount; else { (iBuf)->cc = ccc; skipNCharsInCharBuf(iBuf,(alen)); ccc = (iBuf)->cc; ffin = (iBuf)->fin; }}; }};
        }
        goto fin;
endOfFile:
        error(ERR_ST,"unexpected end of file");
fin:
        *accc = ccc; *affin = ffin;
}
S_symbol *cfAddCastsToModule(S_symbol *memb, S_symbol *sup) {
        { if (!(memb->u.s)) internalCheckFail("memb->u.s", "cfread.c", 963);};
        cctAddSimpleValue(&memb->u.s->casts, sup, 1);
        { if (!(sup->u.s)) internalCheckFail("sup->u.s", "cfread.c", 965);};
        cctAddCctTree(&memb->u.s->casts, &sup->u.s->casts, 1);
        return(sup);
}
void addSuperClassOrInterface( S_symbol *memb, S_symbol *supp, int origin ) {
        S_symbolList *ssl, *ss;
        for(ss=memb->u.s->super; ss!=NULL && ss->d!=supp; ss=ss->next) ;
        if (ss!=NULL && ss->d==supp) return;
        { if (s_opt.debug) {fprintf(dumpOut," adding supperclass %s to %s\n",supp->linkName,memb->linkName);fflush(dumpOut);}};
        if (cctIsMember(&supp->u.s->casts, memb, 1) || memb==supp) {
                sprintf(tmpBuff,"a cycle in super classes of %s detected",
                                memb->linkName);
                error(ERR_ST, tmpBuff);
                return;
        }
        cfAddCastsToModule(memb, supp);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cfread.c", 982);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbolList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ssl = (S_symbolList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbolList);};};};
        { (ssl)->d = supp; (ssl)->next = NULL;};
        { if ((memb->u.s->super)==NULL) memb->u.s->super = ssl; else { register S_symbolList *tempnsl; tempnsl = memb->u.s->super; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = ssl; } };
        addSubClassItemToFileTab(supp->u.s->classFile,
                                                         memb->u.s->classFile,
                                                         origin);
}
void addSuperClassOrInterfaceByName(S_symbol *memb, char *super, int origin,
                                                                        int loadSuper) {
        S_symbol *supp;
        supp = javaGetFieldClass(super,NULL);
        if (loadSuper==LOAD_SUPER) javaLoadClassSymbolsFromFile(supp);
        addSuperClassOrInterface( memb, supp, origin);
}
int javaCreateClassFileItem( S_symbol *memb) {
        char ftname[MAX_FILE_NAME_SIZE];
        char *rftname;
        int ii, newItem;
        { sprintf(ftname, "%c%s.class", ';', memb->linkName); { if (!(strlen(ftname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(ftname)+1 < MAX_FILE_NAME_SIZE", "cfread.c", 1002);};};
        newItem = addFileTabItem(ftname, &ii);
        memb->u.s->classFile = ii;
        return(ii);
}
void javaReadClassFile(char *name, S_symbol *memb, int loadSuper) {
        register int cval,tmp,i,inum,innval,rinners,snum,modifs;
        FILE *ff;
        int fnlen,upp,innNameInd,membFlag;
        char *ccc, *ffin;
        char *super,*interf,*innerCName, *zipsep;
        S_symbol *interfs, *inners, *supp;
        S_symbolList *ssl;
        int thisClass, superClass, accesFlags, cpSize;
        int fileInd,mm,ind,count,aname,alen,cn;
        char *inner,*upper,*thisClassName;
        S_charBuf *inBuf;
        union constantPoolUnion *constantPool;
        S_fileItem ffi;
        S_position pos;
        memb->b.javaFileLoaded = 1;
        zipsep = strchr(name, ';');
        if (zipsep != NULL) *zipsep = 0;
        ff = fopen(name, "rb");
        if (zipsep != NULL) *zipsep = ';';
        if (ff == NULL) {
                error(ERR_CANT_OPEN, name);
                return;
        }
        fileInd = javaCreateClassFileItem( memb);
        s_fileTab.tab[fileInd]->b.cxLoading = 1;
        { (&pos)->file = fileInd; (&pos)->line = 1; (&pos)->coll = 0;};
        addCxReference(memb, &pos, UsageClassFileDefinition,
                                   s_noneFileIndex, s_noneFileIndex);
        addCfClassTreeHierarchyRef(fileInd, UsageClassFileDefinition);
        pushNewInclude( ff, s_fileTab.tab[fileInd]->name, "");
        { if (s_opt.debug) {fprintf(dumpOut,"\nreading file %s\n",name);fflush(dumpOut);}}; fflush(dumpOut);
        inBuf = &cFile.lb.cb;
        ccc = cFile.lb.cb.cc; ffin = cFile.lb.cb.fin;
        if (zipsep != NULL) {
                if (zipSeekToFile(&ccc,&ffin,&cFile.lb.cb,name) == 0) goto fini;
        }
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { cval = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
        if (cval != 0xcafebabe) {
                sprintf(tmpBuff,"%s is not a valid class file\n",name);
                error(ERR_ST,tmpBuff);
                goto fini;
        }
        { if (!(cval == 0xcafebabe)) internalCheckFail("cval == 0xcafebabe", "cfread.c", 1073);};
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { cval = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
        constantPool = cfReadConstantPool(&ccc, &ffin, &cFile.lb.cb, &cpSize);
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { accesFlags = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; accesFlags = * ((unsigned char*)ccc); ccc ++; } } else { accesFlags = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; accesFlags = accesFlags*256+chh;};
        memb->b.accessFlags = accesFlags;
        if (accesFlags & 0x200) s_fileTab.tab[fileInd]->b.isInterface=1;
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { thisClass = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; thisClass = * ((unsigned char*)ccc); ccc ++; } } else { thisClass = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; thisClass = thisClass*256+chh;};
        if (thisClass<0 || thisClass>=cpSize) goto corrupted;
        thisClassName = constantPool[constantPool[thisClass].clas.nameIndex].asciz;
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { superClass = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; superClass = * ((unsigned char*)ccc); ccc ++; } } else { superClass = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; superClass = superClass*256+chh;};
        if (superClass != 0) {
                if (superClass<0 || superClass>=cpSize) goto corrupted;
                super = constantPool[constantPool[superClass].clas.nameIndex].asciz;
                addSuperClassOrInterfaceByName(memb, super, memb->u.s->classFile,
                                                                           loadSuper);
        }
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { inum = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; inum = * ((unsigned char*)ccc); ccc ++; } } else { inum = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; inum = inum*256+chh;};
        for(i=0; i<inum; i++) {
                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { cval = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; cval = * ((unsigned char*)ccc); ccc ++; } } else { cval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; cval = cval*256+chh;};
                if (cval != 0) {
                        if (cval<0 || cval>=cpSize) goto corrupted;
                        interf = constantPool[constantPool[cval].clas.nameIndex].asciz;
                        addSuperClassOrInterfaceByName(memb, interf, memb->u.s->classFile,
                                                                                   loadSuper);
                }
        }
        cfReadFieldInfos(&ccc, &ffin, &cFile.lb.cb, memb, constantPool);
        if (cFile.lb.cb.isAtEOF) goto endOfFile;
        cfReadMethodInfos(&ccc, &ffin, &cFile.lb.cb, memb, constantPool);
        if (cFile.lb.cb.isAtEOF) goto endOfFile;
        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { count = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; count = * ((unsigned char*)ccc); ccc ++; } } else { count = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; count = count*256+chh;};
        for(ind=0; ind<count; ind++) {
                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { aname = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; aname = * ((unsigned char*)ccc); ccc ++; } } else { aname = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; aname = aname*256+chh;};
                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { alen = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; alen = * ((unsigned char*)ccc); ccc ++; } } else { alen = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; alen = alen*256+chh;};
                if (strcmp(constantPool[aname].asciz,"InnerClasses")==0) {
                        { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { inum = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; inum = * ((unsigned char*)ccc); ccc ++; } } else { inum = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; inum = inum*256+chh;};
                        memb->u.s->nnested = inum;
                        if (inum >= MAX_INNERS_CLASSES) {
                                fatalError(ERR_ST,"number of nested classes overflowed over MAX_INNERS_CLASSES", 65);
                        }
                        memb->u.s->nest = NULL;
                        if (inum > 0) {
                                {{ { if (!((inum) >= 0)) internalCheckFail("(inum) >= 0", "cfread.c", 1130);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(inum)*sizeof(S_nestedSpec) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } memb->u.s->nest = (S_nestedSpec*) (ppmMemory + ppmMemoryi); ppmMemoryi += (inum)*sizeof(S_nestedSpec);};};
                        }
                        for(rinners=0; rinners<inum; rinners++) {
                                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { innval = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; innval = * ((unsigned char*)ccc); ccc ++; } } else { innval = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; innval = innval*256+chh;};
                                inner = constantPool[constantPool[innval].clas.nameIndex].asciz;
                                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { upp = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; upp = * ((unsigned char*)ccc); ccc ++; } } else { upp = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; upp = upp*256+chh;};
                                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { innNameInd = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; innNameInd = * ((unsigned char*)ccc); ccc ++; } } else { innNameInd = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; innNameInd = innNameInd*256+chh;};
                                if (innNameInd==0) innerCName = "";
                                else innerCName = constantPool[innNameInd].asciz;
                                inners = javaFQTypeSymbolDefinition(innerCName, inner);
                                membFlag = 0;
                                if (upp != 0) {
                                        upper = constantPool[constantPool[upp].clas.nameIndex].asciz;
                                        if (strcmp(upper,thisClassName)==0) {
                                                membFlag = 1;
                                        }
                                }
                                { register int chh; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { modifs = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; modifs = * ((unsigned char*)ccc); ccc ++; } } else { modifs = * ((unsigned char*)ccc); ccc++; } }; { if (ccc >= ffin) { (&cFile.lb.cb)->cc = ccc; if ((&cFile.lb.cb)->isAtEOF || getCharBuf(&cFile.lb.cb) == 0) { chh = -1; (&cFile.lb.cb)->isAtEOF = 1; goto endOfFile; } else { ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; chh = * ((unsigned char*)ccc); ccc ++; } } else { chh = * ((unsigned char*)ccc); ccc++; } }; modifs = modifs*256+chh;};
                                { (& memb->u.s->nest[rinners])->cl = inners; (& memb->u.s->nest[rinners])->membFlag = membFlag; (& memb->u.s->nest[rinners])->accFlags = modifs;};
                                { if (!(inners && inners->b.symType==TypeStruct && inners->u.s)) internalCheckFail("inners && inners->b.symType==TypeStruct && inners->u.s", "cfread.c", 1156);};
                                cn = inners->u.s->classFile;
                                { if (!(s_fileTab.tab[cn])) internalCheckFail("s_fileTab.tab[cn]", "cfread.c", 1158);};
                                if (membFlag && ! (modifs & 0x008)) {
                                        inners->u.s->existsDEIarg = 1;
                                        s_fileTab.tab[cn]->directEnclosingInstance = memb->u.s->classFile;
                                } else {
                                        inners->u.s->existsDEIarg = 0;
                                        s_fileTab.tab[cn]->directEnclosingInstance = s_noneFileIndex;
                                }
                        }
                } else {
                        { register int ccount,i,ch; ccount = (alen); if (ccc + ccount < ffin) ccc += ccount; else { (&cFile.lb.cb)->cc = ccc; skipNCharsInCharBuf(&cFile.lb.cb,(alen)); ccc = (&cFile.lb.cb)->cc; ffin = (&cFile.lb.cb)->fin; }};
                }
        }
        s_fileTab.tab[fileInd]->b.cxLoaded = 1;
        goto fini;
endOfFile:
        sprintf(tmpBuff,"unexpected end of file '%s'", name);
        error(ERR_ST, tmpBuff);
        goto emergency;
corrupted:
        sprintf(tmpBuff,"corrupted file '%s'", name);
        error(ERR_ST, tmpBuff);
        goto emergency;
emergency:
        memb->u.s->nnested = 0;
fini:
        { if (s_opt.debug) {fprintf(dumpOut,"closing file %s\n",name);fflush(dumpOut);}};
        popInclude();
}
