
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
FILE *dumpOut=NULL, *errOut=NULL;
char tmpBuff[TMP_BUFF_SIZE];
void initCwd() {
        char *rr;
        char nid[MAX_FILE_NAME_SIZE];
        rr = getcwd(s_cwd, MAX_FILE_NAME_SIZE);
        if (rr==NULL) {
                rr = getenv("PWD");
                if (rr==NULL) {
                        error(ERR_ST, "can't get current working directory");
                        sprintf(s_cwd, ".");
                } else {
                        { if (!(strlen(rr) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(rr) < MAX_FILE_NAME_SIZE", "commons.c", 35);};
                        strcpy(s_cwd, rr);
                }
        }
#ifdef __WIN32__
        if (strlen(s_cwd)<=2 || s_cwd[1]!=':') {
                sprintf(nid,"%c:",tolower('c'));
                if (strlen(nid)+strlen(s_cwd) < MAX_FILE_NAME_SIZE-1) {
                        strcpy(nid+strlen(nid),s_cwd);
                        strcpy(s_cwd,nid);
                }
        }
#endif
#ifdef __QNX__
        if (strlen(s_cwd)<=1 || s_cwd[1] != '/') {
                sprintf(nid,"//%d", getnid());
                if (strlen(nid)+strlen(s_cwd) < MAX_FILE_NAME_SIZE-1) {
                        strcpy(nid+strlen(nid),s_cwd);
                        strcpy(s_cwd,nid);
                }
        }
#endif
        if (!s_opt.fileNamesCaseSensitive) {
                for(rr=s_cwd; *rr; rr++) *rr = tolower(*rr);
        }
}
char *normalizeFileName(char *name, char *relativeto) {
        static char res[MAX_FILE_NAME_SIZE];
        int l1,l2,i,j,s1,inzip=0;
        char *ss;
        l1 = strlen(relativeto);
        l2 = strlen(name);
        s1 = 0;
        if (name[0] == ';') {
                l1 = -1;
                inzip = 1;
#if defined(__WIN32__)
        } else if (name[0]=='\\' || name[0]=='/') {
                res[0] = relativeto[0]; res[1] = ':';
                l1 = 1;
        } else if (name[0]!=0 && name[1]==':') {
                l1 = -1;
                s1 = 0;
#elif defined(__QNX__)
        } else if (name[0] == SLASH) {
                if (name[1] == SLASH) {
                        l1 = -1;
                } else {
                        strncpy(res,s_cwd,2);
                        for(l1=2; s_cwd[l1]!=0 && s_cwd[l1]!=SLASH; l1++)res[l1]=s_cwd[l1];
                        l1 --;
                }
#else
        } else if (name[0] == SLASH) {
                l1 = -1;
#endif
        } else {
                if (l1+l2+2 >= MAX_FILE_NAME_SIZE) {
                        l1 = -1;
                } else {
                        strcpy(res,relativeto);
                        if (! s_opt.fileNamesCaseSensitive) {
                                for(ss=res; *ss; ss++) *ss = tolower(*ss);
                        }
                        if (l1>0 && res[l1-1] == SLASH) l1--;
                        else res[l1]=SLASH;
                }
        }
        for(i=s1, j=l1+1; i<l2+1; ) {
                if (name[i]=='.' && (name[i+1]==SLASH||name[i+1]=='/')) {i+=2;
                } else if (name[i]=='.' && name[i+1]=='.' && (name[i+2]==SLASH||name[i+2]=='/')) {
                                for(j-=2; j>=0 && res[j]!=SLASH && res[j]!='/'; j--) ;
                                i+=3; j++;
                                if (j==0) j++;
                } else {
                        for(; name[i]!=0 && name[i]!=SLASH && name[i]!='/'; i++,j++) {
                                res[j]=name[i];
                                if (res[j]==';') inzip=1;
                                if ((!inzip) && ! s_opt.fileNamesCaseSensitive) {
                                        res[j]=tolower(res[j]);
                                }
                        }
                        res[j]=name[i];
                        if (res[j]=='/' && !inzip) res[j]=SLASH;
                        i++; j++;
# ifdef __QNX__
                        if (i>1 && i<l2+1 && (name[i]=='/'||name[i]==SLASH) && !inzip) i++;
# else
                        if (i<l2+1 && (name[i]=='/' || name[i]==SLASH) && !inzip) i++;
# endif
                }
        }
        if (j>=2 && res[j-2]==SLASH && !inzip) res[j-2]=0;
        return(res);
}
char *crTmpFileName_st() {
        static char ttt[MAX_FILE_NAME_SIZE];
        char *tmp;
        static int count =0;
#if defined(__WIN32__)
        tmp = getenv("TEMP");
        if (tmp==NULL) {
                tmp = tmpnam(NULL);
                strcpy(ttt,tmp);
        } else {
                sprintf(ttt,"%s\\xrefu%d.tmp", tmp, count++);
                strcpy(ttt, normalizeFileName(ttt, s_cwd));
        }
#else
        tmp = tmpnam(NULL);
        strcpy(ttt,tmp);
#endif
        if (ttt == NULL) fatalError(ERR_ST, "can't create temporary file", 65);
        { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "commons.c", 159);};
        return(ttt);
}
void copyFile(char *src, char *dest) {
        FILE *fs,*fd;
        int n,nn;
        fs = fopen(src,"r");
        if (fs==NULL) {
                error(ERR_CANT_OPEN, src);
                return;
        }
        fd = fopen(dest,"w");
        if (fd==NULL) {
                error(ERR_CANT_OPEN, dest);
                fclose(fs);
                return;
        }
        do {
                n = fread(tmpBuff,1,TMP_BUFF_SIZE,fs);
                nn = fwrite(tmpBuff,1,n,fd);
                if (n!=nn) error(ERR_ST,"problem with writing to a file.");
        } while (n > 0);
        fclose(fd);
        fclose(fs);
}
void createDir(char *dirname) {
#ifdef __WIN32__
        mkdir(dirname);
#else
        mkdir(dirname,0777);
#endif
}
void removeFile(char *dirname) {
        unlink(dirname);
}
void copyDir(char *dest, char *s, int *i) {
        int ii;
        *i = 0;
        for(ii=0; s[ii]!=0; ii++) {
                dest[ii] = s[ii];
                if (s[ii]=='/' || s[ii]=='\\') *i = ii+1;
        }
        dest[*i] = 0;
}
static void errorMessage(int errCode, char *mess) {
  if (s_opt.taskRegime != RegimeEditServer) {
        fprintf(errOut,"%s ",placeIdent());
  }
  switch (errCode) {
  case ERR_CANT_OPEN:
        fprintf(errOut,"can't open file %s\n",mess);
        break;
  case ERR_CANT_EXECUTE:
        fprintf(errOut,"can't execute the command %s\n",mess);
        break;
  case ERR_NO_MEMORY:
        fprintf(errOut,"sorry, memory %s overflowed over borne\n",mess);
        fprintf(errOut,"\tread the TROUBLES section of the README file.\n");
        break;
  case ERR_INTERNAL:
        fprintf(errOut,"internal error, %s\n",mess);
        break;
  case ERR_INTERNAL_CHECK:
        fprintf(errOut,"internal check %s\n",mess);
        break;
  case ERR_CFG:
        fprintf(errOut,"a problem while reading config record %s\n",mess);
        break;
  case ERR_LICENSE:
        fprintf(errOut,"evaluation license expired\n");
        break;
  case ERR_BIN_LICENSE:
        fprintf(errOut,"evaluation license expired.\n");
        fprintf(errOut,"\t\tPlease, be aware that further usage \n");
        fprintf(errOut,"\t\tof this software is against the\n");
        fprintf(errOut,"\t\tXrefactory license agreement.\n");
        break;
  default:
        fprintf(errOut,"%s\n",mess);
        break;
  }
  fflush(errOut);
}
void warning(int errCode, char *mess) {
        if (! s_opt.noErrors) {
                fprintf(errOut,"![warning] ");
                errorMessage(errCode, mess);
        }
}
void error(int errCode, char *mess) {
        if (! s_opt.noErrors) {
                fprintf(errOut,"![error] ");
                errorMessage(errCode, mess);
        }
}
void fatalError(int errCode, char *mess, int exitStatus) {
        fprintf(errOut,"![error] ");
        errorMessage(errCode, mess);
        fprintf(errOut,"\t fatal, emergency exit\n");
        fflush(errOut);
        exit(exitStatus);
}
void internalCheckFail(char *expr, char *file, int line) {
        if (errOut == NULL) errOut = stderr;
        sprintf(tmpBuff,"'%s' is not valid in '%s:%d'",expr,file,line);
        error(ERR_INTERNAL_CHECK,tmpBuff);
        if (s_opt.taskRegime == RegimeEditServer) {
                fprintf(errOut, "\t exiting!\n"); fflush(stderr);
                exit(65);
        }
        fprintf(errOut, "\t file aborted!\n"); fflush(stderr);
        longjmp(cxmemOverflow,MESS_FILE_ABORT);
}
