
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static void formatFullCompletions(char *tt, int indent, int inipos) {
        int pos;
        char *nlpos,*p;
        pos = inipos; nlpos=NULL;
        p = tt;
        for(;;) {
                while (pos<s_opt.olineLen || nlpos==NULL) {
                        if (*p == 0) return;
                        if ((p[0]==' '||p[0]==','||p[0]==';'||p[0]=='(') && p[1]==' ') nlpos = p+1;
                        p++; pos++;
                        if (*p == 0) return;
                }
                *nlpos = '\n'; pos = indent+(p-nlpos); nlpos=NULL;
        }
}
static int printJavaModifiers(char *buf, int *size, unsigned acc) {
        int i;
        i = 0;
        if (acc & 0x008) {
                sprintf(buf+i,"static "); i+=strlen(buf+i);
        }
        if (1 || (s_opt.ooChecksBits & 00002)==0) {
                if (acc & 0x001) {
                        sprintf(buf+i,"public "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 47);};
                }
                if (acc & 0x002) {
                        sprintf(buf+i,"private "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 51);};
                }
                if (acc & 0x004) {
                        sprintf(buf+i,"protected "); i+=strlen(buf+i);
                        { if (!(i< *size)) internalCheckFail("i< *size", "complet.c", 55);};
                }
        }
        *size -= i;
        return(i);
}
char *javaGetNudeTypeName( char *inn) {
        int i;
        char *cut,*res;
        cut = strchr(inn, '!');
        if (cut==NULL) cut = inn;
        else cut ++;
        res = cut;
        for(i=0; cut[i]; i++) {
                if (cut[i]=='.' || cut[i]=='/' || cut[i]=='\\' || cut[i]=='$') {
                        res = cut+i+1;
                }
        }
        return(res);
}
char *javaGetNudePreTypeName_st( char *inn, int cutMode) {
        int i,len;
        char *cut,*res,*res2;
        static char ttt[TMP_STRING_SIZE];
        cut = strchr(inn, '!');
        if (cut==NULL) cut = inn;
        else cut ++;
        res = res2 = cut;
        for(i=0; cut[i] ; i++) {
                if (cut[i]=='.' || cut[i]=='/' || cut[i]=='\\'
                        || cut[i] == ';'
                        || (cut[i]=='$' && cutMode==CUT_OUTERS)) {
                        res = res2;
                        res2 = cut+i+1;
                }
        }
        len = res2-res-1;
        if (len<0) len=0;
        strncpy(ttt, res, len);
        ttt[len]=0;
        return(ttt);
}
static char *getCompletionClassFieldString( S_cline *cl) {
        char *cname;
        if (cl->vFunClass!=NULL) {
                cname = javaGetNudeTypeName(cl->vFunClass->linkName);
        } else {
                { if (!(cl->t)) internalCheckFail("cl->t", "complet.c", 124);};
                cname = javaGetNudePreTypeName_st(cl->t->linkName,CUT_OUTERS);
        }
        return(cname);
}
static void printFullCompletionInfo(S_completions* c, int ii, int maxi, int indent) {
        int size,ll,i,tdexpFlag,vFunCl,cindent;
        char tt[COMPLETION_STRING_SIZE];
        char ttt[TMP_STRING_SIZE];
        char *pname,*cname;
        S_olCompletion *olc;
        if (c->a[ii].symType == TypeUndefMacro) return;
        sprintf(tt, "%-*s:", indent+2, c->a[ii].s);
        fprintf(ccOut,"%s", tt);
        cindent = strlen(tt);
        vFunCl = s_noneFileIndex;
        size = COMPLETION_STRING_SIZE;
        ll = 0;
        if (c->a[ii].symType==TypeDefault) {
                { if (!(c->a[ii].t && c->a[ii].t->u.type)) internalCheckFail("c->a[ii].t && c->a[ii].t->u.type", "complet.c", 146);};
                if (((s_language & (4)) != 0)) {
                        cname = getCompletionClassFieldString(&c->a[ii]);
                        if (c->a[ii].virtLevel>1000) {
                                sprintf(tmpBuff,"(%d.%d)%s: ",
                                                c->a[ii].virtLevel/1000,
                                                c->a[ii].virtLevel%1000,
                                                cname);
                        } else if (c->a[ii].virtLevel>0) {
                                sprintf(tmpBuff,"(%d)%s: ", c->a[ii].virtLevel, cname);
                        } else {
                                sprintf(tmpBuff,"   : ");
                        }
                        cindent += strlen(tmpBuff);
                        fprintf(ccOut,"%s", tmpBuff);
                }
                tdexpFlag = 1;
                if (c->a[ii].t->b.storage == StorageTypedef) {
                        sprintf(tt,"typedef ");
                        ll = strlen(tt);
                        size -= ll;
                        tdexpFlag = 0;
                }
                pname = c->a[ii].t->name;
                if (((s_language & (4)) != 0)) {
                        ll += printJavaModifiers(tt+ll, &size, c->a[ii].t->b.accessFlags);
                        if (c->a[ii].vFunClass!=NULL) {
                                vFunCl = c->a[ii].vFunClass->u.s->classFile;
                                if (vFunCl == -1) vFunCl = s_noneFileIndex;
                        }
                }
                typeSPrint(tt+ll, &size, c->a[ii].t->u.type, pname,' ', 0, tdexpFlag,SHORT_NAME);
        } else if (c->a[ii].symType==TypeMacro) {
                macDefSPrintf(tt, &size, "", c->a[ii].s,
                                          c->a[ii].margn, c->a[ii].margs);
        } else if (((s_language & (4)) != 0) && c->a[ii].symType==TypeStruct ) {
                if (c->a[ii].t!=NULL) {
                        ll += printJavaModifiers(tt+ll, &size, c->a[ii].t->b.accessFlags);
                        if (c->a[ii].t->b.accessFlags & 0x200) {
                                sprintf(tt+ll,"interface ");
                        } else {
                                sprintf(tt+ll,"class ");
                        }
                        ll = strlen(tt);
                        javaTypeStringSPrint(tt+ll, c->a[ii].t->linkName,LONG_NAME);
                } else {
                        sprintf(tt,"class ");
                }
        } else if (c->a[ii].symType == TypeInheritedFullMethod) {
                if (c->a[ii].vFunClass!=NULL) {
                        sprintf(tt,"%s \t:%s", c->a[ii].vFunClass->name, typesName[c->a[ii].symType]);
                        vFunCl = c->a[ii].vFunClass->u.s->classFile;
                        if (vFunCl == -1) vFunCl = s_noneFileIndex;
                } else {
                        sprintf(tt,"%s", typesName[c->a[ii].symType]);
                }
        } else {
                { if (!(c->a[ii].symType>=0 && c->a[ii].symType<MAX_TYPE)) internalCheckFail("c->a[ii].symType>=0 && c->a[ii].symType<MAX_TYPE", "complet.c", 208);};
                sprintf(tt,"%s",typesName[c->a[ii].symType]);
        }
        formatFullCompletions(tt, indent+2 +2,
                                                  cindent+2 +2);
        olc = olCompletionListPrepend(c->a[ii].s, c->a[ii].t,NULL, &s_noRef, vFunCl);
        for(i=0; tt[i]; i++) {
                fprintf(ccOut,"%c",tt[i]);
                if (tt[i] == '\n') {
                        fprintf(ccOut,"%-*s  ",indent+2, "");
                        olc->lineCount++;
                }
        }
        if (maxi!=1) fprintf(ccOut,"\n");
}
void olCompletionListInit(S_position *originalPos) {
        olcxFreeCompletionsLists(s_opt.user);
        olcxPushUser();
        olSetCallerPosition(originalPos);
}
void printCompletions(S_completions* c) {
        int i, indent, max;
        if (c->ai == 0) {
                fprintf(ccOut,"-");
                goto fini;
        }
        if (c->comPrefix[0]!=0) {
                if (c->fullMatchFlag) {
                        fprintf(ccOut,",%s", c->comPrefix);
                } else {
                        fprintf(ccOut,".%s", c->comPrefix);
                }
        } else {
                olCompletionListInit(& c->idToProcessPos);
                if (c->ai == 1) {
                        fprintf(ccOut,";");
                } else {
                        fprintf(ccOut,";");
                }
                indent = c->maxLen;
                if (indent > MAX_COMPLETION_INTEND) indent = MAX_COMPLETION_INTEND;
                if (c->ai > s_opt.maxCompletions) max = s_opt.maxCompletions;
                else max = c->ai;
                for(i=0; i<max; i++) {
                        printFullCompletionInfo(c, i, max, indent);
                }
                if (max >= MAX_COMPLETIONS - 2 || max == s_opt.maxCompletions) {
                        fprintf(ccOut,"...\n");
                }
                olCompletionListReverse();
        }
fini:
        fflush(ccOut);
}
static int isTheSameSymbol(S_cline *c1, S_cline *c2) {
        int r;
        if (s_language != 4) return(1);
        if (c1->symType != c2->symType) return(0);
        if (c1->symType == TypeStruct) {
                if (c1->t!=NULL && c2->t!=NULL) {
                        return(strcmp(c1->t->linkName, c2->t->linkName)==0);
                }
        }
        if (c1->symType != TypeDefault) return(1);
        { if (!(c1->t && c1->t->u.type)) internalCheckFail("c1->t && c1->t->u.type", "complet.c", 322);};
        { if (!(c2->t && c2->t->u.type)) internalCheckFail("c2->t && c2->t->u.type", "complet.c", 323);};
        if (c1->t->u.type->m != c2->t->u.type->m) return(0);
        if (c1->vFunClass != c2->vFunClass) return(0);
        if (c2->t->u.type->m != TypeFunction) return(1);
        { if (!(c1->t->u.type->u.sig && c2->t->u.type->u.sig)) internalCheckFail("c1->t->u.type->u.sig && c2->t->u.type->u.sig", "complet.c", 329);};
        if (strcmp(c1->t->u.type->u.sig,c2->t->u.type->u.sig)) return(0);
        return(1);
}
static int symbolIsInTab(S_cline *a, int ai, int *ii, char *s, S_cline *t) {
        int i,j;
        for(i= *ii-1; i>=0 && strcmp(a[i].s,s)==0; i--) ;
        for(j= *ii+1; j<ai && strcmp(a[j].s,s)==0; j++) ;
        for (i++; i<j; i++) if (isTheSameSymbol(&a[i],t)) return(1);
        return(0);
}
static int compareCompletionClassName(S_cline *c1, S_cline *c2) {
        char n1[TMP_STRING_SIZE];
        int c;
        char *n2;
        strcpy(n1, getCompletionClassFieldString(c1));
        n2 = getCompletionClassFieldString(c2);
        c = strcmp(n1, n2);
        if (c<0) return(-1);
        if (c>0) return(1);
        return(0);
}
static int completionOrderCmp(S_cline *c1, S_cline *c2) {
        int c;
        if (! ((s_language & (4)) != 0)) {
                return(strcmp(c1->s, c2->s));
        } else {
                if (c1->symType==TypeKeyword) return(1);
                if (c1->symType!=TypeInheritedFullMethod && c2->symType==TypeInheritedFullMethod) return(1);
                if (c1->symType==TypeInheritedFullMethod && c2->symType!=TypeInheritedFullMethod) return(-1);
                if (c1->symType==TypeInheritedFullMethod && c2->symType==TypeInheritedFullMethod) {
                        if (c1->t == NULL) return(1);
                        if (c2->t == NULL) return(-1);
                        c = compareCompletionClassName(c1, c2);
                        if (c!=0) return(c);
                }
                if (c1->symType!=TypeDefault && c2->symType==TypeDefault) return(1);
                if (c1->symType==TypeDefault && c2->symType!=TypeDefault) return(-1);
                if (c1->symType==TypeDefault && c2->symType==TypeDefault) {
                        c = c1->virtLevel - c2->virtLevel;
                        if (c<0) return(-1);
                        if (c>0) return(1);
                        c = compareCompletionClassName(c1, c2);
                        if (c!=0) return(c);
                }
                return(strcmp(c1->s, c2->s));
        }
}
static int realyInsert( S_cline *a,
                                                int *aip,
                                                char *s,
                                                S_cline *t,
                                                int orderFlag
                                        ) {
        int ai;
        int l,r,x,c,i,tmp;
        ai = *aip;
        l = 0; r = ai-1;
        { if (!(t->s == s)) internalCheckFail("t->s == s", "complet.c", 392);};
        while (l<=r) {
                x = (l+r)/2;
                c = completionOrderCmp(t, &a[x]);
                if (c==0) {
                        if (s_language != 4) return(0);
                        if (symbolIsInTab(a, ai, &x, s, t)) return(0);
                        r = x; l = x + 1;
                        break;
                }
                if (c<0) r=x-1; else l=x+1;
        }
        { if (!(l==r+1)) internalCheckFail("l==r+1", "complet.c", 405);};
        if (orderFlag) for(i=ai-1; i>=l; i--) a[i+1] = a[i];
        else l = ai;
        a[l] = *t;
        a[l].s = s;
        if (ai < MAX_COMPLETIONS-2) ai++;
        *aip = ai;
        return(1);
}
static void computeComPrefix(char *d, char *s) {
        while (*d == *s) {
                if (*d == 0) return;
                d++; s++;
        }
        *d = 0;
}
static int testPrefix(S_completions *ci, char *s) {
        char *d;
        d = ci->idToProcess;
        while (*d == *s) {
                if (*d == 0) {
                        ci->isCompleteFlag = 1;
                        return(0);
                }
                d++; s++;
        }
        if (*d == 0) return(0);
        return(1);
}
int stringContainsCaseInsensitive(char *s1, char *s2) {
        register char *p,*a,*b;
        for (p=s1; *p; p++) {
                for(a=p,b=s2; tolower(*a)==tolower(*b); a++,b++) ;
                if (*b==0) return(1);
        }
        return(0);
}
static void completionInsertName(char *name, S_cline *compLine, int orderFlag,
                                                                 S_completions *ci) {
        int len,l;
        name = compLine->s;
        len = ci->idToProcessLen;
        if (ci->ai == 0) {
                ci->fullMatchFlag = 1;
                strcpy(ci->comPrefix, name+len);
                ci->a[ci->ai] = *compLine;
                ci->a[ci->ai].s = name ;
                ci->ai++;
                ci->maxLen = strlen(name );
        } else {
                if (realyInsert(ci->a, &ci->ai, name , compLine, orderFlag)) {
                        ci->fullMatchFlag = 0;
                        l = strlen(name );
                        if (l > ci->maxLen) ci->maxLen = l;
                        computeComPrefix( ci->comPrefix, name+len);
                }
        }
}
void completeName(char *name, S_cline *compLine, int orderFlag,
                                S_completions *ci) {
        int len,l;
        if (name == NULL) return;
        if (testPrefix(ci, name)) return;
        completionInsertName(name, compLine, orderFlag, ci);
}
void searchName(char *name, S_cline *compLine, int orderFlag,
                                S_completions *ci) {
        int len,l;
        if (name == NULL) return;
        if (s_opt.olcxSearchString==NULL || *s_opt.olcxSearchString==0) {
                if (stringContainsCaseInsensitive(name, ci->idToProcess) == 0) return;
        } else {
                if (searchStringFitness(name, strlen(name)) == 0) return;
        }
        name = compLine->s;
        if (ci->ai == 0) {
                ci->fullMatchFlag = 0;
                ci->comPrefix[0]=0;
                ci->a[ci->ai] = *compLine;
                ci->a[ci->ai].s = name;
                ci->ai++;
                ci->maxLen = strlen(name);
        } else {
                if (realyInsert(ci->a, &ci->ai, name, compLine, 1)) {
                        ci->fullMatchFlag = 0;
                        l = strlen(name);
                        if (l > ci->maxLen) ci->maxLen = l;
                }
        }
}
void processName(char *name, S_cline *compLine, int orderFlag, void *c) {
        S_completions *ci;
        ci = (S_completions *) c;
        if (s_opt.cxrefs == OLO_SEARCH) {
                searchName(name, compLine, orderFlag, ci);
        } else {
                completeName(name, compLine, orderFlag, ci);
        }
}
static void completeFun(S_symbol *s, void *c) {
        S_completionSymInfo *cc;
        S_cline compLine;
        cc = (S_completionSymInfo *) c;
        { if (!(s && cc)) internalCheckFail("s && cc", "complet.c", 522);};
        if (s->b.symType != cc->symType) return;
        if (s->b.symType != TypeMacro) {
                { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        } else {
                if (s->u.mbody==NULL) {
                        { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = TypeUndefMacro; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                } else {
                        { (&compLine)->s = s->name; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = s->u.mbody->argn; (&compLine)->margs = s->u.mbody->args; (&compLine)->vFunClass = NULL;};
                }
        }
        processName(s->name, &compLine, 1, cc->res);
}
static void completeSymFun(S_symbol *s, void *c) {
        S_completionSymFunInfo *cc;
        S_completions *ci;
        S_cline compLine;
        char *completionName;
        cc = (S_completionSymFunInfo *) c;
        { if (!(s)) internalCheckFail("s", "complet.c", 553);};
        if (s->b.symType != TypeDefault) return;
        { if (!(s)) internalCheckFail("s", "complet.c", 555);};
        if (cc->storage==StorageTypedef && s->b.storage!=StorageTypedef) return;
        completionName = s->name;
        { if (cc->storage!=StorageConstructor && s->b.storage==StorageConstructor) { completionName = NULL; } if (cc->storage==StorageConstructor && s->b.storage!=StorageConstructor) { completionName = NULL; }};
        if (completionName!=NULL) {
                { (&compLine)->s = completionName; (&compLine)->t = s; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                processName(completionName, &compLine, 1, cc->res);
        }
}
void completeStructs(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
        { (&ii)->res = c; (&ii)->symType = TypeUnion;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
static int javaLinkable(unsigned storage, unsigned accessFlags) {
        if (s_language != 4) return(1);
        if (storage == 0x800) return(1);
        if ((s_opt.ooChecksBits & 00001) == 0) return(1);
        if (storage & 0x008) return((accessFlags & 0x008) != 0);
        return(1);
}
static void processSpecialInheritedFullCompletion( S_completions *c, int orderFlag, int vlevel, S_symbol *r, S_symbol *vFunCl, char *cname) {
        int size, ll;
        char *fcc;
        char tt[MAX_CX_SYMBOL_SIZE];
        S_cline compLine;
        tt[0]=0; ll=0; size=MAX_CX_SYMBOL_SIZE;
        if (((s_language & (4)) != 0)) {
                ll+=printJavaModifiers(tt+ll, &size, r->b.accessFlags);
        }
        typeSPrint(tt+ll, &size, r->u.type, cname, ' ', 0, 1,SHORT_NAME);
        {fcc = (char*) stackMemoryAlloc((strlen(tt)+1)*sizeof(char)); };
        strcpy(fcc,tt);
        { (&compLine)->s = fcc; (&compLine)->t = r; (&compLine)->symType = TypeInheritedFullMethod; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
        processName(fcc, &compLine, orderFlag, (void*) c);
}
static void completeRecordsNames(
                                                        S_completions *c,
                                                        S_symbol *s,
                                                        unsigned accessMod,
                                                        int classification,
                                                        int constructorOpt,
                                                        int completionType,
                                                        int vlevelOffset
                                                        ) {
        S_cline compLine;
        int orderFlag,rr,vlevel, accCheck, visibCheck;
        S_symbol *r, *vFunCl;
        S_recFindStr rfs;
        char *cname,*fcc;
        if (s==NULL) return;
        if ((* c->idToProcess == 0 && s_language!=4)) {
                orderFlag = 0;
        } else {
                orderFlag = 1;
        }
        { if (!(s->u.s)) internalCheckFail("s->u.s", "complet.c", 624);};
        iniFind(s, &rfs);
        for(;;) {
                visibCheck = VISIB_CHECK_NO;
                if (s_opt.ooChecksBits & 00002) {
                        accCheck = ACC_CHECK_YES;
                } else {
                        accCheck = ACC_CHECK_NO;
                }
                rr = findStrRecordSym(&rfs, NULL, &r, classification, accCheck, visibCheck);
                if (rr != 0) break;
                if (constructorOpt==StorageConstructor && rfs.currClass!=s) break;
                { if (!(r)) internalCheckFail("r", "complet.c", 645);};
                cname = r->name;
                { if (constructorOpt!=StorageConstructor && r->b.storage==StorageConstructor) { cname = NULL; } if (constructorOpt==StorageConstructor && r->b.storage!=StorageConstructor) { cname = NULL; }};
                if ( cname!=NULL &&
                                javaLinkable(accessMod,r->b.accessFlags)) {
                        { if (!(rfs.currClass && rfs.currClass->u.s)) internalCheckFail("rfs.currClass && rfs.currClass->u.s", "complet.c", 654);};
                        { if (!(r->b.symType == TypeDefault)) internalCheckFail("r->b.symType == TypeDefault", "complet.c", 655);};
                        vFunCl = rfs.currClass;
                        if (vFunCl->u.s->classFile == -1) {
                                vFunCl = NULL;
                        }
                        vlevel = rfs.sti + vlevelOffset;
                        if (completionType == TypeInheritedFullMethod) {
                                if (vlevel == 2 && r->b.accessFlags!=0x002
                                        && r->b.storage!=StorageStatic) {
                                        processSpecialInheritedFullCompletion(c,orderFlag,vlevel,
                                                                                                                  r, vFunCl, cname);
                                }
                                c->comPrefix[0]=0;
                        } else if (completionType == TypeSpecialConstructorCompletion) {
                                { (&compLine)->s = c->idToProcess; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
                                completionInsertName(c->idToProcess, &compLine, orderFlag, (void*) c);
                        } else {
                                { (&compLine)->s = cname; (&compLine)->t = r; (&compLine)->symType = TypeDefault; (&compLine)->virtLevel = vlevel; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = vFunCl;};
                                processName(cname, &compLine, orderFlag, (void*) c);
                        }
                }
        }
        if ((* c->idToProcess == 0 && s_language!=4)) c->comPrefix[0] = 0;
}
void completeRecNames(S_completions *c) {
    S_typeModifiers *str;
        S_symbol *s;
        { if (!(s_structRecordCompletionType)) internalCheckFail("s_structRecordCompletionType", "complet.c", 686);};
        str = s_structRecordCompletionType;
        if (str->m == TypeStruct || str->m == TypeUnion) {
                s = str->u.t;
                { if (!(s)) internalCheckFail("s", "complet.c", 690);};
                completeRecordsNames(c, s, 0x000,CLASS_TO_ANY,
                                                         StorageDefault,TypeDefault,0);
        }
        s_structRecordCompletionType = &s_errorModifier;
}
static void completeFromSymTab( S_completions*c,
                                                                unsigned storage
                                                          ){
        S_completionSymFunInfo ii;
        S_javaStat *cs;
        int vlevelOffset;
        { (&ii)->res = c; (&ii)->storage = storage;};
        if (s_language == 4) {
                vlevelOffset = 0;
                for(cs=s_javaStat; cs!=NULL && cs->thisClass!=NULL ;cs=cs->next) {
                        symTabMap2(cs->locals, completeSymFun, (void*) &ii);
                        completeRecordsNames(c, cs->thisClass, s_javaStat->cpMethodMods,
                                                                 CLASS_TO_ANY,
                                                                storage,TypeDefault,vlevelOffset);
                        vlevelOffset += 1000;
                }
        } else {
                symTabMap2(s_symTab, completeSymFun, (void*) &ii);
        }
}
void completeEnums(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeEnum;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeLabels(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeLabel;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeMacros(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeMacro;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void completeTypes(S_completions* c) {
        completeFromSymTab(c, StorageTypedef);
}
void completeOthers(S_completions *c) {
        completeFromSymTab(c, StorageDefault);
        completeMacros(c);
}
static S_symbol * getSymFromRef(S_reference *rr) {
        int i;
        S_symbolRefItem *ss;
        S_reference *r;
        S_symbol *sym;
        r = NULL; ss = NULL;
        for(i=0; i<s_cxrefTab.size; i++) {
                ss = s_cxrefTab.tab[i];
                if (ss!=NULL) {
                        for(r=ss->refs; r!=NULL; r=r->next) {
                                if (rr == r) goto cont;
                        }
                }
        }
 cont:
        if (i>=s_cxrefTab.size) return(NULL);
        { if (!(r==rr)) internalCheckFail("r==rr", "complet.c", 763);};
        for(i=0; i<s_symTab->size; i++) {
                for(sym=s_symTab->tab[i]; sym!=NULL; sym=sym->next) {
                        if (strcmp(sym->linkName,ss->name)==0) return(sym);
                }
        }
        return(NULL);
}
static int isEqualType(S_typeModifiers *t1, S_typeModifiers *t2) {
        S_typeModifiers *s1,*s2;
        S_symbol *ss1,*ss2;
        { if (!(t1 && t2)) internalCheckFail("t1 && t2", "complet.c", 776);};
        for(s1=t1,s2=t2; s1->next!=NULL&&s2->next!=NULL; s1=s1->next,s2=s2->next) {
                if (s1->m!=s2->m) return(0);
        }
        if (s1->next!=NULL || s2->next!=NULL) return(0);
        if (s1->m != s2->m) return(0);
        if (s1->m==TypeStruct || s1->m==TypeUnion || s1->m==TypeEnum) {
                if (s1->u.t != s2->u.t) return(0);
        } else if (s1->m==TypeFunction) {
                if (((s_language & (4)) != 0)) {
                        if (strcmp(s1->u.sig,s2->u.sig)!=0) return(0);
                } else {
                        for(ss1=s1->u.f.args, ss2=s2->u.f.args;
                                ss1!=NULL&&ss2!=NULL;
                                ss1=ss1->next, ss2=ss2->next) {
                                if (! isEqualType(ss1->u.type, ss2->u.type)) return(0);
                        }
                        if (ss1!=NULL||ss2!=NULL) return(0);
                }
        }
        return(1);
}
static char *spComplFindNextRecord(S_exprTokenType *tok) {
        S_recFindStr rfs;
        int rr;
        S_symbol *r,*s;
        char *cname,*res;
        static char *cnext="next";
        static char *cprevious="previous";
        s = tok->t->next->u.t;
        res = NULL;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "complet.c", 808);};
        iniFind(s, &rfs);
        for(;;) {
                rr = findStrRecordSym(&rfs, NULL, &r, CLASS_TO_ANY, ACC_CHECK_YES, VISIB_CHECK_YES);
                if (rr != 0) break;
                { if (!(r)) internalCheckFail("r", "complet.c", 813);};
                cname = r->name;
                { if (StorageDefault!=StorageConstructor && r->b.storage==StorageConstructor) { cname = NULL; } if (StorageDefault==StorageConstructor && r->b.storage!=StorageConstructor) { cname = NULL; }};
                if ( cname!=NULL &&
                                javaLinkable(0x800,r->b.accessFlags)) {
                        { if (!(rfs.currClass && rfs.currClass->u.s)) internalCheckFail("rfs.currClass && rfs.currClass->u.s", "complet.c", 818);};
                        { if (!(r->b.symType == TypeDefault)) internalCheckFail("r->b.symType == TypeDefault", "complet.c", 819);};
                        if (isEqualType(r->u.type, tok->t)) {
                                if (res == NULL) res = cname;
                                else if (strcmp(cname,cnext)==0) res = cnext;
                                else if (res!=cnext&&strcmp(cname,"previous")==0)res=cprevious;
                        }
                }
        }
        return(res);
}
static int isForCompletionSymbol(S_completions *c,
                                                                 S_exprTokenType *tok,
                                                                 S_symbol **sym,
                                                                 char **nextRecord
        ) {
        S_symbol *ss,*sy;
        char *rec;
        if (s_opt.cxrefs != OLO_COMPLETION) return(0);
        if (tok->t==NULL) return(0);
        if (c->idToProcessLen != 0) return(0);
        if (tok->t->m == TypePointer) {
                { if (!(tok->t->next)) internalCheckFail("tok->t->next", "complet.c", 842);};
                if (tok->t->next->m == TypeStruct) {
                        *sym = sy = getSymFromRef(tok->r);
                        if (sy==NULL) return(0);
                        *nextRecord = spComplFindNextRecord(tok);
                        return(1);
                }
        }
        return(0);
}
void completeForSpecial1(S_completions* c) {
        static char ss[TMP_STRING_SIZE];
        char *rec;
        S_cline compLine;
        S_symbol *sym;
        if (isForCompletionSymbol(c,&s_forCompletionType,&sym,&rec)) {
                sprintf(ss,"%s!=NULL; ", sym->name);
                { (&compLine)->s = ss; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                completeName(ss, &compLine, 0, c);
        }
}
void completeForSpecial2(S_completions* c) {
        static char ss[TMP_STRING_SIZE];
        char *rec;
        S_cline compLine;
        S_symbol *sym;
        if (isForCompletionSymbol(c, &s_forCompletionType,&sym,&rec)) {
                if (rec!=NULL) {
                        sprintf(ss,"%s=%s->%s) {", sym->name, sym->name, rec);
                        { (&compLine)->s = ss; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                        completeName(ss, &compLine, 0, c);
                }
        }
}
void completeUpFunProfile(S_completions* c) {
        S_symbol *dd;
        if (s_upLevelFunctionCompletionType!=NULL
                && c->idToProcess[0] == 0
                && c->ai==0
                ) {
                {dd = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
                { (&dd->b)->record = 0; (&dd->b)->accessFlags = 0; (&dd->b)->javaSourceLoaded = 0; (&dd->b)->javaFileLoaded = 0; (&dd->b)->symType = TypeDefault; (&dd->b)->storage = StorageDefault; (&dd->b)->npointers = 0;};
                { (dd)->name = "    "; (dd)->linkName = "    "; (dd)->pos = s_noPos; (dd)->b = dd->b; (dd)->u.type = s_upLevelFunctionCompletionType; (dd)->next = NULL;};
                { (&c->a[0])->s = "    "; (&c->a[0])->t = dd; (&c->a[0])->symType = TypeDefault; (&c->a[0])->virtLevel = 0; (&c->a[0])->margn = 0; (&c->a[0])->margs = NULL; (&c->a[0])->vFunClass = NULL;};
                c->fullMatchFlag = 1;
                c->comPrefix[0]=0;
                c->ai++;
        }
}
static S_symbol * javaGetFileNameClass(char *fname) {
        char *pp;
        S_symbol *res;
        pp = javaCutClassPathFromFileName(fname);
        res = javaGetFieldClass(pp,NULL);
        return(res);
}
static void completeConstructorsFromFile(S_completions *c, char *fname) {
        S_symbol *memb;
        memb = javaGetFileNameClass(fname);
        if (strcmp(memb->name, c->idToProcess)==0) {
                javaLoadClassSymbolsFromFile(memb);
                completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,TypeDefault,0);
        }
}
static void completeJavaConstructors(S_symbol *s, void *c) {
        if (s->b.symType != TypeStruct) return;
        completeConstructorsFromFile((S_completions *)c, s->linkName);
}
static void javaPackageNameCompletion(
                                                                        char *fname,
                                                                        char *path,
                                                                        char *pack,
                                                                        S_completions *c,
                                                                        void *idp,
                                                                        int *pstorage
                                                                ) {
        S_cline compLine;
        char *cname;
        struct stat stt;
        S_idIdentList *id;
        id = (S_idIdentList *) idp;
        if (strchr(fname,'.')!=NULL) return;
        {cname = (char*) stackMemoryAlloc((strlen(fname)+1)*sizeof(char)); };
        strcpy(cname, fname);
        { (&compLine)->s = cname; (&compLine)->t = NULL; (&compLine)->symType = TypePackage; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(cname, &compLine, 1, (void*) c);
}
static void javaTypeNameCompletion(
                                                                        char *fname,
                                                                        char *path,
                                                                        char *pack,
                                                                        S_completions *c,
                                                                        void *idp,
                                                                        int *pstorage
                                                                ) {
        char cfname[MAX_FILE_NAME_SIZE];
        S_cline compLine;
        char *cname,*suff;
        struct stat stt;
        S_idIdentList ttl,*id;
        int len,storage,complType;
        S_symbol *memb;
        memb = NULL;
        id = (S_idIdentList *) idp;
        if (pstorage == NULL) storage = StorageDefault;
        else storage = *pstorage;
        len = strlen(fname);
        complType = TypePackage;
        if (strchr(fname,'.') != NULL) {
                if (strchr(fname,'$') != NULL) return;
                suff = strchr(fname,'.');
                if (suff == NULL) return;
                if (strcmp(suff,".java")==0) len -= 5;
                else if (strcmp(suff,".class")==0) len -= 6;
                else return;
                complType = TypeStruct;
                sprintf(cfname,"%s/%s", pack, fname);
                { if (!(strlen(cfname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(cfname)+1 < MAX_FILE_NAME_SIZE", "complet.c", 986);};
                memb = javaGetFieldClass(cfname,NULL);
                if (storage == StorageConstructor) {
                        sprintf(cfname,"%s/%s/%s", path, pack, fname);
                        { if (!(strlen(cfname)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(cfname)+1 < MAX_FILE_NAME_SIZE", "complet.c", 990);};
                        memb = javaGetFileNameClass(cfname);
                        completeConstructorsFromFile(c, cfname);
                }
        }
        {cname = (char*) stackMemoryAlloc((len+1)*sizeof(char)); };
        strncpy(cname, fname, len);
        cname[len]=0;
        { (&compLine)->s = cname; (&compLine)->t = memb; (&compLine)->symType = complType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(cname, &compLine, 1, (void*) c);
}
static void javaCompleteNestedClasses( S_completions *c,
                                                                                S_symbol *cclas,
                                                                                int storage
                                                                                ) {
        S_cline compLine;
        int i;
        S_symbol *memb;
        S_symbol *str;
        str = cclas;
        for(str=cclas;
                str!=NULL && str->u.s->super!=NULL;
                str=str->u.s->super->d) {
                { if (!(str && str->u.s)) internalCheckFail("str && str->u.s", "complet.c", 1015);};
                for(i=0; i<str->u.s->nnested; i++) {
                        if (str->u.s->nest[i].membFlag) {
                                memb = str->u.s->nest[i].cl;
                                { if (!(memb)) internalCheckFail("memb", "complet.c", 1019);};
                                memb->b.accessFlags |= str->u.s->nest[i].accFlags;
                                { (&compLine)->s = memb->name; (&compLine)->t = memb; (&compLine)->symType = TypeStruct; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                                processName(memb->name, &compLine, 1, (void*) c);
                                if (storage == StorageConstructor) {
                                        javaLoadClassSymbolsFromFile(memb);
                                        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,TypeDefault,0);
                                }
                        }
                }
        }
}
static void javaCompleteNestedClSingleName(S_completions *cc) {
        S_cline compLine;
        S_javaStat *cs;
        S_symbol *nest,*mc;
        int i;
        for(cs=s_javaStat; cs!=NULL && cs->thisClass!=NULL; cs=cs->next) {
                javaCompleteNestedClasses(cc, cs->thisClass, StorageDefault);
        }
}
static void javaCompleteComposedName(
                                                                S_completions*c,
                                                                int classif,
                                                                int storage,
                                                                int innerConstruct
                                                                ) {
        S_symbol *str;
        S_typeModifiers *expr;
        int i,nameType;
        char *p,*lp,*fullName;
        char packName[MAX_FILE_NAME_SIZE];
        unsigned accs;
        S_reference *orr;
        nameType = javaClassifyAmbiguousName(s_javaStat->lastParsedName,NULL,&str,
                                                                                 &expr,&orr,NULL,classif,UsageUsed);
        if (innerConstruct && nameType != TypeExpression) return;
        if (nameType == TypeExpression) {
                if (expr->m == TypeArray) expr = &s_javaArrayObjectSymbol.u.s->stype;
                if (expr->m != TypeStruct) return;
                str = expr->u.t;
                accs = 0x000;
        } else {
                accs = 0x008;
        }
        if (nameType==TypePackage){
                javaCreateComposedName(NULL,s_javaStat->lastParsedName,NULL,packName,MAX_FILE_NAME_SIZE);
                javaMapDirectoryFiles1(packName, javaTypeNameCompletion,
                                                        c,s_javaStat->lastParsedName, &storage);
        }
        if (nameType==TypeStruct || innerConstruct){
                javaLoadClassSymbolsFromFile(str);
                javaCompleteNestedClasses(c, str, storage);
        }
        if (classif==CLASS_TO_EXPR && str!=NULL && storage!=StorageConstructor
                        && (nameType==TypeStruct || nameType==TypeExpression)) {
                javaLoadClassSymbolsFromFile(str);
                completeRecordsNames(c, str, accs,CLASS_TO_ANY, storage,TypeDefault,0);
        }
}
void javaCompletePackageSingleName(S_completions*c) {
        javaMapDirectoryFiles2(NULL, javaPackageNameCompletion, c, NULL, NULL);
}
void javaCompleteThisPackageName(S_completions *c) {
        S_cline compLine;
        static char cname[TMP_STRING_SIZE];
        char *cc, *ss, *dd;
        if (c->idToProcessLen != 0) return;
        ss = javaCutSourcePathFromFileName(getRealFileNameStatic(s_fileTab.tab[s_olOriginalFileNumber]->name));
        strcpy(cname, ss);
        dd = lastOccurenceInString(cname, '.');
        if (dd!=NULL) *dd=0;
        javaDotifyFileName(cname);
        cc = lastOccurenceInString(cname, '.');
        if (cc==NULL) return;
        *cc++ = ';'; *cc = 0;
        { (&compLine)->s = cname; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        completeName(cname, &compLine, 0, c);
}
static void javaCompleteThisClassDefinitionName(S_completions*c) {
        S_cline compLine;
        static char cname[TMP_STRING_SIZE];
        char *cc;
        javaGetClassNameFromFileNum(s_olOriginalFileNumber, cname, DOTIFY_NAME);
        cc = strchr(cname,0);
        { if (!(cc!=NULL)) internalCheckFail("cc!=NULL", "complet.c", 1117);};
        *cc++ = ' '; *cc=0;
        cc = lastOccurenceInString(cname, '.');
        if (cc==NULL) return;
        cc++;
        { (&compLine)->s = cc; (&compLine)->t = NULL; (&compLine)->symType = TypeSpecialComplet; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        completeName(cc, &compLine, 0, c);
}
void javaCompleteClassDefinitionNameSpecial(S_completions*c) {
        if (c->idToProcessLen != 0) return;
        javaCompleteThisClassDefinitionName(c);
}
void javaCompleteClassDefinitionName(S_completions*c) {
        S_completionSymInfo ii;
        javaCompleteThisClassDefinitionName(c);
        javaCompleteNestedClSingleName(c);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
void javaCompletePackageCompName(S_completions*c) {
        javaClassifyToPackageNameAndAddRefs(s_javaStat->lastParsedName, UsageUsed);
        javaMapDirectoryFiles2(s_javaStat->lastParsedName,
                        javaPackageNameCompletion, c, s_javaStat->lastParsedName, NULL);
}
void javaCompleteTypeSingleName(S_completions*c) {
        S_completionSymInfo ii;
        javaCompleteNestedClSingleName(c);
        javaMapDirectoryFiles2(NULL, javaTypeNameCompletion, c, NULL, NULL);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
}
static void completeFqtClassFile(char *zip, char *file, void *cc) {
        char ttt[MAX_FILE_NAME_SIZE];
        char sss[TMP_STRING_SIZE];
        char *tt,*suff, *sname, *ss;
        S_cline compLine;
        S_completionFqtMapInfo *fmi;
        S_completions *c;
        S_symbol *memb;
        int i;
        fmi = (S_completionFqtMapInfo *) cc;
        c = fmi->res;
        suff = getFileSuffix(file);
        if (fnCmp(suff, ".class")==0) {
                sprintf(ttt, "%s", file);
                { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "complet.c", 1170);};
                suff = lastOccurenceInString(ttt, '.');
                { if (!(suff)) internalCheckFail("suff", "complet.c", 1172);};
                *suff = 0;
                sname = lastOccurenceInString(ttt, '/');
                if (sname == NULL) sname = ttt;
                else sname ++;
                if (strncmp(c->idToProcess, sname, c->idToProcessLen)==0
                        || (fmi->completionType == FQT_COMPLETE_ALSO_ON_PACKAGE
                                && strncmp(c->idToProcess, ttt, c->idToProcessLen)==0)) {
                        memb = javaGetFieldClass(ttt, &sname);
                        linkNamePrettyPrint(sss, ttt, TMP_STRING_SIZE, LONG_NAME);
                        {ss = (char*) stackMemoryAlloc((strlen(sss)+1)*sizeof(char)); };
                        strcpy(ss, sss);
                        sname = lastOccurenceInString(ss,'.');
                        if (sname==NULL) sname = ss;
                        else sname++;
                        { (&compLine)->s = ss; (&compLine)->t = memb; (&compLine)->symType = TypeNonImportedClass; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
                        if (fmi->completionType == FQT_COMPLETE_ALSO_ON_PACKAGE) {
                                processName(ss, &compLine, 0, c);
                        } else {
                                processName(sname, &compLine, 0, c);
                        }
                        c->comPrefix[0] = 0;
                }
        }
}
static void javaFqtCompletions(S_completions *c, int completionType) {
        S_completionFqtMapInfo ii;
        int i;
        if (! s_opt.fqtNameToCompletions) return;
        { (&ii)->res = c; (&ii)->completionType = completionType;};
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                fsRecMapOnFiles(s_zipArchivTab[i].dir, s_zipArchivTab[i].fn,
                                                "", completeFqtClassFile, &ii);
        }
}
void javaHintCompleteNonImportedTypes(S_completions*c) {
        javaFqtCompletions(c, DEFAULT_VALUE);
}
void javaHintImportFqt(S_completions*c) {
        javaFqtCompletions(c, FQT_COMPLETE_ALSO_ON_PACKAGE);
}
void javaCompleteTypeCompName(S_completions *c) {
        javaCompleteComposedName(c, CLASS_TO_TYPE, StorageDefault,0);
}
void javaCompleteConstructSingleName(S_completions *c) {
        S_completionSymFunInfo ii;
        symTabMap2(s_symTab, completeJavaConstructors, c);
}
void javaCompleteConstructCompName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_TYPE, StorageConstructor,0);
}
void javaCompleteConstructNestNameName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_EXPR, StorageConstructor,1);
}
void javaCompleteConstructNestPrimName(S_completions*c) {
        S_symbol *memb;
        if (s_javaCompletionLastPrimary == NULL) return;
        if (s_javaCompletionLastPrimary->m == TypeStruct) {
                memb = s_javaCompletionLastPrimary->u.t;
        } else return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1249);};
        javaCompleteNestedClasses(c, memb, StorageConstructor);
}
void javaCompleteExprSingleName(S_completions*c) {
        S_completionSymInfo ii;
        javaMapDirectoryFiles1(NULL, javaTypeNameCompletion, c, NULL, NULL);
        { (&ii)->res = c; (&ii)->symType = TypeStruct;};
        symTabMap2(s_symTab, completeFun, (void*) &ii);
        completeFromSymTab(c, StorageDefault);
}
void javaCompleteThisConstructor (S_completions *c) {
        S_symbol *memb;
        if (strcmp(c->idToProcess,"this")!=0) return;
        if (s_opt.cxrefs == OLO_SEARCH) return;
        memb = s_javaStat->thisClass;
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,
                                                 TypeSpecialConstructorCompletion,0);
}
void javaCompleteSuperConstructor (S_completions *c) {
        S_symbol *memb;
        if (strcmp(c->idToProcess,"super")!=0) return;
        if (s_opt.cxrefs == OLO_SEARCH) return;
        memb = javaCurrentSuperClass();
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x800,CLASS_TO_ANY, StorageConstructor,
                                                 TypeSpecialConstructorCompletion,0);
}
void javaCompleteSuperNestedConstructor (S_completions *c) {
        if (strcmp(c->idToProcess,"super")!=0) return;
}
void javaCompleteExprCompName(S_completions*c) {
        javaCompleteComposedName(c, CLASS_TO_EXPR, StorageDefault,0);
}
void javaCompleteStrRecordPrimary(S_completions*c) {
        S_symbol *memb;
        if (s_javaCompletionLastPrimary == NULL) return;
        if (s_javaCompletionLastPrimary->m == TypeStruct) {
                memb = s_javaCompletionLastPrimary->u.t;
        } else if (s_javaCompletionLastPrimary->m == TypeArray) {
                memb = &s_javaArrayObjectSymbol;
        } else return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1298);};
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, 0x000,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteStrRecordSuper(S_completions*c) {
        S_symbol *memb;
        memb = javaCurrentSuperClass();
        if (memb == &s_errorSymbol || memb->b.symType==TypeError) return;
        { if (!(memb)) internalCheckFail("memb", "complet.c", 1308);};
        javaLoadClassSymbolsFromFile(memb);
        completeRecordsNames(c, memb, s_javaStat->cpMethodMods,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteStrRecordQualifiedSuper(S_completions*c) {
        S_symbol *str;
        S_typeModifiers *expr;
        S_idIdentList *ii;
        S_reference *rr, *lastUselessRef;
        int ttype;
        lastUselessRef = NULL;
        ttype = javaClassifyAmbiguousName(s_javaStat->lastParsedName, NULL,&str,&expr,&rr,
                                                                          &lastUselessRef,CLASS_TO_TYPE,UsageUsed);
        if (ttype != TypeStruct) return;
        javaLoadClassSymbolsFromFile(str);
        str = javaGetSuperClass(str);
        if (str == &s_errorSymbol || str->b.symType==TypeError) return;
        { if (!(str)) internalCheckFail("str", "complet.c", 1326);};
        completeRecordsNames(c, str, s_javaStat->cpMethodMods,CLASS_TO_ANY, StorageDefault,TypeDefault,0);
}
void javaCompleteUpMethodSingleName(S_completions*c) {
        S_completionSymFunInfo ii;
        if (s_javaStat!=NULL) {
                completeRecordsNames(c, s_javaStat->thisClass, 0x800,CLASS_TO_ANY,
                                                         StorageDefault,TypeDefault,0);
        }
}
void javaCompleteFullInheritedMethodHeader(S_completions*c) {
        S_completionSymFunInfo ii;
        S_cline compLine;
        char *maindecl;
        if (c->idToProcessLen != 0) return;
        if (s_javaStat!=NULL) {
                completeRecordsNames(c,s_javaStat->thisClass,0x800,CLASS_TO_METHOD,
                                                         StorageDefault,TypeInheritedFullMethod,0);
        }
}
void javaCompleteMethodCompName(S_completions*c) {
        javaCompleteExprCompName(c);
}
static void completeFromXrefFun(S_symbolRefItem *s, void *c) {
        S_completionSymInfo *cc;
        S_cline compLine;
        cc = (S_completionSymInfo *) c;
        { if (!(s && cc)) internalCheckFail("s && cc", "complet.c", 1369);};
        if (s->b.symType != cc->symType) return;
        { (&compLine)->s = s->name; (&compLine)->t = NULL; (&compLine)->symType = s->b.symType; (&compLine)->virtLevel = 0; (&compLine)->margn = 0; (&compLine)->margs = NULL; (&compLine)->vFunClass = NULL;};
        processName(s->name, &compLine, 1, cc->res);
}
void completeYaccLexem(S_completions*c) {
        S_completionSymInfo ii;
        { (&ii)->res = c; (&ii)->symType = TypeYaccSymbol;};
        refTabMap2(&s_cxrefTab, completeFromXrefFun, (void*) &ii);
}
