
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static unsigned s_javaExtractFromFunctionMods=0x000;
static void dumpProgram(S_programGraphNode *program) {
        S_programGraphNode *p;
        fprintf(dumpOut,"[ProgramDump]\n");
        for(p=program; p!=NULL; p=p->next) {
                fprintf(dumpOut,"%x: %2d %2d %s %s",p,
                        p->posBits,p->stateBits,
                        p->symRef->name,
                        usagesName[p->ref->usage]+5);
                if (p->symRef->b.symType==TypeLabel && p->ref->usage!=UsageDefined) {
                        fprintf(dumpOut," %x",p->jump);
                }
                fprintf(dumpOut,"\n");
        }
        fflush(dumpOut);
}
void genInternalLabelReference(int counter, int usage) {
        char ttt[TMP_STRING_SIZE];
        S_idIdent ll;
        { sprintf(ttt,"%%L%d",counter); { if (!(strlen(ttt) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(ttt) < TMP_STRING_SIZE-1", "extract.c", 47);};};
        { (&ll)->name = ttt; (&ll)->sd = NULL; (&ll)->p.file = cFile.lb.cb.fileNumber; (&ll)->p.line = 0; (&ll)->p.coll = 0;};
        if (usage != UsageDefined) ll.p.line++;
        labelReference(&ll, usage);
}
S_symbol * addContinueBreakLabelSymbol(int labn, char *name) {
        S_symbol *s;
        {s = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
        { (&s->b)->record = 0; (&s->b)->accessFlags = 0; (&s->b)->javaSourceLoaded = 0; (&s->b)->javaFileLoaded = 0; (&s->b)->symType = TypeLabel; (&s->b)->storage = StorageAuto; (&s->b)->npointers = 0;};
        { (s)->name = name; (s)->linkName = name; (s)->pos = s_noPos; (s)->b = s->b; (s)->u.labn = labn; (s)->next = NULL;};
        { int i; S_symbol *memb; symTabIsMember(s_symTab,s,&i,&memb); if ( ((s_language & (16)) != 0) && s->b.symType==TypeDefault && s->u.type->m == TypeFunction) { s->u.type->u.f.thisFunList = &(s_symTab->tab[i]); } symTabSet(s_symTab,s,i);};
        return(s);
}
void deleteContinueBreakLabelSymbol(char *name) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
          { if (s_opt.cxrefs == OLO_EXTRACT) deleteSymDef(memb);};
        } else {
          { if (!(0)) internalCheckFail("0", "extract.c", 73);};
        }
}
void genContinueBreakReference(char *name) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
                genInternalLabelReference(memb->u.labn, UsageUsed);
        }
}
void genSwitchCaseFork(int lastFlag) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = " %swtl%"; (&ss)->linkName = " %swtl%"; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
                genInternalLabelReference(memb->u.labn, UsageDefined);
                if (! lastFlag) {
                        memb->u.labn++;
                        genInternalLabelReference(memb->u.labn, UsageFork);
                }
        }
}
static void extractFunGraphRef(S_symbolRefItem *rr, void *prog) {
        S_reference *r;
        S_programGraphNode *p,**ap;
        ap = (S_programGraphNode **) prog;
        for(r=rr->refs; r!=NULL; r=r->next) {
                if (( ((char*)r) >= cxMemory.b + (s_cp.cxMemiAtFunBegin) && ((char*)r) < cxMemory.b + (s_cp.cxMemiAtFunEnd) )){
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "extract.c", 107);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(1)*sizeof(S_programGraphNode) >= cxMemory.size) { if (cxMemory.overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } p = (S_programGraphNode*) (cxMemory.b + cxMemory.i); cxMemory.i += (1)*sizeof(S_programGraphNode);};};};
                        { (p)->ref = r; (p)->symRef = rr; (p)->jump = NULL; (p)->posBits = 0; (p)->stateBits = 0; (p)->classifBits = EXTRACT_NONE; (p)->next = *ap;};
                        *ap = p;
                }
        }
}
static S_programGraphNode *getGraphAddress( S_programGraphNode *program,
                                                                                        S_reference *ref
                                                                                ) {
        S_programGraphNode *p,*res;
        res = NULL;
        for(p=program; res==NULL && p!=NULL; p=p->next) {
                if (p->ref == ref) res = p;
        }
        return(res);
}
static S_reference *getDefinitionReference(S_symbolRefItem *lab) {
        S_reference *res;
        for(res=lab->refs; res!=NULL && res->usage!=UsageDefined; res=res->next) ;
        if (res == NULL) {
                sprintf(tmpBuff,"jump to unknown label '%s'\n",lab->name);
                error(ERR_ST,tmpBuff);
        }
        return(res);
}
static S_programGraphNode *getLabelGraphAddress(S_programGraphNode *program,
                                                                                                S_symbolRefItem *lab
                                                                                        ) {
        S_programGraphNode *res;
        S_reference *defref;
        { if (!(lab->b.symType == TypeLabel)) internalCheckFail("lab->b.symType == TypeLabel", "extract.c", 140);};
        defref = getDefinitionReference(lab);
        res = getGraphAddress(program, defref);
        return(res);
}
static int linearOrder(S_programGraphNode *n1, S_programGraphNode *n2) {
        return(n1->ref < n2->ref);
}
static S_programGraphNode * extMakeProgramGraph() {
        S_programGraphNode *program,*p;
        program = NULL;
        refTabMap5(&s_cxrefTab, extractFunGraphRef, ((void *) &program));
        { register S_programGraphNode *tmpInList, *tmptmp; S_programGraphNode *tmpOutList; tmpOutList = NULL; tmpInList = program; while (tmpInList!=NULL) { tmptmp = tmpInList->next; tmpInList->next = NULL; { S_programGraphNode **ptmp; { register S_programGraphNode *tmp,**lStMp; tmp = *((&tmpOutList)); lStMp = (&tmpOutList); while (tmp!=NULL && linearOrder(tmp, ((tmpInList)))) { lStMp = &(tmp->next); tmp = *lStMp; } ptmp = lStMp; }; {(tmpInList)->next = ((*ptmp)); (*ptmp) = tmpInList;}; }; tmpInList = tmptmp; } program = tmpOutList;};
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType==TypeLabel && p->ref->usage!=UsageDefined) {
                        p->jump = getLabelGraphAddress(program, p->symRef);
                }
        }
        return(program);
}
static void extSetSetStates( S_programGraphNode *p,
                                                                S_symbolRefItem *symRef,
                                                                unsigned cstate
                                                        ) {
        unsigned cpos,oldStateBits;
        for(; p!=NULL; p=p->next) {
                cont:
                if (p->stateBits == cstate) return;
                oldStateBits = p->stateBits;
                cstate = p->stateBits = (cstate | oldStateBits | 1);
                cpos = p->posBits | 1;
                if (p->symRef == symRef) {
                        if (p->ref->usage == UsageAddrUsed) cstate = cpos;
                        else if (p->ref->usage == UsageLvalUsed
                                        || (p->ref->usage == UsageDefined
                                                && ! (p->symRef->name[0]=='*'))
                                ) {
                                cstate = cpos;
                                p->stateBits = cstate;
                        }
                } else if (p->symRef->b.symType==TypeBlockMarker &&
                                        (p->posBits&2) == 0) {
                        if (cstate & 2) {
                                cstate |= 8;
                        }
                        if (cstate & 4) {
                                cstate |= 16;
                        }
                } else if (p->symRef->b.symType==TypeLabel) {
                        if (p->ref->usage==UsageUsed) {
                                p = p->jump;
                                goto cont;
                        } else if (p->ref->usage==UsageFork) {
                                extSetSetStates(p->jump, symRef, cstate);
                        }
                }
        }
}
static int extCategorizeLocalVar0( S_programGraphNode *program,
                                                                        S_programGraphNode *varRef
                                                                ) {
        S_programGraphNode *p;
        S_symbolRefItem *symRef;
        unsigned inUsages,outUsages;
        symRef = varRef->symRef;
        for(p=program; p!=NULL; p=p->next) {
                p->stateBits = 0;
        }
        extSetSetStates(program, symRef, 1);
        inUsages = outUsages = 0;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef == varRef->symRef && p->ref->usage != UsageNone) {
                        if (p->posBits==2) {
                                inUsages |= p->stateBits;
                        } else if (p->posBits==4) {
                                outUsages |= p->stateBits;
                        } else { if (!(0)) internalCheckFail("0", "extract.c", 258);};
                }
        }
        if (varRef->posBits == 4) {
                if (outUsages & 2) {
                        if ((inUsages & (8|4)) == 0
                                && (outUsages & 16) == 0) {
                                return(EXTRACT_OUT_ARGUMENT);
                        } else {
                                return(EXTRACT_IN_OUT_ARGUMENT);
                        }
                }
                if (inUsages & 8) return(EXTRACT_IN_OUT_ARGUMENT);
                if (inUsages & 4) return(EXTRACT_VALUE_ARGUMENT);
                if (inUsages) return(EXTRACT_LOCAL_VAR);
                return(EXTRACT_NONE);
        } else {
                if ( outUsages & 2
                        || outUsages & 4) {
                        return(EXTRACT_LOCAL_OUT_ARGUMENT);
                } else {
                        return(EXTRACT_NONE);
                }
        }
}
static int extCategorizeLocalVar( S_programGraphNode *program,
                                                                        S_programGraphNode *varRef
                                                                ) {
        int res;
        res = extCategorizeLocalVar0(program, varRef);
        if ((varRef->symRef->name[0]=='*')
                && res!=EXTRACT_NONE && res!=EXTRACT_LOCAL_VAR) {
                return(EXTRACT_ADDRESS_ARGUMENT);
        }
        return(res);
}
static void extSetInOutBlockFields(S_programGraphNode *program) {
        S_programGraphNode *p;
        unsigned pos;
        pos = 4;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType == TypeBlockMarker) { if (pos==2) pos = 4; else if (pos==4) pos = 2; else { if (!(0)) internalCheckFail("0", "extract.c", 307);};};
                p->posBits = pos;
        }
}
static int extIsJumpInOutBlock(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType==TypeLabel) {
                        if (p->ref->usage==UsageUsed || p->ref->usage==UsageFork) {
                                if (p->posBits != p->jump->posBits) {
                                        return(1);
                                }
                        }
                }
        }
        return(0);
}
static void extClassifyLocalVariables(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (( p->ref->usage==UsageDefined && p->symRef->b.symType==TypeDefault && p->symRef->b.scope==ScopeAuto )) {
                        p->classifBits = extCategorizeLocalVar(program,p);
                }
        }
}
static void extReClassifyIOVars(S_programGraphNode *program) {
        S_programGraphNode *p,*op;
        int uniqueOutFlag;
        op = NULL; uniqueOutFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (s_opt.extractMode == EXTR_FUNCTION_ADDRESS_ARGS) {
                        if ( p->classifBits == EXTRACT_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                                ) {
                                p->classifBits = EXTRACT_ADDRESS_ARGUMENT;
                        }
                } else if (s_opt.extractMode == EXTR_FUNCTION) {
                        if (p->classifBits == EXTRACT_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                                ) {
                                if (op == NULL) op = p;
                                else uniqueOutFlag = 0;
                        }
                }
        }
        if (op!=NULL && uniqueOutFlag) {
                if (op->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                        op->classifBits = EXTRACT_LOCAL_RESULT_VALUE;
                } else {
                        op->classifBits = EXTRACT_RESULT_VALUE;
                }
                return;
        }
        op = NULL; uniqueOutFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (s_opt.extractMode == EXTR_FUNCTION) {
                        if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                                if (op == NULL) op = p;
                                else uniqueOutFlag = 0;
                        }
                }
        }
        if (op!=NULL && uniqueOutFlag) {
                op->classifBits = EXTRACT_IN_RESULT_VALUE;
                return;
        }
}
static void extGenNewMacroCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr;
        int i, fFlag=1;
        fprintf(ccOut,"\t%s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_VAR) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "%s);\n", fFlag?"(":"");
}
static void extGenNewMacroHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi;
        char dcla[TMP_STRING_SIZE];
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr;
        int i, uniqueOutFlag, fFlag=1;
        fprintf(ccOut,"#define %s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_VAR) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 485);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 485);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 485);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 485);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s%s", fFlag?"(":"," , name);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "%s) {\\\n", fFlag?"(":"");
}
static void extGenNewMacroTail(S_programGraphNode *program) {
        fprintf(ccOut,"}\n\n");
}
static void extGenNewFunCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr;
        int i, fFlag=1;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) break;
        }
        if (p!=NULL) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 517);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 517);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 517);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 517);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                if (p->classifBits == EXTRACT_LOCAL_RESULT_VALUE) {
                        fprintf(ccOut,"\t%s = ", decl);
                } else {
                        fprintf(ccOut,"\t%s = ", name);
                }
        } else {
                fprintf(ccOut,"\t");
        }
        fprintf(ccOut,"%s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 531);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 531);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 531);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 531);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 542);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 542);}; d = strmcpy(d, s_opt.olExtractAddrParPrefix); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 542);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 542);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s&%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "%s);\n", fFlag?"(":"");
}
static void extGenNewFunHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi,ldclaLen;
        char ldcla[TMP_STRING_SIZE];
        char dcla[TMP_STRING_SIZE];
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr;
        int i, uniqueOutFlag, fFlag=1;
        nhi = 0;
        sprintf(nhead+nhi,"%s",s_opt.extractName);
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 571);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 571);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 571);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 571);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 582);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 582);}; d = strmcpy(d, s_opt.olExtractAddrParPrefix); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 582);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 582);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_ADDRESS_ARGUMENT) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 591);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 591);}; d = strmcpy(d, EXTRACT_REFERENCE_ARG_STRING); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 591);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 591);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        sprintf(nhead+nhi, "%s)", fFlag?"(":"");
        nhi += strlen(nhead+nhi);
        if (((s_language & (4)) != 0) && (s_javaExtractFromFunctionMods&0x008)==0){
          fprintf(ccOut, "");
        } else {
          fprintf(ccOut, "static ");
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) break;
        }
        if (p==NULL) {
          fprintf(ccOut,"void %s",nhead);
        } else {
          { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 614);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 614);}; d = strmcpy(d, nhead); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (0) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 614);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 614);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
          fprintf(ccOut, "%s", decl);
        }
        fprintf(ccOut, " {\n");
        ldcla[0] = 0; ldclaLen = 0; fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_LOCAL_VAR
                                || p->classifBits == EXTRACT_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_RESULT_VALUE
                                || ( p->symRef->b.storage == StorageExtern
                                         && p->ref->usage == UsageDeclared)
                                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 630);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 630);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 630);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 630);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (strcmp(ldcla,dcla)==0) {
                                fprintf(ccOut, ",%s",decl+ldclaLen);
                        } else {
                                strcpy(ldcla,dcla); ldclaLen=strlen(ldcla);
                                if (fFlag) fprintf(ccOut, "\t%s",decl);
                                else fprintf(ccOut, ";\n\t%s",decl);
                        }
                        if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                                fprintf(ccOut, " = %s%s", s_opt.olExtractAddrParPrefix, name);
                        }
                        fFlag = 0;
                }
        }
        if (fFlag == 0) fprintf(ccOut, ";\n");
}
static void extGenNewFunTail(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 657);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 657);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 657);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 657);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "\t%s%s = %s;\n", s_opt.olExtractAddrParPrefix,
                                        name, name);
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 667);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 667);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 667);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 667);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "\treturn(%s);\n", name);
                }
        }
        fprintf(ccOut,"}\n\n");
}
static char * extJavaNewClassName() {
  static char classname[TMP_STRING_SIZE];
  if (s_opt.extractName[0]==0) {
        sprintf(classname,"NewClass");
  } else {
        sprintf(classname, "%c%s", toupper(s_opt.extractName[0]),
                        s_opt.extractName+1);
  }
  return(classname);
}
static void extJavaGenNewClassCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr,*classname;
        int i, fFlag=1;
        classname = extJavaNewClassName();
        fprintf(ccOut,"\t\t%s %s = new %s",classname, s_opt.extractName,classname);
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
          if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                fprintf(ccOut, "%s %s", fFlag?"(":"," , name);
                fFlag = 0;
          }
        }
        fprintf(ccOut, "%s);\n", fFlag?"(":"");
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        ) break;
        }
        if (p!=NULL) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 734);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 734);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 734);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 734);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                if (p->classifBits == EXTRACT_LOCAL_RESULT_VALUE) {
                        fprintf(ccOut,"\t\t%s = ", decl);
                } else {
                        fprintf(ccOut,"\t\t%s = ", name);
                }
        } else {
                fprintf(ccOut,"\t\t");
        }
        fprintf(ccOut,"%s.perform",s_opt.extractName);
        fFlag=1;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 749);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 749);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 749);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 749);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "%s);\n", fFlag?"(":"");
        fprintf(ccOut, "\t\t");
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 763);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 763);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 763);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 763);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                                fprintf(ccOut, "%s=%s.%s; ", decl, s_opt.extractName, name);
                        } else {
                                fprintf(ccOut, "%s=%s.%s; ", name, s_opt.extractName, name);
                        }
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "\n");
        fprintf(ccOut,"\t\t%s = null;\n", s_opt.extractName);
}
static void extJavaGenNewClassHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi,ldclaLen;
        char ldcla[TMP_STRING_SIZE];
        char dcla[TMP_STRING_SIZE];
        char *classname;
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr, *mattrib;
        int i, uniqueOutFlag, fFlag=1;
        classname = extJavaNewClassName();
        fprintf(ccOut, "\t");
        if (s_javaExtractFromFunctionMods & 0x008){
          fprintf(ccOut, "static ");
        }
        fprintf(ccOut, "class %s {\n", classname);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 804);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 804);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 804);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 804);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "\t\t%s;\n", decl);
                }
        }
        fprintf(ccOut, "\t\t%s", classname);
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT){
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 816);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 816);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 816);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 816);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "%s%s", fFlag?"(":", " , decl);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "%s) {", fFlag?"(":"");
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT){
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 826);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 826);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 826);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 826);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (fFlag) fprintf(ccOut, "\n\t\t\t");
                        fprintf(ccOut, "this.%s = %s; ", name, name);
                        fFlag = 0;
                }
        }
        if (! fFlag) fprintf(ccOut,"\n\t\t");
        fprintf(ccOut,"}\n");
        nhi = 0; fFlag = 1;
        sprintf(nhead+nhi,"%s", "perform");
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 844);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 844);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 844);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 844);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        sprintf(nhead+nhi, "%s)", fFlag?"(":"");
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) break;
        }
        if (p==NULL) {
                fprintf(ccOut,"\t\tvoid %s", nhead);
        } else {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 861);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 861);}; d = strmcpy(d, nhead); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (0) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 861);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 861);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                fprintf(ccOut, "\t\t%s", decl);
        }
        fprintf(ccOut, " {\n");
        ldcla[0] = 0; ldclaLen = 0; fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_LOCAL_VAR
                                || p->classifBits == EXTRACT_RESULT_VALUE
                                || ( p->symRef->b.storage == StorageExtern
                                         && p->ref->usage == UsageDeclared)
                                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 875);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 875);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 875);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 875);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (strcmp(ldcla,dcla)==0) {
                                fprintf(ccOut, ",%s",decl+ldclaLen);
                        } else {
                                strcpy(ldcla,dcla); ldclaLen=strlen(ldcla);
                                if (fFlag) fprintf(ccOut, "\t\t\t%s",decl);
                                else fprintf(ccOut, ";\n\t\t\t%s",decl);
                        }
                        fFlag = 0;
                }
        }
        if (fFlag == 0) fprintf(ccOut, ";\n");
}
static void extJavaGenNewClassTail(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        int fFlag;
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 901);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 901);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 901);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 901);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (fFlag) fprintf(ccOut, "\t\t\t");
                        fprintf(ccOut, "this.%s=%s; ", name, name);
                        fFlag = 0;
                }
        }
        fprintf(ccOut, "\n");
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 916);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 916);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 916);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 916);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        fprintf(ccOut, "\t\t\treturn(%s);\n", name);
                }
        }
        fprintf(ccOut,"\t\t}\n\t}\n\n");
}
static int extJavaIsNewClassNecesary(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        ) break;
        }
        if (p==NULL) return(0);
        return(1);
}
static void extMakeExtraction() {
        S_programGraphNode *program,*p;
        int cat,newClassExt;
        if (s_cp.cxMemiAtFunBegin > s_cps.cxMemiAtBlockBegin
                || s_cps.cxMemiAtBlockBegin > s_cps.cxMemiAtBlockEnd
                || s_cps.cxMemiAtBlockEnd > s_cp.cxMemiAtFunEnd
                || s_cps.workMemiAtBlockBegin != s_cps.workMemiAtBlockEnd) {
                fprintf(ccOut,"*** region / program structure mismatch, no extraction **");
                return;
        }
        { if (!(s_cp.cxMemiAtFunBegin)) internalCheckFail("s_cp.cxMemiAtFunBegin", "extract.c", 948);};
        { if (!(s_cps.cxMemiAtBlockBegin)) internalCheckFail("s_cps.cxMemiAtBlockBegin", "extract.c", 949);};
        { if (!(s_cps.cxMemiAtBlockEnd)) internalCheckFail("s_cps.cxMemiAtBlockEnd", "extract.c", 950);};
        { if (!(s_cp.cxMemiAtFunEnd)) internalCheckFail("s_cp.cxMemiAtFunEnd", "extract.c", 951);};
        program = extMakeProgramGraph();
        extSetInOutBlockFields(program);
        if (s_opt.extractMode!=EXTR_MACRO && extIsJumpInOutBlock(program)) {
                fprintf(ccOut,
                        "* ** There are jumps in or out of region, no action made **");
                fflush(ccOut);
                return;
        }
        extClassifyLocalVariables(program);
        extReClassifyIOVars(program);
        newClassExt = 0;
        if (((s_language & (4)) != 0)) newClassExt = extJavaIsNewClassNecesary(program);
        fprintf(ccOut,
"%%!\n------------------------ The Invocation ------------------------\n!\n");
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroCall(program);
        else if (newClassExt) extJavaGenNewClassCall(program);
        else extGenNewFunCall(program);
        fprintf(ccOut,
"!\n--------------------------- The Head ---------------------------\n!\n");
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroHead(program);
        else if (newClassExt) extJavaGenNewClassHead(program);
        else extGenNewFunHead(program);
        fprintf(ccOut,
"!\n--------------------------- The Tail ---------------------------\n!\n");
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroTail(program);
        else if (newClassExt) extJavaGenNewClassTail(program);
        else extGenNewFunTail(program);
        fprintf(ccOut,"!%d!\n", s_cp.funBegPosition);
        fflush(ccOut);
}
void actionsBeforeAfterExternalDefinition() {
        int pi;
        if (s_cps.cxMemiAtBlockEnd != 0
                && s_cp.cxMemiAtFunBegin != 0
                && s_cp.cxMemiAtFunBegin <= s_cps.cxMemiAtBlockBegin
                && s_opt.cxrefs == OLO_EXTRACT
                && (! s_cps.extractProcessedFlag)) {
                        s_cp.cxMemiAtFunEnd = cxMemory.i;
                        extMakeExtraction();
                        s_cps.extractProcessedFlag = 1;
        }
        s_cp.cxMemiAtFunBegin = cxMemory.i;
        if (inStacki) {
                s_cp.funBegPosition = inStack[0].lineNumber+1;
        } else {
                s_cp.funBegPosition = cFile.lineNumber+1;
        }
}
void extractActionOnBlockMarker() {
        S_position pos;
        if (s_cps.cxMemiAtBlockBegin == 0) {
                s_cps.cxMemiAtBlockBegin = cxMemory.i;
                s_cps.workMemiAtBlockBegin = s_topBlock->previousTopBlock;
                if (((s_language & (4)) != 0)) {
                        s_javaExtractFromFunctionMods = s_javaStat->cpMethodMods;
                }
        } else {
                { if (!(s_cps.cxMemiAtBlockEnd == 0)) internalCheckFail("s_cps.cxMemiAtBlockEnd == 0", "extract.c", 1027);};
                s_cps.cxMemiAtBlockEnd = cxMemory.i;
                s_cps.workMemiAtBlockEnd = s_topBlock->previousTopBlock;
        }
        { (&pos)->file = cFile.lb.cb.fileNumber; (&pos)->line = 0; (&pos)->coll = 0;};
        addTrivialCxReference("Block", TypeBlockMarker,StorageDefault, &pos, UsageUsed);
}
