
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static int subToFill(S_symbol *p, int fullFlag) {
        if (p->b.storage == StorageError) return(0);
        { if (!(p->u.type)) internalCheckFail("p->u.type", "generate.c", 22);};
        if (p->u.type->m == TypeAnonymeField) return(0);
        if (p->u.type->m == TypeFunction) return(0);
        if (p->u.type->m == TypeArray) return(0);
        return(1);
}
static void genCopy( S_symbol *defin,
                                                S_symbol *p,
                                                S_typeModifiers *tt,
                                                char *pref,
                                                int pi
                                        ) {
        char stars[200];
        int i;
        for(i=0; i<pi; i++) stars[i]='*';
        stars[i]=0;
        if (tt->m == TypePointer && tt->next->m==TypeVoid) {
                sprintf(tmpBuff,"a void * pointer in %s, wrong structre copy possible",
                                                defin->name);
                warning(ERR_ST,tmpBuff);
        } else if (tt->m == TypePointer && tt->next->m!=TypeStruct) {
                fprintf(cxOut,"  (void*)%sd->%s%s=(*alloc)(sizeof(*%ss->%s%s));\n",
                                                stars,pref,p->name,stars,pref,p->name);
                if (tt->next->m==TypePointer) {
                        genCopy(defin,p,tt->next,pref,pi+1);
                } else {
                        fprintf(cxOut,"  memcpy(%sd->%s%s,%ss->%s%s,sizeof(*%ss->%s%s));\n",
                                        stars,pref,p->name,stars,pref,p->name,stars,pref,p->name);
                }
        } else if (tt->m == TypePointer && tt->next->m==TypeStruct) {
                fprintf(cxOut,"  %sd->%s%s = copy_%s(%ss->%s%s,alloc);\n",stars,
                                        pref,p->name,tt->next->u.t->name,stars,pref,p->name);
        }
}
static void fillGenArgHeadItem(char *name, int *i) {
        fprintf(cxOut,",%s%d", name, *i);
        (*i)++;
}
static int genFillStructArguments( S_symbol *defin,
                                                                        int i,
                                                                        int fullFlag
        ) {
        S_symbol *rec;
        S_symbol *p;
        static int deep=0;
        { if (!(defin->u.s)) internalCheckFail("defin->u.s", "generate.c", 74);};
        rec = defin->u.s->records;
        deep++;
        if (deep > MAX_NESTED_DEEP) {
                fatalError(ERR_ST,"too much nested structures, probably recursive", 65);
        }
        for(p=rec; p!=NULL; p=p->next) {
                if (subToFill(p, fullFlag)) {
                        if (p->u.type->m == TypeStruct && fullFlag) {
                                i = genFillStructArguments(p->u.type->u.t,i,1);
                        } else if (p->u.type->m == TypeUnion) {
                                        fillGenArgHeadItem("FARG", &i);
                                        fillGenArgHeadItem("FARG", &i);
                        } else {
                                fillGenArgHeadItem("FARG", &i);
                        }
                }
        }
        deep--;
        return(i);
}
static char *getFillArgumentName(int i, int argn, int action) {
        static char res[TMP_STRING_SIZE];
        if (action == InternalFillGenerate) {
                sprintf(res,"_ARG_PROJECT_%d_%d ARGS", i, argn);
        } else {
                sprintf(res,"FARG%d",i);
        }
        return(res);
}
static void genFillItem(char *pref, int action,
                                 char *name, int i, int argn) {
        fprintf(cxOut,"\t(XXX)->%s%s = %s;\\\n",
                                pref,name,getFillArgumentName(i,argn,action));
}
static int genFillStructBody(S_symbol *defin, int i, int argn, int fullFlag,
                                                         char *pref, int action) {
        S_symbol *rec;
        S_symbol *p;
        S_typeModifiers *tt;
        char prefix[TMP_STRING_SIZE];
        char rname[TMP_STRING_SIZE];
        int l1,l2;
        static int deep=0;
        { if (!(defin->u.s)) internalCheckFail("defin->u.s", "generate.c", 123);};
        rec = defin->u.s->records;
        deep++;
        if (deep > MAX_NESTED_DEEP) {
                fatalError(ERR_ST,"too much nested structures, probably recursive", 65);
        }
        for(p=rec; p!=NULL; p=p->next) {
                if (subToFill(p, fullFlag)) {
                        if ( (p->u.type->m == TypeStruct && fullFlag)
                                        || p->u.type->m == TypeUnion) {
                                l1 = strlen(pref);
                                l2 = strlen(p->name);
                                { if (!(l1+l2+6 < TMP_STRING_SIZE)) internalCheckFail("l1+l2+6 < TMP_STRING_SIZE", "generate.c", 135);};
                                strcpy(prefix,pref);
                                strcpy(prefix+l1, p->name);
                                prefix[l1+l2] = 0;
                                if (p->u.type->m == TypeUnion) {
                                        if (fullFlag) {
                                                strcpy(rname,getFillArgumentName(i,argn,action));
                                                i++;
                                                fprintf(cxOut,
                                                                "\t_FILLUREC_%s_##%s((&(XXX)->%s), %s);\\\n",
                                                                p->u.type->u.t->name,rname,prefix,
                                                                getFillArgumentName(i,argn,action));
                                                i++;
                                        } else {
                                                prefix[l1+l2] = '.';
                                                prefix[l1+l2+1] = 0;
                                                strcpy(rname,getFillArgumentName(i,argn,action));
                                                i++;
                                                genFillItem( prefix, action, rname, i, argn);
                                                i++;
                                        }
                                } else {
                                        prefix[l1+l2] = '.';
                                        prefix[l1+l2+1] = 0;
                                        i=genFillStructBody(p->u.type->u.t,i,argn,1,prefix,action);
                                }
                        } else {
                                genFillItem( pref, action, p->name, i, argn);
                                i++;
                        }
                }
        }
        deep--;
        return(i);
}
static void genStructTypedef(S_symbol *s) {
        char *name;
        S_symbol *rec;
        { if (!(s)) internalCheckFail("s", "generate.c", 177);};
        name = s->name;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "generate.c", 179);};
        rec = s->u.s->records;
        { if (!(name)) internalCheckFail("name", "generate.c", 181);};
        if (s->b.symType == TypeStruct) {
                fprintf(cxOut,"typedef struct %s S_%s;\n",name,name);
        } else {
                fprintf(cxOut,"typedef union %s U_%s;\n",name,name);
        }
}
static void genStructFill(S_symbol *s) {
        char *name;
        int argn;
        S_symbol *rec;
        { if (!(s)) internalCheckFail("s", "generate.c", 194);};
        name = s->name;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "generate.c", 196);};
        rec = s->u.s->records;
        { if (!(name)) internalCheckFail("name", "generate.c", 198);};
        fprintf(cxOut,"#define FILL_%s(XXX",name);
        argn = genFillStructArguments(s, 0, 0);
        fprintf(cxOut,") {\\\n");
        genFillStructBody(s, 0, argn, 0, "", FillGenerate);
        fprintf(cxOut,"}\n");
        fprintf(cxOut,"#define FILLF_%s(XXX",name);
        argn = genFillStructArguments(s, 0, 1);
        fprintf(cxOut,") {\\\n");
        genFillStructBody(s, 0, argn, 1, "", FillGenerate);
        fprintf(cxOut,"}\n");
        fprintf(cxOut,"#define _FILLF_%s(XXX,ARGS) {\\\n",name);
        genFillStructBody(s, 0, argn, 1, "", InternalFillGenerate);
        fprintf(cxOut,"}\n");
}
static void genUnionRecords(S_symbol *s) {
        char *name;
        int argn;
        S_symbol *rec,*p;
        { if (!(s)) internalCheckFail("s", "generate.c", 219);};
        name = s->name;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "generate.c", 221);};
        rec = s->u.s->records;
        { if (!(name)) internalCheckFail("name", "generate.c", 223);};
        for(p=rec; p!=NULL; p=p->next) {
                if (p->b.symType == TypeDefault) {
                        if (p->u.type->m == TypeStruct) {
                                fprintf(cxOut,
                                "#define _FILLUREC_%s_%s(XX,ARGS) _FILLF_%s(&(XX->%s),ARGS)\n",
                                name, p->name, p->u.type->u.t->name, p->name);
                        } else {
                                fprintf(cxOut,
                                        "#define _FILLUREC_%s_%s(XX,ARG) XX->%s = ARG;\n",
                                        name, p->name, p->name);
                        }
                }
        }
}
static void genStructCopy(S_symbol *s) {
        char *name;
        S_symbol *rec;
        { if (!(s)) internalCheckFail("s", "generate.c", 243);};
        name = s->name;
        { if (!(s->u.s)) internalCheckFail("s->u.s", "generate.c", 245);};
        rec = s->u.s->records;
        { if (!(name)) internalCheckFail("name", "generate.c", 247);};
        if (rec==NULL) return;
        if (s_opt.header) {
                fprintf(cxOut,
                        "extern struct %s*\ncopy_%s(struct %s *, void *(*alloc)(int));\n",
                        name,name,name);
        }
        if (s_opt.body) {
                fprintf(cxOut,
                        "struct %s *\ncopy_%s(struct %s *s, void *(*alloc)(int n))",
                        name,name,name);
                fprintf(cxOut," {\n");
                fprintf(cxOut,"  struct %s *d;\n",name);
                fprintf(cxOut,"  d = (struct %s *) (*alloc)(sizeof(struct %s));\n",
                                                name,name);
                fprintf(cxOut,"  memcpy(d,s,sizeof(struct %s));\n",name);
                genFillStructBody(s, 0, 0 , 1, "", CopyGenerate);
                fprintf(cxOut,"  return(d);\n");
                fprintf(cxOut,"}\n\n");
        }
}
static void genEnumTypedef(S_symbol *s) {
        char *name;
        S_symbolList *e;
        { if (!(s)) internalCheckFail("s", "generate.c", 272);};
        name = s->name;
        e = s->u.enums;
        { if (!(name)) internalCheckFail("name", "generate.c", 275);};
}
static void genEnumText(S_symbol *s) {
        char *name;
        S_symbolList *e;
        { if (!(s)) internalCheckFail("s", "generate.c", 284);};
        name = s->name;
        e = s->u.enums;
        { if (!(name)) internalCheckFail("name", "generate.c", 287);};
        if (s_opt.header) {
                fprintf(cxOut,"extern char * %sName[];\n",name);
        }
        if (s_opt.body) {
                fprintf(cxOut,"char * %sName[] = {\n",name);
                for(;e!=NULL;e=e->next) {
                        { if (!(e->d)) internalCheckFail("e->d", "generate.c", 294);};
                        { if (!(e->d->name)) internalCheckFail("e->d->name", "generate.c", 295);};
                        fprintf(cxOut,"\t\"%s\"",e->d->name);
                        if (e->next!=NULL) fprintf(cxOut,",");
                        fprintf(cxOut,"\n");
                }
                fprintf(cxOut,"};\n\n",name);
        }
}
void genProjections(int n) {
        int i,j,k;
        for (i=1; i<=n; i++) {
                for(j=0; j<i; j++) {
                        fprintf(cxOut,"#define _ARG_PROJECT_%d_%d",j,i);
                        for (k=0;k<i;k++) fprintf(cxOut,"%sA%d",(k?",":"("),k);
                        fprintf(cxOut,") A%d\n",j);
                }
        }
}
void generate(S_symbol *s) {
        { if (!(s)) internalCheckFail("s", "generate.c", 321);};
        if (s->name==NULL || s->name[0]==0) return;
        if (s->b.symType==TypeStruct || s->b.symType==TypeUnion) {
                if (s_opt.typedefg) genStructTypedef(s);
                if (s_opt.str_fill) {
                        if (s->b.symType==TypeStruct) genStructFill(s);
                        if (s->b.symType==TypeUnion) genUnionRecords(s);
                }
                if (s_opt.str_copy) genStructCopy(s);
        } else if (s->b.symType == TypeEnum) {
                if (s_opt.typedefg) genEnumTypedef(s);
                if (s_opt.enum_name) genEnumText(s);
        }
}
