
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static char s_htmlEmptyRefs[MAX_FILE_NAME_SIZE];
static S_olSymbolsMenu *s_htmlCurrentCxlist;
static char *s_cxGlobalReferencesBase;
#if defined(__QNX__)
char *htmlNormalizedPath(char *p) {
        char *pp;
        pp = p;
        if (pp[0]=='/' && pp[1]=='/') {
                for(pp+=2; isdigit(*pp); pp++) ;
        }
        return(pp);
}
#elif defined(__WIN32__)
char *htmlNormalizedPath(char *p) {
        if (p[0]!=0 && p[1]==':') return(p+2);
        return(p);
}
#else
char *htmlNormalizedPath(char *p) {
        return(p);
}
#endif
#if defined(__WIN32__)
int isAbsolutePath(char *p) {
        if (p[0]!=0 && p[1]==':' && p[2]==SLASH) return(1);
        if (p[0]==SLASH) return(1);
        return(0);
}
#else
int isAbsolutePath(char *p) {
        return(p[0]==SLASH);
}
#endif
static char *cutHtmlPath(char *path) {
        char *pp,*cutp;
        int i,m,cutpl;
        pp = htmlNormalizedPath(path);
        m = s_opt.htmlCut.pathesNum;
        for(i=0; i<m; i++) {
                cutp = s_opt.htmlCut.path[i];
                cutpl = s_opt.htmlCut.plen[i];
                if (fnnCmp(pp, cutp, cutpl)==0) return(pp+cutpl);
        }
        return(pp);
}
static void htmlCompressFile(char *fname) {
        char sss[MAX_HTML_REF_LEN];
        char *s;
        int len1;
        if (s_opt.htmlZipCommand == NULL) return;
        s = strchr(s_opt.htmlZipCommand, '!');
        if (s==NULL) {
                static int message=1;
                if (message) error(ERR_ST,"missing the ! meta-char in the zip command");
                message = 0;
                return;
        }
        len1 = s-s_opt.htmlZipCommand;
        strncpy(sss, s_opt.htmlZipCommand, len1);
        strcpy(sss+len1, fname);
        strcat(sss, s+1);
        { if (!(strlen(sss) < MAX_HTML_REF_LEN-2)) internalCheckFail("strlen(sss) < MAX_HTML_REF_LEN-2", "html.c", 103);};
        system(sss);
}
char *htmlGetLinkFileNameStatic(char *link, char *file) {
        static char fn[MAX_FILE_NAME_SIZE];
        char *p1,*p2,*ls1,*ls2,*resp, *ls;
        p1=ls1=htmlNormalizedPath(file);
        p2=ls2=htmlNormalizedPath(getRealFileNameStatic(link));
        p1=ls1=cutHtmlPath(p1);
        p2=ls2=cutHtmlPath(p2);
        for(; *p1 && *p1==*p2; p1++,p2++) {
                if (*p1 == SLASH) {ls1=p1+1; ls2=p2+1;}
        }
        resp = fn;
        for(; *p1; p1++) {
                if (*p1 == SLASH) {
                        sprintf(resp,"..%c",HTML_SLASH); resp+=3;
                        { if (!(resp-fn < MAX_FILE_NAME_SIZE-2)) internalCheckFail("resp-fn < MAX_FILE_NAME_SIZE-2", "html.c", 123);};
                }
        }
        strcpy(resp,ls2);
        ls = resp;
        while ((ls=strchr(ls+1, SLASH))!=NULL) *ls = HTML_SLASH;
        { if (!(resp-fn < MAX_FILE_NAME_SIZE-2)) internalCheckFail("resp-fn < MAX_FILE_NAME_SIZE-2", "html.c", 129);};
        return(fn);
}
static char *htmlCutLastSuffixStatic(char *fname) {
        static char res[MAX_FILE_NAME_SIZE];
        char *dd,*ld;
        if (! s_opt.htmlCutSuffix) return(fname);
        strcpy(res, fname);
        dd = ld = res;
        dd = strchr(dd, '.');
        while (dd) {
                ld = dd;
                dd = strchr(dd+1, '.');
        }
        if (ld != res) *ld = 0;
        return(res);
}
static void htmlGenLogo() {
        fprintf(ccOut,"<p><font size=-1><center>\n");
        fprintf(ccOut, "Html form generated by ");
        if ((s_opt.java2html)) {
          fprintf(ccOut, "<A HREF=\"http://www.xref-tech.com/java2html/\" target=\"_top\">");
          fprintf(ccOut,"<B>Xref-Java2Html</B></A> version 1.4.0 ");
        } else {
          fprintf(ccOut, "<A HREF=\"http://www.xref-tech.com/xrefactory/\" target=\"_top\">");
          fprintf(ccOut,"<B>Xrefactory</B></A>");
          fprintf(ccOut," version %s ","1.5.10");
        }
        fprintf(ccOut," on %s\n", ctime(&s_fileProcessStartTime));
        {
                time_t t = 1067641200;
                fprintf(ccOut,"<br>Trial version.");
        }
        fprintf(ccOut,"</center></font><p>\n");
}
static char *htmlAuxFileNameStatic(int fnum, char *subdir,
                                                                char *suff1, char *suff2) {
        static char res[MAX_FILE_NAME_SIZE];
        char *fn,*fd;
        int n;
        { if (!(s_fileTab.tab[fnum])) internalCheckFail("s_fileTab.tab[fnum]", "html.c", 184);};
        fn = s_fileTab.tab[fnum]->name;
        fn = getRealFileNameStatic(fn);
        fn = cutHtmlPath(fn);
        fd = lastOccurenceInString(fn, SLASH);
        n = fd - fn;
        strncpy(res, fn, n);
        sprintf(res+n,"%c%s%s%s%s",SLASH,subdir,fd,suff1,suff2);
        { if (!(strlen(res)<MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(res)<MAX_FILE_NAME_SIZE-1", "html.c", 192);};
        return(res);
}
static void htmlGenHead(int fn) {
        char *fname,*de,*ss0,*ss,*cutfn;
        int i,ch,sn,cutFlag;
        cutFlag = 0;
        { if (!(s_fileTab.tab[fn])) internalCheckFail("s_fileTab.tab[fn]", "html.c", 200);};
        fname = getRealFileNameStatic(s_fileTab.tab[fn]->name);
        cutfn = cutHtmlPath(fname);
        if (cutfn != fname) cutFlag = 1;
        fprintf(ccOut,"<HTML><HEAD><TITLE>%s</TITLE>\n",fname);
        if (s_opt.htmlNoUnderline) {
                fprintf(ccOut,"<STYLE TYPE=\"text/css\">\n");
                fprintf(ccOut,"<!-- A:link{text-decoration: none}\n");
                fprintf(ccOut,"A:visited{text-decoration: none}\n");
                fprintf(ccOut,"A:active{text-decoration: none} -->\n");
                fprintf(ccOut,"</STYLE>\n");
        }
        fprintf(ccOut,"</HEAD>\n");
        fprintf(ccOut,"<body topmargin=\"0\" leftmargin=\"0\"");
        fprintf(ccOut,"bgcolor=\"#FFFFFF\"\n");
        fprintf(ccOut,"link=\"%s\" vlink=\"%s\" alink=\"red\">\n",
                        s_opt.htmlLinkColor, s_opt.htmlLinkColor);
        fprintf(ccOut,"<center>");
        if (((s_opt.htmlglobalx || s_opt.htmllocalx))) {
                fprintf(ccOut,"<font size=-1>");
                fprintf(ccOut,"<A HREF=\"XFRM%c%s.frm.html%s\" ",
                                                HTML_SLASH, simpleFileName(fname),s_opt.htmlLinkSuffix);
                fprintf(ccOut,">");
                fprintf(ccOut,"Create Xref-Html Frames</A>");
                for(i=0; i<10; i++) fprintf(ccOut,"&nbsp; ");
                fprintf(ccOut,"<A HREF=\"%s.html%s\" target=\"_top\">",
                                htmlCutLastSuffixStatic(simpleFileName(fname)),
                                s_opt.htmlLinkSuffix);
                fprintf(ccOut,"Remove All Frames</A>");
                fprintf(ccOut,"</font>");
                fprintf(ccOut,"<hr>");
        }
        fprintf(ccOut,"file:<B>");
        sn = 0;
        for(i=0; fname[i]; i++) if (fname[i]==SLASH) sn++;
        ss0 = fname;
        while (sn > 0) {
                for(ss=ss0; *ss && *ss!=SLASH; ss++) ;
                { if (!(*ss)) internalCheckFail("*ss", "html.c", 239);};
                ch = *ss; *ss = 0;
                if (cutFlag && ss0<cutfn) {
                        fprintf(ccOut,"%s/", ss0);
                } else {
                        fprintf(ccOut,"<A HREF=\".%c",HTML_SLASH);
                        for(i=1; i<sn; i++) fprintf(ccOut,"..%c",HTML_SLASH);
                        fprintf(ccOut,"\">%s</A>/", ss0);
                }
                *ss = ch;
                ss0 = ss+1;
                sn--;
        }
        fprintf(ccOut,"%s",ss0);
        fprintf(ccOut,"</B>");
        fprintf(ccOut," &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(%s) ",
                        ctime(&s_fileTab.tab[fn]->lastModif));
        fprintf(ccOut,"</center>");
        fprintf(ccOut,"<hr>\n");
        fprintf(ccOut,"<pre>\n");
}
static void htmlGenTail() {
  int i;
  for(i=0;i<40;i++) fprintf(ccOut,"\n");
        fprintf(ccOut,"</pre>\n");
        fprintf(ccOut,"<hr>\n");
        htmlGenLogo();
        fprintf(ccOut,"</BODY></HTML>\n");
}
static void htmlGenAlphaHashLink( FILE *ff, int fi, int i, char *cc) {
  if (i == fi) {
        fprintf(ff, "%s ",cc);
  } else {
        fprintf(ff,"<A HREF=\"X%04d.html%s\" target=\"packageFrame\">%s</A> ",
                        i, s_opt.htmlLinkSuffix,cc);
  }
}
static void htmlGenRefListFileHeadAlphaRefs(FILE *ff, int fi) {
  int i, thisletter, thisindex, ll;
  char tt[10];
  if (s_opt.xfileHashingMethod==1) {
        ll = fi + 'A';
        if (ll>'Z') ll='+';
        fprintf(ff,"<center><h3>%c</h3>", ll);
        fprintf(ff,"<pre>\n");
        for(i=0; i<='Z'-'A'; i++) {
          if (i== 13) fprintf(ff,"\n");
          sprintf(tt,"%c",i+'A');
          htmlGenAlphaHashLink( ff, fi, i, tt);
        }
        htmlGenAlphaHashLink( ff, fi, i, "+");
        fprintf(ff,"\n");
        fprintf(ff,"</pre></center>\n");
  } else if (s_opt.xfileHashingMethod==2) {
        thisindex = fi / ('z'-'a'+2);
        thisletter = thisindex+'A';
        if (thisletter > 'Z') thisletter = '+';
        ll = fi%('z'-'a'+2) + 'A';
        if (ll>'Z') ll='+';
        fprintf(ff,"<center><h3>%c%c</h3>", thisletter, ll);
        fprintf(ff,"<pre>\n");
        for(i=0; i<='Z'-'A'; i++) {
          if (i== 13) fprintf(ff,"\n");
          sprintf(tt,"%c",i+'A');
          htmlGenAlphaHashLink( ff, fi, i*('z'-'a'+2), tt);
        }
        htmlGenAlphaHashLink( ff, fi, i*('z'-'a'+2), "+");
        fprintf(ff,"\n\n");
        for(i=0; i<='Z'-'A'; i++) {
          if (i== 13) fprintf(ff,"\n");
          sprintf(tt,"%c%c", thisletter, i+'A');
          htmlGenAlphaHashLink( ff, fi, thisindex*('z'-'a'+2)+i, tt);
        }
        sprintf(tt,"%c+", thisletter);
        htmlGenAlphaHashLink( ff, fi, thisindex*('z'-'a'+2)+i, tt);
        fprintf(ff,"\n");
        fprintf(ff,"</pre></center>\n");
  }
}
static void htmlGenRefListFileHead(FILE *ff, int fi) {
        fprintf(ff,"<HTML><HEAD><TITLE>Reflist</TITLE></HEAD>\n");
        fprintf(ff,"<base target=\"classFrame\">\n");
        fprintf(ff,"<body topmargin=\"0\" leftmargin=\"0\"");
        fprintf(ff,"bgcolor=\"#FFFFFF\"\n");
        fprintf(ff,"link=\"navy\" vlink=\"navy\" alink=\"red\">\n");
        if (fi < 0) {
                fprintf(ff,"<center><H3>Local&nbsp;Cross&nbsp;References</H3></center>\n");
        } else {
                fprintf(ff,"<center><H3>Cross&nbsp;References</H3></center>\n");
                if (s_opt.xfileHashingMethod==0) {
                  fprintf(ff,"<pre>\n");
                  if (fi>0) {
                        fprintf(ff,"<A HREF=\"X%04d.html%s\" target=\"packageFrame\">prev</A>",fi-1, s_opt.htmlLinkSuffix);
                  } else {
                        fprintf(ff,"    ",fi-1);
                  }
                  fprintf(ff," X%04d ",fi);
                  if (fi<s_opt.refnum-1) {
                        fprintf(ff,"<A HREF=\"X%04d.html%s\" target=\"packageFrame\">next</A>",fi+1, s_opt.htmlLinkSuffix);
                        fprintf(ff,"</pre>\n");
                  }
                } else {
                  htmlGenRefListFileHeadAlphaRefs(ff, fi);
                }
        }
}
static void htmlSymbolCxTableBeg(FILE *ff) {
        fprintf(ff, "<table border=1 cellpadding=\"7\" cellspacing=\"0\" width=\"400\">\n");
}
static void htmlVirtualTableSymName(FILE *ff,S_olSymbolsMenu *rrr,char *color){
        char ln[MAX_HTML_REF_LEN];
        fprintf(ff, "<tr><td bgcolor=\"%s\">\n", color);
        fprintf(ff, "<font FACE=\"arial,helvetica\">\n");
        if ((rrr->s.b.accessFlags&0x008) && rrr->s.b.storage!=StorageField){
                fprintf(ff, "static ");
        }
        linkNamePrettyPrint(ln, rrr->s.name, MAX_HTML_REF_LEN,SHORT_NAME);
        fprintf(ff, "<B>%s</B>\n", ln);
        fprintf(ff, "</font></td></tr>\n");
}
static void htmlSymbolCxTableEnd(FILE *ff) {
        fprintf(ff, "</table>");
}
static void htmlGenSmallTabHead( FILE *ff, char *color, int genFlag) {
        if (genFlag!=SINGLE_VIRT_ITEM) {
                fprintf(ff,"<tr><td bgcolor=\"%s\">", color);
                fprintf(ff,"<font FACE=\"arial,helvetica\">\n");
        }
}
static void htmlGenSmallTabTail( FILE *ff, int genFlag ) {
        if (genFlag!=SINGLE_VIRT_ITEM) {
                fprintf(ff,"</font></td></tr>\n");
        }
}
static void htmlGenRefListItemHead(FILE *ff, char *ln, char *symName,
                                                                   S_symbolRefItem *p, int usage, int genFlag){
        char ttt[TMP_STRING_SIZE];
        char *s,*sn,*snn,*d,*ld,*apc;
        int i,len;
        sn = symName;
        if (p!=NULL && p->b.symType==TypeCppInclude) {
                htmlGenSmallTabHead( ff, "#c0d0ff", genFlag);
                fprintf(ff,"<A NAME=\"%s\"></A>",ln);
                sn = s_fileTab.tab[p->vApplClass]->name;
                sn = simpleFileName(getRealFileNameStatic(sn));
                fprintf(ff,"(#include)&nbsp;<B>%s</B>",sn);
                htmlGenSmallTabTail( ff, genFlag);
        } else if (p!=NULL && p->b.symType==TypeCppCollate) {
                htmlGenSmallTabHead( ff, "#c0d0ff", genFlag);
                fprintf(ff,"<A NAME=\"%s\"></A>",ln);
                fprintf(ff,"(##)&nbsp;<B>%s</B>",sn);
                htmlGenSmallTabTail( ff, genFlag);
        } else if (p!=NULL &&
                           (p->b.storage==StorageField
                                || p->b.storage==StorageMethod
                                || p->b.storage==StorageConstructor)) {
                { if (!(genFlag==SINGLE_VIRT_ITEM || genFlag==VIRT_ITEM)) internalCheckFail("genFlag==SINGLE_VIRT_ITEM || genFlag==VIRT_ITEM", "html.c", 406);};
                apc = javaGetNudePreTypeName_st(getRealFileNameStatic(
                        s_fileTab.tab[p->vFunClass]->name), NO_OUTERS_CUT);
                if (genFlag == SINGLE_VIRT_ITEM) {
                        fprintf(ff,"<A NAME=\"%s\"></A>",ln);
                } else {
                        htmlGenSmallTabHead( ff, "#c0d0ff", genFlag);
                        fprintf(ff,"<A NAME=\"%s.rf\"></A>",ln);
                        fprintf(ff,"<B>%s</B>&nbsp;of&nbsp;%s", sn, apc);
                        if (p->b.storage!=StorageField
                                && (p->b.accessFlags&0x008)==0) {
                                apc = javaGetNudePreTypeName_st(getRealFileNameStatic(
                                        s_fileTab.tab[p->vApplClass]->name), NO_OUTERS_CUT);
                                fprintf(ff,"<br>at <B>%s</B>", apc);
                        }
                        htmlGenSmallTabTail( ff, genFlag);
                }
        } else if (p!=NULL) {
                htmlGenSmallTabHead( ff, "#c0d0ff", genFlag);
                fprintf(ff,"<A NAME=\"%s\"></A>",ln);
                if (p->b.symType==TypeStruct && ((s_language & (4)) != 0)) {
                        if (p->b.accessFlags & 0x200) {
                                fprintf(ff,"interface&nbsp;");
                        } else {
                                fprintf(ff,"class&nbsp;");
                        }
                } else if (p->b.symType==TypeDefault && p->b.storage==StorageTypedef) {
                        fprintf(ff,"typedef&nbsp;");
                } else if (p->b.symType!=TypeDefault) {
                        fprintf(ff,"%s&nbsp;", typesName[p->b.symType]);
                }
                ld = sn;
                while ((d=strchr(ld, '.'))!=NULL) ld = d+1;
                if (((s_language & (4)) != 0)) {
                        while ((d=strchr(ld, '$'))!=NULL) ld = d+1;
                }
                fprintf(ff,"<B>%s</B>",ld);
                htmlGenSmallTabTail(ff, genFlag);
                if (ld!=sn) {
                        htmlGenSmallTabHead(ff, "#ffffcc", genFlag);
                        for(s=sn; s<ld-1; s++) fputc(*s, ff);
                        htmlGenSmallTabTail( ff, genFlag);
                }
        } else {
                htmlGenSmallTabHead( ff, "#c0d0ff", genFlag);
                fprintf(ff,"<A NAME=\"%s\"></A>",ln);
                fprintf(ff,"<B>%s</B>",sn);
                htmlGenSmallTabTail( ff, genFlag);
        }
}
static void htmlGenRefListTail(FILE *ff) {
        int i;
        fprintf(ff,"\n");
        for(i=0; i<30; i++) fprintf(ff,"<br>");
        fprintf(ff,"\n</BODY></HTML>\n");
}
static char * getDefaultCxFileStatic() {
        static char ttt[MAX_FILE_NAME_SIZE];
        char tt[MAX_FILE_NAME_SIZE];
        char *ss;
        if (s_opt.refnum <= 1) {
                sprintf(tt,"%s.html", s_opt.cxrefFileName);
        } else {
                sprintf(tt,"%s%s%04d.html",
                                normalizeFileName(s_opt.cxrefFileName,s_cwd),
                                PRF_REF_PREFIX, 0);
        }
        ss = cutHtmlPath(tt);
        concatPathes(ttt,MAX_FILE_NAME_SIZE,
                                s_opt.htmlRoot,
                                cutHtmlPath(tt),
                                "");
        return(ttt);
}
static void htmlGenFrameFile(FILE *ff, int fnum, char *thisfn) {
        char *ssn;
        char ffn[MAX_FILE_NAME_SIZE];
        { if (!(s_fileTab.tab[fnum])) internalCheckFail("s_fileTab.tab[fnum]", "html.c", 490);};
        fprintf(ff,"<HTML><HEAD><TITLE>Xref-Html Frames</TITLE></HEAD>\n");
        fprintf(ff,"<frameset cols=\"20%,80%\">\n");
        fprintf(ff,"<frame src=\"%s%s\" name=\"packageFrame\">\n",
                        htmlGetLinkFileNameStatic(getDefaultCxFileStatic(),thisfn),
                        s_opt.htmlLinkSuffix);
        concatPathes(ffn,MAX_FILE_NAME_SIZE,
                                s_opt.htmlRoot,
                                cutHtmlPath(getRealFileNameStatic(s_fileTab.tab[fnum]->name)),
                                "");
        fprintf(ff,"<frame src=\"%s.html%s\" name=\"classFrame\">\n",
                        htmlCutLastSuffixStatic(htmlGetLinkFileNameStatic(ffn,thisfn)),
                        s_opt.htmlLinkSuffix);
        fprintf(ff,"</frameset>\n");
        fprintf(ff,"</html>");
}
void htmlGetDefinitionReferences() {
        char *tt;
        scanReferenceFiles(s_opt.cxrefFileName,s_cxFullScanFunTab);
        {{ { if (!((cxMemory.chunkSize) >= 0)) internalCheckFail("(cxMemory.chunkSize) >= 0", "html.c", 517);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(cxMemory.chunkSize)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(cxMemory.chunkSize)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } s_cxGlobalReferencesBase = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (cxMemory.chunkSize)*sizeof(char);};};
        {{ { if (!((cxMemory.chunkSize) >= 0)) internalCheckFail("(cxMemory.chunkSize) >= 0", "html.c", 518);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(cxMemory.chunkSize)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(cxMemory.chunkSize)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } tt = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (cxMemory.chunkSize)*sizeof(char);};};
        {{ { if (!((s_cxGlobalReferencesBase)>=cxMemory.b && (s_cxGlobalReferencesBase)<= cxMemory.b+cxMemory.i)) internalCheckFail("(s_cxGlobalReferencesBase)>=cxMemory.b && (s_cxGlobalReferencesBase)<= cxMemory.b+cxMemory.i", "html.c", 519);}; cxMemory.i = ((char*)(s_cxGlobalReferencesBase))-cxMemory.b;};};
}
static int htmlRefListOrdering(S_reference *r1, S_reference *r2) {
        char *sss1,*sss2;
        int fc;
        if (r1->p.file < r2->p.file) return(1);
        if (r1->p.file > r2->p.file) return(0);
        if (r1->p.line < r2->p.line) return(1);
        if (r1->p.line > r2->p.line) return(0);
        if (r1->p.coll < r2->p.coll) return(1);
        if (r1->p.coll > r2->p.coll) return(0);
        if (r1->usage < r2->usage) return(1);
        if (r1->usage > r2->usage) return(0);
        return(0);
}
void htmlPutChar(FILE *ff, int c) {
        static int collumn=0;
        int n;
        collumn++;
        switch (c) {
        case 1:
                n = 6 -(collumn-1)%6 -1;
                collumn += n;
                if (collumn >= s_opt.htmlCxLineLen) {
                        fprintf(ff,"\n%*s",6,"");
                        collumn= 6;
                } else {
                        fprintf(ff,"%*s",n+1,"");
                }
                break;
        case '<':
                fprintf(ff,"&lt;");
                break;
        case '>':
                fprintf(ff,"&gt;");
                break;
        case '&':
                fprintf(ff,"&amp;");
                break;
        case 015:
                fputc(' ', ff);
                break;
        case '\n':
                fputc('\n',ff);
                collumn=0;
                break;
        case '\t':
                n = s_opt.tabulator-(collumn-1)%s_opt.tabulator-1;
                collumn += n;
                fprintf(ff,"%*s",n+1,"");
                break;
        default:
                fputc(c,ff);
        }
}
void htmlPrint(FILE *ff, char *ss) {
        char *s;
        for(s=ss; *s; s++) htmlPutChar(ff,*s);
}
static void htmlPutCharLF(FILE *ff, int c, S_position *cp) {
        htmlPutChar(ff,c);
        if (c=='\n') {
                fprintf(ff,"<A NAME=\"%s%d\"></A>",s_opt.htmlLineNumLabel, cp->line+1);
                if (s_opt.htmlLineNums) {
                        if (s_opt.htmlLineNumColor!=NULL) {
                                fprintf(ff,"<font color=\"%s\">", s_opt.htmlLineNumColor);
                        }
                        fprintf(ff,"%4d: ",cp->line+1);
                        if (s_opt.htmlLineNumColor!=NULL) {
                                fprintf(ff,"</font>");
                        }
                }
        }
}
static int htmlPositionLess(S_position *p1, S_position *p2) {
        return( p1->line < p2->line
                        || (p1->line == p2->line && p1->coll < p2->coll)
                );
}
void recursivelyCreateFileDirIfNotExists(char *fpath) {
        char *p;
        int ch,len,loopFlag;
        S_stat st;
        len = strlen(fpath);
        loopFlag = 1;
        for (p=fpath+len; p>fpath && loopFlag; p--) {
                if (*p!=SLASH) continue;
                ch = *p; *p = 0;
                if (stat(fpath, &st)==0 && (st.st_mode & S_IFMT) == S_IFDIR) {
                         loopFlag=0;
                }
                *p = ch;
        }
        for(p+=2; *p; p++) {
                if (*p!=SLASH) continue;
                ch = *p; *p = 0;
                createDir(fpath);
                *p = ch;
        }
}
void concatPathes(char *res, int rsize, char *p1, char *p2, char *p3) {
        int i,j;
        if (p1==NULL) p1="";
        if (p2==NULL) p2="";
        if (p3==NULL) p3="";
        sprintf(res,"%s%s%s",p1,htmlNormalizedPath(p2),htmlNormalizedPath(p3));
        { if (!(strlen(res)<rsize-1)) internalCheckFail("strlen(res)<rsize-1", "html.c", 667);};
}
static S_reference * htmlGetDefinitionRef(S_htmlRefList *rrr, int usage) {
        S_symbolRefItem *rr,*cr;
        register S_reference *r,*res;
        { if (!(rrr && rrr->s && rrr->s->refs)) internalCheckFail("rrr && rrr->s && rrr->s->refs", "html.c", 673);};
        rr = rrr->s;
        res = NULL;
        if (rr->vApplClass == s_noneFileIndex) {
                for(r=rr->refs; r!=NULL; r=r->next) {
                        if (r->usage==usage) {
                                if (res==NULL || res<r ) res=r;
                        }
                }
        } else {
                for(cr=rrr->slist; cr!=NULL; cr=cr->next) {
                        if (itIsSameCxSymbol(cr,rr)) {
                                for(r=cr->refs; r!=NULL; r=r->next) {
                                        if ( (r->usage==UsageDefined || r->usage==UsageDeclared)
                                                && cr->vFunClass==rr->vFunClass) {
                                                res = r;
                                                goto fini;
                                        }
                                }
                        }
                        nextsym:;
                }
        }
fini:
        return(res);
}
static char *htmlStSymbolCode(S_symbolRefItem *r, int usage) {
        static char ss[MAX_CX_SYMBOL_SIZE];
        char ttt[MAX_CX_SYMBOL_SIZE];
        char *sss, *tt;
        if (r->b.category==CatLocal) {
                sprintf(ss,"local.%x",r);
        } else {
                if (r->vApplClass == s_noneFileIndex) {
                        sprintf(ss,"%s.%s", typesName[r->b.symType], r->name);
                } else {
                        if (r->b.storage == StorageField) {
                                strcpy(ttt, s_fileTab.tab[r->vFunClass]->name);
                        } else {
                                strcpy(ttt, s_fileTab.tab[r->vApplClass]->name);
                        }
                        tt = strchr(ttt, '.');
                        if (tt!=NULL) *tt = 0;
                        tt = ttt;
                        if (*tt == ';') tt++;
                        if (r->b.symType == TypeDefault) {
                                sprintf(ss,"%s.%s", tt, r->name);
                        } else {
                                sprintf(ss,"%s.%s.%s", typesName[r->b.symType], tt, r->name);
                        }
                }
                for(sss=ss; *sss; sss++) {
                        if (*sss=='/' || *sss=='\\') *sss = '.';
                }
        }
        { if (!(strlen(ss) < MAX_CX_SYMBOL_SIZE-2)) internalCheckFail("strlen(ss) < MAX_CX_SYMBOL_SIZE-2", "html.c", 739);};
        return(ss);
}
static void htmlCrGlobalXrefsFileName(S_symbolRefItem *cri, int usage,
                                                                char *fout, char *lout) {
        char *s;
        if (s_opt.refnum > 1) {
                sprintf(fout,"%s%s%04d", normalizeFileName(s_opt.cxrefFileName,s_cwd),
                                                PRF_REF_PREFIX, cxFileHashNumber(cri->name));
        } else {
                sprintf(fout,"%s", normalizeFileName(s_opt.cxrefFileName,s_cwd));
        }
        { if (!(strlen(fout) + 10 < MAX_HTML_REF_LEN)) internalCheckFail("strlen(fout) + 10 < MAX_HTML_REF_LEN", "html.c", 752);};
        strcpy(lout, htmlStSymbolCode(cri,usage));
        { if (!(strlen(lout) + 10 < MAX_HTML_REF_LEN)) internalCheckFail("strlen(lout) + 10 < MAX_HTML_REF_LEN", "html.c", 754);};
        for(s=lout; *s; s++) if (*s=='/' || *s=='\\' || *s=='#') *s='.';
}
static void htmlCrLocalRefsFileName(int fnum, S_symbolRefItem *cri,
                                                                        int usage, char *fout, char *lout) {
        char *ss,*s;
        strcpy(fout, htmlAuxFileNameStatic(fnum, "XLL", "", ""));
        { if (!(strlen(fout) + 10 < MAX_HTML_REF_LEN)) internalCheckFail("strlen(fout) + 10 < MAX_HTML_REF_LEN", "html.c", 762);};
        strcpy(lout, htmlStSymbolCode(cri,usage));
        { if (!(strlen(lout) + 10 < MAX_HTML_REF_LEN)) internalCheckFail("strlen(lout) + 10 < MAX_HTML_REF_LEN", "html.c", 764);};
        for(s=lout; *s; s++) if (*s=='/' || *s=='\\') *s='.';
}
static int htmlJdkDocAvailable(S_symbolRefItem *rr){
        char *lfn, *url;
        url = getJavaDocUrl_st(rr);
        lfn = getLocalJavaDocFile_st(url);
        if (lfn==NULL && ! htmlJdkDocAvailableForUrl(url)) return(0);
        return(1);
}
static void htmlPrintExternHtmlJavaDocReference(char *prf,S_symbolRefItem *rr){
        int off;
        struct stat st;
        char *ss;
        sprintf(prf, "<A HREF=\"%s\">", getFullUrlOfJavaDoc_st(getJavaDocUrl_st(rr)));
}
static void htmlGetStaticHREFItems(
                                                        S_htmlRefList *ref,
                                                        S_position *cp,
                                                        char **prefix1,
                                                        char **suffix1,
                                                        char **prefix,
                                                        char **suffix
                                                        ) {
        static char prf[MAX_HTML_REF_LEN];
        static char prf1[MAX_HTML_REF_LEN];
        char tmp[MAX_HTML_REF_LEN];
        char tmp2[MAX_HTML_REF_LEN];
        S_reference *dr;
        char *df;
        char *thisfn;
        int usage,emph;
        S_symbolRefItem *cri;
        S_reference *rr;
        cri = ref->s;
        rr = ref->r;
        usage = UsageUsed;
        *prefix = prf;
        *suffix = "</A>";
        *prefix1 = prf1;
        *suffix1 = "</A>";
        emph = 0;
        thisfn = s_fileTab.tab[cp->file]->name;
        if (usage==UsageDeclared) {
                dr = htmlGetDefinitionRef(ref, UsageDefined);
                if (dr!=NULL) {
                        df = s_fileTab.tab[dr->p.file]->name;
                        df = htmlGetLinkFileNameStatic(df,thisfn);
                        df = htmlCutLastSuffixStatic(df);
                        sprintf(prf,"<A HREF=\"%s.html%s#%s%d\">",df,s_opt.htmlLinkSuffix,
                                        s_opt.htmlLineNumLabel, dr->p.line);
                } else {
                        sprintf(prf,"<EM>");
                        *suffix = "</EM>";
                        emph = 1;
                }
        } else if (usage==UsageDefined) {
                sprintf(prf,"<EM>");
                *suffix = "</EM>";
                emph = 1;
        } else {
                dr=htmlGetDefinitionRef(ref, UsageDefined);
                if (dr==NULL) dr=htmlGetDefinitionRef(ref, UsageDeclared);
                if (dr!=NULL) {
                        df = s_fileTab.tab[dr->p.file]->name;
                        df = htmlGetLinkFileNameStatic(df,thisfn);
                        df = htmlCutLastSuffixStatic(df);
                        sprintf(prf,"<A HREF=\"%s.html%s#%s%d\">",df,s_opt.htmlLinkSuffix,
                                        s_opt.htmlLineNumLabel, dr->p.line);
                } else if (( ((s_language & (4)) != 0) && s_opt.htmlGenJdkDocLinks && (s_opt.htmlJdkDocUrl!=NULL || s_opt.javaDocPath!=NULL) && htmlJdkDocAvailable(ref->s) )) {
                        htmlPrintExternHtmlJavaDocReference(prf, ref->s);
                } else {
                        sprintf(prf,"<A>");
                }
        }
        { if (!(strlen(prf)<MAX_HTML_REF_LEN-2)) internalCheckFail("strlen(prf)<MAX_HTML_REF_LEN-2", "html.c", 865);};
        if (cri->b.category == CatLocal) {
                htmlCrLocalRefsFileName(cp->file, cri, usage, tmp, tmp2);
        } else {
                htmlCrGlobalXrefsFileName(cri, usage, tmp, tmp2);
        }
        df = htmlGetLinkFileNameStatic(tmp,thisfn);
        if (emph) {
                sprintf(prf1,"<EM><A HREF=\"%s.html%s#%s\" target=\"packageFrame\">",
                                df, s_opt.htmlLinkSuffix, tmp2);
                *suffix1 = "</A></EM>";
        } else {
                sprintf(prf1,"<A HREF=\"%s.html%s#%s\" target=\"packageFrame\">",
                                df, s_opt.htmlLinkSuffix, tmp2);
        }
}
static int htmlNotYetInList(S_htmlRefList *place, S_htmlRefList *ref) {
        while (place!=NULL && ! ( ((place)->r->p.file != (*ref).r->p.file) || ((place)->r->p.line != (*ref).r->p.line) || ((place)->r->p.coll != (*ref).r->p.coll) )) {
                if ( place->s->b.symType == ref->s->b.symType
                        && strcmp(place->s->name,ref->s->name)==0
                        && place->s->b.category == ref->s->b.category) return(0);
                place = place->next;
        }
        return(1);
}
static void htmlGenListLink(FILE *off,char *lname,char *lfile,int line,
                                        char *ofname, int usage) {
        char ttt[TMP_STRING_SIZE];
        char *ln;
        ln = htmlGetLinkFileNameStatic(lfile, ofname);
        ln = htmlCutLastSuffixStatic(ln);
        htmlPutChar(off, 1);
        htmlPutChar(off, refCharCode(usage));
        fprintf(off,"<A HREF=\"%s.html%s#%s%d\">", ln,
                        s_opt.htmlLinkSuffix, s_opt.htmlLineNumLabel, line);
        sprintf(ttt,"%d", line);
        htmlPrint(off,ttt);
        fprintf(off,"</A>");
}
static int genRefListFileBody(FILE *ff, char *fname,
                                                          S_symbolRefItem *p, int usages, int option){
        S_reference *r,*oldr;
        char *rfn;
        char *ln;
        int genflag,filen,linen,usage,count,groupedCount,lastFilen;
        count = 0;
        lastFilen = s_noneFileIndex;
        oldr = NULL;
        r = p->refs;
        while (r!=NULL) {
                { if (!(r != oldr)) internalCheckFail("r != oldr", "html.c", 918);};
                genflag = 0; filen=r->p.file; linen=r->p.line; usage=r->usage;
                groupedCount = 0;
                while (r!=NULL && ((filen==r->p.file && linen==r->p.line)
                                                   || (r->usage>UsageMaxOLUsages))) {
                        if (r->usage<UsageMaxOLUsages
                                && (usages==USAGE_ANY || r->usage==usages)) {
                                genflag=1; groupedCount ++;
                                if (usage>r->usage) usage=r->usage;
                        }
                        r=r->next;
                }
                if (genflag) {
                        if (option != COUNT_ONLY) {
                                ln = s_fileTab.tab[filen]->name;
                                if (lastFilen != filen) {
                                        htmlPutChar(ff,'\n');
                                        sprintf(tmpBuff,"%s",
                                                        simpleFileName(getRealFileNameStatic(ln)));
                                        htmlPrint(ff,tmpBuff);
                                        htmlPutChar(ff,':');
                                        lastFilen = filen;
                                }
                                htmlGenListLink(ff,"",ln,linen,fname,usage);
                                if (groupedCount>1) {
                                        sprintf(tmpBuff,"+");
                                        htmlPrint(ff,tmpBuff);
                                }
                        }
                        count++;
                }
        }
        return(count);
}
static void htmlGenLocalRefList2(FILE *ff, char *fname, S_symbolRefItem *p,
                                                                int fnum, int usage){
        static char fn2[MAX_HTML_REF_LEN];
        static char fn3[MAX_HTML_REF_LEN];
        char *cut;
        htmlCrLocalRefsFileName(fnum,p,usage, fn2, fn3);
        cut = strchr(p->name, '!');
        if (cut==NULL) cut = p->name;
        else cut ++;
        fprintf(ff,"\n<br>");
        htmlSymbolCxTableBeg(ff);
        htmlGenRefListItemHead(ff, fn3, cut, NULL, USAGE_ANY, DEFAULT_VALUE);
        fprintf(ff,"<tr><td><pre>\n");
        genRefListFileBody(ff, fn2, p, USAGE_ANY,DEFAULT_VALUE);
        fprintf(ff,"</pre></td></tr>");
        htmlSymbolCxTableEnd(ff);
}
static int htmlContainFileReference(S_symbolRefItem *p, int fnum) {
        S_reference *r;
        if (p==NULL) return(0);
        for(r=p->refs; r!=NULL; r=r->next) {
                if (r->p.file == fnum) return(1);
        }
        return(0);
}
static void htmlGenLocalRefList(FILE *ff, char *fname,
                                                                S_symbolRefItem *p, int fnum) {
        if (p->b.category != CatLocal) return;
        if (p->b.htmlWasLn == 0) return;
        if (((s_language & (8)) != 0) && p->name[0] == '$') return;
        if (! htmlContainFileReference(p, fnum)) return;
        htmlGenLocalRefList2(ff, fname, p, fnum, UsageUsed);
}
static void htmlGenLocalRefLists(S_symbolRefItem *p, void *ss) {
        S_htmlLocalListms *s;
        s = (S_htmlLocalListms *)ss;
        if (p->b.category==CatLocal && p->b.htmlWasLn) {
                htmlGenLocalRefList(s->ff, s->fname, p, s->fnum);
        }
}
static void htmlGetThisFileReferences(int fnum, S_htmlRefList **rrr, int kind){
        S_symbolRefItem *d,*dd;
        S_reference *rr;
        S_htmlRefList **place,*r,rref,**rrr0;
        int i;
        *rrr = NULL;
        for(i=0; i<s_cxrefTab.size; i++) {
                dd = s_cxrefTab.tab[i];
                for(d=dd; d!=NULL; d=d->next) {
                        rrr0 = rrr;
                        for(rr=d->refs; rr!=NULL; rr=rr->next) {
                                if (rr->p.file == fnum &&
                                        (kind==ALL_REFS || rr->usage<UsageMaxOLUsages)) {
                                        { (&rref)->s = d; (&rref)->r = rr; (&rref)->slist = dd; (&rref)->next = NULL;};
                                        { register S_htmlRefList *tmp,**lStMp; tmp = *(rrr0); lStMp = rrr0; while (tmp!=NULL && (htmlRefListOrdering((tmp)->r, ((rref)).r))) { lStMp = &(tmp->next); tmp = *lStMp; } place = lStMp; };
                                        if (*place==NULL
                                                || ( ((*place)->r->p.file != (rref).r->p.file) || ((*place)->r->p.line != (rref).r->p.line) || ((*place)->r->p.coll != (rref).r->p.coll) )
                                                || htmlNotYetInList(*place,&rref)) {
                                                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "html.c", 1022);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_htmlRefList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } r = (S_htmlRefList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_htmlRefList);};};};
                                                *r = rref;
                                                {(r)->next = ((*place)); (*place) = r;};
                                        }
                                        rrr0 = place;
                                }
                        }
                }
        }
}
static int htmlGenGlobRefListBody(FILE *ff, S_symbolRefItem *pp,
                                                                   char *fname, int usage, int opt) {
        S_reference *r;
        S_symbolRefItem *p;
        int detail, count;
        count = 0; detail=0;
        count += genRefListFileBody(ff, fname, pp, USAGE_ANY, opt);
        return(count);
}
static void htmlGenGlobRefList(FILE *ff, char *fname,
                                                                S_symbolRefItem *p, int usage,
                                                           int genFlag) {
        static char sn[MAX_HTML_REF_LEN];
        static char ln[MAX_HTML_REF_LEN];
        char lab[MAX_HTML_REF_LEN];
        char *deffn, *cut;
        int i, count, llen;
        if (p->refs == NULL) return;
        htmlCrGlobalXrefsFileName(p, usage, sn, lab);
        linkNamePrettyPrint( ln, p->name,MAX_HTML_REF_LEN,SHORT_NAME);
        count = htmlGenGlobRefListBody(ff, p, sn, usage, COUNT_ONLY);
        if (count != 0) {
          htmlGenRefListItemHead(ff, lab, ln, p, usage, genFlag);
          fprintf(ff,"<tr><td><pre>\n");
          { S_reference *_macrores; _macrores = (p->refs); { S_reference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (olcxListLessFunction(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (p->refs) = _macrores;};
          htmlGenGlobRefListBody(ff, p, sn, usage, DEFAULT_VALUE);
          fprintf(ff,"</pre></td></tr>");
        }
}
static int chUpperAdequate(S_fileItem *s, S_fileItem *origin) {
        return(origin->b.isInterface == s->b.isInterface);
}
int htmlRefItemsOrderLess(S_olSymbolsMenu *ss1, S_olSymbolsMenu *ss2) {
        S_symbolRefItem *s1, *s2;
        int r,len1,len2;
        char *n1, *n2;
        s1 = &ss1->s; s2 = &ss2->s;
        { int c; char *ss; ss = n1 = s1->name; while ((c= *ss)) { if (c == '(') break; if (c == '.') n1 = ss+1; if (c == '/') n1 = ss+1; if (c == '#') n1 = ss+1; if (c == '!') n1 = ss+1; ss++ ; } len1 = ss - n1;};
        { int c; char *ss; ss = n2 = s2->name; while ((c= *ss)) { if (c == '(') break; if (c == '.') n2 = ss+1; if (c == '/') n2 = ss+1; if (c == '#') n2 = ss+1; if (c == '!') n2 = ss+1; ss++ ; } len2 = ss - n2;};
        r = strcmp(n1, n2);
        if (r!=0) return(r<0);
        r = strcmp(s1->name, s2->name);
        if (r!=0) return(r<0);
        r = classHierarchyClassNameLess(ss1->s.vApplClass,ss2->s.vApplClass);
        return(r);
}
static void shiftToTheBeginningOfClassList(S_fileItem *fi,S_chReference **orr){
        S_chReference *rr;
        { if (!(orr!=NULL)) internalCheckFail("orr!=NULL", "html.c", 1113);};
        for(rr= *orr; rr!=NULL && s_fileTab.tab[rr->clas]!=fi; rr=rr->next) ;
        if (rr==NULL) return;
}
int isThereSomethingPrintable(S_olSymbolsMenu *itt) {
        S_reference *r;
        for(r=itt->s.refs; r!=NULL; r=r->next) {
                if (r->usage<UsageMaxOLUsages) return(1);
        }
        return(0);
}
static int htmlIsThereSomethingPrintable(S_olSymbolsMenu *itt) {
        S_reference *r;
        if (((s_language & (4)) != 0) && itt->s.b.symType==TypeCppInclude) return(0);
        for(r=itt->s.refs; r!=NULL; r=r->next) {
                if (r->usage==UsageClassTreeDefinition) return(1);
                if (r->usage<UsageMaxOLUsages) return(1);
        }
        return(0);
}
void genClassHierarchyItemLinks( FILE *ff, S_olSymbolsMenu *itt,
                                                                                int virtFlag) {
        char thisFileName[MAX_HTML_REF_LEN];
        char ttt[MAX_HTML_REF_LEN];
        char tmp[MAX_HTML_REF_LEN];
        char tmp2[MAX_HTML_REF_LEN];
        S_symbolRefItem *rr;
        S_position *dr;
        char *ln,*jdoc, *df, *ccc;
        { if (!(itt)) internalCheckFail("itt", "html.c", 1145);};
        rr = &itt->s;
        dr = NULL;
        htmlCrGlobalXrefsFileName(rr, UsageUsed, thisFileName, tmp2);
        if (isThereSomethingPrintable(itt)) {
                if (virtFlag!=SINGLE_VIRT_ITEM) {
                        fprintf(ff,"<A NAME=\"%s\"></A>",tmp2);
                        fprintf(ff,"<A HREF=\"#%s.rf\" target=\"packageFrame\">x</A> ",
                                        tmp2);
                } else {
                        fprintf(ff,"  ");
                }
        } else {
                fprintf(ff,"  ");
        }
        if (itt!=NULL && itt->defpos.file != s_noneFileIndex) {
                dr = & itt->defpos;
        }
        if (dr!=NULL && rr->vApplClass==rr->vFunClass) {
                df = s_fileTab.tab[dr->file]->name;
                df = htmlGetLinkFileNameStatic(df, thisFileName);
                df = htmlCutLastSuffixStatic(df);
                fprintf(ff,"<A HREF=\"%s.html%s#%s%d\">s</A> ",df,
                                s_opt.htmlLinkSuffix, s_opt.htmlLineNumLabel, dr->line);
        } else {
                fprintf(ff, "  ");
        }
}
void htmlGenNonVirtualGlobSymList( FILE *ff, char *fn, S_symbolRefItem *p ) {
        fprintf(ff,"<br><br><br>");
        htmlSymbolCxTableBeg(ff);
        htmlGenGlobRefList(ff, fn, p, UsageDefined,
                                           DEFAULT_VALUE);
        htmlSymbolCxTableEnd(ff);
}
static void genVirtualsGlobRefLists2( S_olSymbolsMenu *rrr, FILE *ff,
                                                                          char *fn, int genFlag ){
        S_olSymbolsMenu *ss;
        S_symbolRefItem *p;
        int loop, cmin, minline;
        loop = 1; minline = 0; p=NULL;
        while (loop) {
                loop = 0;
                cmin = ((int) (((unsigned) -2)>>1));
                for(ss=rrr; ss!=NULL; ss=ss->next) {
                        if (ss->outOnLine>=minline && ss->outOnLine<cmin) {
                                cmin = ss->outOnLine;
                                p = &ss->s;
                        }
                }
                if (cmin != ((int) (((unsigned) -2)>>1))) {
                        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "html.c", 1212);};
                        htmlGenGlobRefList(ff, fn, p, UsageDefined, genFlag);
                        loop = 1;
                        minline = cmin+1;
                        p = NULL;
                }
        }
}
static void htmlMarkVisibleAllClassesHavingReferences(S_olSymbolsMenu *rrr) {
        S_olSymbolsMenu *ss;
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                if (htmlIsThereSomethingPrintable(ss)) {
                        ss->visible = ss->selected = 1;
                }
        }
}
static void htmlJoinAllStaticLinkedRefs(S_olSymbolsMenu *rrr) {
        S_olSymbolsMenu *rr, *ss;
        int cFunCl;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                cFunCl = rr->s.vFunClass;
                if (cFunCl==rr->s.vApplClass && cFunCl!=s_noneFileIndex) {
                        for(ss=rrr; ss!=NULL; ss=ss->next) {
                                if (ss->s.vFunClass == cFunCl && ss!=rr) {
                                        { if ((rr->s.refs)==NULL) rr->s.refs = ss->s.refs; else { register S_reference *tempnsl; tempnsl = rr->s.refs; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = ss->s.refs; } };
                                        ss->s.refs = NULL;
                                        ss->selected = 0;
                                }
                        }
                }
        }
}
void htmlGenGlobRefsForVirtMethod(FILE *ff, char *fn, S_olSymbolsMenu *rrr) {
        int vcount, virtFlag;
        S_olSymbolsMenu *rr;
        if (( (rrr->s.b.storage==StorageField || ((rrr->s.b.storage==StorageMethod || rrr->s.b.storage==StorageConstructor) && (rrr->s.b.accessFlags & 0x008))))) {
                htmlJoinAllStaticLinkedRefs(rrr);
        }
        vcount = 0;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                if (rr->selected) vcount++;
        }
        if (vcount==1) virtFlag = SINGLE_VIRT_ITEM;
        else virtFlag = VIRT_ITEM;
        fprintf(ff,"<br><br><br>");
        htmlSymbolCxTableBeg(ff);
        htmlVirtualTableSymName(ff, rrr, "#c0d0ff");
        fprintf(ff, "<tr><td bgcolor=\"%s\">\n", "#ffffcc");
        fprintf(ff, "<pre>\n");
        classHierarchyGenInit();
        htmlGenClassHierarchies( ff, rrr, virtFlag, FIRST_PASS);
        htmlGenClassHierarchies( ff, rrr, virtFlag, SECOND_PASS);
        fprintf(ff,"</pre></tr>");
        genVirtualsGlobRefLists2( rrr, ff, fn, virtFlag);
        htmlSymbolCxTableEnd(ff);
}
static void htmlGetReferencesMetrics( S_symbolRefItem *p,
                                                                          int *refn,
                                                                          int *defRefn,
                                                                          int *defusage,
                                                                          S_position *defpos
        ) {
        S_reference *r;
        int rn, drn;
        rn = drn = 0;
        *defpos = s_noPos;
        for (r=p->refs; r!=NULL; r=r->next) {
                if (r->usage == UsageDefined) {
                        *defusage = r->usage;
                        *defpos = r->p;
                        drn ++;
                } else if (r->usage == UsageDeclared) {
                        drn++;
                } else if (r->usage == UsageClassTreeDefinition) {
                        *defusage = r->usage;
                        *defpos = r->p;
                } else if (r->usage < UsageMaxOLUsages) {
                        rn++;
                }
        }
        *refn = rn;
        *defRefn = drn;
}
static void htmlCreateGlobSymList(int i, void *off, void *ffn, void *genfi) {
        FILE *ff;
        char *fn;
        int genFileIndex, refn, defRefn, defusage;
        static int counter;
        S_symbolRefItem *p,*pp;
        S_olSymbolsMenu *hh;
        S_reference *r;
        S_position defpos;
        ff = off;
        fn = ffn;
        { if (!(genfi)) internalCheckFail("genfi", "html.c", 1315);};
        genFileIndex = *((int *)genfi);
        pp = s_cxrefTab.tab[i];
        for (p=pp; p!=NULL; p=p->next) {
                if (p->b.category == CatGlobal && p->b.symType<MAX_HTML_LIST_TYPE) {
                        if (genFileIndex==-1
                                || genFileIndex == cxFileHashNumber(p->name)) {
                          htmlGetReferencesMetrics( p, &refn, &defRefn, &defusage,&defpos);
                          {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "html.c", 1323);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(1)*sizeof(S_olSymbolsMenu) >= cxMemory.size) { if (cxMemory.overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } hh = (S_olSymbolsMenu*) (cxMemory.b + cxMemory.i); cxMemory.i += (1)*sizeof(S_olSymbolsMenu);};};};
                          { (hh)->s = *p; (hh)->selected = 0; (hh)->visible = 0; (hh)->ooBits = (00300 | 02000); (hh)->olUsage = UsageUsed; (hh)->vlevel = 0; (hh)->refn = refn; (hh)->defRefn = defRefn; (hh)->defUsage = defusage; (hh)->defpos = defpos; (hh)->outOnLine = 0; (hh)->next = s_htmlCurrentCxlist;};
                          s_htmlCurrentCxlist = hh;
                        }
                }
        }
}
static void htmlScanCxFileAndGenRefLists(char *fn1, char *fn2,
                                                                                 int fi, int genFlag) {
        char fn[MAX_FILE_NAME_SIZE];
        char ln[MAX_FILE_NAME_SIZE];
        char *ffn;
        FILE *ff;
        S_symbolRefItem *rr;
        S_olSymbolsMenu *ss;
        sprintf(fn, "%s%s", getRealFileNameStatic(normalizeFileName(fn1,s_cwd)), fn2);
        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE-1", "html.c", 1347);};
        if (! s_opt.noCxFile) {
          fIn = fopen(fn, "r");
          if (fIn == NULL) {
                error(ERR_CANT_OPEN, fn);
          } else {
                scanCxFile(s_cxHtmlGlobRefListScanFunTab);
                fclose(fIn);
          }
        }
        ffn = cutHtmlPath(fn);
        if (genFlag == HTML_GEN) {
                if (fi%10==0) fprintf(stdout,"\n");
                fprintf(stdout,"X%04d ",fi);
                fflush(stdout);
                concatPathes(ln,MAX_FILE_NAME_SIZE, s_opt.htmlRoot, ffn,".html");
                recursivelyCreateFileDirIfNotExists(ln);
                ff = fopen(ln, "w");
                if (ff==NULL) error(ERR_CANT_OPEN, ln);
                else {
                        htmlGenRefListFileHead(ff,fi);
                        s_htmlCurrentCxlist = NULL;
                        refTabMap32(&s_cxrefTab, htmlCreateGlobSymList, ff, ffn, &fi);
                        { S_olSymbolsMenu *_macrores; _macrores = (s_htmlCurrentCxlist); { S_olSymbolsMenu *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (htmlRefItemsOrderLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (s_htmlCurrentCxlist) = _macrores;};
                        htmlMarkVisibleAllClassesHavingReferences(s_htmlCurrentCxlist);
                        htmlGenGlobRefLists(s_htmlCurrentCxlist, ff, ffn);
                        htmlGenRefListTail(ff);
                        fclose(ff);
                        htmlCompressFile(ln);
                }
        }
}
static void htmlJavaDocPosProcess( FILE **fff,
                                                        S_htmlRefList **rrr,
                                                        S_position *cp,
                                                        int *cch
                                                ) {
  S_htmlRefList *dr,*rr;
  char *prf,*suf,*prf1,*suf1;
  int usage;
  { if (!(rrr)) internalCheckFail("rrr", "html.c", 1414);};
  rr = *rrr;
  { if (!(rr && rr->r)) internalCheckFail("rr && rr->r", "html.c", 1416);};
  if (rr->r->usage == UsageJavaDocFullEntry
          || rr->r->usage == UsageJavaDoc) {
        usage = rr->r->usage;
        dr = rr;
        if (usage == UsageJavaDoc) {
          for(; dr!=NULL && !( (dr->r->usage==UsageDefined && dr->s->b.symType==TypeDefault)); dr=dr->next) {
                if (dr->r->usage == UsageJavaDocFullEntry) dr->r->usage=UsageNone;
          }
        }
        if (dr!=NULL) {
          htmlGetStaticHREFItems(dr,cp, &prf1, &suf1, &prf, &suf);
          if (usage == UsageJavaDocFullEntry) fprintf(ccOut," /**");
          fprintf(ccOut,"\n  * @see %s[Source]%s\n",prf,suf);
          fprintf(ccOut,"  * @see %s[Xrefs]%s\n",prf1,suf1);
          if (usage == UsageJavaDocFullEntry) fprintf(ccOut,"  */\n");
        }
  }
  rr = rr->next;
  *rrr = rr;
}
int addHtmlCutPath( char *ss ) {
        int i,ln,len, res;
        res = 0;
        ss = htmlNormalizedPath(ss);
        ln = strlen(ss);
        if (ln>=1 && ss[ln-1] == SLASH) {
                warning(ERR_ST,"slash at the end of -htmlcutpath path, ignoring it");
                return(res);
        }
        for(i=0; i<s_opt.htmlCut.pathesNum; i++) {
                if (strcmp(s_opt.htmlCut.path[i], ss)==0) return(res);
        }
        s_opt.htmlCut.path[s_opt.htmlCut.pathesNum] = ss;
        s_opt.htmlCut.plen[s_opt.htmlCut.pathesNum] = ln;
        for(i=0; i<s_opt.htmlCut.pathesNum; i++) {
                len = s_opt.htmlCut.plen[i];
                if (fnnCmp(s_opt.htmlCut.path[i], ss, len)==0) {
                        sprintf(tmpBuff,
                                        "htmlcutpath: '%s' supersede \n\t\t'%s', exchanging them",
                                        s_opt.htmlCut.path[i], ss);
                        warning(ERR_ST, tmpBuff);
                        res = 1;
                        s_opt.htmlCut.path[s_opt.htmlCut.pathesNum]=s_opt.htmlCut.path[i];
                        s_opt.htmlCut.plen[s_opt.htmlCut.pathesNum]=s_opt.htmlCut.plen[i];
                        s_opt.htmlCut.path[i] = ss;
                        s_opt.htmlCut.plen[i] = ln;
                }
        }
        if (s_opt.htmlCut.pathesNum+2 >= MAX_HTML_CUT_PATHES) {
                error(ERR_ST,"# of htmlcutpathes overflow over MAX_HTML_CUT_PATHES");
        } else {
                s_opt.htmlCut.pathesNum++;
        }
        return(res);
}
static void htmlPosProcess( FILE **fff,
                                                        S_htmlRefList **rrr,
                                                        S_position *cp,
                                                        int *cch
                                                ) {
        int ch,rlen;
        S_htmlRefList *rr;
        S_symbolRefItem *cri;
        char *prf,*suf,*prf1,*suf1;
        char *prf0,*suf0;
        FILE *ff;
        ff = *fff;
        rr = *rrr;
        ch = *cch;
        cri = rr->s;
        prf = suf = "";
        prf0 = suf0 = "";
        prf1 = suf1 = "";
        if (cri->b.symType == TypeFunSep) {
                if (s_opt.htmlFunSeparate) {
                        fprintf(ccOut, "</pre><font size= -1 color=\"red\"><hr><center>");
                        fprintf(ccOut,"%s:%d ( %s )",
                                        s_fileTab.tab[cp->file]->name, cp->line,
                                        ctime(&s_fileTab.tab[cp->file]->lastModif));
                        fprintf(ccOut, "</center><hr></font><pre>");
                }
                goto fini;
        } else if (cri->b.symType == TypeComment) {
                if (rr->r->usage == UsageDefined) {
                        fprintf(ccOut,"<font color=\"green\">");
                } else {
                        fprintf(ccOut,"</font>");
                }
                goto fini;
        } else if (cri->b.symType == TypeCppAny) {
                prf0 = "<font color=\"brun\">";
                suf0 = "</font>";
        } else if (cri->b.symType == TypeKeyword) {
                prf0 = "<font color=\"blue\">";
                suf0 = "</font>";
        } else {
                if (cri->b.symType == TypeCppIfElse) {
                        if (s_opt.htmlNoColors==0) {
                                prf0 = "<font color=\"brun\">";
                                suf0 = "</font>";
                        }
                }
                if (cri->b.symType==TypeCppInclude && rr->r->usage==UsageDefined) {
                        goto fini;
                }
                htmlGetStaticHREFItems(rr,cp, &prf1, &suf1, &prf, &suf);
        }
        if (ff == NULL) goto fini;
        if (htmlPositionLess(&rr->r->p, cp)) {
                fprintf(ccOut,"%s%s",prf0,prf);
                fprintf(ccOut,"%s%s",suf,suf0);
        } else {
                if ( cri->b.symType==TypeCppIfElse
                                || cri->b.symType==TypeCppInclude
                                || cri->b.symType==TypeCppAny
                        ) {
                        if (ch != '#') {
                                fprintf(dumpOut,"cpp ref on '%c' not at #: %s,%d,%d\n",ch,s_fileTab.tab[rr->r->p.file]->name,rr->r->p.line,rr->r->p.coll);fflush(dumpOut);
                        }
                        htmlPutCharLF(ccOut, ch, cp);
                        { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }};
                        while (ch==' '||ch=='\t') {
                                htmlPutCharLF(ccOut, ch, cp);
                                { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }};
                        }
                }
                if (rr->r->usage==UsageDefined) {
                  if ((rr->s->b.category==CatLocal && s_opt.htmllocalx)
                          || (rr->s->b.category==CatGlobal && s_opt.htmlglobalx)) {
                        fprintf(ccOut,"%s%s",prf0,prf1);
                        { while (ch!=EOF && (isalpha(ch)||isdigit(ch)||ch=='_'||ch=='$')) { htmlPutCharLF(ccOut, ch, cp); { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }}; }};
                        fprintf(ccOut,"%s%s",suf1,suf0);
                  } else {
                        fprintf(ccOut,"%s",prf0);
                        { while (ch!=EOF && (isalpha(ch)||isdigit(ch)||ch=='_'||ch=='$')) { htmlPutCharLF(ccOut, ch, cp); { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }}; }};
                        fprintf(ccOut,"%s",suf0);
                  }
                } else if (s_opt.htmlDirectX &&
                                   ((cri->b.category == CatGlobal && s_opt.htmlglobalx)
                                        || (cri->b.category == CatLocal && s_opt.htmllocalx))) {
                        fprintf(ccOut,"%s%s",prf0,prf1);
                        if (ch!=EOF && (isalpha(ch)||isdigit(ch)||ch=='_'||ch=='$')) {
                                htmlPutCharLF(ccOut, ch, cp);
                                { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }};
                        }
                        fprintf(ccOut,"%s%s",suf1,prf);
                        { while (ch!=EOF && (isalpha(ch)||isdigit(ch)||ch=='_'||ch=='$')) { htmlPutCharLF(ccOut, ch, cp); { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }}; }};
                        fprintf(ccOut,"%s%s",suf,suf0);
                } else {
                        fprintf(ccOut,"%s%s",prf0,prf);
                        { while (ch!=EOF && (isalpha(ch)||isdigit(ch)||ch=='_'||ch=='$')) { htmlPutCharLF(ccOut, ch, cp); { if (ch=='\n') {(cp)->line++; (cp)->coll=0;} else (cp)->coll++; ch=fgetc(ff); if (ch==EOF) { fclose(ff); ff = NULL; }}; }};
                        fprintf(ccOut,"%s%s",suf,suf0);
                }
                cri->b.htmlWasLn = 1;
        }
fini:
        rr = rr->next;
        *rrr = rr;
        *fff = ff;
        *cch = ch;
}
static void htmlPassRefsThroughSourceFile(S_htmlRefList **rrr, int ifile,
                                                                                int genFlag) {
        S_htmlRefList *rr,*oldrr;
        int n,ch;
        FILE *cofile;
        char *cofileName;
        S_position cp;
        rr = *rrr;
        { if (!(s_fileTab.tab[ifile])) internalCheckFail("s_fileTab.tab[ifile]", "html.c", 1621);};
        cofileName = s_fileTab.tab[ifile]->name;
        cofile = fopen(cofileName, "r");
        if (cofile==NULL) error(ERR_CANT_OPEN, cofileName);
        { (&cp)->file = ifile; (&cp)->line = 0; (&cp)->coll = 0;};
        ch = '\n';
        if (genFlag==GEN_HTML) htmlPutCharLF(ccOut, ch, &cp);
        else fputc(ch,ccOut);
        if (cofile!=NULL) {
                { if (ch=='\n') {(&cp)->line++; (&cp)->coll=0;} else (&cp)->coll++; ch=fgetc(cofile); if (ch==EOF) { fclose(cofile); cofile = NULL; }};
        }
        oldrr = NULL;
        while (rr != NULL) {
                { if (!(oldrr!=rr)) internalCheckFail("oldrr!=rr", "html.c", 1635);}; oldrr=rr;
                while (cofile!=NULL && htmlPositionLess(&cp, &rr->r->p)) {
                  if (genFlag==GEN_HTML) htmlPutCharLF(ccOut, ch, &cp);
                  else fputc(ch,ccOut);
                  { if (ch=='\n') {(&cp)->line++; (&cp)->coll=0;} else (&cp)->coll++; ch=fgetc(cofile); if (ch==EOF) { fclose(cofile); cofile = NULL; }};
                }
                if (genFlag==GEN_HTML) htmlPosProcess(&cofile, &rr, &cp, &ch);
                else htmlJavaDocPosProcess(&cofile, &rr, &cp, &ch);
        }
        while (cofile!=NULL) {
          if (genFlag==GEN_HTML) htmlPutCharLF(ccOut, ch, &cp);
          else fputc(ch,ccOut);
          { if (ch=='\n') {(&cp)->line++; (&cp)->coll=0;} else (&cp)->coll++; ch=fgetc(cofile); if (ch==EOF) { fclose(cofile); cofile = NULL; }};
        }
        if (cofile != NULL) fclose(cofile);
        *rrr = rr;
}
static void htmlGenerateFileToCcOut(int fnum) {
        S_htmlRefList *rr;
        S_position cp;
        recoverCachePoint(1,s_cache.cp[1].lbcc,0);
        htmlGenHead(fnum);
        { (&cp)->file = fnum; (&cp)->line = 1; (&cp)->coll = 0;};
        htmlGetThisFileReferences(fnum, &rr, ONLINE_ONLY);
        htmlPassRefsThroughSourceFile(&rr,fnum,GEN_HTML);
        htmlGenTail();
}
static void htmlGenerateFile(int fnum) {
        S_htmlLocalListms sss;
        char *fn,*frn,*lrn;
        char ffn[MAX_FILE_NAME_SIZE];
        char ffn2[MAX_FILE_NAME_SIZE];
        int i;
        FILE *ff;
        { if (!(s_fileTab.tab[fnum])) internalCheckFail("s_fileTab.tab[fnum]", "html.c", 1672);};
        concatPathes(ffn,MAX_FILE_NAME_SIZE,
                        s_opt.htmlRoot,
                        htmlAuxFileNameStatic(fnum,"XFRM","",".frm.html"),
                        NULL);
        if (((s_opt.htmlglobalx || s_opt.htmllocalx))) {
                recursivelyCreateFileDirIfNotExists(ffn);
                ff = fopen(ffn,"w");
                if (ff==NULL) error(ERR_CANT_OPEN,ffn);
                else {
                        htmlGenFrameFile(ff,fnum, ffn);
                        fclose(ff);
                        htmlCompressFile(ffn);
                }
        }
        concatPathes(ffn,MAX_FILE_NAME_SIZE,
                        s_opt.htmlRoot,htmlCutLastSuffixStatic(cutHtmlPath(getRealFileNameStatic(s_fileTab.tab[fnum]->name))),".html");
        recursivelyCreateFileDirIfNotExists(ffn);
        ccOut = fopen(ffn,"w");
        if (ccOut==NULL) {
                warning(ERR_CANT_OPEN,ffn);
                ccOut=stdout;
        } else {
                fprintf(dumpOut," -> '%s'\n", ffn); fflush(dumpOut);
                htmlGenerateFileToCcOut(fnum);
                fclose(ccOut);
                htmlCompressFile(ffn);
                ccOut=stdout;
                if (s_opt.htmllocalx) {
                        strcpy(ffn,htmlAuxFileNameStatic(fnum,"XLL","",""));
                        concatPathes(ffn2,MAX_FILE_NAME_SIZE,s_opt.htmlRoot,ffn,".html");
                        recursivelyCreateFileDirIfNotExists(ffn2);
                        ff = fopen(ffn2,"w");
                        if (ff==NULL) error(ERR_CANT_OPEN,ffn2);
                        else {
                                htmlGenRefListFileHead(ff, -1);
                                { (&sss)->ff = ff; (&sss)->fnum = fnum; (&sss)->fname = ffn;};
                                refTabMap2(&s_cxrefTab, htmlGenLocalRefLists, &sss);
                                htmlGenRefListTail(ff);
                                fclose(ff);
                                htmlCompressFile(ffn2);
                        }
                }
        }
}
static void htmlGenerateJavaDocFile(int fnum) {
        char *fn;
        S_htmlRefList *rr;
        char ffn[MAX_FILE_NAME_SIZE];
        struct stat st;
        int stt;
        { if (!(s_fileTab.tab[fnum])) internalCheckFail("s_fileTab.tab[fnum]", "html.c", 1726);};
        concatPathes(ffn,MAX_FILE_NAME_SIZE,
                                 s_opt.jdocTmpDir,
                                 cutHtmlPath(getRealFileNameStatic(s_fileTab.tab[fnum]->name)),
                                 "");
        fprintf(dumpOut," -> '%s'\n", ffn); fflush(dumpOut);
        recursivelyCreateFileDirIfNotExists(ffn);
        stt = stat(ffn,&st);
        if (stt==0) {
                sprintf(tmpBuff, "file %s exists, not overwriting it", ffn);
                warning(ERR_ST, tmpBuff);
                return;
        }
        ccOut = fopen(ffn,"w");
        if (ccOut==NULL) {
                warning(ERR_CANT_OPEN,ffn);
                ccOut=stdout;
        } else {
                htmlGetThisFileReferences(fnum, &rr, ALL_REFS);
                htmlPassRefsThroughSourceFile(&rr,fnum,GEN_JAVA_DOC);
                fclose(ccOut);
        }
}
void htmlAddFunctionSeparatorReference() {
        S_position pos;
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                { (&pos)->file = cFile.lb.cb.fileNumber; (&pos)->line = cFile.lineNumber+1; (&pos)->coll = -1;};
                addTrivialCxReference("  fun separator", TypeFunSep,StorageDefault,
                                                          &pos, UsageUsed);
                return;
        }
}
void htmlAddJavaDocReference(S_symbol *p, S_position *pos,
                                                         int vFunClass, int vApplClass) {
        S_position npos;
        if (s_opt.taskRegime == RegimeHtmlGenerate && s_opt.javaDoc) {
                { (&npos)->file = pos->file; (&npos)->line = pos->line; (&npos)->coll = 0;};
                addCxReference(p, &npos, UsageJavaDocFullEntry, vFunClass, vApplClass);
        }
}
int isJavaClassFile(S_fileItem *ffi) {
        char *ss;
        ss = getFileSuffix(ffi->name);
        if (strcmp(ss,".class")==0) return(1);
        return(0);
}
void htmlGenEmptyRefsFile() {
        FILE *ff;
        ff = fopen(s_htmlEmptyRefs,"w");
        if (ff!=NULL) {
                htmlGenRefListFileHead(ff, -1);
                htmlGenRefListItemHead(ff, "",
                "Xrefs",
                NULL, USAGE_ANY, DEFAULT_VALUE
                );
                htmlGenRefListTail(ff);
                fclose(ff);
                htmlCompressFile(s_htmlEmptyRefs);
        }
}
static void dumpClList(S_chReference *ll) {
        for(; ll!=NULL; ll=ll->next) {
                fprintf(dumpOut,"  %s\n",
                                javaGetNudePreTypeName_st(getRealFileNameStatic(
                                        s_fileTab.tab[ll->clas]->name), NO_OUTERS_CUT));
        }
}
static void sortSubClassesList(S_fileItem *fi) {
        { S_chReference *_macrores; _macrores = (fi->infs); { S_chReference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (classHierarchySupClassNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (fi->infs) = _macrores;};
}
void htmlGenGlobalReferenceLists(char *cxMemFreeBase) {
        char fn[MAX_FILE_NAME_SIZE];
        char *dirname,*fname,*newFreeBase;
        int i;
        if (s_opt.htmlglobalx == 0) return;
        fprintf(dumpOut,"\nGenerating global symbol reference lists");
        fflush(dumpOut);
        fname = s_opt.cxrefFileName;
        if (s_opt.refnum <= 1) {
                recoverMemoriesAfterOverflow(cxMemFreeBase);
                htmlScanCxFileAndGenRefLists(fname, "",-1, HTML_GEN);
        } else {
                dirname = fname;
                recoverMemoriesAfterOverflow(cxMemFreeBase);
                htmlScanCxFileAndGenRefLists(dirname,PRF_FILES,-1,HTML_NO_GEN);
                htmlScanCxFileAndGenRefLists(dirname,PRF_CLASS,
                                                                                 -1, HTML_NO_GEN);
                idTabMap(&s_fileTab, sortSubClassesList);
                {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "html.c", 1831);}; cxMemory.i = ((char*)(((char*)(cxMemory.b+cxMemory.i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(cxMemory.b+cxMemory.i))-1) & (STANDARD_ALLIGNEMENT-1))))) - cxMemory.b; if (cxMemory.i+(0)*sizeof(char) >= cxMemory.size) { if (cxMemory.overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } newFreeBase = (char*) (cxMemory.b + cxMemory.i); cxMemory.i += (0)*sizeof(char);};};
                for (i=0; i<s_opt.refnum; i++) {
                        recoverMemoriesAfterOverflow(newFreeBase);
                        sprintf(fn, "%s%04d", PRF_REF_PREFIX, i);
                        htmlScanCxFileAndGenRefLists(dirname,fn, i, HTML_GEN);
                }
        }
        fprintf(dumpOut,"\nDone.\n"); fflush(dumpOut);
}
void generateHtml() {
        register int i;
        S_fileItem *fi;
        if (s_opt.htmlRoot==NULL || s_opt.htmlRoot[0]==0) {
                fatalError(ERR_ST, "No HTML output directory specified, use -htmlroot=<dir>", 65);
        }
        concatPathes(s_htmlEmptyRefs,MAX_FILE_NAME_SIZE,
                                        s_opt.htmlRoot,"/XrefEmptyRefs.html","");
        for(i=0; i<MAX_FILES; i++) {
                fi = s_fileTab.tab[i];
                if (fi == NULL) continue;
                if (fi->b.cxLoading==0) continue;
                if (isJavaClassFile(fi)) continue;
                htmlGenerateFile(i);
                if (s_opt.javaDoc) htmlGenerateJavaDocFile(i);
        }
}
