
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static void initTokensFromTab(S_tokenNameIni *tokenTabIni) {
        char *nn;
        int tok, ii, i, tlan;
        S_symbol *pp;
        for(i=0; tokenTabIni[i].name!=NULL; i++) {
                nn = tokenTabIni[i].name;
                tok = tokenTabIni[i].token;
                tlan = tokenTabIni[i].languages;
                s_tokenName[tok] = nn;
                if ((isalpha(*nn) || *nn=='_') && (tlan & s_language)) {
                        {pp = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
                        { (&pp->b)->record = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeKeyword; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
                        { (pp)->name = nn; (pp)->linkName = nn; (pp)->pos = s_noPos; (pp)->b = pp->b; (pp)->u.keyWordVal = tok; (pp)->next = NULL;};
                        pp->u.keyWordVal = tok;
                        symTabAdd(s_symTab,pp,&ii);
                }
        }
}
static int stringContainsSubstring(char *s, char *subs) {
        register int i, im;
        int sl, sbl;
        sl = strlen(s);
        sbl = strlen(subs);
        im = sl-sbl;
        for(i=0; i<=im; i++) {
                if (strncmp(s+i, subs, sbl)==0) return(1);
        }
        return(0);
}
static char *autoDetectJavaVersion() {
        int i;
        char *res;
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                if (stringContainsSubstring(s_zipArchivTab[i].fn, "rt.jar")) {
                        if (stringContainsSubstring(s_zipArchivTab[i].fn, "1.4")) {
                                res = "Java 1.4";
                                goto fini;
                        }
                }
        }
        res = "Java 1.3";
 fini:
        return(res);
}
void initTokenNameTab() {
        char *nn, *jv;
        int tok,ii,i,tlan;
        S_symbol *pp;
        static int messageWritten=0;
        if (! s_opt.strictAnsi) {
                initTokensFromTab(s_tokenNameIniTab2);
        }
        jv = s_opt.javaVersion;
        if (strcmp(jv, "Auto")==0) jv = autoDetectJavaVersion();
        if (s_opt.taskRegime!=RegimeEditServer && messageWritten==0) {
                fprintf(dumpOut,"java version == %s\n", jv);
                messageWritten=1;
        }
        if (strcmp(jv, "Java 1.4")==0) {
                initTokensFromTab(s_tokenNameIniTab3);
        }
        initTokensFromTab(s_tokenNameIniTab);
        {pp = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
        { (&pp->b)->record = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeDefinedOp; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
        { (pp)->name = "defined"; (pp)->linkName = "defined"; (pp)->pos = s_noPos; (pp)->b = pp->b; (pp)->u.type = NULL; (pp)->next = NULL;};
        symTabAdd(s_symTab,pp,&ii);
}
void initTypeModifiersTabs() {
        int i,t;
        for(i=0; i<MAX_TYPE; i++) {
                typeShortChange[i] = i;
                typeLongChange[i] = i;
                typeSignedChange[i] = i;
                typeUnsignedChange[i] = i;
        }
        for(i=0; s_typeModificationsInit[i].type >= 0; i++) {
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modShort; if (tmp>=0) typeShortChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modLong; if (tmp>=0) typeLongChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modSigned; if (tmp>=0) typeSignedChange[t] = tmp;};
                { int t,tmp; t = s_typeModificationsInit[i].type; tmp = s_typeModificationsInit[i].modUnsigned; if (tmp>=0) typeUnsignedChange[t] = tmp;};
        }
}
void initJavaTypePCTIConvertIniTab() {
        int i;
        S_javaTypePCTIConvertIni *s;
        for (i=0; s_javaTypePCTIConvertIniTab[i].symType != -1; i++) {
                s = &s_javaTypePCTIConvertIniTab[i];
                { if (!(s->symType >= 0 && s->symType < MAX_TYPE)) internalCheckFail("s->symType >= 0 && s->symType < MAX_TYPE", "init.c", 126);};
                s_javaTypePCTIConvert[s->symType] = s->PCTIndex;
        }
}
void initTypeCharCodeTab() {
        int i;
        S_typeCharCodeIni *s;
        for (i=0; s_baseTypeCharCodesIniTab[i].symType != -1; i++) {
                s = &s_baseTypeCharCodesIniTab[i];
                { if (!(s->symType >= 0 && s->symType < MAX_TYPE)) internalCheckFail("s->symType >= 0 && s->symType < MAX_TYPE", "init.c", 136);};
                s_javaBaseTypeCharCodes[s->symType] = s->code;
                { if (!(s->code >= 0 && s->code < 127)) internalCheckFail("s->code >= 0 && s->code < 127", "init.c", 138);};
                s_javaCharCodeBaseTypes[s->code] = s->symType;
        }
}
void initTypesNamesTab() {
        int i;
        S_intStringTab *s;
        for (i=0; s_typesNamesInitTab[i].i != -1; i++) {
                s = &s_typesNamesInitTab[i];
                { if (!(s->i >= 0 && s->i < MAX_TYPE)) internalCheckFail("s->i >= 0 && s->i < MAX_TYPE", "init.c", 148);};
                typesName[s->i] = s->s;
        }
}
void initExtractStoragesNameTab() {
        int i;
        S_intStringTab *s;
        for(i=0; i<MAX_STORAGE; i++) s_extractStorageName[i]="";
        for (i=0; s_extractStoragesNamesInitTab[i].i != -1; i++) {
                s = &s_extractStoragesNamesInitTab[i];
                { if (!(s->i >= 0 && s->i < MAX_TYPE)) internalCheckFail("s->i >= 0 && s->i < MAX_TYPE", "init.c", 159);};
                s_extractStorageName[s->i] = s->s;
        }
}
void initArchaicTypes() {
        { (&s_defaultIntModifier)->m = TypeInt; { (&((&(&s_defaultIntModifier)->u)->f))->args = NULL; (&((&(&s_defaultIntModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultIntModifier)->typedefin = NULL; (&s_defaultIntModifier)->next = NULL;};
        { (&s_defaultIntDefinition.b)->record = 0; (&s_defaultIntDefinition.b)->accessFlags = 0; (&s_defaultIntDefinition.b)->javaSourceLoaded = 0; (&s_defaultIntDefinition.b)->javaFileLoaded = 0; (&s_defaultIntDefinition.b)->symType = TypeDefault; (&s_defaultIntDefinition.b)->storage = StorageDefault; (&s_defaultIntDefinition.b)->npointers = 0;};
        { (&s_defaultIntDefinition)->name = NULL; (&s_defaultIntDefinition)->linkName = NULL; (&s_defaultIntDefinition)->pos = s_noPos; (&s_defaultIntDefinition)->b = s_defaultIntDefinition.b; (&s_defaultIntDefinition)->u.type = &s_defaultIntModifier; (&s_defaultIntDefinition)->next = NULL;};
        s_defaultIntDefinition.u.type = &s_defaultIntModifier;
        { (&s_defaultPackedTypeModifier)->m = TypePackedType; { (&((&(&s_defaultPackedTypeModifier)->u)->f))->args = NULL; (&((&(&s_defaultPackedTypeModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultPackedTypeModifier)->typedefin = NULL; (&s_defaultPackedTypeModifier)->next = NULL;};
        { (&s_defaultVoidModifier)->m = TypeVoid; { (&((&(&s_defaultVoidModifier)->u)->f))->args = NULL; (&((&(&s_defaultVoidModifier)->u)->f))->thisFunList = NULL;}; (&s_defaultVoidModifier)->typedefin = NULL; (&s_defaultVoidModifier)->next = NULL;};
        { (&s_defaultVoidDefinition.b)->record = 0; (&s_defaultVoidDefinition.b)->accessFlags = 0; (&s_defaultVoidDefinition.b)->javaSourceLoaded = 0; (&s_defaultVoidDefinition.b)->javaFileLoaded = 0; (&s_defaultVoidDefinition.b)->symType = TypeDefault; (&s_defaultVoidDefinition.b)->storage = StorageDefault; (&s_defaultVoidDefinition.b)->npointers = 0;};
        { (&s_defaultVoidDefinition)->name = NULL; (&s_defaultVoidDefinition)->linkName = NULL; (&s_defaultVoidDefinition)->pos = s_noPos; (&s_defaultVoidDefinition)->b = s_defaultVoidDefinition.b; (&s_defaultVoidDefinition)->u.type = &s_defaultVoidModifier; (&s_defaultVoidDefinition)->next = NULL;};
        s_defaultVoidDefinition.u.type = &s_defaultVoidModifier;
        { (&s_errorModifier)->m = TypeError; { (&((&(&s_errorModifier)->u)->f))->args = NULL; (&((&(&s_errorModifier)->u)->f))->thisFunList = NULL;}; (&s_errorModifier)->typedefin = NULL; (&s_errorModifier)->next = NULL;};
        { (&s_errorSymbol.b)->record = 0; (&s_errorSymbol.b)->accessFlags = 0; (&s_errorSymbol.b)->javaSourceLoaded = 0; (&s_errorSymbol.b)->javaFileLoaded = 0; (&s_errorSymbol.b)->symType = TypeError; (&s_errorSymbol.b)->storage = StorageNone; (&s_errorSymbol.b)->npointers = 0;};
        { (&s_errorSymbol)->name = "__ERROR__"; (&s_errorSymbol)->linkName = "__ERROR__"; (&s_errorSymbol)->pos = s_noPos; (&s_errorSymbol)->b = s_errorSymbol.b; (&s_errorSymbol)->u.type = &s_errorModifier; (&s_errorSymbol)->next = NULL;};
        s_errorSymbol.u.type = &s_errorModifier;
}
void initPreCreatedTypes() {
        int i,t;
        S_typeModifiers *tt;
        for(i=0; i<MAX_TYPE; i++) {
                s_preCrTypesTab[i] = NULL;
                s_preCrPtr1TypesTab[i] = NULL;
        }
        for(i=0; ; i++) {
                t = s_preCrTypesIniTab[i];
                if (t<0) break;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = t; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = NULL;};
                { if (!(t>=0 && t<MAX_TYPE)) internalCheckFail("t>=0 && t<MAX_TYPE", "init.c", 200);};
                s_preCrTypesTab[t] = tt;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = TypePointer; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = s_preCrTypesTab[t];};
                s_preCrPtr1TypesTab[t] = tt;
                {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (tt)->m = TypePointer; (&(tt)->u)->t = NULL;; (tt)->typedefin = NULL; (tt)->next = s_preCrPtr1TypesTab[t];};
                s_preCrPtr2TypesTab[t] = tt;
        }
}
